##############################################################################
##  BKPI prekladac - skript na post-processing subora Parser.java,          ##
##                   vygenerovaneho nastrojom javacc.                       ##
##                                                                          ##
##  Skript je potrebne spustat z adresara, v ktorom sa nachadza podadresar  ##  
##  "src" so zdrojovymi subormi prekladaca BKPI.                            ##
##  Predpoklada sa, ze subor Parser.java sa nachadza v adresari             ##
##  src\sk\tuke\bkpi\parser\javacc   (da sa zmenit v premennej path         ##
##                                                                          ##
##  Autori: M. Dancak, S.Korecko                                            ##
##############################################################################


import os
import stat

#Parametre
path ="src/sk/tuke/bkpi/parser/javacc"
jjFile ="BParser.jj"
pFile ="Parser.java"

#Uvodne vypisy 

print "BKPI.postproc> starting."

print "BKPI.postproc> javacc specification file: "+path+"/"+jjFile
print "BKPI.postproc> file to be modified: "+path+"/"+pFile

#Zistovanie casu poslednej modifikacie BParser.jj 

last_modification = os.stat(path+"/"+jjFile)[stat.ST_MTIME]
#last_modification = os.stat(path+"/"+jjFile.replace("/", os.sep))[stat.ST_MTIME]

stamp = "/* javacc postprocess: last modification: %s */\n" % last_modification

def parse_last_modification(text):
	start = text.find("last modification: ")
	if start != -1:
		t = int(text[start+19:start+29])
		#print "parsed: %d" % t
		return t



#Modifikacia subora


print "BKPI.postproc> opening "+pFile+"." 
parser =path+"/"+pFile
f = open(parser, "r")
data = f.read()
f.close()
if parse_last_modification(data) != last_modification:
	print "BKPI.postproc> modifying "+pFile+"."
	position = data.find("private Token jj_consume_token(int kind) throws ParseException {")
	if position != -1:
		after = data[position:]	 
		start = after.rfind("private void trace_call(String s)")
		end   = after.find("private void jj_rescan_token()")
		if start != -1 and end != -1:
			after = after[:start] + after[end:]
			
		#"""
		
		data = data[:position] + after.replace("token_source.getNextToken()", "getFollowingToken()")
		f = open(parser, "w")
		f.write(stamp+data)
		f.close()
else:
  print "BKPI.postproc> no modification of "+pFile+" needed."
  pass
print "BKPI.postproc> done."  