/*
 * InteractiveCompiledImplementationsManager.java
 *
 * Created on __DATE__, __TIME__
 */

package sk.tuke.bkpi.complexGui;

import java.awt.FileDialog;
import java.awt.Frame;
import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

import sk.tuke.bkpi.extensions.CompiledImplementationManager;

/**
 *
 * @author  __USER__
 */
public class InteractiveCompiledImplementationsManager extends
		javax.swing.JFrame {

	private CompiledImplementationManager compiledImplementationsManagers = null;

	public void setCompiledImplementationsManager(
			CompiledImplementationManager CIM) {
		this.compiledImplementationsManagers = CIM;
		refreshTables();
	}

	public CompiledImplementationManager getCompiledImplementationsManager() {
		return this.compiledImplementationsManagers;
	}

	public void refreshTables() {

		DefaultTableModel DTM1 = (DefaultTableModel) jTable1.getModel();
		DefaultTableModel DTM2 = (DefaultTableModel) jTable2.getModel();

		while (jTable1.getModel().getRowCount() > 0) {
			DTM1.removeRow(0);
		}

		while (jTable2.getModel().getRowCount() > 0) {
			DTM2.removeRow(0);
		}

		Hashtable<String, String> JavaPairs = this.compiledImplementationsManagers
				.AllMachineImplementationPairs("Java");

		for (String machine : JavaPairs.keySet()) {
			DTM1.addRow(new Object[] {});
			jTable1.getModel()
					.setValueAt(
							machine,
							(jTable1.getModel().getRowCount() - 1),
							((jTable1.getModel().getColumnName(0))
									.equals("Machine") ? 0 : 1));
			jTable1.getModel().setValueAt(
					JavaPairs.get(machine),
					(jTable1.getModel().getRowCount() - 1),
					((jTable1.getModel().getColumnName(0))
							.equals("Implementation") ? 0 : 1));
		}

		Hashtable<String, String> CsharpPairs = this.compiledImplementationsManagers
				.AllMachineImplementationPairs("Csharp");

		for (String machine : CsharpPairs.keySet()) {
			DTM2.addRow(new Object[] {});
			jTable2.getModel()
					.setValueAt(
							machine,
							(jTable2.getModel().getRowCount() - 1),
							((jTable2.getModel().getColumnName(0))
									.equals("Machine") ? 0 : 1));
			jTable2.getModel().setValueAt(
					CsharpPairs.get(machine),
					(jTable2.getModel().getRowCount() - 1),
					((jTable2.getModel().getColumnName(0))
							.equals("Implementation") ? 0 : 1));
		}

	}

	/** Creates new form InteractiveCompiledImplementationsManager */
	private InterfaceCompiledImplementationsManager interfaceManager;

	public InteractiveCompiledImplementationsManager() {
		initComponents();
		interfaceManager = new InterfaceCompiledImplementationsManager();
		interfaceManager.setVisible(false);
		interfaceManager.setICIM(this);

	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	//GEN-BEGIN:initComponents
	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		jTabbedPane1 = new javax.swing.JTabbedPane();
		jPanel1 = new javax.swing.JPanel();
		jScrollPane1 = new javax.swing.JScrollPane();
		jTable1 = new javax.swing.JTable();
		jPanel2 = new javax.swing.JPanel();
		jScrollPane2 = new javax.swing.JScrollPane();
		jTable2 = new javax.swing.JTable();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jButton3 = new javax.swing.JButton();
		jButton4 = new javax.swing.JButton();
		jButton5 = new javax.swing.JButton();

		setTitle("Interactive compiled implementations manager");

		jTable1.setModel(new javax.swing.table.DefaultTableModel(
				new Object[][] {

				}, new String[] { "Machine", "Implementation" }) {
			Class[] types = new Class[] { java.lang.String.class,
					java.lang.String.class };
			boolean[] canEdit = new boolean[] { false, false };

			public Class getColumnClass(int columnIndex) {
				return types[columnIndex];
			}

			public boolean isCellEditable(int rowIndex, int columnIndex) {
				return canEdit[columnIndex];
			}
		});
		jScrollPane1.setViewportView(jTable1);

		javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(
				jPanel1);
		jPanel1.setLayout(jPanel1Layout);
		jPanel1Layout.setHorizontalGroup(jPanel1Layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addComponent(
				jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 336,
				Short.MAX_VALUE));
		jPanel1Layout.setVerticalGroup(jPanel1Layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addComponent(
				jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 261,
				Short.MAX_VALUE));

		jTabbedPane1.addTab("Java", jPanel1);

		jTable2.setModel(new javax.swing.table.DefaultTableModel(
				new Object[][] {

				}, new String[] { "Machine", "Implementation" }) {
			Class[] types = new Class[] { java.lang.String.class,
					java.lang.String.class };
			boolean[] canEdit = new boolean[] { false, false };

			public Class getColumnClass(int columnIndex) {
				return types[columnIndex];
			}

			public boolean isCellEditable(int rowIndex, int columnIndex) {
				return canEdit[columnIndex];
			}
		});
		jScrollPane2.setViewportView(jTable2);

		javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(
				jPanel2);
		jPanel2.setLayout(jPanel2Layout);
		jPanel2Layout.setHorizontalGroup(jPanel2Layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addComponent(
				jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 336,
				Short.MAX_VALUE));
		jPanel2Layout.setVerticalGroup(jPanel2Layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addComponent(
				jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 261,
				Short.MAX_VALUE));

		jTabbedPane1.addTab("C#", jPanel2);

		jButton1.setText("Save ...");
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jButton2.setText("Load ...");
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton2ActionPerformed(evt);
			}
		});

		jButton3.setText("Definition interface");
		jButton3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton3ActionPerformed(evt);
			}
		});

		jButton4.setText("+");
		jButton4.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton4ActionPerformed(evt);
			}
		});

		jButton5.setText("-");
		jButton5.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton5ActionPerformed(evt);
			}
		});

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(
				getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						layout.createSequentialGroup()
								.addContainerGap()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
												.addGroup(
														layout.createSequentialGroup()
																.addComponent(
																		jButton1)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																.addComponent(
																		jButton2)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED,
																		109,
																		Short.MAX_VALUE)
																.addComponent(
																		jButton3))
												.addGroup(
														javax.swing.GroupLayout.Alignment.TRAILING,
														layout.createSequentialGroup()
																.addComponent(
																		jTabbedPane1,
																		javax.swing.GroupLayout.DEFAULT_SIZE,
																		341,
																		Short.MAX_VALUE)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																.addGroup(
																		layout.createParallelGroup(
																				javax.swing.GroupLayout.Alignment.TRAILING,
																				false)
																				.addComponent(
																						jButton5,
																						javax.swing.GroupLayout.DEFAULT_SIZE,
																						javax.swing.GroupLayout.DEFAULT_SIZE,
																						Short.MAX_VALUE)
																				.addComponent(
																						jButton4,
																						javax.swing.GroupLayout.DEFAULT_SIZE,
																						javax.swing.GroupLayout.DEFAULT_SIZE,
																						Short.MAX_VALUE))))
								.addContainerGap()));
		layout.setVerticalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						layout.createSequentialGroup()
								.addContainerGap()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.BASELINE)
												.addComponent(jButton1)
												.addComponent(jButton2)
												.addComponent(jButton3))
								.addPreferredGap(
										javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
												.addGroup(
														layout.createSequentialGroup()
																.addComponent(
																		jButton4)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																.addComponent(
																		jButton5))
												.addComponent(
														jTabbedPane1,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														291, Short.MAX_VALUE))
								.addContainerGap()));

		pack();
	}// </editor-fold>
	//GEN-END:initComponents

	private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {
		interfaceManager.setVisible(true);
	}

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		FileDialog fileDialog = new FileDialog(new Frame(),
				"Save compiled implementations definition", FileDialog.SAVE);
		fileDialog.setVisible(true);
		if (fileDialog.getFile() != null) {
			File file = new File(
					(fileDialog.getDirectory() + fileDialog.getFile()));
			compiledImplementationsManagers.WriteMIPairDefinition(file);
		}
	}

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		FileDialog fileDialog = new FileDialog(new Frame(),
				"Load compiled implementations definition", FileDialog.LOAD);
		fileDialog.setVisible(true);
		if (fileDialog.getFile() != null) {
			File file = new File(
					(fileDialog.getDirectory() + fileDialog.getFile()));
			if (compiledImplementationsManagers
					.CheckMIPairDuplicationError(file)) {
				if (compiledImplementationsManagers
						.MachineImplementationPairsEmpty()) {
					compiledImplementationsManagers.ReadMIPairDefinition(file);
				} else {
					int option = JOptionPane
							.showConfirmDialog(
									null,
									"Would you like to keep already defined\nmachine-implementations pairs",
									"", JOptionPane.YES_NO_CANCEL_OPTION,
									JOptionPane.WARNING_MESSAGE);
					if (option == 0) {
						compiledImplementationsManagers
								.ReadMIPairDefinition(file);
					}

					if (option == 1) {
						compiledImplementationsManagers
								.resetMachineImplementationPairs();
						compiledImplementationsManagers
								.ReadMIPairDefinition(file);
					}
				}

			} else {
				JOptionPane.showMessageDialog(null,
						"Wrong machine-implementation pairs definition file");
			}

		}
		refreshTables();
	}

	private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {

		if (jTabbedPane1.getSelectedIndex() == 0) {
			int[] selection = jTable1.getSelectedRows();

			for (int pair : selection) {
				String machine = (String) jTable1.getModel().getValueAt(
						pair,
						((jTable1.getModel().getColumnName(0))
								.equals("Machine") ? 0 : 1));
				compiledImplementationsManagers
						.RemoveMachineImplementationPair(machine, "Java");
			}

			refreshTables();

		}

		if (jTabbedPane1.getSelectedIndex() == 1) {
			int[] selection = jTable2.getSelectedRows();

			for (int pair : selection) {
				String machine = (String) jTable2.getModel().getValueAt(
						pair,
						((jTable2.getModel().getColumnName(0))
								.equals("Machine") ? 0 : 1));
				compiledImplementationsManagers
						.RemoveMachineImplementationPair(machine, "Csharp");
			}

			refreshTables();

		}

	}

	private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {

		String machine = (String) JOptionPane
				.showInputDialog(
						null,
						"Input machine name for which you want\nto define compiled implementation",
						"Machine name", JOptionPane.PLAIN_MESSAGE, null, null,
						"");
		if (compiledImplementationsManagers.CanBeIdentifier(machine)) {
			String implementation = (String) JOptionPane
					.showInputDialog(
							null,
							("Input implementation name which should be compiled\nas representation of machine " + machine),
							"Implementation name", JOptionPane.PLAIN_MESSAGE,
							null, null, "");
			if (compiledImplementationsManagers.CanBeIdentifier(implementation)) {

				Object[] languages = { "ALL", "Java", "C#" };
				String language = (String) JOptionPane
						.showInputDialog(
								null,
								"Choose language for which you want to\nadd compiled implementation for machine",
								"Choose language", JOptionPane.PLAIN_MESSAGE,
								null, languages, "Java");

				if (language != null) {
					if (language.equals("Java")) {
						compiledImplementationsManagers
								.InsertMachineImplementationPair("Java",
										machine, implementation);
					}

					if (language.equals("C#")) {
						compiledImplementationsManagers
								.InsertMachineImplementationPair("Csharp",
										machine, implementation);
					}

					if (language.equals("ALL")) {
						compiledImplementationsManagers
								.InsertMachineImplementationPair("Java",
										machine, implementation);
						compiledImplementationsManagers
								.InsertMachineImplementationPair("Csharp",
										machine, implementation);
					}

					refreshTables();
					if (language != null) {
						if (jTabbedPane1.getSelectedIndex() == 0
								&& language == "C#") {
							jTabbedPane1.setSelectedIndex(1);
						}
						if (jTabbedPane1.getSelectedIndex() == 1
								&& language == "Java") {
							jTabbedPane1.setSelectedIndex(0);
						}
					}
				}

			} else {
				if (implementation != null) {
					JOptionPane
							.showMessageDialog(null,
									"Inputed implementation name is not proper B identifier");
				}
			}
		} else {
			if (machine != null) {
				JOptionPane.showMessageDialog(null,
						"Inputed machine name is not proper B identifier");
			}
		}

	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new InteractiveCompiledImplementationsManager()
						.setVisible(true);
			}
		});
	}

	//GEN-BEGIN:variables
	// Variables declaration - do not modify
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JButton jButton3;
	private javax.swing.JButton jButton4;
	private javax.swing.JButton jButton5;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JScrollPane jScrollPane2;
	private javax.swing.JTabbedPane jTabbedPane1;
	private javax.swing.JTable jTable1;
	private javax.swing.JTable jTable2;
	// End of variables declaration//GEN-END:variables

}