/*
 * InterfaceCompiledImplementationsManager.java
 *
 * Created on __DATE__, __TIME__
 */

package sk.tuke.bkpi.complexGui;

import java.awt.FileDialog;
import java.awt.Frame;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import javax.swing.JOptionPane;

/**
 *
 * @author  __USER__
 */
public class InterfaceCompiledImplementationsManager extends javax.swing.JFrame {

	/** Creates new form InterfaceCompiledImplementationsManager */
	public InterfaceCompiledImplementationsManager() {
		initComponents();
	}

	private InteractiveCompiledImplementationsManager ICIM;

	public void setICIM(InteractiveCompiledImplementationsManager ICIM) {
		this.ICIM = ICIM;
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	//GEN-BEGIN:initComponents
	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		jScrollPane1 = new javax.swing.JScrollPane();
		jTextArea1 = new javax.swing.JTextArea();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jButton3 = new javax.swing.JButton();

		setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);

		jTextArea1.setColumns(20);
		jTextArea1.setRows(5);
		jScrollPane1.setViewportView(jTextArea1);

		jButton1.setText("Add MI pairs");
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jButton2.setText("Write to file ...");
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton2ActionPerformed(evt);
			}
		});

		jButton3.setText("Read from file ...");
		jButton3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton3ActionPerformed(evt);
			}
		});

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(
				getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						javax.swing.GroupLayout.Alignment.TRAILING,
						layout.createSequentialGroup()
								.addContainerGap()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.TRAILING)
												.addComponent(
														jScrollPane1,
														javax.swing.GroupLayout.Alignment.LEADING,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														461, Short.MAX_VALUE)
												.addGroup(
														layout.createSequentialGroup()
																.addComponent(
																		jButton1)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED,
																		131,
																		Short.MAX_VALUE)
																.addComponent(
																		jButton3)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																.addComponent(
																		jButton2)))
								.addContainerGap()));
		layout.setVerticalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						javax.swing.GroupLayout.Alignment.TRAILING,
						layout.createSequentialGroup()
								.addContainerGap()
								.addComponent(jScrollPane1,
										javax.swing.GroupLayout.DEFAULT_SIZE,
										238, Short.MAX_VALUE)
								.addPreferredGap(
										javax.swing.LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.BASELINE)
												.addComponent(jButton1)
												.addComponent(jButton2)
												.addComponent(jButton3))
								.addContainerGap()));

		pack();
	}// </editor-fold>
	//GEN-END:initComponents

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		if (this.ICIM.getCompiledImplementationsManager().CheckMIDefinitionSyntax(jTextArea1.getText()))
		{
			if (this.ICIM.getCompiledImplementationsManager().CheckMIPairDuplicationError(jTextArea1.getText()))
			{
				this.ICIM.getCompiledImplementationsManager().ReadMIPairDefinition(jTextArea1.getText());
				this.ICIM.refreshTables();
				JOptionPane.showMessageDialog(null, "Machine-Implementation pairs from definition added successfully");
			}
			else
			{
			 JOptionPane.showMessageDialog(null, "Definition contains duplicit Machine-Implementation pair definition");	
			}
		}
		else
		{
			JOptionPane.showMessageDialog(null, "Wrong Machine-Implementation pairs definition");
		}
		
	}

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		FileDialog fileDialog = new FileDialog(new Frame(),
				"Save MI pairs definition", FileDialog.SAVE);
		fileDialog.setVisible(true);
		File file = new File((fileDialog.getDirectory() + fileDialog.getFile()));
		FileWriter outFile;
		try {
			outFile = new FileWriter(file);
			PrintWriter out = new PrintWriter(outFile);
			out.printf(jTextArea1.getText());
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {
		FileDialog fileDialog = new FileDialog(new Frame(),
				"Read MI pairs definition", FileDialog.LOAD);
		fileDialog.setVisible(true);
		if (fileDialog.getFile() != null) {
			File file = new File(
					(fileDialog.getDirectory() + fileDialog.getFile()));
			StringBuffer contents = new StringBuffer();
			BufferedReader reader = null;
			try {
				reader = new BufferedReader(new FileReader(file));
				String text = null;
				while ((text = reader.readLine()) != null) {
					contents.append(text).append(
							System.getProperty("line.separator"));
				}
				if (jTextArea1.getText().equals("")) {
					jTextArea1.setText(contents.toString());
				} else {
					int option = JOptionPane.showConfirmDialog(jTextArea1,
							"Clear current MI pairs definition", "",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.WARNING_MESSAGE);
					if (option == 0) {
						jTextArea1.setText(contents.toString());
					}
					if (option == 1) {
						jTextArea1.append(contents.toString());
					}
				}
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				try {
					if (reader != null) {
						reader.close();
					}
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

		}
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new InterfaceCompiledImplementationsManager().setVisible(true);
			}
		});
	}

	//GEN-BEGIN:variables
	// Variables declaration - do not modify
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JButton jButton3;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JTextArea jTextArea1;
	// End of variables declaration//GEN-END:variables

}