/*
 * InterfaceManagerGui.java
 *
 * Created on __DATE__, __TIME__
 */

package sk.tuke.bkpi.complexGui;

import java.awt.FileDialog;
import java.awt.Frame;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;

import javax.swing.JOptionPane;

import sk.tuke.bkpi.extensions.ExcludedWordsManager;

/**
 *
 * @author  __USER__
 */
public class InterfaceManagerGui extends javax.swing.JFrame {

	/** Creates new form InterfaceManagerGui */

	InteractiveManagerGui interactiveManagerGui = new InteractiveManagerGui();

	public InterfaceManagerGui() {
		initComponents();
	}

	private ExcludedWordsManager EWM;

	private File excludedWordsDefinition = null;

	public void SetExcludedWordsFile(File ExcludedWordsFile) {
		this.excludedWordsDefinition = ExcludedWordsFile;
	}

	public void SetExcludedWordsmanager(ExcludedWordsManager EWM) {
		this.EWM = EWM;
		interactiveManagerGui.SetExcludedWordsmanager(EWM);
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	//GEN-BEGIN:initComponents
	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		jScrollPane1 = new javax.swing.JScrollPane();
		jTextArea1 = new javax.swing.JTextArea();
		jButton1 = new javax.swing.JButton();
		jButton3 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jMenuBar1 = new javax.swing.JMenuBar();
		jMenu1 = new javax.swing.JMenu();
		jMenuItem1 = new javax.swing.JMenuItem();
		jMenuItem2 = new javax.swing.JMenuItem();
		jMenu2 = new javax.swing.JMenu();
		jMenuItem3 = new javax.swing.JMenuItem();

		setTitle("Excluded words manager interface");
		addComponentListener(new java.awt.event.ComponentAdapter() {
			public void componentHidden(java.awt.event.ComponentEvent evt) {
				formComponentHidden(evt);
			}
		});

		jTextArea1.setColumns(20);
		jTextArea1.setRows(5);
		jScrollPane1.setViewportView(jTextArea1);

		jButton1.setText("Add excluded words");
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jButton3.setText("Write to file ...");
		jButton3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton3ActionPerformed(evt);
			}
		});

		jButton2.setText("Read from file ...");
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton2ActionPerformed(evt);
			}
		});

		jMenu1.setLabel("Generate");

		jMenuItem1.setText("New excluded words ...");
		jMenuItem1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem1MousePressed(evt);
			}
		});
		jMenu1.add(jMenuItem1);

		jMenuItem2.setText("Current excluded words");
		jMenuItem2.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem2MousePressed(evt);
			}
		});
		jMenu1.add(jMenuItem2);

		jMenuBar1.add(jMenu1);

		jMenu2.setText("Tools");

		jMenuItem3.setText("Interactive manager");
		jMenuItem3.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem3MousePressed(evt);
			}
		});
		jMenu2.add(jMenuItem3);

		jMenuBar1.add(jMenu2);

		setJMenuBar(jMenuBar1);

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(
				getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						layout.createSequentialGroup()
								.addContainerGap()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
												.addGroup(
														layout.createSequentialGroup()
																.addComponent(
																		jButton1)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED,
																		95,
																		Short.MAX_VALUE)
																.addComponent(
																		jButton2)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																.addComponent(
																		jButton3))
												.addComponent(
														jScrollPane1,
														javax.swing.GroupLayout.Alignment.TRAILING,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														465, Short.MAX_VALUE))
								.addContainerGap()));
		layout.setVerticalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						layout.createSequentialGroup()
								.addContainerGap()
								.addComponent(jScrollPane1,
										javax.swing.GroupLayout.DEFAULT_SIZE,
										227, Short.MAX_VALUE)
								.addPreferredGap(
										javax.swing.LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.BASELINE)
												.addComponent(jButton1)
												.addComponent(jButton3)
												.addComponent(jButton2))
								.addContainerGap()));

		pack();
	}// </editor-fold>
	//GEN-END:initComponents

	private void formComponentHidden(java.awt.event.ComponentEvent evt) {
		interactiveManagerGui.setVisible(false);
	}

	private void jMenuItem3MousePressed(java.awt.event.MouseEvent evt) {
		interactiveManagerGui.setVisible(true);
	}

	private InteractiveManagerGui getInteractiveManagerGui() {
		return this.interactiveManagerGui;
	}

	private void jMenuItem1MousePressed(java.awt.event.MouseEvent evt) {
		Object[] languages = { "ALL", "Java", "C#" };
		String language = (String) JOptionPane
				.showInputDialog(
						jTextArea1,
						"Choose language for which you want to\ngenerate excluded words definition",
						"Choose language", JOptionPane.PLAIN_MESSAGE, null,
						languages, "Java");
		if (language != null) {
			String excluded_words = (String) JOptionPane
					.showInputDialog(
							jTextArea1,
							"Input excluded words of the definition (comma separated)",
							"Excluded words", JOptionPane.PLAIN_MESSAGE, null,
							null, "");
			if (excluded_words != null) {
				if (excluded_words
						.matches("((\\s)*(\\w)+(\\s)*(,(\\s)*(\\w)+(\\s)*)*)|(\\s)*")) {

					String trimmed_excluded_words = new String();
					for (int count = 0; count < excluded_words.length(); count++) {
						if (excluded_words.substring(count, count + 1).matches(
								"[\\w,]")) {
							trimmed_excluded_words = trimmed_excluded_words
									+ excluded_words
											.substring(count, count + 1);
						}
					}

					ArrayList<String> words = new ArrayList<String>(
							Arrays.asList(trimmed_excluded_words.split(",")));

					String appender = new String();
					appender = appender + "#LANGUAGES = ["
							+ (language.equals("C#") ? "Csharp" : language)
							+ "]\n";
					appender = appender + "#EXCLUDE = {";

					if (trimmed_excluded_words.length() != 0) {
						for (String word : words) {
							appender = appender + "'" + word + "'" + ",";
						}

						appender = appender.substring(0,
								(appender.length() - 1));

					}

					appender = appender + "}\n";

					if (jTextArea1.getText().equals("")) {
						jTextArea1.setText(appender);

					} else {
						int option = JOptionPane.showConfirmDialog(jTextArea1,
								"Clear current excluded words definition", "",
								JOptionPane.YES_NO_CANCEL_OPTION,
								JOptionPane.WARNING_MESSAGE);

						if (option == 0) {
							jTextArea1.setText(appender);
						}

						if (option == 1) {
							jTextArea1.append(appender);
						}

					}
				} else {
					JOptionPane.showMessageDialog(jTextArea1,
							"Wrong excluded words definition");
				}
			}//jj
		}
	}

	private void jMenuItem2MousePressed(java.awt.event.MouseEvent evt) {
		if (jTextArea1.getText().equals("")) {
			jTextArea1.setText(EWM.WriteExcludedWords());
		} else {
			int option = JOptionPane.showConfirmDialog(jTextArea1,
					"Clear current excluded words definition", "",
					JOptionPane.YES_NO_CANCEL_OPTION,
					JOptionPane.WARNING_MESSAGE);

			if (option == 0) {
				jTextArea1.setText(EWM.WriteExcludedWords());
			}

			if (option == 1) {
				jTextArea1.append(EWM.WriteExcludedWords());
			}

		}
	}

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		FileDialog fileDialog = new FileDialog(new Frame(),
				"Read excluded words definition", FileDialog.LOAD);
		fileDialog.setVisible(true);
		if (fileDialog.getFile() != null) {
			File file = new File(
					(fileDialog.getDirectory() + fileDialog.getFile()));
			StringBuffer contents = new StringBuffer();
			BufferedReader reader = null;
			try {
				reader = new BufferedReader(new FileReader(file));
				String text = null;
				while ((text = reader.readLine()) != null) {
					contents.append(text).append(
							System.getProperty("line.separator"));
				}
				if (jTextArea1.getText().equals("")) {
					jTextArea1.setText(contents.toString());
				} else {
					int option = JOptionPane.showConfirmDialog(jTextArea1,
							"Clear current excluded words definition", "",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.WARNING_MESSAGE);
					if (option == 0) {
						jTextArea1.setText(contents.toString());
					}
					if (option == 1) {
						jTextArea1.append(contents.toString());
					}
				}
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				try {
					if (reader != null) {
						reader.close();
					}
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

		}
	}

	private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {

		FileDialog fileDialog = new FileDialog(new Frame(),
				"Save excluded words definition", FileDialog.SAVE);
		fileDialog.setVisible(true);
		File file = new File((fileDialog.getDirectory() + fileDialog.getFile()));
		FileWriter outFile;
		try {
			outFile = new FileWriter(file);
			PrintWriter out = new PrintWriter(outFile);
			out.printf(jTextArea1.getText());
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		if (EWM.checkExcludedWordsDefinition(jTextArea1.getText())) {
			EWM.ReadExcludedWords(jTextArea1.getText());
			JOptionPane.showMessageDialog(jTextArea1,
					"Excluded words from definition added successfully");
			if (excludedWordsDefinition != null) {
				int option = JOptionPane.showConfirmDialog(jTextArea1,
						"Save changes to projects excluded words file", "",
						JOptionPane.YES_NO_OPTION, JOptionPane.PLAIN_MESSAGE);
				if (option == 0) {
					try {
						EWM.WriteExcludedWords(excludedWordsDefinition);
					} catch (Exception E) {

					}
				}
			}
		} else {
			JOptionPane.showMessageDialog(jTextArea1,
					"Wrong excluded words definition");
		}
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new InterfaceManagerGui().setVisible(true);
			}
		});
	}

	//GEN-BEGIN:variables
	// Variables declaration - do not modify
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JButton jButton3;
	private javax.swing.JMenu jMenu1;
	private javax.swing.JMenu jMenu2;
	private javax.swing.JMenuBar jMenuBar1;
	private javax.swing.JMenuItem jMenuItem1;
	private javax.swing.JMenuItem jMenuItem2;
	private javax.swing.JMenuItem jMenuItem3;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JTextArea jTextArea1;
	// End of variables declaration//GEN-END:variables

}