/*
 * MainWindow.java
 *
 * Created on __DATE__, __TIME__
 */

package sk.tuke.bkpi.complexGui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.LinkedList;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.UIManager;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import sk.tuke.bkpi.configReaders.CompilerConfigurationFileReader;
import sk.tuke.bkpi.configReaders.ProjectConfigurationFileReader;
import sk.tuke.bkpi.extensions.AccessPolicyManager;
import sk.tuke.bkpi.extensions.ClassAccessPolicy;
import sk.tuke.bkpi.extensions.ClassModificationPolicy;
import sk.tuke.bkpi.extensions.CompiledImplementationManager;
import sk.tuke.bkpi.extensions.ExcludedWordsManager;
import sk.tuke.bkpi.extensions.ModificationPolicyManager;
import sk.tuke.bkpi.generator.CsCodeGenerationException;
import sk.tuke.bkpi.generator.CsGenerator;
import sk.tuke.bkpi.generator.JavaCodeGenerationException;
import sk.tuke.bkpi.generator.JavaGenerator;
import sk.tuke.bkpi.gui.GraphvizVisualization;
import sk.tuke.bkpi.gui.HtmlConsole;
import sk.tuke.bkpi.gui.HtmlConsoleAppender;
import sk.tuke.bkpi.gui.ImagePanel;
import sk.tuke.bkpi.model.Module;
import sk.tuke.bkpi.model.Project;
import sk.tuke.bkpi.parser.ProjectParseException;
import sk.tuke.bkpi.parser.ProjectParser;

/**
 *
 * @author  __USER__
 */
public class MainWindow extends javax.swing.JFrame {
	
	private TreePath doubleClickedPath;
	private int doubleClickClock = 500;
	private long recentClick = 0;
	
	private String defaultTextEditor = null;

	// Components BEGIN

	InterfaceManagerGui IEWM = new InterfaceManagerGui();
	InteractiveCompiledImplementationsManager ICIM = new InteractiveCompiledImplementationsManager();
	InterfaceModificationPolicyManager IMPM = new InterfaceModificationPolicyManager();
	InterfaceAccessPolicyManager IAPM = new InterfaceAccessPolicyManager();
	Projectconfg projectconf = new Projectconfg();
	CompilerConfig compilerConfig = new CompilerConfig();

	// Components END

	// Component interaction BEGIN

	ExcludedWordsManager excludedWordsManager = new ExcludedWordsManager();
	CompiledImplementationManager compiledImplementationManager = new CompiledImplementationManager();
	ModificationPolicyManager modificationPolicyManager = new ModificationPolicyManager();
	AccessPolicyManager accessPolicyManager = new AccessPolicyManager();

	// Component interaction END

	private File projectsDirectory = null;
	private File projectDirectory = null;

	static {

	
		
		
		
		sk.tuke.bkpi.logging.Logger.configure("log4j.properties");
	}

	private static Logger logger = sk.tuke.bkpi.logging.Logger
			.getLogger(MainWindow.class);

	LinkedList<String> recentProjectsList = new LinkedList<String>();

	private CompilerConfigurationFileReader compilerConfigurationFileReader = new CompilerConfigurationFileReader();

	private DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode(
			"B projects");

	private String selectedProject = null;

	private String javaCodeDirectory = "java";
	private String csharpCodeDirectory = "c#";
	private String configFileName = "config.ini";

	private class bProjectSignature {
		public String projectName;
		public ArrayList<String> machines = new ArrayList<String>();
		public ArrayList<String> refinements = new ArrayList<String>();
		public ArrayList<String> implementations = new ArrayList<String>();

		public ArrayList<String> generatedJavaClasses = new ArrayList<String>();
		public ArrayList<String> generatedCsharpClasses = new ArrayList<String>();

		public String configFile = new String();

		public String toString() {
			return projectName;
		}

		public boolean equals(Object O) {
			if (O instanceof bProjectSignature) {
				bProjectSignature S = (bProjectSignature) O;
				if (S.projectName.equals(this.projectName)) {
					return true;
				} else {
					return false;
				}
			} else {
				return false;
			}
		}

	}

	public void RefreshRecentProjectsComboBox() {
		DefaultComboBoxModel DCBM = new DefaultComboBoxModel();
		for (String recentProject : recentProjectsList) {
			DCBM.addElement(new String(recentProject));
		}
		recentProjectsComboBox.setModel(DCBM);
	}

	MouseAdapter InternalML = null;

	public void RefreshProjectBrowser() {
		ArrayList<bProjectSignature> bProjectSignatures = new ArrayList<bProjectSignature>();
		if (this.projectsDirectory.exists()) {
			DefaultMutableTreeNode IrootNode = new DefaultMutableTreeNode(
					"B projects");

			DefaultTreeModel defaultTreeModel = new DefaultTreeModel(
					this.rootNode);
			projectDirectoryTree.setModel(defaultTreeModel);

			try {
				File[] bProjects = this.projectsDirectory.listFiles();

				for (File bProject : bProjects) {
					if (bProject.isDirectory()) {
						//DEBUG Virtual folders
						//System.out.println("Working on: " + bProject.getName()); 

						bProjectSignature BPS = new bProjectSignature();
						BPS.projectName = bProject.getName();

						File[] bProjectElements = bProject.listFiles();

						for (File bProjectElement : bProjectElements) {

							if (bProjectElement.isFile()) {
								if (bProjectElement.getName().endsWith(".mch")) {
									if (bProjectElement
											.getName()
											.substring(
													0,
													bProjectElement.getName()
															.length() /*- 4*/)
											.length() > 0) {
										BPS.machines.add(bProjectElement
												.getName().substring(
														0,
														bProjectElement
																.getName()
																.length() /*- 4*/));
									}
								}

								if (bProjectElement.getName().endsWith(".ref")) {
									if (bProjectElement
											.getName()
											.substring(
													0,
													bProjectElement.getName()
															.length() /*- 4*/)
											.length() > 0) {
										BPS.refinements.add(bProjectElement
												.getName().substring(
														0,
														bProjectElement
																.getName()
																.length() /*- 4*/));
									}
								}

								if (bProjectElement.getName().endsWith(".imp")) {
									if (bProjectElement
											.getName()
											.substring(
													0,
													bProjectElement.getName()
															.length() /*- 4*/)
											.length() > 0) {
										BPS.implementations.add(bProjectElement
												.getName().substring(
														0,
														bProjectElement
																.getName()
																.length() /*- 4*/));
									}
								}

								if (bProjectElement.getName().equals(
										configFileName)) {
									if (bProjectElement
											.getName()
											.substring(
													0,
													bProjectElement.getName()
															.length() /*- 4*/)
											.length() > 0) {
										BPS.configFile = bProjectElement
												.getName().substring(
														0,
														bProjectElement
																.getName()
																.length() /*- 4*/);
									}
								}
							} else {
								if (bProjectElement.getName().equals(
										this.javaCodeDirectory)) {
									File[] generatedJavaClasses = bProjectElement
											.listFiles();
									for (File generatedJavaClass : generatedJavaClasses) {
										if (generatedJavaClass.isFile()) {
											if (generatedJavaClass.getName()
													.endsWith(".java")
													&& generatedJavaClass
															.getName().length() > 5) {
												BPS.generatedJavaClasses
														.add(generatedJavaClass
																.getName()
																.substring(
																		0,
																		generatedJavaClass
																				.getName()
																				.length() /*- 5*/));
											}
										}
									}

								}

								if (bProjectElement.getName().equals(
										this.csharpCodeDirectory)) {
									File[] generatedCsharpClasses = bProjectElement
											.listFiles();
									for (File generatedCsharpClass : generatedCsharpClasses) {
										if (generatedCsharpClass.isFile()) {
											if (generatedCsharpClass.getName()
													.endsWith(".cs")
													&& generatedCsharpClass
															.getName().length() > 3) {
												BPS.generatedCsharpClasses
														.add(generatedCsharpClass
																.getName()
																.substring(
																		0,
																		generatedCsharpClass
																				.getName()
																				.length() /*- 3*/));
											}
										}
									}
								}

							}
						}
						bProjectSignatures.add(BPS);
					}
				}

				for (bProjectSignature BPS : bProjectSignatures) {
					if (BPS.machines.size() > 0 || BPS.refinements.size() > 0
							|| BPS.implementations.size() > 0
							|| BPS.generatedJavaClasses.size() > 0
							|| BPS.generatedCsharpClasses.size() > 0
							|| BPS.configFile.length() > 0) {
						DefaultMutableTreeNode BPSNode = new DefaultMutableTreeNode(
								BPS);

						if (BPS.generatedJavaClasses.size() > 0) {
							DefaultMutableTreeNode javaCodeNode = new DefaultMutableTreeNode(
									"Java code");
							for (String generatedJavaClass : BPS.generatedJavaClasses) {
								DefaultMutableTreeNode javaClassNode = new DefaultMutableTreeNode(
										generatedJavaClass);
								javaCodeNode.add(javaClassNode);
							}
							BPSNode.add(javaCodeNode);
						}

						if (BPS.generatedCsharpClasses.size() > 0) {
							DefaultMutableTreeNode csCodeNode = new DefaultMutableTreeNode(
									"C# code");
							for (String generatedCsClass : BPS.generatedCsharpClasses) {
								DefaultMutableTreeNode csClassNode = new DefaultMutableTreeNode(
										generatedCsClass);
								csCodeNode.add(csClassNode);
							}
							BPSNode.add(csCodeNode);
						}

						for (String machineName : BPS.machines) {
							DefaultMutableTreeNode machineNode = new DefaultMutableTreeNode(
									machineName);
							BPSNode.add(machineNode);
						}

						for (String refinementName : BPS.refinements) {
							DefaultMutableTreeNode refinementNode = new DefaultMutableTreeNode(
									refinementName);
							BPSNode.add(refinementNode);
						}

						for (String implementationName : BPS.implementations) {
							DefaultMutableTreeNode implementationNode = new DefaultMutableTreeNode(
									implementationName);
							BPSNode.add(implementationNode);
						}

						if (BPS.configFile.length() > 0) {
							DefaultMutableTreeNode configFileNode = new DefaultMutableTreeNode(
									BPS.configFile);
							BPSNode.add(configFileNode);
						}

						IrootNode.add(BPSNode);
					}
				}

				DefaultTreeModel IdefaultTreeModel = new DefaultTreeModel(
						IrootNode);
				this.projectDirectoryTree.setModel(IdefaultTreeModel);
				if (InternalML != null) {
					this.projectDirectoryTree.removeMouseListener(InternalML);
				}
				this.projectDirectoryTree
						.addMouseListener(InternalML = new MouseAdapter() {
							public void mousePressed(MouseEvent me) {
								
								if (me.getButton() == 1)
								{
									//
									TreePath pressedNode = projectDirectoryTree.getPathForLocation(me.getX(), me.getY());
									if (pressedNode != null)
									{
									   DefaultMutableTreeNode DMTN = (DefaultMutableTreeNode) pressedNode.getLastPathComponent();
									   if (DMTN.isLeaf())
									   {
										   if (doubleClickedPath != null)
										   {
											   if ((recentClick > 0) && (me.getWhen() - recentClick < doubleClickClock) && doubleClickedPath.getLastPathComponent().equals(pressedNode.getLastPathComponent()))
											   {/*
												   System.out.println("Double clicked");
												   
												   System.out.println(pressedNode.getParentPath().getLastPathComponent());
												   System.out.println(pressedNode);
												   */
												   if (pressedNode.getPathCount() == 3)
												   {
													  // System.out.println(projectsDirectory.getAbsolutePath() + "\\" +pressedNode.getParentPath().getLastPathComponent() +"\\" +pressedNode.getLastPathComponent());
													   openFile(projectsDirectory.getAbsolutePath() + "\\" +pressedNode.getParentPath().getLastPathComponent() +"\\" +pressedNode.getLastPathComponent());
													   //openFile("");
												   }
												   if (pressedNode.getPathCount() == 4)
												   {

													   if (pressedNode.getParentPath().getLastPathComponent().toString().equals("Java code"))
													   {
														   openFile (projectsDirectory.getAbsolutePath()+ "\\"+ pressedNode.getParentPath().getParentPath().getLastPathComponent() + "\\" + "java" + "\\" + pressedNode.getLastPathComponent());
													   }
													   
													   if (pressedNode.getParentPath().getLastPathComponent().toString().equals("C# code"))
													   {
														   openFile (projectsDirectory.getAbsolutePath()+ "\\"+ pressedNode.getParentPath().getParentPath().getLastPathComponent() + "\\" + "c#" + "\\" + pressedNode.getLastPathComponent());
													   }
												   }
												   
												   recentClick = me.getWhen();
											   }
											   else
											   {
												   doubleClickedPath = pressedNode;
												   recentClick = me.getWhen();
											   }
											   
										   }
										   else
										   {
											   doubleClickedPath = pressedNode;
											   recentClick = me.getWhen();
										   }
										   
									   }
									   else
									   {
										   doubleClickedPath = null;
										   recentClick = 0;
									   }

									}
									else
									{
										doubleClickedPath = null;
										recentClick = 0;
									}
								}
								
								if (me.getButton() == 3) {
									TreePath pressedNode = projectDirectoryTree
											.getPathForLocation(me.getX(),
													me.getY());
									popupMenuForNode = pressedNode;
									if (pressedNode != null) {
										if (pressedNode.getPathCount() == 2) {

											if (selectedProject == null) { ////

												bProjectPopupMenu.removeAll();
												//System.out.println(bProjectPopupMenu.getComponentCount());

												JMenuItem selectProject = new JMenuItem(
														"Select project");
												selectProject
														.addMouseListener(new MouseAdapter() {

															public void mousePressed(
																	MouseEvent me) {
																projectDirectory = new File(
																		projectsDirectory
																				.getAbsolutePath()
																				+ "/"
																				+ popupMenuForNode
																						.getLastPathComponent()
																						.toString());
																selectedProject = popupMenuForNode
																		.getLastPathComponent()
																		.toString();

																projectconf
																		.setConfigurationFile(new File(
																				projectDirectory
																						.getAbsolutePath()
																						+ "/"
																						+ configFileName));

																projectconf
																		.refreshProjectconfg();

																jButton1.setEnabled(true);
																jButton2.setEnabled(true);
																jMenuItem1
																		.setEnabled(true);
																jMenuItem2
																		.setEnabled(true);
																jMenuItem3
																		.setEnabled(true);
																jMenuItem4
																		.setEnabled(true);
																jMenuItem7
																		.setEnabled(true);
																jMenuItem8
																		.setEnabled(true);

																if (new File(
																		projectDirectory
																				.getAbsolutePath()
																				+ "/"
																				+ configFileName)
																		.exists()) {
																	ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																	if (PCFR.ReadConfigurationFile(new File(
																			projectDirectory
																					.getAbsolutePath()
																					+ "/"
																					+ configFileName))) {

																		if (PCFR.getModificationPolicy()
																				.length() > 0) {
																			if (new File(
																					PCFR.getModificationPolicy())
																					.exists()) {
																				if (modificationPolicyManager
																						.CheckMachineDuplicationError(new File(
																								PCFR.getModificationPolicy()))) {
																					modificationPolicyManager = new ModificationPolicyManager();
																					modificationPolicyManager
																							.ReadModificationPolicy(new File(
																									PCFR.getModificationPolicy()));
																					IMPM.setModificationPolicyManager(modificationPolicyManager);
																				} else {
																					logger.debug("\nWrong modification policy definition file\n");
																					modificationPolicyManager = new ModificationPolicyManager();
																					IMPM.setModificationPolicyManager(modificationPolicyManager);
																				}

																			} else {
																				logger.debug("\nFile containing modification policy definition does not exist file\n");
																				modificationPolicyManager = new ModificationPolicyManager();
																				IMPM.setModificationPolicyManager(modificationPolicyManager);
																			}

																		} else {
																			modificationPolicyManager = new ModificationPolicyManager();
																			IMPM.setModificationPolicyManager(modificationPolicyManager);
																		}

																		if (PCFR.getAccessPolicy()
																				.length() > 0) {
																			if (new File(
																					PCFR.getAccessPolicy())
																					.exists()) {
																				if (accessPolicyManager
																						.CheckMachineDuplicationError(new File(
																								PCFR.getAccessPolicy()))) {
																					accessPolicyManager = new AccessPolicyManager();
																					accessPolicyManager
																							.ReadAccessPolicy(new File(
																									PCFR.getAccessPolicy()));
																					IAPM.setAccessPolicy(accessPolicyManager);
																				} else {
																					logger.debug("\nWrong access policy definition file\n");
																					accessPolicyManager = new AccessPolicyManager();
																					IAPM.setAccessPolicy(accessPolicyManager);
																				}

																			} else {
																				logger.debug("\nFile containing modification policy definition does not exist file\n");
																				accessPolicyManager = new AccessPolicyManager();
																				IAPM.setAccessPolicy(accessPolicyManager);
																			}

																		} else {
																			accessPolicyManager = new AccessPolicyManager();
																			IAPM.setAccessPolicy(accessPolicyManager);
																		}

																		if (PCFR.getCompiledImplementations()
																				.length() > 0) {
																			if (new File(
																					PCFR.getCompiledImplementations())
																					.exists()) {
																				if (compiledImplementationManager
																						.CheckMIPairDuplicationError(new File(
																								PCFR.getCompiledImplementations()))) {
																					compiledImplementationManager = new CompiledImplementationManager();
																					compiledImplementationManager
																							.ReadMIPairDefinition(new File(
																									PCFR.getCompiledImplementations()));
																					ICIM.setCompiledImplementationsManager(compiledImplementationManager);

																				} else {
																					logger.debug("Wrong compiled implementations definition file");
																					compiledImplementationManager = new CompiledImplementationManager();
																					ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																				}

																			} else {
																				logger.debug("\nFile containing compiled implementations definition does not exist\n");
																				compiledImplementationManager = new CompiledImplementationManager();
																				ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																			}
																		} else {
																			compiledImplementationManager = new CompiledImplementationManager();
																			ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																		}

																		if (PCFR.getExcludedWords()
																				.length() > 0) {
																			if (new File(
																					PCFR.getExcludedWords())
																					.exists()) {
																				if (excludedWordsManager
																						.checkExcludedWordsDefinition(new File(
																								PCFR.getExcludedWords()))) {
																					excludedWordsManager = new ExcludedWordsManager();
																					excludedWordsManager
																							.ReadExcludedWords(new File(
																									PCFR.getExcludedWords()));
																					IEWM.SetExcludedWordsmanager(excludedWordsManager);
																					IEWM.SetExcludedWordsFile(new File(
																							PCFR.getExcludedWords()));
																				} else {
																					logger.debug("\nWrong excluded words definition file\n");
																					excludedWordsManager = new ExcludedWordsManager();
																					IEWM.SetExcludedWordsmanager(excludedWordsManager);
																					IEWM.SetExcludedWordsFile(null);

																				}
																			} else {
																				logger.debug("\nFile containing excluded words definition does not exist\n");
																				excludedWordsManager = new ExcludedWordsManager();
																				IEWM.SetExcludedWordsmanager(excludedWordsManager);
																				IEWM.SetExcludedWordsFile(null);
																			}

																		} else {
																			excludedWordsManager = new ExcludedWordsManager();
																			IEWM.SetExcludedWordsmanager(excludedWordsManager);
																			IEWM.SetExcludedWordsFile(null);
																		}
																	} else {
																		logger.debug("\nWrong configuration file definition\n");
																		excludedWordsManager = new ExcludedWordsManager();
																		IEWM.SetExcludedWordsmanager(excludedWordsManager);
																		IEWM.SetExcludedWordsFile(null);
																		compiledImplementationManager = new CompiledImplementationManager();
																		ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																		accessPolicyManager = new AccessPolicyManager();
																		IAPM.setAccessPolicy(accessPolicyManager);
																		modificationPolicyManager = new ModificationPolicyManager();
																		IMPM.setModificationPolicyManager(modificationPolicyManager);
																	}
																} else {
																	excludedWordsManager = new ExcludedWordsManager();
																	IEWM.SetExcludedWordsmanager(excludedWordsManager);
																	IEWM.SetExcludedWordsFile(null);
																	compiledImplementationManager = new CompiledImplementationManager();
																	ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																	accessPolicyManager = new AccessPolicyManager();
																	IAPM.setAccessPolicy(accessPolicyManager);
																	modificationPolicyManager = new ModificationPolicyManager();
																	IMPM.setModificationPolicyManager(modificationPolicyManager);
																}

																if (!recentProjectsList
																		.contains(popupMenuForNode
																				.getLastPathComponent()
																				.toString())) {
																	recentProjectsList
																			.addFirst(popupMenuForNode
																					.getLastPathComponent()
																					.toString());
																	RefreshRecentProjectsComboBox();
																} else {
																	recentProjectsList
																			.remove(popupMenuForNode
																					.getLastPathComponent()
																					.toString());
																	recentProjectsList
																			.addFirst(popupMenuForNode
																					.getLastPathComponent()
																					.toString());
																	RefreshRecentProjectsComboBox();
																}
															}
														});

												bProjectPopupMenu
														.add(selectProject);
												JMenuItem generateJavaCode = new JMenuItem(
														"Generate Java code");
												generateJavaCode
														.addMouseListener(new MouseAdapter() {

															public void mousePressed(
																	MouseEvent me) {
																File generatedProjectDirectory = new File(
																		projectsDirectory
																				.getAbsolutePath()
																				+ "/"
																				+ popupMenuForNode
																						.getLastPathComponent()
																						.toString());
																try {

																	File[] generatedProjectFiles = generatedProjectDirectory
																			.listFiles();

																	boolean containsConfigurationFile = false;
																	for (File generatedProjectFile : generatedProjectFiles) {
																		if (generatedProjectFile
																				.isFile()
																				&& generatedProjectFile
																						.getName()
																						.equals(configFileName)) {
																			containsConfigurationFile = true;
																		}
																	}

																	if (containsConfigurationFile) {
																		File configurationFile = new File(
																				generatedProjectDirectory
																						.getAbsolutePath()
																						+ "/"
																						+ configFileName);
																		ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																		if (PCFR.ReadConfigurationFile(configurationFile)) {
																			CompiledImplementationManager CIM = new CompiledImplementationManager();
																			if (PCFR.getCompiledImplementations()
																					.length() > 0) {
																				if (new File(
																						PCFR.getCompiledImplementations())
																						.exists()) {
																					if (CIM.CheckMIPairDuplicationError(new File(
																							PCFR.getCompiledImplementations()))) {
																						CIM.ReadMIPairDefinition(new File(
																								PCFR.getCompiledImplementations()));
																					} else {
																						logger.debug("\nWrong compiled implementations definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing compiled implementations definition does not exist\n");
																				}
																			}

																			ExcludedWordsManager EWM = new ExcludedWordsManager();
																			if (PCFR.getExcludedWords()
																					.length() > 0) {
																				if (new File(
																						PCFR.getExcludedWords())
																						.exists()) {
																					if (EWM.checkExcludedWordsDefinition(new File(
																							PCFR.getExcludedWords()))) {
																						EWM.ReadExcludedWords(new File(
																								PCFR.getExcludedWords()));
																					} else {
																						logger.debug("\nWrong excluded words definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing excluded words definition does not exist\n");
																				}
																			}

																			ModificationPolicyManager MPM = new ModificationPolicyManager();
																			if (PCFR.getModificationPolicy()
																					.length() > 0) {
																				if (new File(
																						PCFR.getModificationPolicy())
																						.exists()) {
																					if (MPM.CheckMachineDuplicationError(new File(
																							PCFR.getModificationPolicy()))) {
																						MPM.ReadModificationPolicy(new File(
																								PCFR.getModificationPolicy()));
																					} else {
																						logger.debug("\nWrong modification policy definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing modification policy definition does not exist\n");
																				}
																			}

																			AccessPolicyManager APM = new AccessPolicyManager();
																			if (PCFR.getAccessPolicy()
																					.length() > 0) {
																				if (new File(
																						PCFR.getAccessPolicy())
																						.exists()) {
																					if (APM.CheckMachineDuplicationError(new File(
																							PCFR.getAccessPolicy()))) {
																						APM.ReadAccessPolicy(new File(
																								PCFR.getAccessPolicy()));
																					} else {
																						logger.debug("\nWrong access policy definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing access policy definition does not exist\n");
																				}
																			}
																			parseProjectAsynchronously(
																					"Java",
																					generatedProjectDirectory,
																					CIM.AllMachineImplementationPairs("Java"),
																					EWM.getExcludedWords("Java"),
																					MPM.getLanguageModificationPolicy("Java"),
																					APM.getAccessPolicy("Java"));
																		} else {
																			logger.debug("\nWrong project configuration file definition\n");
																			parseProjectAsynchronously(
																					"Java",
																					generatedProjectDirectory,
																					new CompiledImplementationManager()
																							.AllMachineImplementationPairs("Java"),
																					new ExcludedWordsManager()
																							.getExcludedWords("Java"),
																					new ModificationPolicyManager()
																							.getLanguageModificationPolicy("Java"),
																					new AccessPolicyManager()
																							.getAccessPolicy("Java"));
																		}
																	} else {
																		parseProjectAsynchronously(
																				"Java",
																				generatedProjectDirectory,
																				new CompiledImplementationManager()
																						.AllMachineImplementationPairs("Java"),
																				new ExcludedWordsManager()
																						.getExcludedWords("Java"),
																				new ModificationPolicyManager()
																						.getLanguageModificationPolicy("Java"),
																				new AccessPolicyManager()
																						.getAccessPolicy("Java"));
																	}

																} catch (Exception e) {
																	System.out
																			.println(e
																					.getStackTrace());
																}
															}
														});
												bProjectPopupMenu
														.add(generateJavaCode);
												JMenuItem generateCsharpCode = new JMenuItem(
														"Generate C# code");

												//

												generateCsharpCode
														.addMouseListener(new MouseAdapter() {

															public void mousePressed(
																	MouseEvent me) {
																File generatedProjectDirectory = new File(
																		projectsDirectory
																				.getAbsolutePath()
																				+ "/"
																				+ popupMenuForNode
																						.getLastPathComponent()
																						.toString());
																try {

																	File[] generatedProjectFiles = generatedProjectDirectory
																			.listFiles();

																	boolean containsConfigurationFile = false;
																	for (File generatedProjectFile : generatedProjectFiles) {
																		if (generatedProjectFile
																				.isFile()
																				&& generatedProjectFile
																						.getName()
																						.equals(configFileName)) {
																			containsConfigurationFile = true;
																		}
																	}

																	if (containsConfigurationFile) {
																		File configurationFile = new File(
																				generatedProjectDirectory
																						.getAbsolutePath()
																						+ "/"
																						+ configFileName);
																		ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																		if (PCFR.ReadConfigurationFile(configurationFile)) {
																			CompiledImplementationManager CIM = new CompiledImplementationManager();
																			if (PCFR.getCompiledImplementations()
																					.length() > 0) {
																				if (new File(
																						PCFR.getCompiledImplementations())
																						.exists()) {
																					if (CIM.CheckMIPairDuplicationError(new File(
																							PCFR.getCompiledImplementations()))) {
																						CIM.ReadMIPairDefinition(new File(
																								PCFR.getCompiledImplementations()));
																					} else {
																						logger.debug("\nWrong compiled implementations definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing compiled implementations definition does not exist\n");
																				}
																			}

																			ExcludedWordsManager EWM = new ExcludedWordsManager();
																			if (PCFR.getExcludedWords()
																					.length() > 0) {
																				if (new File(
																						PCFR.getExcludedWords())
																						.exists()) {
																					if (EWM.checkExcludedWordsDefinition(new File(
																							PCFR.getExcludedWords()))) {
																						EWM.ReadExcludedWords(new File(
																								PCFR.getExcludedWords()));
																					} else {
																						logger.debug("\nWrong excluded words definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing excluded words definition does not exist\n");
																				}
																			}

																			ModificationPolicyManager MPM = new ModificationPolicyManager();
																			if (PCFR.getModificationPolicy()
																					.length() > 0) {
																				if (new File(
																						PCFR.getModificationPolicy())
																						.exists()) {
																					if (MPM.CheckMachineDuplicationError(new File(
																							PCFR.getModificationPolicy()))) {
																						MPM.ReadModificationPolicy(new File(
																								PCFR.getModificationPolicy()));
																					} else {
																						logger.debug("\nWrong modification policy definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing modification policy definition does not exist\n");
																				}
																			}

																			AccessPolicyManager APM = new AccessPolicyManager();
																			if (PCFR.getAccessPolicy()
																					.length() > 0) {
																				if (new File(
																						PCFR.getAccessPolicy())
																						.exists()) {
																					if (APM.CheckMachineDuplicationError(new File(
																							PCFR.getAccessPolicy()))) {
																						APM.ReadAccessPolicy(new File(
																								PCFR.getAccessPolicy()));
																					} else {
																						logger.debug("\nWrong access policy definition file\n");
																					}
																				} else {
																					logger.debug("\nFile containing access policy definition does not exist\n");
																				}
																			}
																			parseProjectAsynchronously(
																					"Csharp",
																					generatedProjectDirectory,
																					CIM.AllMachineImplementationPairs("Csharp"),
																					EWM.getExcludedWords("Csharp"),
																					MPM.getLanguageModificationPolicy("Csharp"),
																					APM.getAccessPolicy("Csharp"));
																		} else {
																			logger.debug("\nWrong project configuration file definition\n");
																			parseProjectAsynchronously(
																					"Csharp",
																					generatedProjectDirectory,
																					new CompiledImplementationManager()
																							.AllMachineImplementationPairs("Csharp"),
																					new ExcludedWordsManager()
																							.getExcludedWords("Csharp"),
																					new ModificationPolicyManager()
																							.getLanguageModificationPolicy("Csharp"),
																					new AccessPolicyManager()
																							.getAccessPolicy("Csharp"));
																		}
																	} else {
																		parseProjectAsynchronously(
																				"Csharp",
																				generatedProjectDirectory,
																				new CompiledImplementationManager()
																						.AllMachineImplementationPairs("Csharp"),
																				new ExcludedWordsManager()
																						.getExcludedWords("Csharp"),
																				new ModificationPolicyManager()
																						.getLanguageModificationPolicy("Csharp"),
																				new AccessPolicyManager()
																						.getAccessPolicy("Csharp"));
																	}
																} catch (Exception e) {
																	System.out
																			.println(e
																					.getStackTrace());
																}
															}
														});

												//
												bProjectPopupMenu
														.add(generateCsharpCode);

												/*
												bProjectPopupMenu.addMouseListener(new MouseAdapter(){
													public void mousePressed(MouseEvent me)
													{
														System.out.println(popupMenuForNode);
													}
												});*/

												bProjectPopupMenu.show(
														projectDirectoryTree,
														me.getX(), me.getY());

											} else {
												if (pressedNode
														.getLastPathComponent()
														.toString()
														.equals(selectedProject)) {
													///

													bProjectPopupMenu
															.removeAll();
													//System.out.println(bProjectPopupMenu.getComponentCount());

													JMenuItem selectProject = new JMenuItem(
															"Deselect project");
													selectProject
															.addMouseListener(new MouseAdapter() {

																public void mousePressed(
																		MouseEvent me) {
																	recentProjectsComboBox
																			.setSelectedItem(null);
																	jButton1.setEnabled(false);
																	jButton2.setEnabled(false);
																	jMenuItem1
																			.setEnabled(false);
																	jMenuItem2
																			.setEnabled(false);
																	jMenuItem3
																			.setEnabled(false);
																	jMenuItem4
																			.setEnabled(false);
																	jMenuItem7
																			.setEnabled(false);
																	jMenuItem8
																			.setEnabled(false);
																	projectDirectory = null;
																	selectedProject = null;
																}
															});

													bProjectPopupMenu
															.add(selectProject);
													JMenuItem generateJavaCode = new JMenuItem(
															"Generate Java code");
													generateJavaCode
															.addMouseListener(new MouseAdapter() {

																public void mousePressed(
																		MouseEvent me) {
																	File generatedProjectDirectory = new File(
																			projectsDirectory
																					.getAbsolutePath()
																					+ "/"
																					+ popupMenuForNode
																							.getLastPathComponent()
																							.toString());
																	try {

																		File[] generatedProjectFiles = generatedProjectDirectory
																				.listFiles();

																		boolean containsConfigurationFile = false;
																		for (File generatedProjectFile : generatedProjectFiles) {
																			if (generatedProjectFile
																					.isFile()
																					&& generatedProjectFile
																							.getName()
																							.equals(configFileName)) {
																				containsConfigurationFile = true;
																			}
																		}

																		if (containsConfigurationFile) {
																			File configurationFile = new File(
																					generatedProjectDirectory
																							.getAbsolutePath()
																							+ "/"
																							+ configFileName);
																			ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																			if (PCFR.ReadConfigurationFile(configurationFile)) {
																				CompiledImplementationManager CIM = new CompiledImplementationManager();
																				if (PCFR.getCompiledImplementations()
																						.length() > 0) {
																					if (new File(
																							PCFR.getCompiledImplementations())
																							.exists()) {
																						if (CIM.CheckMIPairDuplicationError(new File(
																								PCFR.getCompiledImplementations()))) {
																							CIM.ReadMIPairDefinition(new File(
																									PCFR.getCompiledImplementations()));
																						} else {
																							logger.debug("\nWrong compiled implementations definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing compiled implementations definition does not exist\n");
																					}
																				}

																				ExcludedWordsManager EWM = new ExcludedWordsManager();
																				if (PCFR.getExcludedWords()
																						.length() > 0) {
																					if (new File(
																							PCFR.getExcludedWords())
																							.exists()) {
																						if (EWM.checkExcludedWordsDefinition(new File(
																								PCFR.getExcludedWords()))) {
																							EWM.ReadExcludedWords(new File(
																									PCFR.getExcludedWords()));
																						} else {
																							logger.debug("\nWrong excluded words definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing excluded words definition does not exist\n");
																					}
																				}

																				ModificationPolicyManager MPM = new ModificationPolicyManager();
																				if (PCFR.getModificationPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getModificationPolicy())
																							.exists()) {
																						if (MPM.CheckMachineDuplicationError(new File(
																								PCFR.getModificationPolicy()))) {
																							MPM.ReadModificationPolicy(new File(
																									PCFR.getModificationPolicy()));
																						} else {
																							logger.debug("\nWrong modification policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing modification policy definition does not exist\n");
																					}
																				}

																				AccessPolicyManager APM = new AccessPolicyManager();
																				if (PCFR.getAccessPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getAccessPolicy())
																							.exists()) {
																						if (APM.CheckMachineDuplicationError(new File(
																								PCFR.getAccessPolicy()))) {
																							APM.ReadAccessPolicy(new File(
																									PCFR.getAccessPolicy()));
																						} else {
																							logger.debug("\nWrong access policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing access policy definition does not exist\n");
																					}
																				}
																				parseProjectAsynchronously(
																						"Java",
																						generatedProjectDirectory,
																						CIM.AllMachineImplementationPairs("Java"),
																						EWM.getExcludedWords("Java"),
																						MPM.getLanguageModificationPolicy("Java"),
																						APM.getAccessPolicy("Java"));
																			} else {
																				logger.debug("\nWrong project configuration file definition\n");
																				parseProjectAsynchronously(
																						"Java",
																						generatedProjectDirectory,
																						new CompiledImplementationManager()
																								.AllMachineImplementationPairs("Java"),
																						new ExcludedWordsManager()
																								.getExcludedWords("Java"),
																						new ModificationPolicyManager()
																								.getLanguageModificationPolicy("Java"),
																						new AccessPolicyManager()
																								.getAccessPolicy("Java"));
																			}
																		} else {
																			parseProjectAsynchronously(
																					"Java",
																					generatedProjectDirectory,
																					new CompiledImplementationManager()
																							.AllMachineImplementationPairs("Java"),
																					new ExcludedWordsManager()
																							.getExcludedWords("Java"),
																					new ModificationPolicyManager()
																							.getLanguageModificationPolicy("Java"),
																					new AccessPolicyManager()
																							.getAccessPolicy("Java"));
																		}

																	} catch (Exception e) {
																		System.out
																				.println(e
																						.getStackTrace());
																	}
																}
															});
													bProjectPopupMenu
															.add(generateJavaCode);
													JMenuItem generateCsharpCode = new JMenuItem(
															"Generate C# code");

													//

													generateCsharpCode
															.addMouseListener(new MouseAdapter() {

																public void mousePressed(
																		MouseEvent me) {
																	File generatedProjectDirectory = new File(
																			projectsDirectory
																					.getAbsolutePath()
																					+ "/"
																					+ popupMenuForNode
																							.getLastPathComponent()
																							.toString());
																	try {

																		File[] generatedProjectFiles = generatedProjectDirectory
																				.listFiles();

																		boolean containsConfigurationFile = false;
																		for (File generatedProjectFile : generatedProjectFiles) {
																			if (generatedProjectFile
																					.isFile()
																					&& generatedProjectFile
																							.getName()
																							.equals(configFileName)) {
																				containsConfigurationFile = true;
																			}
																		}

																		if (containsConfigurationFile) {
																			File configurationFile = new File(
																					generatedProjectDirectory
																							.getAbsolutePath()
																							+ "/"
																							+ configFileName);
																			ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																			if (PCFR.ReadConfigurationFile(configurationFile)) {
																				CompiledImplementationManager CIM = new CompiledImplementationManager();
																				if (PCFR.getCompiledImplementations()
																						.length() > 0) {
																					if (new File(
																							PCFR.getCompiledImplementations())
																							.exists()) {
																						if (CIM.CheckMIPairDuplicationError(new File(
																								PCFR.getCompiledImplementations()))) {
																							CIM.ReadMIPairDefinition(new File(
																									PCFR.getCompiledImplementations()));
																						} else {
																							logger.debug("\nWrong compiled implementations definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing compiled implementations definition does not exist\n");
																					}
																				}

																				ExcludedWordsManager EWM = new ExcludedWordsManager();
																				if (PCFR.getExcludedWords()
																						.length() > 0) {
																					if (new File(
																							PCFR.getExcludedWords())
																							.exists()) {
																						if (EWM.checkExcludedWordsDefinition(new File(
																								PCFR.getExcludedWords()))) {
																							EWM.ReadExcludedWords(new File(
																									PCFR.getExcludedWords()));
																						} else {
																							logger.debug("\nWrong excluded words definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing excluded words definition does not exist\n");
																					}
																				}

																				ModificationPolicyManager MPM = new ModificationPolicyManager();
																				if (PCFR.getModificationPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getModificationPolicy())
																							.exists()) {
																						if (MPM.CheckMachineDuplicationError(new File(
																								PCFR.getModificationPolicy()))) {
																							MPM.ReadModificationPolicy(new File(
																									PCFR.getModificationPolicy()));
																						} else {
																							logger.debug("\nWrong modification policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing modification policy definition does not exist\n");
																					}
																				}

																				AccessPolicyManager APM = new AccessPolicyManager();
																				if (PCFR.getAccessPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getAccessPolicy())
																							.exists()) {
																						if (APM.CheckMachineDuplicationError(new File(
																								PCFR.getAccessPolicy()))) {
																							APM.ReadAccessPolicy(new File(
																									PCFR.getAccessPolicy()));
																						} else {
																							logger.debug("\nWrong access policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing access policy definition does not exist\n");
																					}
																				}
																				parseProjectAsynchronously(
																						"Csharp",
																						generatedProjectDirectory,
																						CIM.AllMachineImplementationPairs("Csharp"),
																						EWM.getExcludedWords("Csharp"),
																						MPM.getLanguageModificationPolicy("Csharp"),
																						APM.getAccessPolicy("Csharp"));
																			} else {
																				logger.debug("\nWrong project configuration file definition\n");
																				parseProjectAsynchronously(
																						"Csharp",
																						generatedProjectDirectory,
																						new CompiledImplementationManager()
																								.AllMachineImplementationPairs("Csharp"),
																						new ExcludedWordsManager()
																								.getExcludedWords("Csharp"),
																						new ModificationPolicyManager()
																								.getLanguageModificationPolicy("Csharp"),
																						new AccessPolicyManager()
																								.getAccessPolicy("Csharp"));
																			}
																		} else {
																			parseProjectAsynchronously(
																					"Csharp",
																					generatedProjectDirectory,
																					new CompiledImplementationManager()
																							.AllMachineImplementationPairs("Csharp"),
																					new ExcludedWordsManager()
																							.getExcludedWords("Csharp"),
																					new ModificationPolicyManager()
																							.getLanguageModificationPolicy("Csharp"),
																					new AccessPolicyManager()
																							.getAccessPolicy("Csharp"));
																		}
																	} catch (Exception e) {
																		System.out
																				.println(e
																						.getStackTrace());
																	}
																}
															});

													//
													bProjectPopupMenu
															.add(generateCsharpCode);

													/*
													bProjectPopupMenu.addMouseListener(new MouseAdapter(){
														public void mousePressed(MouseEvent me)
														{
															System.out.println(popupMenuForNode);
														}
													});*/

													bProjectPopupMenu
															.show(projectDirectoryTree,
																	me.getX(),
																	me.getY());

													///
												} else {
													bProjectPopupMenu
															.removeAll();
													//System.out.println(bProjectPopupMenu.getComponentCount());

													JMenuItem selectProject = new JMenuItem(
															"Select project");
													selectProject
															.addMouseListener(new MouseAdapter() {

																public void mousePressed(
																		MouseEvent me) {
																	projectDirectory = new File(
																			projectsDirectory
																					.getAbsolutePath()
																					+ "/"
																					+ popupMenuForNode
																							.getLastPathComponent()
																							.toString());
																	selectedProject = popupMenuForNode
																			.getLastPathComponent()
																			.toString();

																	projectconf
																			.setConfigurationFile(new File(
																					projectDirectory
																							.getAbsolutePath()
																							+ "/"
																							+ configFileName));
																	projectconf
																			.refreshProjectconfg();

																	jButton1.setEnabled(true);
																	jButton2.setEnabled(true);
																	jMenuItem1
																			.setEnabled(true);
																	jMenuItem2
																			.setEnabled(true);
																	jMenuItem3
																			.setEnabled(true);
																	jMenuItem4
																			.setEnabled(true);
																	jMenuItem7
																			.setEnabled(true);
																	jMenuItem8
																			.setEnabled(true);

																	if (new File(
																			projectDirectory
																					.getAbsolutePath()
																					+ "/"
																					+ configFileName)
																			.exists()) {
																		ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																		if (PCFR.ReadConfigurationFile(new File(
																				projectDirectory
																						.getAbsolutePath()
																						+ "/"
																						+ configFileName))) {

																			if (PCFR.getModificationPolicy()
																					.length() > 0) {
																				if (new File(
																						PCFR.getModificationPolicy())
																						.exists()) {
																					if (modificationPolicyManager
																							.CheckMachineDuplicationError(new File(
																									PCFR.getModificationPolicy()))) {
																						modificationPolicyManager = new ModificationPolicyManager();
																						modificationPolicyManager
																								.ReadModificationPolicy(new File(
																										PCFR.getModificationPolicy()));
																						IMPM.setModificationPolicyManager(modificationPolicyManager);
																					} else {
																						logger.debug("\nWrong modification policy definition file\n");
																						modificationPolicyManager = new ModificationPolicyManager();
																						IMPM.setModificationPolicyManager(modificationPolicyManager);
																					}

																				} else {
																					logger.debug("\nFile containing modification policy definition does not exist file\n");
																					modificationPolicyManager = new ModificationPolicyManager();
																					IMPM.setModificationPolicyManager(modificationPolicyManager);
																				}

																			} else {
																				modificationPolicyManager = new ModificationPolicyManager();
																				IMPM.setModificationPolicyManager(modificationPolicyManager);
																			}

																			if (PCFR.getAccessPolicy()
																					.length() > 0) {
																				if (new File(
																						PCFR.getAccessPolicy())
																						.exists()) {
																					if (accessPolicyManager
																							.CheckMachineDuplicationError(new File(
																									PCFR.getAccessPolicy()))) {
																						accessPolicyManager = new AccessPolicyManager();
																						accessPolicyManager
																								.ReadAccessPolicy(new File(
																										PCFR.getAccessPolicy()));
																						IAPM.setAccessPolicy(accessPolicyManager);
																					} else {
																						logger.debug("\nWrong access policy definition file\n");
																						accessPolicyManager = new AccessPolicyManager();
																						IAPM.setAccessPolicy(accessPolicyManager);
																					}

																				} else {
																					logger.debug("\nFile containing modification policy definition does not exist file\n");
																					accessPolicyManager = new AccessPolicyManager();
																					IAPM.setAccessPolicy(accessPolicyManager);
																				}

																			} else {
																				accessPolicyManager = new AccessPolicyManager();
																				IAPM.setAccessPolicy(accessPolicyManager);
																			}

																			if (PCFR.getCompiledImplementations()
																					.length() > 0) {
																				if (new File(
																						PCFR.getCompiledImplementations())
																						.exists()) {
																					if (compiledImplementationManager
																							.CheckMIPairDuplicationError(new File(
																									PCFR.getCompiledImplementations()))) {
																						compiledImplementationManager = new CompiledImplementationManager();
																						compiledImplementationManager
																								.ReadMIPairDefinition(new File(
																										PCFR.getCompiledImplementations()));
																						ICIM.setCompiledImplementationsManager(compiledImplementationManager);

																					} else {
																						logger.debug("Wrong compiled implementations definition file");
																						compiledImplementationManager = new CompiledImplementationManager();
																						ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																					}

																				} else {
																					logger.debug("\nFile containing compiled implementations definition does not exist\n");
																					compiledImplementationManager = new CompiledImplementationManager();
																					ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																				}
																			} else {
																				compiledImplementationManager = new CompiledImplementationManager();
																				ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																			}

																			if (PCFR.getExcludedWords()
																					.length() > 0) {
																				if (new File(
																						PCFR.getExcludedWords())
																						.exists()) {
																					if (excludedWordsManager
																							.checkExcludedWordsDefinition(new File(
																									PCFR.getExcludedWords()))) {
																						excludedWordsManager = new ExcludedWordsManager();
																						excludedWordsManager
																								.ReadExcludedWords(new File(
																										PCFR.getExcludedWords()));
																						IEWM.SetExcludedWordsmanager(excludedWordsManager);
																						IEWM.SetExcludedWordsFile(new File(
																								PCFR.getExcludedWords()));
																					} else {
																						logger.debug("\nWrong excluded words definition file\n");
																						excludedWordsManager = new ExcludedWordsManager();
																						IEWM.SetExcludedWordsmanager(excludedWordsManager);
																						IEWM.SetExcludedWordsFile(null);

																					}
																				} else {
																					logger.debug("\nFile containing excluded words definition does not exist\n");
																					excludedWordsManager = new ExcludedWordsManager();
																					IEWM.SetExcludedWordsmanager(excludedWordsManager);
																					IEWM.SetExcludedWordsFile(null);
																				}

																			} else {
																				excludedWordsManager = new ExcludedWordsManager();
																				IEWM.SetExcludedWordsmanager(excludedWordsManager);
																				IEWM.SetExcludedWordsFile(null);
																			}
																		} else {
																			logger.debug("\nWrong configuration file definition\n");
																			excludedWordsManager = new ExcludedWordsManager();
																			IEWM.SetExcludedWordsmanager(excludedWordsManager);
																			IEWM.SetExcludedWordsFile(null);
																			compiledImplementationManager = new CompiledImplementationManager();
																			ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																			accessPolicyManager = new AccessPolicyManager();
																			IAPM.setAccessPolicy(accessPolicyManager);
																			modificationPolicyManager = new ModificationPolicyManager();
																			IMPM.setModificationPolicyManager(modificationPolicyManager);
																		}
																	} else {
																		excludedWordsManager = new ExcludedWordsManager();
																		IEWM.SetExcludedWordsmanager(excludedWordsManager);
																		IEWM.SetExcludedWordsFile(null);
																		compiledImplementationManager = new CompiledImplementationManager();
																		ICIM.setCompiledImplementationsManager(compiledImplementationManager);
																		accessPolicyManager = new AccessPolicyManager();
																		IAPM.setAccessPolicy(accessPolicyManager);
																		modificationPolicyManager = new ModificationPolicyManager();
																		IMPM.setModificationPolicyManager(modificationPolicyManager);

																	}
																	if (!recentProjectsList
																			.contains(popupMenuForNode
																					.getLastPathComponent()
																					.toString())) {
																		recentProjectsList
																				.addFirst(popupMenuForNode
																						.getLastPathComponent()
																						.toString());
																		RefreshRecentProjectsComboBox();
																	} else {
																		recentProjectsList
																				.remove(popupMenuForNode
																						.getLastPathComponent()
																						.toString());
																		recentProjectsList
																				.addFirst(popupMenuForNode
																						.getLastPathComponent()
																						.toString());
																		RefreshRecentProjectsComboBox();
																	}
																}
															});

													bProjectPopupMenu
															.add(selectProject);
													JMenuItem generateJavaCode = new JMenuItem(
															"Generate Java code");
													generateJavaCode
															.addMouseListener(new MouseAdapter() {

																public void mousePressed(
																		MouseEvent me) {
																	File generatedProjectDirectory = new File(
																			projectsDirectory
																					.getAbsolutePath()
																					+ "/"
																					+ popupMenuForNode
																							.getLastPathComponent()
																							.toString());
																	try {

																		File[] generatedProjectFiles = generatedProjectDirectory
																				.listFiles();

																		boolean containsConfigurationFile = false;
																		for (File generatedProjectFile : generatedProjectFiles) {
																			if (generatedProjectFile
																					.isFile()
																					&& generatedProjectFile
																							.getName()
																							.equals(configFileName)) {
																				containsConfigurationFile = true;
																			}
																		}

																		if (containsConfigurationFile) {
																			File configurationFile = new File(
																					generatedProjectDirectory
																							.getAbsolutePath()
																							+ "/"
																							+ configFileName);
																			ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																			if (PCFR.ReadConfigurationFile(configurationFile)) {
																				CompiledImplementationManager CIM = new CompiledImplementationManager();
																				if (PCFR.getCompiledImplementations()
																						.length() > 0) {
																					if (new File(
																							PCFR.getCompiledImplementations())
																							.exists()) {
																						if (CIM.CheckMIPairDuplicationError(new File(
																								PCFR.getCompiledImplementations()))) {
																							CIM.ReadMIPairDefinition(new File(
																									PCFR.getCompiledImplementations()));
																						} else {
																							logger.debug("\nWrong compiled implementations definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing compiled implementations definition does not exist\n");
																					}
																				}

																				ExcludedWordsManager EWM = new ExcludedWordsManager();
																				if (PCFR.getExcludedWords()
																						.length() > 0) {
																					if (new File(
																							PCFR.getExcludedWords())
																							.exists()) {
																						if (EWM.checkExcludedWordsDefinition(new File(
																								PCFR.getExcludedWords()))) {
																							EWM.ReadExcludedWords(new File(
																									PCFR.getExcludedWords()));
																						} else {
																							logger.debug("\nWrong excluded words definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing excluded words definition does not exist\n");
																					}
																				}

																				ModificationPolicyManager MPM = new ModificationPolicyManager();
																				if (PCFR.getModificationPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getModificationPolicy())
																							.exists()) {
																						if (MPM.CheckMachineDuplicationError(new File(
																								PCFR.getModificationPolicy()))) {
																							MPM.ReadModificationPolicy(new File(
																									PCFR.getModificationPolicy()));
																						} else {
																							logger.debug("\nWrong modification policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing modification policy definition does not exist\n");
																					}
																				}

																				AccessPolicyManager APM = new AccessPolicyManager();
																				if (PCFR.getAccessPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getAccessPolicy())
																							.exists()) {
																						if (APM.CheckMachineDuplicationError(new File(
																								PCFR.getAccessPolicy()))) {
																							APM.ReadAccessPolicy(new File(
																									PCFR.getAccessPolicy()));
																						} else {
																							logger.debug("\nWrong access policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing access policy definition does not exist\n");
																					}
																				}
																				parseProjectAsynchronously(
																						"Java",
																						generatedProjectDirectory,
																						CIM.AllMachineImplementationPairs("Java"),
																						EWM.getExcludedWords("Java"),
																						MPM.getLanguageModificationPolicy("Java"),
																						APM.getAccessPolicy("Java"));
																			} else {
																				logger.debug("\nWrong project configuration file definition\n");
																				parseProjectAsynchronously(
																						"Java",
																						generatedProjectDirectory,
																						new CompiledImplementationManager()
																								.AllMachineImplementationPairs("Java"),
																						new ExcludedWordsManager()
																								.getExcludedWords("Java"),
																						new ModificationPolicyManager()
																								.getLanguageModificationPolicy("Java"),
																						new AccessPolicyManager()
																								.getAccessPolicy("Java"));
																			}
																		} else {
																			parseProjectAsynchronously(
																					"Java",
																					generatedProjectDirectory,
																					new CompiledImplementationManager()
																							.AllMachineImplementationPairs("Java"),
																					new ExcludedWordsManager()
																							.getExcludedWords("Java"),
																					new ModificationPolicyManager()
																							.getLanguageModificationPolicy("Java"),
																					new AccessPolicyManager()
																							.getAccessPolicy("Java"));
																		}

																	} catch (Exception e) {
																		System.out
																				.println(e
																						.getStackTrace());
																	}
																}
															});
													bProjectPopupMenu
															.add(generateJavaCode);
													JMenuItem generateCsharpCode = new JMenuItem(
															"Generate C# code");

													//

													generateCsharpCode
															.addMouseListener(new MouseAdapter() {

																public void mousePressed(
																		MouseEvent me) {
																	File generatedProjectDirectory = new File(
																			projectsDirectory
																					.getAbsolutePath()
																					+ "/"
																					+ popupMenuForNode
																							.getLastPathComponent()
																							.toString());
																	try {

																		File[] generatedProjectFiles = generatedProjectDirectory
																				.listFiles();

																		boolean containsConfigurationFile = false;
																		for (File generatedProjectFile : generatedProjectFiles) {
																			if (generatedProjectFile
																					.isFile()
																					&& generatedProjectFile
																							.getName()
																							.equals(configFileName)) {
																				containsConfigurationFile = true;
																			}
																		}

																		if (containsConfigurationFile) {
																			File configurationFile = new File(
																					generatedProjectDirectory
																							.getAbsolutePath()
																							+ "/"
																							+ configFileName);
																			ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
																			if (PCFR.ReadConfigurationFile(configurationFile)) {
																				CompiledImplementationManager CIM = new CompiledImplementationManager();
																				if (PCFR.getCompiledImplementations()
																						.length() > 0) {
																					if (new File(
																							PCFR.getCompiledImplementations())
																							.exists()) {
																						if (CIM.CheckMIPairDuplicationError(new File(
																								PCFR.getCompiledImplementations()))) {
																							CIM.ReadMIPairDefinition(new File(
																									PCFR.getCompiledImplementations()));
																						} else {
																							logger.debug("\nWrong compiled implementations definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing compiled implementations definition does not exist\n");
																					}
																				}

																				ExcludedWordsManager EWM = new ExcludedWordsManager();
																				if (PCFR.getExcludedWords()
																						.length() > 0) {
																					if (new File(
																							PCFR.getExcludedWords())
																							.exists()) {
																						if (EWM.checkExcludedWordsDefinition(new File(
																								PCFR.getExcludedWords()))) {
																							EWM.ReadExcludedWords(new File(
																									PCFR.getExcludedWords()));
																						} else {
																							logger.debug("\nWrong excluded words definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing excluded words definition does not exist\n");
																					}
																				}

																				ModificationPolicyManager MPM = new ModificationPolicyManager();
																				if (PCFR.getModificationPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getModificationPolicy())
																							.exists()) {
																						if (MPM.CheckMachineDuplicationError(new File(
																								PCFR.getModificationPolicy()))) {
																							MPM.ReadModificationPolicy(new File(
																									PCFR.getModificationPolicy()));
																						} else {
																							logger.debug("\nWrong modification policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing modification policy definition does not exist\n");
																					}
																				}

																				AccessPolicyManager APM = new AccessPolicyManager();
																				if (PCFR.getAccessPolicy()
																						.length() > 0) {
																					if (new File(
																							PCFR.getAccessPolicy())
																							.exists()) {
																						if (APM.CheckMachineDuplicationError(new File(
																								PCFR.getAccessPolicy()))) {
																							APM.ReadAccessPolicy(new File(
																									PCFR.getAccessPolicy()));
																						} else {
																							logger.debug("\nWrong access policy definition file\n");
																						}
																					} else {
																						logger.debug("\nFile containing access policy definition does not exist\n");
																					}
																				}
																				parseProjectAsynchronously(
																						"Csharp",
																						generatedProjectDirectory,
																						CIM.AllMachineImplementationPairs("Csharp"),
																						EWM.getExcludedWords("Csharp"),
																						MPM.getLanguageModificationPolicy("Csharp"),
																						APM.getAccessPolicy("Csharp"));
																			} else {
																				logger.debug("\nWrong project configuration file definition\n");
																				parseProjectAsynchronously(
																						"Csharp",
																						generatedProjectDirectory,
																						new CompiledImplementationManager()
																								.AllMachineImplementationPairs("Csharp"),
																						new ExcludedWordsManager()
																								.getExcludedWords("Csharp"),
																						new ModificationPolicyManager()
																								.getLanguageModificationPolicy("Csharp"),
																						new AccessPolicyManager()
																								.getAccessPolicy("Csharp"));
																			}
																		} else {
																			parseProjectAsynchronously(
																					"Csharp",
																					generatedProjectDirectory,
																					new CompiledImplementationManager()
																							.AllMachineImplementationPairs("Csharp"),
																					new ExcludedWordsManager()
																							.getExcludedWords("Csharp"),
																					new ModificationPolicyManager()
																							.getLanguageModificationPolicy("Csharp"),
																					new AccessPolicyManager()
																							.getAccessPolicy("Csharp"));
																		}
																	} catch (Exception e) {
																		System.out
																				.println(e
																						.getStackTrace());
																	}
																}
															});

													//
													bProjectPopupMenu
															.add(generateCsharpCode);

													/*
													bProjectPopupMenu.addMouseListener(new MouseAdapter(){
														public void mousePressed(MouseEvent me)
														{
															System.out.println(popupMenuForNode);
														}
													});*/

													bProjectPopupMenu
															.show(projectDirectoryTree,
																	me.getX(),
																	me.getY());
												}

											}
										}
									}
								}
							}
						});

			} catch (Exception E) {
				System.out.println(E.getStackTrace());
			}
		} else {
			DefaultTreeModel defaultTreeModel = new DefaultTreeModel(
					this.rootNode);
			projectDirectoryTree.setModel(defaultTreeModel);
			JOptionPane.showMessageDialog(null,
					"Projects directory does not exist",
					"Projects directory error", JOptionPane.ERROR_MESSAGE);
		}
	}

	private TreePath popupMenuForNode;

	// Compiler functions BEGIN

	// Grapwiz Begin

	public static final String NO_GRAPHVIZ_ERROR_MESSAGE = "Graphviz library not installed!";
	public static final File GRAPH_TEMPLATE = new File("freemarker.template");

	private void showError(String text) {
		JOptionPane.showMessageDialog(this, text, "Error",
				JOptionPane.ERROR_MESSAGE);
	}

	private void showGraphAsynchronously() {
		Runnable task = new Runnable() {
			public void run() {
				showGraph();
			}
		};
		new Thread(task).start();
	}

	private void showGraph() {

		try {
			Process p = Runtime.getRuntime().exec("dot -V");
			if (p.waitFor() != 0){
				showError(NO_GRAPHVIZ_ERROR_MESSAGE);
				return;
			}
		} catch (Exception ex) {
			showError(NO_GRAPHVIZ_ERROR_MESSAGE);
			return;
		}

		File graphFile = new File(projectDirectory, "graph.png");
		// && !graphFile.exists()

		parseProject();
		if (bProject == null) // not successful parsing
			return;

		GraphvizVisualization graphGenerator = new GraphvizVisualization(
				bProject, GRAPH_TEMPLATE, graphFile);

		ImagePanel graphImage = null;
		ImagePanel legend = null;
		try {
			graphGenerator.generateGraph();

			graphImage = new ImagePanel(new File(projectDirectory, "graph.png"));
			//graphImage = new ImagePanel(new File(projectFolder() + "\\" + "graph.png"));

			legend = new ImagePanel("graph_legend.png");

		} catch (Exception ex) {
			logger.log(Level.ERROR,
					"error during generating graph: " + ex.getMessage());
		}

		graphImage.setBackground(Color.white);
		legend.setOpaque(false);
		legend.setBackground(new Color(0, 0, 0, 0));
		legend.setSize(legend.getPreferredSize());
		// legend.setLocation(10, 10);
		graphImage.add(legend);

		JPanel graph = new JPanel();
		graph.setLayout(new GridBagLayout());
		graph.setBackground(Color.white);
		GridBagConstraints c = new GridBagConstraints();
		c.weightx = 1.0;
		c.gridx = 0;
		c.gridy = 0;
		c.anchor = GridBagConstraints.WEST;
		c.fill = GridBagConstraints.NONE;
		graph.add(legend, c);

		c.gridy = 1;
		c.anchor = GridBagConstraints.NORTH;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.weighty = 1.0;
		graph.add(graphImage, c);

		//added blindsight
		JScrollPane jScrollPane3 = new JScrollPane();
		jScrollPane3.setViewportView(graph);
		JDialog dialog = new JDialog(this, "Project Graph");

		dialog.getContentPane().add(jScrollPane3, BorderLayout.CENTER);

		dialog.pack();
		dialog.setLocation(6, 30);
		dialog.setVisible(true);
	}

	private void parseProject() {

		StringWriter buffer = new StringWriter();
		ProjectParser parser = new ProjectParser(projectDirectory);

		try {
			parser.setLibraries("BasicMachines/MCH");
			bProject = parser.parseProject(compiledImplementationManager
					.AllMachineImplementationPairs("Java"));

		} catch (ProjectParseException e) {
			logger.error("Error in parsing file:");
			logger.error(e.getSource());
			logger.error(e.getMessage());
			e.printStackTrace();
			return;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		}

	}

	// Grapwiz End

	private Project bProject;

	private void generateCode(String language, File projectDirectory,
			Hashtable<String, String> MIPairs, ArrayList<String> excludedWords,
			ArrayList<ClassModificationPolicy> modificationPolicy,
			ArrayList<ClassAccessPolicy> accessPolicy) {
		long ts = System.currentTimeMillis();
		StringWriter buffer = new StringWriter();
		ProjectParser parser = new ProjectParser(projectDirectory);

		try {
			parser.setLibraries("BasicMachines/MCH");
			bProject = parser.parseProject(MIPairs);
		} catch (ProjectParseException e) {
			logger.error("Error in parsing file:");
			logger.error(e.getSource());
			logger.error(e.getMessage());
			e.printStackTrace();
			return;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		}

		if (language.equals("Java")) {
			File javaOutputFolder = new File(projectDirectory, "java");
			JavaGenerator javaGenerator = new JavaGenerator(bProject,
					javaOutputFolder);
			javaGenerator.setJavaExcludedWords(excludedWords);
			javaGenerator.setModificationPolicy(modificationPolicy);
			javaGenerator.setAccessPolicy(accessPolicy);

			logger.info("\nGenerating Java Code ...");
			try {
				javaGenerator.generateJavaCode(buffer);
				
				File file = new File(projectDirectory.getAbsolutePath() +"\\java\\report.txt");
							
				FileWriter outFile;
				try {
					outFile = new FileWriter(file);
					PrintWriter out = new PrintWriter(outFile);
					
					for (String machines :javaGenerator.getProjectConstructorAccessRight().keySet())
					{
						out.printf("---------------------------------------------\n");
						out.printf("INSTANCES of class %s can be created by classes:\n", machines);
						for (String accessMachine: javaGenerator.getProjectConstructorAccessRight().get(machines))
						{
							out.printf("    %s\n", accessMachine);
						}
						
						out.printf("METHODS of class %s can be accessed by classes:\n", machines);
						for (String accessMachine: javaGenerator.getProjectMethodAccessRight().get(machines))
						{
							out.printf("    %s\n", accessMachine);
						}
						out.printf("---------------------------------------------\n");
						
					}
										
					out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
				
			} catch (JavaCodeGenerationException jcge) {
				logger.error("Error in generating java code for module: "
						+ jcge.getSource());
				logger.error(jcge.getMessage());
				jcge.printStackTrace();
				return;
			}
			long te = System.currentTimeMillis();
			System.out.println(te - ts);
			for (Module m : bProject.modules()) {
				System.out.println(m.machine() + " " + m.refinements() + " "
						+ m.implementation());
			}
			long compileTime = te - ts;
			logger.info("\nGenerating Code finished in " + compileTime
					+ " [ms]");
		}

		if (language.equals("Csharp")) {
			File csOutputFolder = new File(projectDirectory, "c#");
			CsGenerator csGenerator = new CsGenerator(bProject, csOutputFolder);
			csGenerator.ResetCsExcludedWords();

			csGenerator.setCsExcludedWords(excludedWords);
			csGenerator.setModificationPolicy(modificationPolicy);
			csGenerator.setAccessPolicy(accessPolicy);

			logger.info("\nGenerating C# Code ...");
			try {
				csGenerator.generateCsCode(buffer);
				
				File file = new File(projectDirectory.getAbsolutePath() +"\\c#\\report.txt");
				
				FileWriter outFile;
				try {
					outFile = new FileWriter(file);
					PrintWriter out = new PrintWriter(outFile);
					
					for (String machines :csGenerator.getProjectConstructorAccessRight().keySet())
					{
						out.printf("---------------------------------------------\n");
						out.printf("INSTANCES of class %s can be created by classes:\n", machines);
						for (String accessMachine: csGenerator.getProjectConstructorAccessRight().get(machines))
						{
							out.printf("    %s\n", accessMachine);
						}
						
						out.printf("METHODS of class %s can be accessed by classes:\n", machines);
						for (String accessMachine: csGenerator.getProjectMethodAccessRight().get(machines))
						{
							out.printf("    %s\n", accessMachine);
						}
						out.printf("---------------------------------------------\n");
						
					}
										
					out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			} catch (CsCodeGenerationException jcge) {
				logger.error("Error in generating c# code for module: "
						+ jcge.getSource());
				logger.error(jcge.getMessage());
				jcge.printStackTrace();
				return;
			}
			long te = System.currentTimeMillis();
			System.out.println(te - ts);
			for (Module m : bProject.modules()) {
				System.out.println(m.machine() + " " + m.refinements() + " "
						+ m.implementation());
			}
			long compileTime = te - ts;
			logger.info("\nGenerating Code finished in " + compileTime
					+ " [ms]");
		}
	}

	private String Clanguage;
	private File CprojectDirectory;
	private Hashtable<String, String> CMIPairs;
	ArrayList<String> CexcludedWords;
	ArrayList<ClassModificationPolicy> CmodificationPolicy;
	ArrayList<ClassAccessPolicy> CaccessPolicy;

	private void parseProjectAsynchronously(String language,
			File projectDirectory, Hashtable<String, String> MIPairs,
			ArrayList<String> excludedWords,
			ArrayList<ClassModificationPolicy> modificationPolicy,
			ArrayList<ClassAccessPolicy> accessPolicy) {
		this.Clanguage = language;
		this.CprojectDirectory = projectDirectory;
		this.CMIPairs = MIPairs;
		this.CexcludedWords = excludedWords;
		this.CmodificationPolicy = modificationPolicy;
		this.CaccessPolicy = accessPolicy;
		Runnable task = new Runnable() {
			public void run() {
				generateCode(Clanguage, CprojectDirectory, CMIPairs,
						CexcludedWords, CmodificationPolicy, CaccessPolicy);
			}
		};
		new Thread(task).start();
	}

	// Compiler functions END

	private void openFile(String path) {
		
		if (this.defaultTextEditor != null)
		{
			try {
				Process p = Runtime.getRuntime().exec(defaultTextEditor + " " + path);
			}
			catch (Exception E)
			{
				System.out.println(E.getStackTrace());
			}
		}
		else
		{
			if (System.getProperty("os.name").contains("Windows"))
			{
				defaultTextEditor = "notepad";
				openFile (path);
			}
			else
			{
			   if (System.getProperty("os.name").contains("Linux"))
			    {
				 defaultTextEditor = "gedit";
				 openFile(path);
			    }
			    else
			   {
				JOptionPane.showMessageDialog(null, "Default text editor not set, and compiler was unable\n" +
						"to find other text editor");   
			   }
			}
		}
		
		

	}

	private HtmlConsole console;

	/** Creates new form MainWindow */
	public MainWindow() {
		initComponents();
		console = new HtmlConsole();
		consoleScrollPane.setViewportView(console);
		HtmlConsoleAppender.htmlConsole = console;

		console.addHyperlinkListener(new HyperlinkListener() {

			public void hyperlinkUpdate(HyperlinkEvent e) {
				if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
					System.out.println(e.getURL());
					openFile(e.getURL().toString());
				}
			}
		});

		if (new File("config.ini").exists()) {
			if (compilerConfigurationFileReader.ReadConfigurationFile(new File(
					"config.ini"))) {
				if (compilerConfigurationFileReader
						.getDefaultBprojectsDirectory().length() > 0) {
					if (new File(compilerConfigurationFileReader.getDefaultBprojectsDirectory()).exists())
					{

					projectsDirectory = new File(
							compilerConfigurationFileReader
								.getDefaultBprojectsDirectory());
					RefreshProjectBrowser();
					}
					else
					{
						JOptionPane.showMessageDialog(null, "Default projects directory does not exist");
						DefaultTreeModel defaultTreeModel = new DefaultTreeModel(this.rootNode);
						projectDirectoryTree.setModel(defaultTreeModel);
					}
				}
				else
				{
					DefaultTreeModel defaultTreeModel = new DefaultTreeModel(this.rootNode);
					projectDirectoryTree.setModel(defaultTreeModel);
				}

				if (compilerConfigurationFileReader
						.getProjectConfigurationFileName().length() > 0) {
					configFileName = compilerConfigurationFileReader
							.getProjectConfigurationFileName();
				}
				
				if (compilerConfigurationFileReader.getDefaultTextEditor().length() > 0)
				{
					if (new File (compilerConfigurationFileReader.getDefaultTextEditor()).exists())
					{
						this.defaultTextEditor = compilerConfigurationFileReader.getDefaultTextEditor();
					}
					else
					{
						JOptionPane.showMessageDialog(null, "Default text editor does not exist");
					}
				}

			} else {
				JOptionPane
						.showMessageDialog(
								null,
								"Compiler configuration file error, starting BKPI B language compiler\nlike there is no configuration file present",
								"Configuration file error",
								JOptionPane.ERROR_MESSAGE);
				DefaultTreeModel defaultTreeModel = new DefaultTreeModel(this.rootNode);
				projectDirectoryTree.setModel(defaultTreeModel);
			}
			compilerConfig.refreshCompilerConfig();

			
		}
		else
		{
			DefaultTreeModel defaultTreeModel = new DefaultTreeModel(this.rootNode);
			projectDirectoryTree.setModel(defaultTreeModel);
		}

		if (projectDirectory == null) {
			jButton1.setEnabled(false);
			jButton2.setEnabled(false);
			jMenuItem1.setEnabled(false);
			jMenuItem2.setEnabled(false);
			jMenuItem3.setEnabled(false);
			jMenuItem4.setEnabled(false);
			jMenuItem7.setEnabled(false);
			jMenuItem8.setEnabled(false);
			//jMenu2.setEnabled(false);
		}

		

	}

	//GEN-BEGIN:initComponents
	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		bProjectPopupMenu = new javax.swing.JPopupMenu();
		label1 = new java.awt.Label();
		recentProjectsComboBox = new javax.swing.JComboBox();
		jScrollPane1 = new javax.swing.JScrollPane();
		projectDirectoryTree = new javax.swing.JTree();
		consoleScrollPane = new javax.swing.JScrollPane();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		menuBar = new javax.swing.JMenuBar();
		jMenu1 = new javax.swing.JMenu();
		jMenuItem1 = new javax.swing.JMenuItem();
		jMenu2 = new javax.swing.JMenu();
		jMenuItem2 = new javax.swing.JMenuItem();
		jSeparator1 = new javax.swing.JSeparator();
		jMenuItem7 = new javax.swing.JMenuItem();
		jMenuItem8 = new javax.swing.JMenuItem();
		jMenuItem3 = new javax.swing.JMenuItem();
		jSeparator2 = new javax.swing.JSeparator();
		jMenuItem4 = new javax.swing.JMenuItem();
		jMenu3 = new javax.swing.JMenu();
		jMenuItem5 = new javax.swing.JMenuItem();
		jMenuItem6 = new javax.swing.JMenuItem();

		bProjectPopupMenu.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				bProjectPopupMenuMousePressed(evt);
			}
		});

		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		setTitle("BKPI B language compiler");

		label1.setText("Selected project");

		recentProjectsComboBox
				.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
					public void popupMenuCanceled(
							javax.swing.event.PopupMenuEvent evt) {
					}

					public void popupMenuWillBecomeInvisible(
							javax.swing.event.PopupMenuEvent evt) {
					}

					public void popupMenuWillBecomeVisible(
							javax.swing.event.PopupMenuEvent evt) {
						recentProjectsComboBoxPopupMenuWillBecomeVisible(evt);
					}
				});
		recentProjectsComboBox
				.addItemListener(new java.awt.event.ItemListener() {
					public void itemStateChanged(java.awt.event.ItemEvent evt) {
						recentProjectsComboBoxItemStateChanged(evt);
					}
				});
		recentProjectsComboBox
				.addInputMethodListener(new java.awt.event.InputMethodListener() {
					public void caretPositionChanged(
							java.awt.event.InputMethodEvent evt) {
					}

					public void inputMethodTextChanged(
							java.awt.event.InputMethodEvent evt) {
						recentProjectsComboBoxInputMethodTextChanged(evt);
					}
				});
		recentProjectsComboBox
				.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
					public void propertyChange(
							java.beans.PropertyChangeEvent evt) {
						recentProjectsComboBoxPropertyChange(evt);
					}
				});

		jScrollPane1.setViewportView(projectDirectoryTree);
		jScrollPane1.setMinimumSize(new Dimension(250, 100));
		jScrollPane1.setPreferredSize(new Dimension(600,600));
		

		jButton1.setText("Generate Java Code");
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jButton2.setText("Generate C# code");
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton2ActionPerformed(evt);
			}
		});

		jMenu1.setText("Project");

		jMenuItem1.setText("Compiled implementations ...");
		jMenuItem1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem1MousePressed(evt);
			}
		});
		jMenuItem1.addHierarchyListener(new java.awt.event.HierarchyListener() {
			public void hierarchyChanged(java.awt.event.HierarchyEvent evt) {
				jMenuItem1HierarchyChanged(evt);
			}
		});
		jMenu1.add(jMenuItem1);

		jMenu2.setText("Software developement");

		jMenuItem2.setText("Excluded words ...");
		jMenuItem2.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem2MousePressed(evt);
			}
		});
		jMenu2.add(jMenuItem2);
		jMenu2.add(jSeparator1);

		jMenuItem7.setText("Modification policy ...");
		jMenuItem7.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem7MousePressed(evt);
			}
		});
		jMenuItem7.addMenuKeyListener(new javax.swing.event.MenuKeyListener() {
			public void menuKeyPressed(javax.swing.event.MenuKeyEvent evt) {
				jMenuItem7MenuKeyPressed(evt);
			}

			public void menuKeyReleased(javax.swing.event.MenuKeyEvent evt) {
			}

			public void menuKeyTyped(javax.swing.event.MenuKeyEvent evt) {
			}
		});
		jMenu2.add(jMenuItem7);

		jMenuItem8.setText("Access policy ...");
		jMenuItem8.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem8MousePressed(evt);
			}
		});
		jMenu2.add(jMenuItem8);

		jMenu1.add(jMenu2);

		jMenuItem3.setText("Dependence graph");
		jMenuItem3.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem3MousePressed(evt);
			}
		});
		jMenu1.add(jMenuItem3);
		jMenu1.add(jSeparator2);

		jMenuItem4.setText("Configure ...");
		jMenuItem4.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem4MousePressed(evt);
			}
		});
		jMenu1.add(jMenuItem4);

		menuBar.add(jMenu1);

		jMenu3.setText("Compiler");

		jMenuItem5.setText("Change projects directory ...");
		jMenuItem5.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem5MousePressed(evt);
			}

			public void mouseReleased(java.awt.event.MouseEvent evt) {
				jMenuItem5MouseReleased(evt);
			}
		});
		jMenu3.add(jMenuItem5);

		jMenuItem6.setText("Settings ...");
		jMenuItem6.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(java.awt.event.MouseEvent evt) {
				jMenuItem6MousePressed(evt);
			}
		});
		jMenu3.add(jMenuItem6);

		menuBar.add(jMenu3);

		setJMenuBar(menuBar);

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(
				getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						javax.swing.GroupLayout.Alignment.TRAILING,
						layout.createSequentialGroup()
								.addContainerGap()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.TRAILING)
												.addGroup(
														javax.swing.GroupLayout.Alignment.LEADING,
														layout.createSequentialGroup()
																.addComponent(
																		jButton1)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
																.addComponent(
																		jButton2))
												.addComponent(
														consoleScrollPane,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														372, Short.MAX_VALUE))
								.addPreferredGap(
										javax.swing.LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
												.addComponent(
														label1,
														javax.swing.GroupLayout.PREFERRED_SIZE,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														javax.swing.GroupLayout.PREFERRED_SIZE)
												.addGroup(
														layout.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING,
																false)
																.addComponent(
																		recentProjectsComboBox,
																		javax.swing.GroupLayout.Alignment.TRAILING,
																		0,
																		javax.swing.GroupLayout.DEFAULT_SIZE,
																		Short.MAX_VALUE)
																.addComponent(
																		jScrollPane1,
																		javax.swing.GroupLayout.Alignment.TRAILING,
																		javax.swing.GroupLayout.DEFAULT_SIZE,
																		158,
																		Short.MAX_VALUE)))
								.addContainerGap()));
		layout.setVerticalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						layout.createSequentialGroup()
								.addContainerGap()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
												.addGroup(
														layout.createSequentialGroup()
																.addComponent(
																		label1,
																		javax.swing.GroupLayout.PREFERRED_SIZE,
																		20,
																		javax.swing.GroupLayout.PREFERRED_SIZE)
																.addGap(2, 2, 2)
																.addComponent(
																		recentProjectsComboBox,
																		javax.swing.GroupLayout.PREFERRED_SIZE,
																		javax.swing.GroupLayout.DEFAULT_SIZE,
																		javax.swing.GroupLayout.PREFERRED_SIZE)
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																.addComponent(
																		jScrollPane1,
																		javax.swing.GroupLayout.DEFAULT_SIZE,
																		303,
																		Short.MAX_VALUE))
												.addGroup(
														layout.createSequentialGroup()
																.addGroup(
																		layout.createParallelGroup(
																				javax.swing.GroupLayout.Alignment.BASELINE)
																				.addComponent(
																						jButton1)
																				.addComponent(
																						jButton2))
																.addPreferredGap(
																		javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																.addComponent(
																		consoleScrollPane,
																		javax.swing.GroupLayout.DEFAULT_SIZE,
																		322,
																		Short.MAX_VALUE)))
								.addContainerGap()));

		pack();
	}// </editor-fold>
	//GEN-END:initComponents

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		
		this.parseProjectAsynchronously("Csharp", this.projectDirectory,
				compiledImplementationManager
						.AllMachineImplementationPairs("Csharp"),
				excludedWordsManager.getExcludedWords("Csharp"),
				this.IMPM.getModificationPolicyManager()
						.getLanguageModificationPolicy("Csharp"),
				this.IAPM.getAccessPolicyManager().getAccessPolicy("Csharp"));
		/*
		this.parseProjectAsynchronously("Csharp", this.projectDirectory,
				compiledImplementationManager
						.AllMachineImplementationPairs("Csharp"),
				excludedWordsManager.getExcludedWords("Csharp"),
				this.modificationPolicyManager
						.getLanguageModificationPolicy("Csharp"),
				this.accessPolicyManager.getAccessPolicy("Csharp"));*/
	}

	private void jMenuItem6MousePressed(java.awt.event.MouseEvent evt) {
		compilerConfig.refreshCompilerConfig();
		compilerConfig.setVisible(true);
	}

	private void jMenuItem3MousePressed(java.awt.event.MouseEvent evt) {
		showGraphAsynchronously();
	}

	private void jMenuItem5MouseReleased(java.awt.event.MouseEvent evt) {
		// TODO add your handling code here:
	}

	private void jMenuItem4MousePressed(java.awt.event.MouseEvent evt) {
		projectconf.setVisible(true);
	}

	private void jMenuItem8MousePressed(java.awt.event.MouseEvent evt) {
		IAPM.setVisible(true);
	}

	private void jMenuItem7MousePressed(java.awt.event.MouseEvent evt) {

		IMPM.setVisible(true);

	}

	private void jMenuItem7MenuKeyPressed(javax.swing.event.MenuKeyEvent evt) {
		// TODO add your handling code here:
	}

	private void jMenuItem1MousePressed(java.awt.event.MouseEvent evt) {
		ICIM.setVisible(true);
	}

	private void jMenuItem1HierarchyChanged(java.awt.event.HierarchyEvent evt) {
		// TODO add your handling code here:
	}

	private void recentProjectsComboBoxPopupMenuWillBecomeVisible(
			javax.swing.event.PopupMenuEvent evt) {
		// TODO add your handling code here:
	}

	private void jMenuItem2MousePressed(java.awt.event.MouseEvent evt) {
		IEWM.setVisible(true);
	}

	private void recentProjectsComboBoxInputMethodTextChanged(
			java.awt.event.InputMethodEvent evt) {
		// TODO add your handling code here:
	}

	private void jMenuItem5MousePressed(java.awt.event.MouseEvent evt) {
		JFileChooser fc = new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

		int option = fc.showDialog(null, "Select projects directory");
		if (option == JFileChooser.APPROVE_OPTION) {
			System.out.println(fc.getSelectedFile());
			projectsDirectory = fc.getSelectedFile();
			projectDirectory = null;
			recentProjectsList = new LinkedList<String>();
			selectedProject = null;
			RefreshRecentProjectsComboBox();
			RefreshProjectBrowser();
			
			//by SKor: pridanie funkcionality, aby sa po zmene projektovho adresra optal, i ho nenastavi ako predvolen.  
			int response = JOptionPane.showOptionDialog(this, "Would you like to make the selected directory the default projects directory?\n The default projects directory can be changed in the Compiler\\Settings menu.", "Default projects directory", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
			if (response==JOptionPane.YES_OPTION){
				CompilerConfigurationFileReader ccfr = new CompilerConfigurationFileReader();
				File cfl = new File(configFileName);
				ccfr.ReadConfigurationFile(cfl);
				ccfr.setDefaultBprojectsDirectory(fc.getSelectedFile().getAbsolutePath());
				ccfr.WriteConfigurationFile(cfl);
				compilerConfig.refreshCompilerConfig();
			}
			
		}
	}

	private void recentProjectsComboBoxItemStateChanged(
			java.awt.event.ItemEvent evt) {
		if (recentProjectsComboBox.getSelectedItem() != null) {
			projectDirectory = new File(projectsDirectory.getAbsolutePath()
					+ "/" + recentProjectsComboBox.getSelectedItem().toString());
			selectedProject = recentProjectsComboBox.getSelectedItem()
					.toString();

			projectconf.setConfigurationFile(new File(projectDirectory
					.getAbsolutePath() + "/" + configFileName));
			projectconf.refreshProjectconfg();
			jButton1.setEnabled(true);
			jButton2.setEnabled(true);
			jMenuItem1.setEnabled(true);
			jMenuItem2.setEnabled(true);
			jMenuItem3.setEnabled(true);
			jMenuItem4.setEnabled(true);
			jMenuItem7.setEnabled(true);
			jMenuItem8.setEnabled(true);

			if (new File(projectDirectory.getAbsolutePath() + "/"
					+ configFileName).exists()) {
				ProjectConfigurationFileReader PCFR = new ProjectConfigurationFileReader();
				if (PCFR.ReadConfigurationFile(new File(projectDirectory
						.getAbsolutePath() + "/" + configFileName))) {

					if (PCFR.getModificationPolicy().length() > 0) {
						if (new File(PCFR.getModificationPolicy()).exists()) {
							if (modificationPolicyManager
									.CheckMachineDuplicationError(new File(PCFR
											.getModificationPolicy()))) {
								modificationPolicyManager = new ModificationPolicyManager();
								modificationPolicyManager
										.ReadModificationPolicy(new File(PCFR
												.getModificationPolicy()));
								IMPM.setModificationPolicyManager(modificationPolicyManager);
							} else {
								logger.debug("\nWrong modification policy definition file\n");
								modificationPolicyManager = new ModificationPolicyManager();
								IMPM.setModificationPolicyManager(modificationPolicyManager);
							}

						} else {
							logger.debug("\nFile containing modification policy definition does not exist file\n");
							modificationPolicyManager = new ModificationPolicyManager();
							IMPM.setModificationPolicyManager(modificationPolicyManager);
						}

					} else {
						modificationPolicyManager = new ModificationPolicyManager();
						IMPM.setModificationPolicyManager(modificationPolicyManager);
					}

					if (PCFR.getAccessPolicy().length() > 0) {
						if (new File(PCFR.getAccessPolicy()).exists()) {
							if (accessPolicyManager
									.CheckMachineDuplicationError(new File(PCFR
											.getAccessPolicy()))) {
								accessPolicyManager = new AccessPolicyManager();
								accessPolicyManager.ReadAccessPolicy(new File(
										PCFR.getAccessPolicy()));
								IAPM.setAccessPolicy(accessPolicyManager);
							} else {
								logger.debug("\nWrong access policy definition file\n");
								accessPolicyManager = new AccessPolicyManager();
								IAPM.setAccessPolicy(accessPolicyManager);
							}

						} else {
							logger.debug("\nFile containing modification policy definition does not exist file\n");
							accessPolicyManager = new AccessPolicyManager();
							IAPM.setAccessPolicy(accessPolicyManager);
						}

					} else {
						accessPolicyManager = new AccessPolicyManager();
						IAPM.setAccessPolicy(accessPolicyManager);
					}
					if (PCFR.getCompiledImplementations().length() > 0) {
						if (new File(PCFR.getCompiledImplementations())
								.exists()) {
							if (compiledImplementationManager
									.CheckMIPairDuplicationError(new File(PCFR
											.getCompiledImplementations()))) {
								compiledImplementationManager = new CompiledImplementationManager();
								compiledImplementationManager
										.ReadMIPairDefinition(new File(PCFR
												.getCompiledImplementations()));
								ICIM.setCompiledImplementationsManager(compiledImplementationManager);

							} else {
								logger.debug("Wrong compiled implementations definition file");
								compiledImplementationManager = new CompiledImplementationManager();
								ICIM.setCompiledImplementationsManager(compiledImplementationManager);
							}

						} else {
							logger.debug("\nFile containing compiled implementations definition does not exist\n");
							compiledImplementationManager = new CompiledImplementationManager();
							ICIM.setCompiledImplementationsManager(compiledImplementationManager);
						}
					} else {
						compiledImplementationManager = new CompiledImplementationManager();
						ICIM.setCompiledImplementationsManager(compiledImplementationManager);
					}

					if (PCFR.getExcludedWords().length() > 0) {
						if (new File(PCFR.getExcludedWords()).exists()) {
							if (excludedWordsManager
									.checkExcludedWordsDefinition(new File(PCFR
											.getExcludedWords()))) {
								excludedWordsManager = new ExcludedWordsManager();
								excludedWordsManager
										.ReadExcludedWords(new File(PCFR
												.getExcludedWords()));
								IEWM.SetExcludedWordsmanager(excludedWordsManager);
								IEWM.SetExcludedWordsFile(new File(PCFR
										.getExcludedWords()));
							} else {
								logger.debug("\nWrong excluded words definition file\n");
								excludedWordsManager = new ExcludedWordsManager();
								IEWM.SetExcludedWordsmanager(excludedWordsManager);
								IEWM.SetExcludedWordsFile(null);

							}
						} else {
							logger.debug("\nFile containing excluded words definition does not exist\n");
							excludedWordsManager = new ExcludedWordsManager();
							IEWM.SetExcludedWordsmanager(excludedWordsManager);
							IEWM.SetExcludedWordsFile(null);
						}

					} else {
						excludedWordsManager = new ExcludedWordsManager();
						IEWM.SetExcludedWordsmanager(excludedWordsManager);
						IEWM.SetExcludedWordsFile(null);
					}
				} else {
					logger.debug("\nWrong configuration file definition\n");
					excludedWordsManager = new ExcludedWordsManager();
					IEWM.SetExcludedWordsmanager(excludedWordsManager);
					IEWM.SetExcludedWordsFile(null);
					compiledImplementationManager = new CompiledImplementationManager();
					ICIM.setCompiledImplementationsManager(compiledImplementationManager);
					accessPolicyManager = new AccessPolicyManager();
					IAPM.setAccessPolicy(accessPolicyManager);
					modificationPolicyManager = new ModificationPolicyManager();
					IMPM.setModificationPolicyManager(modificationPolicyManager);
				}
			} else {
				excludedWordsManager = new ExcludedWordsManager();
				IEWM.SetExcludedWordsmanager(excludedWordsManager);
				IEWM.SetExcludedWordsFile(null);
				compiledImplementationManager = new CompiledImplementationManager();
				ICIM.setCompiledImplementationsManager(compiledImplementationManager);
				accessPolicyManager = new AccessPolicyManager();
				IAPM.setAccessPolicy(accessPolicyManager);
				modificationPolicyManager = new ModificationPolicyManager();
				IMPM.setModificationPolicyManager(modificationPolicyManager);

			}
		} else {
			projectDirectory = null;
			selectedProject = null;
			jButton1.setEnabled(false);
			jButton2.setEnabled(false);
			jMenuItem1.setEnabled(false);
			jMenuItem2.setEnabled(false);
			jMenuItem3.setEnabled(false);
			jMenuItem4.setEnabled(false);
			jMenuItem7.setEnabled(false);
			jMenuItem8.setEnabled(false);
		}
	}

	private void recentProjectsComboBoxPropertyChange(
			java.beans.PropertyChangeEvent evt) {

	}

	private void bProjectPopupMenuMousePressed(java.awt.event.MouseEvent evt) {

	}

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		/*
		this.parseProjectAsynchronously("Java", this.projectDirectory,
				compiledImplementationManager
						.AllMachineImplementationPairs("Java"),
				excludedWordsManager.getExcludedWords("Java"),
				this.modificationPolicyManager
						.getLanguageModificationPolicy("Java"),
				this.accessPolicyManager.getAccessPolicy("Java"));*/
		
		this.parseProjectAsynchronously("Java", this.projectDirectory,
				compiledImplementationManager
						.AllMachineImplementationPairs("Java"),
				excludedWordsManager.getExcludedWords("Java"),
				this.IMPM.getModificationPolicyManager()
						.getLanguageModificationPolicy("Java"),
				this.IAPM.getAccessPolicyManager().getAccessPolicy("Java"));
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		PropertyConfigurator.configure("log4j.properties");
		try {
			UIManager
					.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
		} catch (Exception ex) {
			logger.log(Level.ERROR, null, ex);
		}
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new MainWindow().setVisible(true);
			}
		});
	}

	//GEN-BEGIN:variables
	// Variables declaration - do not modify
	private javax.swing.JPopupMenu bProjectPopupMenu;
	private javax.swing.JScrollPane consoleScrollPane;
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JMenu jMenu1;
	private javax.swing.JMenu jMenu2;
	private javax.swing.JMenu jMenu3;
	private javax.swing.JMenuItem jMenuItem1;
	private javax.swing.JMenuItem jMenuItem2;
	private javax.swing.JMenuItem jMenuItem3;
	private javax.swing.JMenuItem jMenuItem4;
	private javax.swing.JMenuItem jMenuItem5;
	private javax.swing.JMenuItem jMenuItem6;
	private javax.swing.JMenuItem jMenuItem7;
	private javax.swing.JMenuItem jMenuItem8;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JSeparator jSeparator1;
	private javax.swing.JSeparator jSeparator2;
	private java.awt.Label label1;
	private javax.swing.JMenuBar menuBar;
	private javax.swing.JTree projectDirectoryTree;
	private javax.swing.JComboBox recentProjectsComboBox;
	// End of variables declaration//GEN-END:variables

}