package sk.tuke.bkpi.configReaders;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class CompilerConfigurationFileReader {

	private String defaultBprojectsDirectory = new String();
	public void setDefaultBprojectsDirectory(String defaultBprojectsDirectory) {
		this.defaultBprojectsDirectory = defaultBprojectsDirectory;
	}

	public void setProjectConfigurationFileName(String projectConfigurationFileName) {
		this.projectConfigurationFileName = projectConfigurationFileName;
	}

	public void setDefaultTextEditor(String defaultTextEditor) {
		this.defaultTextEditor = defaultTextEditor;
	}

	private String projectConfigurationFileName = new String();
	private String defaultTextEditor = new String();
	
	public boolean ReadConfigurationFile(File configurationFile)
	{
		StringBuffer contents = new StringBuffer();
		BufferedReader reader = null; 
		try {
		      reader = new BufferedReader(new FileReader(configurationFile));
              String text = null;
		      while ((text = reader.readLine()) != null) {
		               contents.append(text)
	                   .append(System.getProperty(
		                        "line.separator"));
		           }
		    } catch (FileNotFoundException e) {
		           e.printStackTrace();
		    } catch (IOException e) {
		            e.printStackTrace();
		    } finally {
		                try {
		                if (reader != null) {
		                    reader.close();
		                }
		              } catch (IOException e) {
		                e.printStackTrace();
		                                      }
		    }
		  
		String INIDefinition = new String(contents.toString());

	  if (!INIDefinition.matches("(((\\s)*(Projects|ConfigurationFile|TextEditor)[ \\t]*=[ \\t]*\"[^\"\\n]*\"(\\s)*\\n)*)|(\\s)*"))
	  {   
		  return false;
	  }
	  else
	  {
		String[] INILines = INIDefinition.split("\\n");  
		
		for (String INILine: INILines)
		{
			Boolean Paranthesis = false;
			String trimmedINILineString = new String();
			for (int count = 0; count < INILine.length(); count++)
			{
				if (INILine.substring(count, count + 1).equals("\""))
				{
					Paranthesis = !Paranthesis;
				}
				
				if (Paranthesis == true)
				{
					trimmedINILineString = trimmedINILineString + INILine.substring(count, count + 1);
				}
				
				if (Paranthesis == false && !INILine.substring(count, count + 1).matches("\\s"))
				{
					trimmedINILineString = trimmedINILineString + INILine.substring(count, count + 1);
				}	
			}
			
			if (trimmedINILineString.startsWith("Projects"))
			{
				this.defaultBprojectsDirectory = trimmedINILineString.substring(trimmedINILineString.indexOf("\"") + 1, trimmedINILineString.length() - 1);
			}
			
			if (trimmedINILineString.startsWith("ConfigurationFile"))
			{
				this.projectConfigurationFileName = trimmedINILineString.substring(trimmedINILineString.indexOf("\"") + 1, trimmedINILineString.length() - 1);
			}
			
			if (trimmedINILineString.startsWith("TextEditor"))
			{
				this.defaultTextEditor = trimmedINILineString.substring(trimmedINILineString.indexOf("\"") + 1, trimmedINILineString.length() - 1);
			}						
		}
	  }
      return true;
	}
	
	public String getDefaultBprojectsDirectory() {
		return defaultBprojectsDirectory;
	}

	public String getProjectConfigurationFileName() {
		return projectConfigurationFileName;
	}

	public String getDefaultTextEditor() {
		return defaultTextEditor;
	}

	public void WriteConfigurationFile (File configurationFile)
	{
		FileWriter outFile;
		try {
			outFile = new FileWriter(configurationFile);
			PrintWriter out = new PrintWriter(outFile);
			out.printf("Projects = \"%s\"\n", this.defaultBprojectsDirectory);
			out.printf("ConfigurationFile = \"%s\"\n", this.projectConfigurationFileName);
			out.printf("TextEditor = \"%s\"\n", this.defaultTextEditor);
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
