package sk.tuke.bkpi.configReaders;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class ProjectConfigurationFileReader {
	
	private String CompiledImplementations = new String();
	private String ExcludedWords = new String();
	private String ModificationPolicy = new String();
	private String AccessPolicy = new String();

	public boolean ReadConfigurationFile(File configurationFile)
	{
		StringBuffer contents = new StringBuffer();
		BufferedReader reader = null; 
		try {
		      reader = new BufferedReader(new FileReader(configurationFile));
              String text = null;
		      while ((text = reader.readLine()) != null) {
		               contents.append(text)
	                   .append(System.getProperty(
		                        "line.separator"));
		           }
		    } catch (FileNotFoundException e) {
		           e.printStackTrace();
		    } catch (IOException e) {
		            e.printStackTrace();
		    } finally {
		                try {
		                if (reader != null) {
		                    reader.close();
		                }
		              } catch (IOException e) {
		                e.printStackTrace();
		                                      }
		    }
		  
		String INIDefinition = new String(contents.toString());

	  if (!INIDefinition.matches("(((\\s)*(CompiledImplementations|ExcludedWords|ModificationPolicy|AccessPolicy)[ \\t]*=[ \\t]*\"[^\"\\n]*\"(\\s)*\\n)*)|(\\s)*"))
	  {   
		  return false;
	  }
	  else
	  {
		String[] INILines = INIDefinition.split("\\n");  
		
		for (String INILine: INILines)
		{
			Boolean Paranthesis = false;
			String trimmedINILineString = new String();
			for (int count = 0; count < INILine.length(); count++)
			{
				if (INILine.substring(count, count + 1).equals("\""))
				{
					Paranthesis = !Paranthesis;
				}
				
				if (Paranthesis == true)
				{
					trimmedINILineString = trimmedINILineString + INILine.substring(count, count + 1);
				}
				
				if (Paranthesis == false && !INILine.substring(count, count + 1).matches("\\s"))
				{
					trimmedINILineString = trimmedINILineString + INILine.substring(count, count + 1);
				}	
			}
			
			if (trimmedINILineString.startsWith("CompiledImplementations"))
			{
				this.CompiledImplementations = trimmedINILineString.substring(trimmedINILineString.indexOf("\"") + 1, trimmedINILineString.length() - 1);
			}
			
			if (trimmedINILineString.startsWith("ExcludedWords"))
			{
				this.ExcludedWords = trimmedINILineString.substring(trimmedINILineString.indexOf("\"") + 1, trimmedINILineString.length() - 1);
			}
			
			if (trimmedINILineString.startsWith("ModificationPolicy"))
			{
				this.ModificationPolicy = trimmedINILineString.substring(trimmedINILineString.indexOf("\"") + 1, trimmedINILineString.length() - 1);
			}		
			
			if (trimmedINILineString.startsWith("AccessPolicy"))
			{
				this.AccessPolicy = trimmedINILineString.substring(trimmedINILineString.indexOf("\"") + 1, trimmedINILineString.length() - 1);
			}	
								
		}
	  }
      return true;
	}

	public void WriteConfigurationFile (File configurationFile)
	{
		FileWriter outFile;
		try {
			outFile = new FileWriter(configurationFile);
			PrintWriter out = new PrintWriter(outFile);
			out.printf("CompiledImplementations = \"%s\"\n", this.CompiledImplementations);
			out.printf("ExcludedWords = \"%s\"\n", this.ExcludedWords);
			out.printf("ModificationPolicy = \"%s\"\n", this.ModificationPolicy);
			out.printf("AccessPolicy = \"%s\"\n", this.AccessPolicy);
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String getCompiledImplementations() {
		return CompiledImplementations;
	}

	public void setCompiledImplementations(String compiledImplementations) {
		CompiledImplementations = compiledImplementations;
	}

	public String getExcludedWords() {
		return ExcludedWords;
	}

	public void setExcludedWords(String excludedWords) {
		ExcludedWords = excludedWords;
	}

	public String getModificationPolicy() {
		return ModificationPolicy;
	}

	public void setModificationPolicy(String modificationPolicy) {
		ModificationPolicy = modificationPolicy;
	}

	public String getAccessPolicy() {
		return AccessPolicy;
	}

	public void setAccessPolicy(String accessPolicy) {
		AccessPolicy = accessPolicy;
	}

}
