package sk.tuke.bkpi.extensions;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;

public class AccessPolicyManager {
	
	private Hashtable <String, ArrayList <ClassAccessPolicy>> accessPolicy = new Hashtable <String, ArrayList <ClassAccessPolicy>>();

	public boolean CheckAccessPolicyDefinitionSyntax (String accessPolicy)
	{
		if (accessPolicy.matches("(((\\s)*#ACCESS_POLICY_DEFINITION(\\s)*((\\s)+#LANGUAGES(\\s)*=(\\s)*\\[(\\s)*(\\w)+(\\s)*(,(\\s)*(\\w)+(\\s)*)*\\]((\\s)+ALL_ALLOWED_EXCEPT_FORBIDDEN|(\\s)+ALL_FORBIDDEN_EXCEPT_ALLOWED((((\\s)+Comment(\\s)*)?((\\s)+Report(\\s)*)?((\\s)+Code(\\s*))?)|(((\\s)+Comment(\\s)*)?((\\s)+Code(\\s)*)?((\\s)+Report(\\s*))?)|(((\\s)+Code(\\s)*)?((\\s)+Report(\\s)*)?((\\s)+Comment(\\s*))?)|(((\\s)+Code(\\s)*)?((\\s)+Comment(\\s)*)?((\\s)+Report(\\s*))?)|(((\\s)+Report(\\s)*)?((\\s)+Comment(\\s)*)?((\\s)+Code(\\s*))?)|(((\\s)+Report(\\s)*)?((\\s)+Code(\\s)*)?((\\s)+Comment(\\s*))?))|(((\\s)+#MACHINES(\\s)*=(\\s)*\\[(\\s)*(\\w)+(\\s)*(,(\\s)*(\\w)+(\\s)*)*\\](\\s)*:(\\s)*(ALL_ALLOWED_EXCEPT_FORBIDDEN|ALL_FORBIDDEN_EXCEPT_ALLOWED((((\\s)+Comment(\\s)*)?((\\s)+Report(\\s)*)?((\\s)+Code(\\s*))?)|(((\\s)+Comment(\\s)*)?((\\s)+Code(\\s)*)?((\\s)+Report(\\s*))?)|(((\\s)+Code(\\s)*)?((\\s)+Report(\\s)*)?((\\s)+Comment(\\s*))?)|(((\\s)+Code(\\s)*)?((\\s)+Comment(\\s)*)?((\\s)+Report(\\s*))?)|(((\\s)+Report(\\s)*)?((\\s)+Comment(\\s)*)?((\\s)+Code(\\s*))?)|(((\\s)+Report(\\s)*)?((\\s)+Code(\\s)*)?(\\s)+Comment(\\s*))?)))+((\\s+)#ALL_OTHERS(\\s)+(ALLOW|FORBID)(\\s)*)?)))*(\\s)*)|(\\s)*)"))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public String TrimAccessPolicy (String modificationPolicy)
	{
		String trimmedModificationPolicy = new String();
		for (int count = 0; count < modificationPolicy.length(); count++)
		{
		
			if (modificationPolicy.substring(count, count + 1).matches("[\\w,#\\[\\]=:]"))
			{
				trimmedModificationPolicy = trimmedModificationPolicy + modificationPolicy.substring(count, count + 1);
			}
		}
		return trimmedModificationPolicy;
	}
	
	public boolean CheckLanguageDuplicationError(String accessPolicy)
	{
		if (CheckAccessPolicyDefinitionSyntax(accessPolicy))
		{
			ArrayList <String> Languages = new ArrayList <String>();
			
			String trimmedModificationPolicy = TrimAccessPolicy(accessPolicy);
			String[] policyOfLanguageGroups = trimmedModificationPolicy.split("#LANGUAGES"); 
			for (String policyOfLanguageGroup: policyOfLanguageGroups)
			{
				if (policyOfLanguageGroup.startsWith("="))
				{
					String languageList = policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("[") + 1, policyOfLanguageGroup.indexOf("]"));
					String[] languagesOfLanguageGroup = languageList.split(",");
					for (String languageOfLanguageGroup: languagesOfLanguageGroup)
					{
						if (!Languages.contains(languageOfLanguageGroup))
						{
							Languages.add(languageOfLanguageGroup);
						}
						else
						{
							return false;
						}
					}
				}
			}
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public boolean CheckMachineDuplicationError(String accessPolicy)
	{
		
		if (CheckLanguageDuplicationError(accessPolicy))
		{
			String trimmedModificationPolicy = TrimAccessPolicy(accessPolicy);
			String[] policyOfLanguageGroups = trimmedModificationPolicy.split("#LANGUAGES"); 
			for (String policyOfLanguageGroup: policyOfLanguageGroups)
			{
				ArrayList <String> definedMachinesOfLanguageGroup = new ArrayList <String>();
				while (policyOfLanguageGroup.contains("#MACHINES"))
				{
					
					String MachinesOfPolicyDefinition = policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("#MACHINES") + 9);
					policyOfLanguageGroup = policyOfLanguageGroup.substring(0, policyOfLanguageGroup.indexOf("#MACHINES")) + policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("#MACHINES") + 9, policyOfLanguageGroup.length());
					ArrayList <String> MachinesOfPolicyDefinitionArray = new ArrayList <String> (Arrays.asList((MachinesOfPolicyDefinition.substring(MachinesOfPolicyDefinition.indexOf("[") + 1, MachinesOfPolicyDefinition.indexOf("]"))).split(",")));
					
					for (String MachineOfPolicyDefiniton: MachinesOfPolicyDefinitionArray)
					{
						if (!definedMachinesOfLanguageGroup.contains(MachineOfPolicyDefiniton))
						{
							definedMachinesOfLanguageGroup.add(MachineOfPolicyDefiniton);
						}
						else
						{
							return false;
						}
					}
				}
			}
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public boolean CheckMachineDuplicationError(File accessPolicy)
	{
		StringBuffer contents = new StringBuffer();
		BufferedReader reader = null; 
		try {
		      reader = new BufferedReader(new FileReader(accessPolicy));
              String text = null;
		      while ((text = reader.readLine()) != null) {
		               contents.append(text)
	                   .append(System.getProperty(
		                        "line.separator"));
		           }
		      
		      return CheckMachineDuplicationError (contents.toString());
		    } catch (FileNotFoundException e) {
		           e.printStackTrace();
		    } catch (IOException e) {
		            e.printStackTrace();
		    } finally {
		                try {
		                if (reader != null) {
		                    reader.close();
		                }
		              } catch (IOException e) {
		                e.printStackTrace();
		                                      }
		    }
		    return false;
	}
	

	public void ReadAccessPolicy (String accessPolicy)
	{
		if (CheckMachineDuplicationError(accessPolicy))
		{

			String trimmedModificationPolicy = TrimAccessPolicy(accessPolicy);
			String[] policyOfLanguageGroups = trimmedModificationPolicy.split("#LANGUAGES"); 
			
			for (String policyOfLanguageGroup: policyOfLanguageGroups)
			{
				if (policyOfLanguageGroup.startsWith("="))
				{
					
					String languageList = policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("[") + 1, policyOfLanguageGroup.indexOf("]"));
					String[] languagesOfLanguageGroup = languageList.split(",");
					
					for (String languageOfLanguageGroup: languagesOfLanguageGroup)
					{
						this.accessPolicy.put(languageOfLanguageGroup, new ArrayList<ClassAccessPolicy>());
					}
					
					if (policyOfLanguageGroup.contains("#MACHINES"))
					{
						
						while (policyOfLanguageGroup.contains("#MACHINES"))
						{
							
							String MachinesOfPolicyDefinition = policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("#MACHINES") + 9);
							Integer machinesClauseIndex = policyOfLanguageGroup.indexOf("#MACHINES");
							policyOfLanguageGroup = policyOfLanguageGroup.substring(0, policyOfLanguageGroup.indexOf("#MACHINES")) + policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("#MACHINES") + 9, policyOfLanguageGroup.length());
							ArrayList <String> MachinesOfPolicyDefinitionArray = new ArrayList <String> (Arrays.asList((MachinesOfPolicyDefinition.substring(MachinesOfPolicyDefinition.indexOf("[") + 1, MachinesOfPolicyDefinition.indexOf("]"))).split(",")));
							
							String policyOfMachineGroup = new String();
							if (policyOfLanguageGroup.contains("#MACHINES"))
							{
							 	policyOfMachineGroup = policyOfLanguageGroup.substring(machinesClauseIndex, policyOfLanguageGroup.indexOf("#MACHINES"));
							}
							else
							{
								policyOfMachineGroup = policyOfLanguageGroup.substring(machinesClauseIndex, policyOfLanguageGroup.length());
							}
							
							if (policyOfMachineGroup.contains("ALL_FORBIDDEN_EXCEPT_ALLOWED"))
							{
								
								Integer allForbiddenPolicyImplementation = 1;
								
								if (policyOfMachineGroup.contains("Comment"))
								{
									allForbiddenPolicyImplementation = allForbiddenPolicyImplementation + 10;
								}
								
								if (policyOfMachineGroup.contains("Report"))
								{
									allForbiddenPolicyImplementation = allForbiddenPolicyImplementation + 100;
								}							
								
								if ((!policyOfMachineGroup.contains("Code")) && (allForbiddenPolicyImplementation != 1))
								{
									allForbiddenPolicyImplementation--;
								}
								
								for (String languageOfLanguageGroup: languagesOfLanguageGroup)
								{
									for (String machineOfMachineGroup: MachinesOfPolicyDefinitionArray)
									{
									  this.accessPolicy.get(languageOfLanguageGroup).add(new ClassAccessPolicy(machineOfMachineGroup, allForbiddenPolicyImplementation));
									}
								}
								
							}
							else
							{
								for (String languageOfLanguageGroup: languagesOfLanguageGroup)
								{
									for (String machineOfMachineGroup: MachinesOfPolicyDefinitionArray)
									{
									  this.accessPolicy.get(languageOfLanguageGroup).add(new ClassAccessPolicy(machineOfMachineGroup, 0));
									}
								}	
							}	
						}
						
						if (policyOfLanguageGroup.contains("#ALL_OTHERSFORBID"))
						{
							for (String languageOfLanguageGroup: languagesOfLanguageGroup)
							{
								this.accessPolicy.get(languageOfLanguageGroup).add(new ClassAccessPolicy(111));	
							}	
						}
						else
						{
							for (String languageOfLanguageGroup: languagesOfLanguageGroup)
							{
								this.accessPolicy.get(languageOfLanguageGroup).add(new ClassAccessPolicy());
							}
						}
					}
					else
					{
						if (policyOfLanguageGroup.contains("ALL_FORBIDDEN_EXCEPT_ALLOWED"))
						{
							Integer allForbiddenPolicyImplementation = 1;
							
							if (policyOfLanguageGroup.contains("Comment"))
							{
								allForbiddenPolicyImplementation = allForbiddenPolicyImplementation + 10;
							}
							
							if (policyOfLanguageGroup.contains("Report"))
							{
								allForbiddenPolicyImplementation = allForbiddenPolicyImplementation + 100;
							}							
							
							if ((!policyOfLanguageGroup.contains("Code")) && (allForbiddenPolicyImplementation != 1))
							{
								allForbiddenPolicyImplementation--;
							}

							for (String languageOfLanguageGroup: languagesOfLanguageGroup)
							{
								this.accessPolicy.get(languageOfLanguageGroup).add(new ClassAccessPolicy(allForbiddenPolicyImplementation));
							}	
						}
						else
						{
							for (String languageOfLanguageGroup: languagesOfLanguageGroup)
							{
								this.accessPolicy.get(languageOfLanguageGroup).add(new ClassAccessPolicy());
							}
						}
					}
				}
			}
		}
	}
	
	public void ReadAccessPolicy (File accessPolicy)
	{
		StringBuffer contents = new StringBuffer();
		BufferedReader reader = null; 
		try {
		      reader = new BufferedReader(new FileReader(accessPolicy));
              String text = null;
		      while ((text = reader.readLine()) != null) {
		               contents.append(text)
	                   .append(System.getProperty(
		                        "line.separator"));
		           }
		      
		       ReadAccessPolicy (contents.toString());
		    } catch (FileNotFoundException e) {
		           e.printStackTrace();
		    } catch (IOException e) {
		            e.printStackTrace();
		    } finally {
		                try {
		                if (reader != null) {
		                    reader.close();
		                }
		              } catch (IOException e) {
		                e.printStackTrace();
		                                      }
		    }
	}
	
	public String WriteAccessPolicy()
	{
		String accessPolicy = new String("#ACCESS_POLICY_DEFINITION\n");
		
		for (String Language: this.accessPolicy.keySet())
		{
			accessPolicy = accessPolicy + "#LANGUAGES = [" + Language + "]\n";
			if (this.accessPolicy.get(Language).size() > 1)
			{
				Boolean globalPolicy = true;
				
				for (ClassAccessPolicy CAP: this.accessPolicy.get(Language))
				{
					if (!CAP.getClassName().equals("#ALL"))
					{
						accessPolicy = accessPolicy + "  #MACHINES = [" + CAP.getClassName() + "] : ";
						
						//
						
						if (CAP.getClassAccessPolicy() != 0)
						{
							Boolean code = false;
							Boolean comment = false;
							Boolean report = false;
							accessPolicy = accessPolicy + "ALL_FORBIDDEN_EXCEPT_ALLOWED";
							Integer accessPolicyImplementation = CAP.getClassAccessPolicy();
							if (accessPolicyImplementation > 99)
							{
								report = true;
								accessPolicyImplementation = accessPolicyImplementation - 100;
							}
							
							if (accessPolicyImplementation > 9)
							{
								comment = true;
								accessPolicyImplementation = accessPolicyImplementation - 10;
							}
							
							if (accessPolicyImplementation > 0)
							{
								code = true;
							}
							
							if (code == true)
							{
							 accessPolicy = accessPolicy + " Code";	
							}
							if (comment == true)
							{
								accessPolicy = accessPolicy + " Comment";
							}
							if (report == true)
							{
								accessPolicy = accessPolicy + " Report";
							}
							
							accessPolicy = accessPolicy + "\n";
						}
						else
						{
						 	accessPolicy = accessPolicy + "ALL_ALLOWED_EXCEPT_FORBIDDEN\n";
						}

						
						//
						
					}
					else
					{
						if (CAP.getClassAccessPolicy() == 0)
						{
							globalPolicy = true;
						}
						else
						{
							globalPolicy = false;
						}
					}
				}
				
				if (globalPolicy == true)
				{
					accessPolicy = accessPolicy + "  #ALL_OTHERS ALLOW\n";
				}
				else
				{
					accessPolicy = accessPolicy + "  #ALL_OTHERS FORBID\n";	
				}
				
			}
			else
			{
				if (this.accessPolicy.get(Language).get(0).getClassAccessPolicy() != 0)
				{
					Boolean code = false;
					Boolean comment = false;
					Boolean report = false;
					accessPolicy = accessPolicy + "  ALL_FORBIDDEN_EXCEPT_ALLOWED";
					Integer accessPolicyImplementation = this.accessPolicy.get(Language).get(0).getClassAccessPolicy();
					if (accessPolicyImplementation > 99)
					{
						report = true;
						accessPolicyImplementation = accessPolicyImplementation - 100;
					}
					
					if (accessPolicyImplementation > 9)
					{
						comment = true;
						accessPolicyImplementation = accessPolicyImplementation - 10;
					}
					
					if (accessPolicyImplementation > 0)
					{
						code = true;
					}
					
					if (code == true)
					{
					 accessPolicy = accessPolicy + " Code";	
					}
					if (comment == true)
					{
						accessPolicy = accessPolicy + " Comment";
					}
					if (report == true)
					{
						accessPolicy = accessPolicy + " Report";
					}
					
					accessPolicy = accessPolicy + "\n";
				}
				else
				{
				 	accessPolicy = accessPolicy + "  ALL_ALLOWED_EXCEPT_FORBIDDEN\n";
				}
			}
		}

		return accessPolicy;
	}
	
	public ArrayList <ClassAccessPolicy> getAccessPolicy (String language)
	{
		if (this.accessPolicy.containsKey(language))
		{
			return this.accessPolicy.get(language);
		}
		else
		{
			ArrayList <ClassAccessPolicy> languageAccessPolicy = new ArrayList <ClassAccessPolicy>();
			languageAccessPolicy.add(new ClassAccessPolicy());
			return languageAccessPolicy;
		}
	}
	
}
