package sk.tuke.bkpi.generator;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import sk.tuke.bkpi.model.Project;
import sk.tuke.bkpi.model.component.Implementation;
import sk.tuke.bkpi.model.component.Machine;

public class CompiledImplementationsResolver {
	
	private Map <String, List <String>> implementations_per_machine = new Hashtable <String, List<String>>();
	
	
	Hashtable <String, String> MIPairs = new Hashtable <String, String>();


   public void createImplementationsPerMachine(List<Machine> machines, List<Implementation> implementations)
   {
	   for (Machine machine:machines)
	   {
		   for (Implementation implementation: implementations)
		   {
			   if (implementation.abstractMachine().name().equals(machine.name()))
			   {
				   if (this.implementations_per_machine.containsKey(machine.name()))
				   {
					   this.implementations_per_machine.get(machine.name()).add(implementation.name());
				   }
				   else
				   {
					   this.implementations_per_machine.put(machine.name(), new ArrayList <String>());
					   this.implementations_per_machine.get(machine.name()).add(implementation.name());
				   }
			   }
		   }
	   }
   }

	public void setMIPairs(Hashtable<String, String> mIPairs) {
		MIPairs = mIPairs;
	}
	
	public boolean generateImplementation (Machine machine, Implementation implementation)
	{

		if (this.MIPairs.containsKey(machine.name()))
		{
			if (this.MIPairs.get(machine.name()).equals(implementation.name()))
			{
				return true;
			}
			else
			{
				if (implementations_per_machine.get(machine.name()).contains(this.MIPairs.get(machine.name())))
				{
					return false;
				}
				else
				{
					this.MIPairs.remove(machine.name());
					this.MIPairs.put(machine.name(), implementation.name());
					return true;
				}	
			}
		}
		else
		{
			this.MIPairs.put(machine.name(), implementation.name());
			return true;
		}
		
	}
}
