package sk.tuke.bkpi.generator;

import sk.tuke.bkpi.model.Module;

public class JavaCodeGenerationException extends Error {

	private Module module;
	
	public JavaCodeGenerationException(String msg) {
		super(msg);
	}
	
	public JavaCodeGenerationException(Throwable cause) {
		super(cause);
	}
	
	public JavaCodeGenerationException(String msg, Throwable cause) {
		super(msg, cause);
	}
	
	public JavaCodeGenerationException(Throwable cause, Module module) {
		super(cause);
		this.module = module;
	}
	
	public JavaCodeGenerationException(String msg, Module module) {
		super(msg);
		this.module = module;
	}
	
	public void setSource(Module module) {
		if (this.module != null)
			throw new IllegalStateException("Cannot change module information");
		this.module = module;
	}
	
	public Module getSource() {
		return module;
	}
}
