package sk.tuke.bkpi.generator;

import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Map;
import sk.tuke.bkpi.model.Project;

public class MachineNameManager {
	
	public MachineNameManager()
	{
		
	}
	
	private Collection<String> excluded_words = Collections.emptyList();
	
	public void setExcluded_words(String ... excluded_words) {
		this.excluded_words = Arrays.asList(excluded_words);
	}
	
	
	public void setExcluded_words(Collection<String> excluded_words) {
		this.excluded_words = excluded_words;
	}
	
	private Map <String, String> machine_names = new Hashtable <String, String>();
	private String main_class_name = new String();
	
	private Map <String, String> class_names = new Hashtable <String, String>();
	
    public void generate_machine_names (Project project)
    {
    	for (int countM = 0; countM < project.machines().size(); countM++)
    	{
    		
    		String proposal = new String (project.machines().get(countM).name());
    		
    		boolean generate_request = true;
    		while (generate_request == true)
    		{
    			generate_request = false;
    			if (excluded_words.contains(proposal) == true)
    			{
    				proposal = proposal + "_mch";
    				generate_request = true; 
    			}
    			for (int countC = 0; countC < project.machines().size(); countC++)
    			{ 
    				if ((countC != countM) && (proposal.equals( project.machines().get(countC).name())))
    				{ 
    					proposal = proposal + "_mch"; 
    					generate_request = true;
    				}
    			}	
    		}
    		
    		this.machine_names.put(project.machines().get(countM).name(), proposal);	
    	}
    }
    
    public String getResolvedName (String machine_name) 
    {
    	String result = new String();
    	if (this.machine_names.containsKey(machine_name))
    	{
    	 result = this.machine_names.get(machine_name);
    	}
    	else
    	{
    		result = null;
    	}
	    return result;    	
    }
    
    public boolean containsResolvedName (String machine_name)
    {
    	return this.machine_names.containsKey(machine_name);
    }
    
    public String generateMainMachineName()
    {
     	String proposal = new String("MainClass");
     	while (this.machine_names.containsValue(proposal))
     	{
     		proposal = proposal + "_mcls";
     	}
     	this.main_class_name = proposal;
     	return proposal;
    }
    
    public String generateUniqueClassName (String proposal)
    {
    	if (this.class_names.containsKey(proposal))
    	{
    	 return this.class_names.get(proposal);	
    	}
    	else
    	{
    		String result = new String(proposal);
    		while ( (this.excluded_words.contains(result)) || (this.machine_names.containsValue(result)) || (this.main_class_name.equals(result)) || (this.class_names.containsValue(result)))
    		{
    			result = result + "_cls";
    		}
    		this.class_names.put(proposal, result);
    		return result;
    	}
    }
    


}
