package sk.tuke.bkpi.generator.support;

import java.util.ArrayList;

import sk.tuke.bkpi.extensions.ClassModificationPolicy;

public class ModificationPolicyResolver {
	
	ArrayList <ClassModificationPolicy> languageModificationPolicy;
	
	public ModificationPolicyResolver (ArrayList <ClassModificationPolicy> languageModificationPolicy)
	{
		this.languageModificationPolicy = languageModificationPolicy;
	}
	
	public ClassModificationPolicy getClassModificationPolicy (String machineName)
	{
		
		ClassModificationPolicy globalModificationPolicy = new ClassModificationPolicy();
		
		for (ClassModificationPolicy classModificationPolicy :languageModificationPolicy)
		{
			
			if (classModificationPolicy.getClassName().equals(machineName))
			{
				return classModificationPolicy;
			}
			
			if (classModificationPolicy.getClassName().equals("#GLOBAL"))
			{
				globalModificationPolicy = classModificationPolicy;
			}
			
		}
		
		return globalModificationPolicy;
	}
	
	public boolean ApplyModificationPolicy (String MachineName)
	{
		if ((getClassModificationPolicy(MachineName).getMethodPolicy().index != 0) || (getClassModificationPolicy(MachineName).getAtributePolicy().index != 0) || (getClassModificationPolicy(MachineName).getConstructorPolicy().index != 0))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
}
