package sk.tuke.bkpi.gui;

import java.io.File;

import org.apache.log4j.AppenderSkeleton;
import org.apache.log4j.spi.LoggingEvent;

import sk.tuke.bkpi.complexGui.MainWindow;

/**
 * Appender for log4j library, redirecting logs to the single graphic console
 * component (instance of class <code>HtmlConsole</code>). Console component
 * is before needed to initialize by setting static field <code>htmlConsole</code>.
 * <code>HtmlConsoleAppender</code> should be used in combination with layout
 * (formatter) that convert logs (<code>LoggingEvent</code>) to the HTML format.
 * 
 * @author Marcel Dancak
 */
public class HtmlConsoleAppender extends AppenderSkeleton {

	public static HtmlConsole htmlConsole;
	
	@Override
	protected void append(final LoggingEvent log) {
		
		if (htmlConsole == null)
			return;
		if (log.getMessage() instanceof File) {
			htmlConsole.write(" ");
			//if hyperlinks aren't blue, use a little pause
			try {
	            Thread.sleep(30);// cannot explain, but hyperlinks are not blue without a little pause
	        } catch (InterruptedException ex) {
	            //java.util.logging.Logger.getLogger(SimpleGui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
	        	java.util.logging.Logger.getLogger(MainWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
	        }
		} else {
			if (!htmlConsole.isCleared()) {
				htmlConsole.writeHTML("<br/>");
			}
		}
		htmlConsole.writeHTML(getLayout().format(log));
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void close() {
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean requiresLayout() {
		return true;
	}

}
