package sk.tuke.bkpi.gui;

import java.io.PrintWriter;
import java.io.StringWriter;

import org.apache.log4j.Layout;
import org.apache.log4j.Level;
import org.apache.log4j.spi.LoggingEvent;

/**
 * Formats logging messages to HTML format, with different
 * color styles by their priority.
 * 
 * @author Marcel Dancak
 */
public class HtmlConsoleLayout extends Layout {

	@Override
	public String format(LoggingEvent log) {
		StringBuilder sb = new StringBuilder();
        switch (log.getLevel().toInt()) {
            case Level.ERROR_INT:
                sb.append("<span color='FF3333'>");
                break;
            case Level.WARN_INT:
                sb.append("<span color='#FF9900'>");
                break;
            case Level.DEBUG_INT:
                sb.append("<span color='339933'>");
                break;
            case Level.TRACE_INT:
                sb.append("<span color='33FF66'>");
                break;
            default:
                sb.append("<span color='#150517'>");
        }
        /*
		if (log.getLevel().isGreaterOrEqual(Level.ERROR)) {
			sb.append("<span color='red'>");
		} else if (log.getLevel().isGreaterOrEqual(Level.INFO)) {
			sb.append("<span color='black'>");
		} else if (log.getLevel().isGreaterOrEqual(Level.TRACE)) {
			sb.append("<span color='green'>");
		} else {
			sb.append("<span color='black'>");
		}
         */
		/*
		if (record.getSourceClassName() != null) {
			sb.append(record.getSourceClassName());
		} else {
			sb.append(record.getLoggerName());
		}
		if (record.getSourceMethodName() != null) {
			sb.append(" ");
			sb.append(record.getSourceMethodName());
		}
		sb.append("<br/>");
		*/
		String message = log.getRenderedMessage();
		//System.out.println("rendered msg: "+message);
		if (message == null)
			message = "";
		//message = message.replaceAll("&", "&amp;").replaceAll("<", "&lt;").replaceAll(">", "&gt;").replaceAll("\n", "<br/>");
		
		/*
		Pattern p = Pattern.compile("([.]*\\s)*(([\\w\\d_])+\\.mch)");
		//message = "	 asad asdsd  Matcher.mch";
		Matcher m = p.matcher(message);
		if (m.matches()) {
			System.out.println("match");
			System.out.println(m.group(1));
		}
		*/
		//message = message.replaceAll("*.mch", "odkaz");
		
		//sb.append(record.getLevel().getLocalizedName());
		//sb.append(": ");
		
		/*
		if (log.getParameters() != null) {
			for (Object param : record.getParameters())
				sb.append(String.format(message, "<a color='blue' href='file://"+param+"'> "+param+ "</a>"));
		} else {
			sb.append(message);
		}
		*/
		sb.append(message);
		if (log.getThrowableInformation() != null) {
			sb.append("<br/>");
			try {
				StringWriter sw = new StringWriter();
				PrintWriter pw = new PrintWriter(sw);
				log.getThrowableInformation().getThrowable().printStackTrace(pw);
				pw.close();
				sb.append(sw.toString());
                //sb.append(HtmlConsole.encodeHTML(sw.toString()));
			} catch (Exception ex) {
			}
		}
		
		sb.append("</span>");
		//System.out.println("********\n"+sb);
		return sb.toString();
	}

	@Override
	public boolean ignoresThrowable() {
		return false;
	}

	@Override
	public void activateOptions() {
		
	}

}
