/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sk.tuke.bkpi.gui;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JComponent;

/**
 * Swing component for displaying image file. Its preferred size
 * will be size of the image.
 * 
 * @author Marcel Dancak
 */
public class ImagePanel extends JComponent {

	private static final long serialVersionUID = 1L;
	
	private BufferedImage image;
    private Dimension size = new Dimension(0, 0);

    /**
     * Creates a new <code>ImagePanel</code> component instance
     * displaying image file <code>filename</code>.
     * 
     * @param filename path name of the file
     */
    public ImagePanel(String filename) throws IOException {
        this(new File(filename));
    }

    /**
     * Creates a new <code>ImagePanel</code> component instance
     * displaying image file <code>file</code>.
     * 
     * @param file image file
     */
    public ImagePanel(File file) throws IOException {
    	//if (!file.exists())
    	//	throw new FileNotFoundException("File: "+file+" does not exist");
        image = ImageIO.read(file);
        size.setSize(image.getWidth(), image.getHeight());
    }
    
    public ImagePanel(BufferedImage image) {
        this.image = image;
    }
    
    @Override
    protected void paintComponent(Graphics g) {
    	g = g.create();
    	g.setColor(getBackground());
        g.fillRect(0, 0, getWidth(), getHeight());
        
        g.drawImage(image, (getWidth()-size.width)/2, 2, this);
        g.dispose();
    }

    public Dimension getImageSize() {
        return size;
    }

    @Override
    public Dimension getPreferredSize() {
        return size;
    }
}
