package sk.tuke.bkpi.main;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import sk.tuke.bkpi.parser.ProjectParser;
import sk.tuke.bkpi.parser.javacc.ParseException;
import java.lang.reflect.Method;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.List;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineFactory;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import sk.tuke.bkpi.model.Identifier;
import sk.tuke.bkpi.model.Project;
import sk.tuke.bkpi.model.clause.Import;
import sk.tuke.bkpi.model.component.Machine;
import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.expression.IntegerLiteral;
import sk.tuke.bkpi.model.substitution.BecomesEqualSubstitution;

public class Main {
	
	public static void processString(String string) {
		System.out.println("process: "+string);
		System.out.println("substring: "+string.substring(1, string.length()-1));
		for (int i = 0 ; i < string.length(); i++) {
			System.out.println("char: "+string.charAt(i));
		}
	}
	/**
	 * @param args
	 * @throws FileNotFoundException 
	 * @throws ParseException 
	 * @throws NoSuchMethodException 
	 * @throws SecurityException 
	 * @throws InvocationTargetException 
	 * @throws IllegalAccessException 
	 * @throws IllegalArgumentException 
	 * @throws NoSuchFieldException 
	 * @throws ScriptException 
	 */
	
	public static void main(String[] args) throws FileNotFoundException, ParseException, SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException, NoSuchFieldException, ScriptException {
		
		String[] array = new String[10];
		String[][] array2 = new String[3][10];
		String[][][] array3 = new String[2][3][4];
		String[][][] array32 = fill2(new String[2][3][4], "32");
		System.out.println(Arrays.deepToString(array32));
		//Arrays.fill(array2[0], "multi");
		fill(array2, "multi");
		fill(array3, "3");
		System.out.println(Arrays.deepToString(array3));
		System.out.println(Arrays.deepToString(array2));
		Arrays.fill(array, "halo");
		
		System.out.println(Arrays.deepToString(array));
		for (String s : array) {
			System.out.println(s);
		}
		
		
		//File projectPath = new File("/home/dencer/AB/bprj/PersonnelSystem");
		File projectPath = new File("/home/dencer/AB/bprj/letisko");
    	ProjectParser parser = new ProjectParser(projectPath);
    	Project project = parser.parseProject(new Hashtable<String, String>());
    	Machine mch = project.machines().get(0);
    	Import i = new Import("haloo", mch);
    	
    	//System.out.println("fields: "+Arrays.asList(Import.class.getDeclaredFields()));
    	Field f = Import.class.getDeclaredField("parameters");
    	IntegerLiteral arg = new IntegerLiteral(5);
    	f.setAccessible(true);
    	f.set(i, Arrays.asList(arg));
    	System.out.println(f);
    	
    	System.out.println("parameters: "+i.formalParametersValues());
    	
    	ScriptEngineManager manager = new ScriptEngineManager();
        List<ScriptEngineFactory> engines = manager.getEngineFactories();
        if (engines.isEmpty()) {
            System.out.println("No scripting engines were found");
            return;
        }
        System.out.println("The following " + engines.size() +
            " scripting engines were found");
        System.out.println();
        for (ScriptEngineFactory engine : engines) {
            System.out.println("Engine name: " + engine.getEngineName());
            System.out.println("\tVersion: " + engine.getEngineVersion());
            System.out.println("\tLanguage: " + engine.getLanguageName());
            List<String> extensions = engine.getExtensions();
            if (extensions.size() > 0) {
                System.out.println("\tEngine supports the following extensions:");
                for (String e : extensions) {
                    System.out.println("\t\t" + e);
                }
            }
            List<String> shortNames = engine.getNames();
            if (shortNames.size() > 0) {
                System.out.println("\tEngine has the following short names:");
                for (String n : engine.getNames()) {
                    System.out.println("\t\t" + n);
                }
            }
            System.out.println("=========================");
        }
        ScriptEngine pyengine = new ScriptEngineManager().getEngineByName("python");
        
        pyengine.put("project", project);
        pyengine.eval(new FileReader("pyScript.py"));
        
		//System.out.println(i);
	}
	
	private static<T> T[] createArray(T value) {
		
		return null;
	}
	private static void fill(Object[] array, Object value) {
		if (array[0] instanceof Object[]) {
			for (Object subarray : array) {
				fill(((Object[]) subarray), value);
			}
		} else {
			Arrays.fill(array, value);
		}
	}
	
	private static<T> T[] fill2(T[] array, Object value) {
		if (array[0] instanceof Object[]) {
			for (Object subarray : array) {
				fill(((Object[]) subarray), value);
			}
		} else {
			Arrays.fill(array, value);
		}
		return array;
	}
	
	public Main() throws FileNotFoundException, ParseException, SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		//File dir = new File("/home/dencer/AB/types");
		File dir = new File("/home/dencer/AB/cgen");
		//File dir = new File("B");
		ProjectParser parser = new ProjectParser(dir);
		parser.parseProject(new Hashtable<String, String>());
	}
	
	/*
	public void generate(Object obj) {
		Method m;
		try {
			m = this.getClass().getMethod("generate", obj.getClass());
			m.invoke(this, obj);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void generate(BinaryExpression expr) {
		generate(expr.getLeft());
		switch (expr.getOperator()) {
		case PLUS:
			System.out.println("+");
			break;
		case MINUS:
			System.out.println("-");
			break;
		case TIMES:
			System.out.println("*");
			break;
		case DIVIDE:
			System.out.println("/");
			break;
		case MODULO:
			System.out.println("%");
			break;
		default:
			throw new IllegalStateException("Unsupported operator: "+expr.getOperator());
		}
		generate(expr.getRight());
	}
	
	public void generate(IntegerLiteral expr) {
		System.out.println(expr.getValue());
	}
	*/
}
