package sk.tuke.bkpi.model;

import java.util.ArrayList;
import java.util.List;

public class Identifier {

	private List<String> prefix;
	private String prefixString;
	private String name;
	
	public Identifier(List<String> list) {
		if (list.size() < 1)
			throw new IllegalArgumentException(
					"Cannot create Identifier from empty list!");

		prefix = new ArrayList<String>(list);
		int last = prefix.size() - 1;
		name = prefix.get(last);
		prefix.remove(last);
		
		prefixString = "";
		for (int i = 0; i < prefix.size(); i++) {
			if (i < prefix.size()-1)
				prefixString += prefix.get(i)+".";
			else
				prefixString += prefix.get(i);
		}
		if (prefixString == ".")
			throw new IllegalStateException("prefix is .");
	}

	public boolean hasPrefix() {
		return prefix != null && prefix.size() > 0;
	}

	public List<String> prefixList() {
		return prefix;
	}
	
	public String name() {
		if (hasPrefix())
			return prefix.get(0);
		return null;
	}
	
	public String prefixString() {
		return prefixString;
	}
	
	public String componentName() {
		return name;
	}

	@Override
	public String toString() {
		return hasPrefix()? prefixString+"."+name : name;
	}
}
