package sk.tuke.bkpi.model.b0data;

import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.types.Record;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class RecordFieldVariable extends B0Variable {

	private B0Variable recordVariable;
	private String field;
	
	public RecordFieldVariable(B0Variable recordVariable, String field) {
		if (recordVariable.type() instanceof Record) {
			Record recordType = (Record) recordVariable.type();
			if (recordType.hasField(field)) {
				type = ((Record)recordVariable.type()).fieldType(field);
			} else {
				throw new TypeCheckException("Record doesn't contain field: "+field);
			}
		} else {
			throw new TypeCheckException("Variable must be of record type");
		}
		
		this.recordVariable = recordVariable;
		this.field = field;
	}
	
	public B0Variable recordVariable() {
		return recordVariable;
	}
	
	public String field() {
		return field;
	}
	
	public RecordFieldVariable(DataField recordVariable, String field) {
		if (!(recordVariable.type() instanceof Record)) {
			throw new TypeCheckException("expected variable with Record type");
		}
		if (!((Record) recordVariable.type()).hasField(field)) {
			throw new TypeCheckException("record variable doesn't contain field: "+field);
		}
	}
	
	@Override
	public String toString() {
		return recordVariable+"."+field;
	}
}
