package sk.tuke.bkpi.model.clause;

import sk.tuke.bkpi.model.component.Machine;

public class ComponentReference {

	private String prefix;
	private String name;
	private Machine machine;
	
	public ComponentReference(Machine machine) {
		this.machine = machine;
	}
	
	public ComponentReference(String prefix, Machine machine) {
		this.prefix = prefix;
		this.machine = machine;
		this.name = prefix != null? prefix+"."+machine.name() : machine.name();
	}
	
	public Machine machine() {
		return machine;
	}
	
	public boolean isRenamed() {
		return prefix != null && prefix.length() > 0; 
	}
	
	public String prefixString() {
		return prefix;
	}
	
	public String name() {
		return name;
	}
}
