package sk.tuke.bkpi.model.clause;

import java.util.List;

import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.types.BasicType;
import sk.tuke.bkpi.model.types.SetType;
import sk.tuke.bkpi.model.types.Type;


public class EnumeratedSet extends Set {
	
	private List<Item> elements;
	
	public EnumeratedSet(String name, List<Item> elements) {
		super(name);
		this.elements = elements;
		Type elementType = type().baseType();
		for (Item item : elements) {
			item.typeData(elementType);
		}
	}
	
	public List<Item> items() {
		return elements;
	}
	
	public static class Item extends DataField {
		
		public Item(String name) {
			super(name);
		}
		
		@Override
		public DataField newData() {
			throw new UnsupportedOperationException("wait a second");
		}
		
		@Override
		public SetType type() {
			return (SetType) super.type();
		}
	}
	
	@Override
	public DataField newData() {
		throw new UnsupportedOperationException("wait a second");
	}
}
