package sk.tuke.bkpi.model.clause;

import java.util.Collections;
import java.util.List;

import sk.tuke.bkpi.model.Identifier;
import sk.tuke.bkpi.model.data.OperationInputParameter;
import sk.tuke.bkpi.model.data.OperationOutputParameter;
import sk.tuke.bkpi.model.instruction.Instruction;

public class OperationB0  {
	
	private OperationHeader header;
	private Instruction body;

	private String name;
	private List<OperationInputParameter> inputParameters;
	private List<OperationOutputParameter> outputParameters;
	
	public OperationB0(String name,
			List<OperationInputParameter> inputParameters,
			List<OperationOutputParameter> outputParameters,
			Instruction body) {
		this.name = name;
		this.inputParameters  = inputParameters != null? inputParameters : Collections.<OperationInputParameter>emptyList();
		this.outputParameters = outputParameters!= null? outputParameters: Collections.<OperationOutputParameter>emptyList();
		this.body = body;
	}
	
	public Identifier getName() {
		return header.operationName();
	}
	
	public String name() {
		return name;
	}
	
	public List<OperationInputParameter> inputParameters() {
		return inputParameters;
	}
	
	public List<OperationOutputParameter> outputParameters() {
		return outputParameters;
	}
	
	public Instruction body() {
		return body;
	}
}
