package sk.tuke.bkpi.model.clause;

import java.util.List;

import sk.tuke.bkpi.model.component.Machine;
import sk.tuke.bkpi.model.data.OperationInputParameter;
import sk.tuke.bkpi.model.data.OperationOutputParameter;

public class OperationDeclaration {

	
	private String operationName;
	private List<OperationInputParameter> inputParameters;
	private List<OperationOutputParameter> outputParameters;
	
	private ComponentReference source;
	
	public OperationDeclaration(String operationName,
			List<OperationInputParameter> inputParameters,
			List<OperationOutputParameter> outputParameters) {
		
		this.operationName = operationName;
		this.inputParameters = inputParameters;
		this.outputParameters = outputParameters;
	}
	
	public OperationDeclaration(ComponentReference source, String operationName,
			List<OperationInputParameter> inputParameters,
			List<OperationOutputParameter> outputParameters) {
		
		this(operationName, inputParameters, outputParameters);
		this.source = source;
	}
	
	public ComponentReference source() {
		return source;
	}
	
	public String operationCallName() {
		System.out.println("chain: "+source);
		if (source != null && source.isRenamed()) {
			return source.prefixString()+"."+operationName;
		}
		return operationName;
		//return source.prefixString().length() > 0? source.prefixString()+"."+operationName : operationName;
	}
	
	public String operationName() {
		return operationName;
	}
	
	public List<OperationInputParameter> inputParameters() {
		return inputParameters;
	}
	
	public List<OperationOutputParameter> outputParameters() {
		return outputParameters;
	}
	
	@Override
	public String toString() {
		return String.format("Operation declaration[name: %s, input parameters: %s, output parameters: %s]", operationName, inputParameters, outputParameters);
		//return "Operation declaration[name: "+operationName+" input parameters: "+inputParameters+ " output parameters:"+outputParameters+"]";
	}
}
