package sk.tuke.bkpi.model.clause;

import java.util.Collections;
import java.util.List;

import sk.tuke.bkpi.model.Identifier;

public class OperationHeader {
	private Identifier operationName;
	private List<String> inputParametersNames;
	private List<String> outputParametersNames;
	
	public OperationHeader(Identifier operationName,
			List<String> inputParametersNames,
			List<String> outputParametersNames) {
		this.operationName = operationName;
		this.inputParametersNames  = inputParametersNames  != null? inputParametersNames  : Collections.<String>emptyList();
		this.outputParametersNames = outputParametersNames != null? outputParametersNames : Collections.<String>emptyList();
	}
	
	public Identifier operationName() {
		return operationName;
	}
	
	public List<String> inputParametersNames() {
		return inputParametersNames;
	}
	
	public List<String> outputParametersNames() {
		return outputParametersNames;
	}
	
	@Override
	public String toString() {
		return "Operation: "+operationName;
	}

}
