package sk.tuke.bkpi.model.clause;

import java.util.List;

import sk.tuke.bkpi.model.component.Component;
import sk.tuke.bkpi.model.component.Machine;

public class SeenMachine extends ComponentReference {

	private boolean isImported;
	private List<String> prefix;
	private Machine machine;
	private String prefixString;
	private String fullName;
	
	public SeenMachine(List<String> prefix, Machine machine) {
		super(machine);
		this.prefix = prefix;
		this.machine = machine;
		prefixString = "";
		for (int i = 0; i < prefix.size(); i++) {
			if (i < prefix.size()-1)
				prefixString += prefix.get(i)+".";
			else
				prefixString += prefix.get(i);
		}
		fullName = prefix.size() > 0? prefixString+"."+machine.name() : machine.name(); 
	}
	
	public void setIsImported(boolean isImported) {
		this.isImported = isImported;
	}
	
	public boolean isImported() {
		return isImported;
	}
	
	public List<String> path() {
		return prefix;
	}
	
	public Machine machine() {
		return machine;
	}
	
	@Override
	public String prefixString() {
		return prefixString;
	}
	
	public String fullName() {
		return fullName;
	}
	
	@Override
	public boolean equals(Object seenMachine) {
		if (seenMachine instanceof SeenMachine) {
			return prefixString.equals(((SeenMachine) seenMachine).prefixString)
				&& machine == ((SeenMachine) seenMachine).machine;
		}
		return false;
	}
}
