package sk.tuke.bkpi.model.component;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import sk.tuke.bkpi.model.Identifier;
import sk.tuke.bkpi.model.clause.IncludedMachine;
import sk.tuke.bkpi.model.clause.SeenMachine;
import sk.tuke.bkpi.model.clause.Set;
import sk.tuke.bkpi.model.data.AbstractConstant;
import sk.tuke.bkpi.model.data.AbstractVariable;
import sk.tuke.bkpi.model.data.ConcreteConstant;
import sk.tuke.bkpi.model.data.ConcreteVariable;
import sk.tuke.bkpi.model.predicate.Predicate;

public class Refinement extends Component implements AbstractComponent {
	
	private AbstractComponent refinedComponent;
	private List<AbstractVariable> abstractVariables;
	private List<AbstractConstant> abstractConstants;
	public Refinement(Header header,
			AbstractComponent refinedComponent,
			List<SeenMachine> seenMachines,
			List<Set> sets,
			List<AbstractConstant> abstractConstants,
			List<ConcreteConstant> concreteConstants,
			List<AbstractVariable> abstractVariables,
			List<ConcreteVariable> concreteVariables,
			Predicate properties,
			Predicate invariant) {
		super(header, seenMachines, sets, concreteConstants, concreteVariables, properties, invariant);
		this.refinedComponent = refinedComponent;
		this.abstractVariables = abstractVariables != null? abstractVariables : new ArrayList<AbstractVariable>();
		this.abstractConstants = abstractConstants != null? abstractConstants : new ArrayList<AbstractConstant>();
		
	}
	
	public AbstractComponent refinedComponent() {
		return refinedComponent;
	}
	
	@Override
	public String toString() {
		return String.format("Refinement: %s [refined %s]", name(), refinedComponent);
	}

	@Override
	public List<AbstractVariable> abstractVariables() {
		return abstractVariables;
	}

	@Override
	public List<AbstractConstant> abstractConstants() {
		return abstractConstants;
	}

	@Override
	public List<Set> includedSets() {
		//throw new UnsupportedOperationException();
		return Collections.emptyList();
	}
}
