package sk.tuke.bkpi.model.data;

import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;

public abstract class DataField {

	protected String name;
	protected Type type;
	//protected DataValue value;
	
	
	public DataField(String name) {
		this.name = name;
	}
	
	public DataField(String name, Type type) {
		this.name = name;
		this.type = type;
	}
	
	public abstract DataField newData();
	
	public boolean isTyped() {
		return type != null;
	}
	
	public void typeData(Type type) {
		if (this.type != null) {
			throw new TypeCheckException("Data: "+name+" already typed");
		}
		if (type == null) {
			throw new TypeCheckException("Cannot type variable: "+name+" with null type");
		}
		//if (type.isGeneric())
		//	throw new TypeCheckException("Cannot type data: "+name+" with generic type: "+type);
		
		this.type = type;
	}
	
	public String name() {
		return name;
	}
	
	//public abstract Type getType();
	public Type type() {
		return type;
	}
	
	public String toString() {
		return name +"(type: "+type()+")";
	}
	
}
