package sk.tuke.bkpi.model.data;

import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;

public abstract class DataValue {

	protected Type type;
	
	//public abstract Type getType();
	public Type type() {
		return type;
	}
	
	public boolean isTyped() {
		return type != null;
	}
	
	public void typeCheck(Type type) {
		if (!isTyped())
			throw new TypeCheckException("Data not typed: "+this);
		//if (!type().isSubtype(type))
		if (!type().isCompatibile(type))
			throw new TypeCheckException("Data "+this+" has type:"+type()+" that is not subtype of "+type);
	}
	
	public void typeCheckAndResolve(Type type) {
		if (!isTyped())
			throw new TypeCheckException("Data not typed: "+this);
		//if (!type().isSubtype(type))
		if (!type().isCompatibile(type))
			throw new TypeCheckException("Expected data type :"+type +", but data: "+this+" has type: "+type());
		type.resolveType(type());
	}

	protected void typeCheck(Type accepted, DataValue encountered, String message) throws TypeCheckException {
		//if (!accepted.isCompatibile(encountered.getType()))
		if (encountered.type() == null)
			throw new TypeCheckException("Expression: "+encountered +" not typed!");
		//if (!encountered.type().isSubtype(accepted))
		if (!encountered.type().isCompatibile(accepted))
			throw new TypeCheckException(accepted, encountered.type(), getClass().getSimpleName()+": "+message);
	}
}
