package sk.tuke.bkpi.model.data;

import sk.tuke.bkpi.model.component.Machine;
import sk.tuke.bkpi.model.types.Type;

public class ForeignData extends DataField {

	public enum Chain {
		REFINE,
		IMPORT,
		INCLUDE,
		SEES,
		USES,
		EXTENDS
	}
	
	private Machine machine;
	private DataField data;
	
	public ForeignData(Machine machine, DataField data) {
		super(data.name);
		this.machine = machine;
		this.data = data;
	}

	public Machine machine() {
		return machine;
	}
	
	public DataField data() {
		return data;
	}
	
	@Override
	public boolean isTyped() {
		return type() != null;
	}
	
	@Override
	public Type type() {
		return data.type();
	}
	
	@Override
	public DataField newData() {
		return new ForeignData(machine, data);
	}
}
