package sk.tuke.bkpi.model.data;

import sk.tuke.bkpi.model.clause.ComponentReference;
import sk.tuke.bkpi.model.types.Type;

public class ForeignVariable extends DataField {
	
	private DataField data;
	private ComponentReference machine;
	
	public ForeignVariable(ComponentReference machine, DataField data) {
		//super(machine.isRenamed()? machine.prefixString()+"."+data.name : data.name);
		super(data.name);
		this.machine = machine;
		this.data = data;
	}
	
	public ComponentReference componentReference() {
		return machine;
	}
	
	@Override
	public Type type() {
		return data.type();
	}
	
	@Override
	public void typeData(Type type) {
		data.typeData(type);
	}
	@Override
	public boolean isTyped() {
		return data.isTyped();
	}
	
	@Override
	public ForeignVariable newData() {
		return new ForeignVariable(machine, data.newData());
	}
	
	public DataField data() {
		return data;
	}
	
	@Override
	public String toString() {
		return super.toString();//+" ("+chain+")";
	}
}
