package sk.tuke.bkpi.model.data;

import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class RefinedVariable extends DataField {

	private Type refinedType;
	private AbstractVariable refinigVariable;
	
	public RefinedVariable(AbstractVariable refinigVariable) {
		super(refinigVariable.name());
		this.refinigVariable = refinigVariable;
		type = refinigVariable.type();
	}
	
	@Override
	public RefinedVariable newData() {
		return new RefinedVariable(refinigVariable);
	}
	
	@Override
	public Type type() {
		return refinedType != null? refinedType : super.type();
	}
	
	public void refineType(Type type) {
		refinedType = type;
	}
	
	@Override
	public void typeData(Type type) {
		if (refinedType == null) {
			//refinedType = type;
		} else throw new TypeCheckException("Data already typed: "+refinedType);
		
	}
}
