package sk.tuke.bkpi.model.expression;

import java.util.Map;

import sk.tuke.bkpi.model.types.Type;

public abstract class BinaryExpression extends Expression {
	
	
	protected Expression left;
	protected Expression right;
	
	public BinaryExpression(Expression left, Expression right) {
		this.left = left;
		this.right = right;
	}
	
	protected void typeCheckLeft(Type acceptedType) {
		typeCheck(acceptedType, left, "Left expression has wrong type");
	}
	
	protected void typeCheckRight(Type acceptedType) {
		typeCheck(acceptedType, right, "Right expression has wrong type");
	}
	
	public Expression getLeft() {
		return left;
	}
	
	public Expression getRight() {
		return right;
	}
	
	//public abstract BinaryExpression newInstance(Expression left, Expression right);
	public BinaryExpression newInstance(Expression left, Expression right) {
		return this;
	}
	
	public Expression instance(Map<Object, Object> substitution) {
		Expression leftInstance = left.instance(substitution);
		Expression rightInstance = right.instance(substitution);
		if (left == leftInstance && right == rightInstance) {
			return this;
		} else {
			return newInstance(leftInstance, rightInstance);
		}
	}
	
	public BinaryExpression instance() {
		/*
		Expression leftInstance = left.instance();
		Expression rightInstance = right.instance();
		if (left == leftInstance && right == rightInstance) {
			return this;
		} else */
			return null;
	}
	
}
