package sk.tuke.bkpi.model.expression;

import static sk.tuke.bkpi.model.types.TypeBuilder.*;

/**
 * 
 * Typing rule: let <code>left</code> has type T and <code>right</code>
 * has type U, then Couple has type TxU 
 * 
 * @author Marcel Dancák
 */
public class CoupleExpression extends BinaryExpression {

	/**
	 * 
	 * @param left
	 * @param right
	 */
	public CoupleExpression(Expression left, Expression right) {
		super(left, right);
		type = CartesianProduct(left.type(), right.type());
	}
	
}
