package sk.tuke.bkpi.model.expression;

import java.util.Hashtable;
import java.util.Map;

import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.types.Type;

public class ExpressionReference extends ExpressionVariable {

	private DataField dataItem;
	
	private static Map<DataField, ExpressionReference> referencesCache = new Hashtable<DataField, ExpressionReference>();
	public static ExpressionReference newReference(DataField dataItem) {
		if (referencesCache.containsKey(dataItem))
			return referencesCache.get(dataItem);
		ExpressionReference newReference = new ExpressionReference(dataItem);
		referencesCache.put(dataItem, newReference);
		return newReference;
	}
	
	private ExpressionReference(DataField dataItem) {
		if (dataItem == null)
			throw new NullPointerException("Null parameter not allowed");
		this.dataItem = dataItem;
		
		// not enough, cause variable can be typed later!!!, so type() and isTyped() must be overwritten
		//type = dataItem.type();
	}
	
	@Override
	public Type type() {
		return dataItem.type();
	}
	@Override
	public boolean isTyped() {
		return dataItem.type() != null;
	}
	
	//@Override
	public DataField getData() {
		return dataItem;
	}

	@Override
	public String toString() {
		return dataItem.toString();
	}

	@Override
	public Expression instance(Map<Object, Object> substitution) {
		//System.out.println("ExpressionReference Instance: "+dataItem +" contains: "+substitution.containsKey(dataItem)+ " in "+substitution);
		if (substitution.containsKey(dataItem))
			return ExpressionReference.newReference((DataField) substitution.get(dataItem));
		return this;
	}

	@Override
	public void typeData(Type type) {
		dataItem.typeData(type);
	}
}
