package sk.tuke.bkpi.model.expression;

import java.util.List;

import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

/**
 * Typing rule:
 * 
 * @author Marcel Dancák
 */
public class FunctionVariable extends ExpressionVariable {

	private Type ARGUMENTS_TYPE = new TypeResolver();
	private Type ELEMENT_TYPE = new TypeResolver();
	private Type FUNCTION_TYPE = PowerSet(CartesianProduct(ARGUMENTS_TYPE, ELEMENT_TYPE));
	
	private FunctionVariable(ExpressionVariable function, List<Expression> arguments) {
		function.typeCheckAndResolve(FUNCTION_TYPE);
		
	}

	@Override
	public void typeData(Type type) {
		throw new TypeCheckException("Varaible should be already typed !");
	}
}
