package sk.tuke.bkpi.model.expression;

import sk.tuke.bkpi.model.types.Record;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class RecordFieldExpressionVariable extends ExpressionVariable {

	private Expression variable;
	private String label;
	
	public RecordFieldExpressionVariable(Expression variable, String label) {
		this.variable = variable;
		this.label = label;
		if (!(variable.type() instanceof Record)) {
			throw new TypeCheckException("Expected record type, but is: "+variable.type());
		}
		if (!((Record) variable.type()).hasField(label))
			throw new TypeCheckException("Record doesn't contain label: "+label);
		type = ((Record) variable.type()).fieldType(label);
	}
	
	@Override
	public void typeData(Type type) {
		throw new UnsupportedOperationException();
	}
}
