package sk.tuke.bkpi.model.expression;

import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import sk.tuke.bkpi.model.types.Record;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class SetOfRecordsExpression extends Expression {

	private TypeResolver T = new TypeResolver();
	private Type SET = PowerSet(T);
	
	private List<RecordField> fields;
	
	public SetOfRecordsExpression(List<RecordField> fields) {
		this.fields = fields;
		List<Record.Field> types = new ArrayList<Record.Field>(fields.size());
		for (RecordField field : fields) {
			field.value.typeCheckAndResolve(SET);
			types.add(new Record.Field(field.label, T.resolvedType()));
			// ISSUE: reset T ?
		}
		type = PowerSet(new Record(types));
	}
	
}
