package sk.tuke.bkpi.model.expression.arithmetical;

import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import static sk.tuke.bkpi.model.types.BasicType.*;

public class BinaryArithmeticalExpression extends BinaryExpression {
	public enum Operator {
		PLUS,
		MINUS,
		TIMES,
		DIVIDE,
		MODULO,
		POWER
	}
	
	private Operator operator;

	public BinaryArithmeticalExpression(Operator operator, Expression left, Expression right) {
		super(left, right);
		typeCheckLeft(Z);
		typeCheckRight(Z);
		type = Z;
		this.operator = operator;
	}
	
	public Operator getOperator() {
		return operator;
	}

	@Override
	public BinaryExpression newInstance(Expression left, Expression right) {
		return new BinaryArithmeticalExpression(operator, left, right);
	}
}
