package sk.tuke.bkpi.model.expression.function;

import java.util.List;

import sk.tuke.bkpi.model.data.LocalVariable;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.predicate.Predicate;
import sk.tuke.bkpi.model.types.Type;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

/**
 * 
 * @author Marcel Dancák
 */
public class LambdaExpression extends Expression {

	/**
	 * 
	 * @param variables 
	 * @param predicate
	 * @param expression
	 */
	public LambdaExpression(List<LocalVariable> variables, Predicate predicate, Expression expression) {
		
		if (variables.size() == 0) {
			type = PowerSet(expression.type());
		} else {
			Type t = variables.get(0).type();
			for (int i = 1; i < variables.size(); i++) {
				t = CartesianProduct(t, variables.get(i).type());
			}
			type = PowerSet(CartesianProduct(t, expression.type()));
		}
	}
}
