package sk.tuke.bkpi.model.expression.function;

import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.PowerSet;
import sk.tuke.bkpi.model.types.TypeCheckException;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class SetOfFunctions extends BinaryExpression {

	public enum Function {
		PARTIAL_FUNCTIONS,
		TOTAL_FUNCTIONS,
		PARTIAL_INJECTIONS,
		TOTAL_INJECTIONS,
		PARTIAL_SURJECTIONS,
		TOTAL_SURJECTIONS,
		TOTAL_BIJECTIONS
	}
	
	private Function function;
	
	/**
	 * Set Of Functions, type P(P(TxV))
	 * @param function
	 * @param left set expression of type P(T)
	 * @param right set expression of type P(V)
	 */
	public SetOfFunctions(Function function, Expression left, Expression right) {
		super(left, right);
		
		//shorter version
		//left.typeCheck(PowerSet(GENERIC));
		//right.typeCheck(PowerSet(GENERIC));
		if (!(left.type() instanceof PowerSet))
			throw new TypeCheckException("expected set type, got "+left.type());
		if (!(right.type() instanceof PowerSet))
			throw new TypeCheckException("expected set type");
		
		type = PowerSet(CartesianProduct(left.type(), right.type()));
		this.function = function;
	}
}
