package sk.tuke.bkpi.model.expression.function;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class TransformedRelation extends Expression {

	private static TypeResolver T = new TypeResolver();
	private static TypeResolver V = new TypeResolver();
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(T, PowerSet(V)));
	
	/**
	 * Transformed Relation, type P(TxV)
	 * @param relation expression of type P(TxP(V))
	 */
	public TransformedRelation(Expression relation) {
		relation.typeCheckAndResolve(RELATION_TYPE);
		type = PowerSet(CartesianProduct(T.resolvedType(), V.resolvedType()));
	}
}
