package sk.tuke.bkpi.model.expression.relation;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.CartesianProduct;
import sk.tuke.bkpi.model.types.PowerSet;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class DomainExpression extends Expression {

	private TypeResolver U = new TypeResolver();
	private Type RELATION_TYPE = PowerSet(CartesianProduct(U, GENERIC));
	
	/**
	 * DomainExpression type: P(U)
	 * @param relation expression of type P(UxV)
	 */
	public DomainExpression(Expression relation) {
		//relation.typeCheckAndResolve(RELATION_TYPE);
		if (!relation.type().isCompatibile(RELATION_TYPE))
			throw new TypeCheckException("not compatibile types");
		
		RELATION_TYPE.resolveType(relation.type());
		type = PowerSet(U.resolvedType());
	}
}
