package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;

public class DomainRestriction extends BinaryExpression {

	private static TypeResolver U = new TypeResolver();
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(U, GENERIC));
	
	/**
	 * DomainRestriction type: P(UxV)
	 * 
	 * @param relation expression of type P(UxV)
	 * @param set expression of type P(U)
	 */
	public DomainRestriction(Expression relation, Expression set) {
		super(set, relation);// TODO: check expressions order, should it be BinaryExpression ??
		//relation.typeCheckAndResolve(RELATION_TYPE);
		//set.typeCheck(PowerSet(U.resolvedType()));
		if (!relation.type().isCompatibile(RELATION_TYPE))
			throw new TypeCheckException("not compatibile types");
		
		type = relation.type();
	}
}
