package sk.tuke.bkpi.model.expression.relation;

import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class DomainSubtraction extends BinaryExpression {

	private static TypeResolver U = new TypeResolver();
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(U, GENERIC));
	
	/**
	 * Domain Subtraction type: P(UxV)
	 * 
	 * @param relation expression of type P(UxV)
	 * @param set expression of type P(U)
	 */
	public DomainSubtraction(Expression relation, Expression set) {
		super(set, relation);
		relation.typeCheckAndResolve(RELATION_TYPE);
		set.typeCheck(PowerSet(U.resolvedType()));
		type = relation.type();
	}
}
