package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class FirstProjection extends BinaryExpression {
	
	private TypeResolver T = new TypeResolver();
	private TypeResolver U = new TypeResolver();
	private Type SET_TYPE1 = PowerSet(T);
	private Type SET_TYPE2 = PowerSet(U);
	
	/**
	 * First Projection, type P(TxUxT)
	 * @param left set expression of type P(T)
	 * @param right set expression of type P(U)
	 */
	public FirstProjection(Expression left, Expression right) {
		super(left, right);
		left.typeCheckAndResolve(SET_TYPE1);
		right.typeCheckAndResolve(SET_TYPE2);
		type = PowerSet(CartesianProduct(CartesianProduct(T.resolvedType(), U.resolvedType()), T.resolvedType()));
	}
}
