package sk.tuke.bkpi.model.expression.relation;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class IdentityRelation extends Expression {

	private TypeResolver T = new TypeResolver();
	private Type SET_TYPE = PowerSet(T);
	
	/**
	 * Identity Relation type P(TxT)
	 * @param set expression of type P(T)
	 */
	public IdentityRelation(Expression set) {
		set.typeCheckAndResolve(SET_TYPE);
		type = PowerSet(CartesianProduct(T.resolvedType(), T.resolvedType()));
		// type = CartesianProduct(set.type(), set.type()); //should be the same, so the T TypeResolver would be not needed
	}
}
