package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class Image extends Expression {
	
	private TypeResolver T = new TypeResolver();
	private TypeResolver V = new TypeResolver();
	private Type RELATION_TYPE = PowerSet(CartesianProduct(T, V));
	
	/**
	 * Image of type P(V)
	 * @param relation expression of type P(TxV)
	 * @param set expression of type P(T)
	 */
	public Image(Expression relation, Expression set) {
		relation.typeCheckAndResolve(RELATION_TYPE);
		set.typeCheck(PowerSet(T.resolvedType()));
		type = PowerSet(V.resolvedType());
	}
}
