package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class InverseRelation extends Expression {
	
	private static TypeResolver U = new TypeResolver();
	private static TypeResolver V = new TypeResolver();
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(U, V));
	
	/**
	 * Inverse Relation of type P(UxT)
	 * @param relation expression of type P(TxU)
	 */
	public InverseRelation(Expression relation) {
		relation.typeCheckAndResolve(RELATION_TYPE);
		type = PowerSet(CartesianProduct(V.resolvedType(), U.resolvedType()));
	}
}
