package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.BasicType.Z;

public class Iteration extends BinaryExpression {

	private static TypeResolver T1 = new TypeResolver();
	private static TypeResolver T2 = new TypeResolver();
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(T1, T2));
	
	/**
	 * Iteration type P(TxT)
	 * @param relation relation expression of type P(TxT)
	 * @param number expression of type Z
	 */
	public Iteration(Expression relation, Expression number) {
		super(relation, number);
		relation.typeCheckAndResolve(RELATION_TYPE);
		if (!T1.resolvedType().isEqual(T2.resolvedType()))
			throw new TypeCheckException("");//TODO text
		number.typeCheck(Z);
	}

	
}
