package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;

public class Overwrite extends BinaryExpression {

	private TypeResolver T1 = new TypeResolver();
	private TypeResolver T2 = new TypeResolver();
	private TypeResolver V1 = new TypeResolver();
	private TypeResolver V2 = new TypeResolver();
	private Type RELATION_TYPE1 = PowerSet(CartesianProduct(T1, V1));
	private Type RELATION_TYPE2 = PowerSet(CartesianProduct(T2, V2));
	
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(GENERIC, GENERIC));
	
	/**
	 * Overwrite of type P(UxV)
	 * @param right relation expression of type P(UxV)
	 * @param left relation expression of type  P(UxV)
	 */
	public Overwrite(Expression left, Expression right) {
		super(left, right);
		left.typeCheck(RELATION_TYPE);
		right.typeCheck(RELATION_TYPE);
		if (!left.type().isEqual(right.type())) //TODO or isCompatibile ?
			throw new TypeCheckException("Relations has incobatibile types");
		/*
		left.typeCheckAndResolve(RELATION_TYPE1);
		right.typeCheckAndResolve(RELATION_TYPE2);
		if (!T1.resolvedType().isEqual(T2.resolvedType()))
			throw new TypeCheckException("Relations has incobatibile types");
		if (!V1.resolvedType().isEqual(V2.resolvedType()))
			throw new TypeCheckException("Relations has incobatibile types");
		*/
		type = left.type();
	}
}
