package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class ParallelProduct extends BinaryExpression {

	private static TypeResolver T = new TypeResolver();
	private static TypeResolver U = new TypeResolver();
	private static TypeResolver V = new TypeResolver();
	private static TypeResolver W = new TypeResolver();
	private static Type RELATION_TYPE1 = PowerSet(CartesianProduct(T, U));
	private static Type RELATION_TYPE2 = PowerSet(CartesianProduct(V, W));
	
	/**
	 * Direct Product: P((TxV)x(UxW))
	 * @param left relation expression of type P(TxU)
	 * @param right relation expression of type P(VxW)
	 */
	public ParallelProduct(Expression left, Expression right) {
		super(left, right);
		typeCheckLeft (RELATION_TYPE1);
		typeCheckRight(RELATION_TYPE2);
		
		type = PowerSet(CartesianProduct(CartesianProduct(T.resolvedType(), V.resolvedType()), CartesianProduct(U.resolvedType(), W.resolvedType())));
	}
}
