package sk.tuke.bkpi.model.expression.relation;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class RangeExpression extends Expression {
	
	private static TypeResolver V = new TypeResolver();
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(GENERIC, V));
	
	/**
	 * Range Expression type P(V)
	 * @param relation expression of type P(UxV)
	 */
	public RangeExpression(Expression relation) {
		relation.typeCheckAndResolve(RELATION_TYPE);
		type = PowerSet(V.resolvedType());
	}
}
