package sk.tuke.bkpi.model.expression.relation;

import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class RangeRestriction extends BinaryExpression {

	private static TypeResolver V = new TypeResolver();
	private static Type RELATION_TYPE = PowerSet(CartesianProduct(GENERIC, V));
	
	/**
	 * Range Restriction type: P(UxV)
	 * @param relation expression of type P(UxV)
	 * @param set expression of type P(V)
	 */
	public RangeRestriction(Expression relation, Expression set) {
		super(relation, set);
		relation.typeCheckAndResolve(RELATION_TYPE);
		set.typeCheck(PowerSet(V.resolvedType()));
		type = relation.type();
	}
}
