package sk.tuke.bkpi.model.expression.sequence;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class GeneralConcatenation extends Expression {

	protected TypeResolver U = new TypeResolver();
	private Type SEQUENCE_TYPE = PowerSet(CartesianProduct(Z, U));
	private Type SEQUENCE_OF_SEQUENCES_TYPE = PowerSet(CartesianProduct(Z, SEQUENCE_TYPE));
	
	public GeneralConcatenation(Expression sequence) {
		sequence.typeCheckAndResolve(SEQUENCE_OF_SEQUENCES_TYPE);
		type = PowerSet(CartesianProduct(Z, U.resolvedType()));
	}
}
