package sk.tuke.bkpi.model.expression.sequence;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;

public class InsertAtTail extends BinaryExpression {
	
	private static TypeResolver T = new TypeResolver();
	private static Type SEQUENCE_TYPE = PowerSet(CartesianProduct(Z, T));
	
	public InsertAtTail(Expression sequence, Expression element) {
		super(sequence, element);
		typeCheckLeft(SEQUENCE_TYPE);
		
		if (!element.type().isCompatibile(T.resolvedType()))
			throw new TypeCheckException("Expected element of type: "+T+", but has: "+element);
		//what type has: 2 -> <>
		type = sequence.type();
	}
}
