package sk.tuke.bkpi.model.expression.sequence;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.GenericType.GENERIC;
import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;

public class RestrictFront extends BinaryExpression {

	private static Type SEQUENCE_TYPE = PowerSet(CartesianProduct(Z, GENERIC));
	
	public RestrictFront(Expression sequence, Expression number) {
		super(sequence, number);
		sequence.typeCheck(SEQUENCE_TYPE);
		number.typeCheck(Z);
		type = sequence.type();
	}
}
