package sk.tuke.bkpi.model.expression.sequence;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import static sk.tuke.bkpi.model.types.BasicType.Z;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;

public class SequenceConcatenation extends BinaryExpression {

	private static TypeResolver T1 = new TypeResolver();
	private static TypeResolver T2 = new TypeResolver();
	private static Type SEQUENCE_TYPE1 = PowerSet(CartesianProduct(Z, T1));
	private static Type SEQUENCE_TYPE2 = PowerSet(CartesianProduct(Z, T2));
	
	public SequenceConcatenation(Expression left, Expression right) {
		super(left, right);
		typeCheckLeft (SEQUENCE_TYPE1);
		typeCheckRight(SEQUENCE_TYPE2);
		if (!T1.resolvedType().isCompatibile(T2.resolvedType()))
			throw new TypeCheckException("Incompatibile sequences for concatenation: "+T1+" and "+T2);
		
		type = left.type();
	}
}
