package sk.tuke.bkpi.model.expression.sequence;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import static sk.tuke.bkpi.model.types.BasicType.*;
public class SetOfSequences extends Expression {

	public enum Type {
		SEQUENCE("seq"),
		NON_EMPTY_SEQUENCE("seq1"),
		INJECTIVE_SEQUENCE("iseq"),
		INJECTIVE_NON_EMPTY_SEQUENCE("iseq1"),
		PERMUTATION("perm");
		
		private String bName;
		Type(String bName) {
			this.bName = bName;
		}
	}
	
	private TypeResolver T = new TypeResolver();
	
	private final Type function;
	private final Expression argument;
	
	/**
	 * Set of sequences, the elements of which belong to set expression <code>set</code>.
	 * Type: P(P(ZxT))
	 * 
	 * @param sequenceType 
	 * @param set expression of type P(T)
	 * 
	 * @throws TypeCheckException
	 */
	public SetOfSequences(Type sequenceType, Expression set) {
		set.typeCheckAndResolve(PowerSet(T));
		// seems to be bad in manual, type should be P(P(ZxT)) and not P(ZxT)
		type = PowerSet(PowerSet(CartesianProduct(Z, T.resolvedType())));
		
		this.function = sequenceType;
		this.argument = set;
	}
	
	@Override
	public String toString() {
		return function.bName+"("+argument+")";
	}
}
