package sk.tuke.bkpi.model.expression.set;

import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.GenericType;
import sk.tuke.bkpi.model.types.PowerSet;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

/**
 * 
 * B Reference Manual: page 49
 * @author Marcel Dancak
 */
public class BinarySetExpression extends BinaryExpression {

	public enum Operator {
		DIFFERENCE,
		UNION,
		INTERSECTION
	}
	
	private Operator operator;
	
	public BinarySetExpression(Operator operator, Expression left, Expression right) {
		super(left, right);
		Type SET = PowerSet(GENERIC);
		this.operator = operator;
		left.typeCheck(SET);
		right.typeCheck(SET);
		//right.typeCheck(left.type());
		if (!left.type().isCompatibile(right.type()))
			throw new TypeCheckException("Incompatibile types for sets "+operator+": "+left.type() +" "+right.type());
		
		//type = TypeRule.lessGenericType(left.getType(), right.getType());
		type = left.type().inference(right.type());
	}
}
