package sk.tuke.bkpi.model.expression.set;

import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class CartesianProductExpression extends BinaryExpression {

	/*
	 * left:  P(U)
	 * right: P(V)
	 * CartesianProductExpression: P(UxV)
	 */
	public CartesianProductExpression(Expression left, Expression right) {
		super(left, right);
		
		typeCheckLeft(PowerSet(GENERIC));
		typeCheckRight(PowerSet(GENERIC));
		type = CartesianProduct(left.type(), right.type());
	}
	
	@Override
	public String toString() {
		return left+" x "+right;
	}
}
