package sk.tuke.bkpi.model.expression.set;

import java.util.List;

import sk.tuke.bkpi.model.data.LocalVariable;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.predicate.Predicate;
import sk.tuke.bkpi.model.types.Type;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class ComprehensionSet extends Expression {

	private List<LocalVariable> variables;
	private Predicate predicate;
	
	/*
	 * variables: T1, T2, ...Tn
	 * ComprehensionSet: P(T1xT2x...Tn)
	 */
	public ComprehensionSet(List<LocalVariable> variables, Predicate predicate) {
		if (variables.size() < 1)
			throw new IllegalArgumentException("At least one variable is needed");
		
		Type t = variables.get(0).type();
		for (int i = 1; i < variables.size(); i++) {
			t = CartesianProduct(t, variables.get(i).type());
		}
		type = PowerSet(t);
		//TODO: check that every variable was typed in predicate
		
		this.variables = variables;
		this.predicate = predicate;
	}
}
