package sk.tuke.bkpi.model.expression.set;

import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class GeneralisedIntersection extends Expression {
	private TypeResolver T = new TypeResolver();
	private Type SET_OF_SETS_TYPE = PowerSet(PowerSet(T));
	
	/**
	 * Generalized Intersection, type P(T)
	 * @param setOfSets expression of type P(P(T))
	 */
	public GeneralisedIntersection(Expression setOfSets) {
		setOfSets.typeCheckAndResolve(SET_OF_SETS_TYPE);
		type = PowerSet(T.resolvedType());
	}
}
