package sk.tuke.bkpi.model.expression.set;

import sk.tuke.bkpi.model.expression.Expression;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import static sk.tuke.bkpi.model.types.BasicType.*;

public class IntegerSet extends Expression {

	enum Kind {
		INTEGER,
		NATURAL,
		NATURAL1,
		INT,
		NAT,
		NAT1
	}
	
	public static final IntegerSet INTEGER  = new IntegerSet(Kind.INTEGER);
	public static final IntegerSet NATURAL  = new IntegerSet(Kind.NATURAL);
	public static final IntegerSet NATURAL1 = new IntegerSet(Kind.NATURAL1);
	public static final IntegerSet INT  = new IntegerSet(Kind.INT);
	public static final IntegerSet NAT  = new IntegerSet(Kind.NAT);
	public static final IntegerSet NAT1 = new IntegerSet(Kind.NAT1);
	
	private Kind kind;
	public IntegerSet(Kind kind) {
		this.kind = kind;
		type = PowerSet(Z);
	}
	
	@Override
	public String toString() {
		return kind.toString();
	}
}
