package sk.tuke.bkpi.model.expression.set;

import java.util.List;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

/**
 * B Reference Manual: page 47
 * @author Marcel Dancak
 */
public class SetExtensionExpression extends Expression {

	private List<Expression> expressions;
	
	public SetExtensionExpression(List<Expression> expressions) {
		
		Type inferencedType = expressions.get(0).type();
		for (int i = 1; i < expressions.size(); i++) {
			if (!inferencedType.isCompatibile(expressions.get(i).type())) {
				throw new TypeCheckException("incompatibile types in set extension expression: "+inferencedType+ " and "+expressions.get(i).type());
			}
			inferencedType = inferencedType.inference(expressions.get(i).type());
		}
		type = PowerSet(inferencedType);
		/*
		Type[] types = new Type[expressions.size()];
		for (int i = 0; i < expressions.size(); i++) {
			types[i] = expressions.get(i).type();
		}
		Type t = TypeRule.lessGenericType(types);
		for (Expression expr : expressions) {
			if (!expr.type().isCompatibile(t))
				throw new TypeCheckException("incompatibile types in set extension expression");
		}
		this.expressions = expressions;
		type = PowerSet(TypeRule.lessGenericType(types));
		//type = expressions.get(0).getType();
		 */
	}
}
