package sk.tuke.bkpi.model.expression.set;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.PowerSet;
import sk.tuke.bkpi.model.types.TypeCheckException;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class SetOfSubsets extends Expression {

	public enum Kind {
		POWERSET,
		SET_OF_NON_EMPTY_SUBSETS,
		SET_OF_FINITE_SUBSETS,
		SET_OF_NON_EMPTY_FINITE_SUBSETS
	}
	
	private Expression set;
	
	public SetOfSubsets(Kind kind, Expression set) {
		if (!(set.type() instanceof PowerSet))
			throw new TypeCheckException("expression must be of set type, but is: "+set.type());
		
		this.set = set;
		type = PowerSet(set.type());
	}
}
