package sk.tuke.bkpi.model.expression.set;

import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class SetsOfRelations extends BinaryExpression {

	/**
	 * Sets Of Relations type: P(P(UxV))
	 * 
	 * @param left set expression of type P(U)
	 * @param right set expression of type P(V)
	 */
	public SetsOfRelations(Expression left, Expression right) {
		super(left, right);
		typeCheckLeft(PowerSet(GENERIC));
		typeCheckRight(PowerSet(GENERIC));
		type = PowerSet(CartesianProduct(left.type(), right.type()));
	}
}
