package sk.tuke.bkpi.model.instruction;

import sk.tuke.bkpi.model.b0data.B0Variable;
import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class BecomesEqualInstruction extends Instruction {
	
	B0Variable variable;
	//DataField variable;
	B0DataValue value;
	
	public BecomesEqualInstruction(B0Variable variable, B0DataValue value) {
		if (variable == null)
			throw new NullPointerException("Variable is null");
		if (value == null)
			throw new NullPointerException("Value is null");
		
		if (!variable.isTyped()) {
			System.out.println("type by value: "+value+ " type: "+value.type());
			variable.typeData(value.type());
		} else {
			// type check
			if (!variable.type().isCompatibile(value.type())) {
				if (value.type() == null)
					throw new TypeCheckException("Value: "+variable +" not typed");
				String errmsg = String.format("variable %s (class %s) has type: %s which is incompatibile with expression: %s with type of value: %s", variable, variable.getClass(), variable.type(), value, value.type());
				throw new TypeCheckException(errmsg);
			}
		}
		this.variable = variable;
		this.value = value;
	}
	/*
	public BecomesEqualInstruction(DataField variable, B0DataValue value) {
		System.out.println("BECOMES EQUAL "+variable + " = "+value);
		if (!variable.isTyped()) {
			variable.typeData(value.getType());
		} else {
			// type check
			System.out.println("TYPE CHECK SHOULD");
		}
		
		this.variable = variable;
		this.value = value;
	}
	*/
	public B0Variable variable() {
		return variable;
	}
	
	public B0DataValue value() {
		return value;
	}
	
	@Override
	public String toString() {
		return variable+" := "+value;
	}
}
