package sk.tuke.bkpi.model.instruction;

import java.util.Collections;
import java.util.List;

import sk.tuke.bkpi.model.condition.Condition;


public class IfConditionalInstruction extends Instruction {

	private Branch ifBranch;
	private List<Branch> elseifBranches = Collections.emptyList();
	private Instruction elseSubstitution;
	
	public IfConditionalInstruction(Branch ifBranch) {
		this.ifBranch = ifBranch;
	}
	
	public IfConditionalInstruction(Branch ifBranch, List<Branch> elseifBranches) {
		this(ifBranch);
		this.elseifBranches = elseifBranches != null? elseifBranches : Collections.<Branch>emptyList();
		//this.elseifBranches = elseifBranches;
	}
	
	public IfConditionalInstruction(Branch ifBranch, List<Branch> elseifBranches, Instruction elseSubstitution) {
		this(ifBranch, elseifBranches);
		this.elseSubstitution = elseSubstitution;
	}
	
	public Branch ifBranch() {
		return ifBranch;
	}
	
	public List<Branch> elseifBranches() {
		return elseifBranches;
	}
	
	public Instruction elseBranch() {
		return elseSubstitution;
	}
	
	public static class Branch {
		private Condition condition;
		private Instruction substitution;
		
		public Branch(Condition condition, Instruction substitution) {
			this.condition = condition;
			this.substitution = substitution;
		}

		public Condition condition() {
			return condition;
		}
		
		public Instruction substitution() {
			return substitution;
		}
	}
}
