package sk.tuke.bkpi.model.instruction;

import sk.tuke.bkpi.model.condition.Condition;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.predicate.Predicate;

public class WhileInstruction extends Instruction {

	private Condition condition;
	private Instruction body;
	private Predicate invariant;
	private Expression variant;
	
	public WhileInstruction(Condition condition, Instruction body, Predicate invariant, Expression variant) {
		this.condition = condition;
		this.body = body;
		this.invariant = invariant;
		this.variant = variant;
	}
	
	public Condition condition() {
		return condition;
	}
	
	public Instruction body() {
		return body;
	}
	
	public Predicate invariant() {
		return invariant;
	}
	
	public Expression variant() {
		return variant;
	}
}
