package sk.tuke.bkpi.model.predicate;

import java.util.Map;

import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.TypeCheckException;

public abstract class BinaryExpressionPredicate extends Predicate {

	protected Expression left;
	protected Expression right;
	
	public BinaryExpressionPredicate(Expression left, Expression right) {
		this.left = left;
		this.right = right;
		
		//if (left.getType() != null && left.getType().isGeneric() && right.getType().isGeneric())
		//	throw new TypeCheckException("nonsense, both expressions has generic types");
	}
	
	public Expression getLeft() {
		return left;
	}
	
	public Expression getRight() {
		return right;
	}
	
	public abstract BinaryExpressionPredicate newInstance(Expression left, Expression right);
	
	@Override
	public Predicate instance(Map<Object, Object> substitution) {
		//System.out.println("predicate before: "+left+" and "+right);
		//System.out.println(left.instance(substitution));
		Expression leftInstance = substitution.containsKey(left)? (Expression) substitution.get(left) : left.instance(substitution);
		Expression rightInstance = substitution.containsKey(right)? (Expression) substitution.get(right) : right.instance(substitution);
		if (left == leftInstance && right == rightInstance) {
			return this;
		} else {
			//System.out.println("new predicate: "+leftInstance+" and "+rightInstance);
			return newInstance(leftInstance, rightInstance);
		}
	}
}
