package sk.tuke.bkpi.model.predicate;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.BasicType;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class ComparisonPredicate extends BinaryExpressionPredicate {
	
	public enum Operator {
		LESS,
		LESS_OR_EQUAL,
		GREATER,
		GREATER_OR_EQUAL
	}
	
	private Operator operator;
	
	public ComparisonPredicate(Expression left, Operator operator, Expression right) {
		super(left, right);
		if (!left.type().isEqual(BasicType.Z) || !right.type().isEqual(BasicType.Z))
			throw new TypeCheckException("both expressions must be of type Z, but is: "+left.type()+" and "+right.type());
			
		this.operator = operator;
	}

	@Override
	public String toString() {
		return String.format("Comparison Predicate:[%s %s %s]", left, operator, right);
	}

	@Override
	public BinaryExpressionPredicate newInstance(Expression left, Expression right) {
		return new ComparisonPredicate(left, operator, right);
	}
}
