package sk.tuke.bkpi.model.predicate;

import java.util.Map;

import sk.tuke.bkpi.model.data.RefinedVariable;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.expression.ExpressionReference;
import sk.tuke.bkpi.model.types.BasicType;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class EqualityPredicate extends BinaryExpressionPredicate {

	public enum Operator {
		EQUAL,
		NOT_EQUAL
	}
	
	private Operator operator;
	
	public EqualityPredicate(Expression left, Operator operator, Expression right) {
		super(left, right);
		this.operator = operator;
		System.out.println("left: "+left+ " = "+right+" ???");
		
		if (!left.isTyped() && left instanceof ExpressionReference && operator == Operator.EQUAL) {
			((ExpressionReference)left).getData().typeData(right.type());
		} else {
			if (!left.type().isCompatibile(right.type())) {
				/*
				 if (left instanceof ExpressionReference && ((ExpressionReference)left).getData() instanceof RefinedVariable) {
					System.out.println(left +" NOT COompatibile with "+right);
					System.out.println(left.type() +" NOT COompatibile with "+right.type());
					((ExpressionReference)left).getData().typeData(right.type());
				}
				else */ 
					throw new TypeCheckException(left.type()+" not compatibile with "+right.type());
			}
			if (left.type().inference(right.type()).containsGenricType())
				throw new TypeCheckException("predicate contains Generic Type: "+left.type().inference(right.type()));
		}
		
	}
	
	public Operator getOperator() {
		return operator;
	}

	@Override
	public BinaryExpressionPredicate newInstance(Expression left, Expression right) {
		return new EqualityPredicate(left, operator, right);
	}
}
