package sk.tuke.bkpi.model.substitution;

import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;

import java.util.List;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.expression.ExpressionVariable;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;

public class BecomesEltSubstitution extends Substitution {

	private static TypeResolver T = new TypeResolver();
	private static Type SET_TYPE = PowerSet(T);
	
	private Expression set;
	
	public BecomesEltSubstitution(List<ExpressionVariable> variables, Expression set) {
		this.set = set;
		set.typeCheckAndResolve(SET_TYPE);
		if (variables.size() == 1) {
			if (variables.get(0).isTyped()) {
				variables.get(0).typeCheck(T.resolvedType());
			} else {
				variables.get(0).typeData(T.resolvedType());
			}
		}
	}
}
