package sk.tuke.bkpi.model.substitution;

import java.util.List;

import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.expression.ExpressionVariable;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class BecomesEqualSubstitution extends Substitution {

	private List<ExpressionVariable> variables;
	//private List<DataField> variables;
	private List<Expression> expressions;
	
	public BecomesEqualSubstitution(List<ExpressionVariable> variables, List<Expression> expressions) {
		
	//}
	//public BecomesEqualSubstitution(List<DataField> variables, List<Expression> expressions) {
		
		for (int i = 0; i < variables.size(); i++) {
			ExpressionVariable variable = variables.get(i);
			Expression value = expressions.get(i);
			
			if (variable.type() != null) {
				if (!variable.type().isCompatibile(value.type()))
					//throw new TypeCheckException(variable.type(), value.getType());
					throw new TypeCheckException(variable.type()+" not compatibile with "+ value.type());
			} else {
				variable.typeData(value.type());
			}
		}
		
		this.variables   = variables;
		this.expressions = expressions;
	}
	
	@Override
	public String toString() {	
		return "BecomesEqualSubstitution";
	}
	
	public List<ExpressionVariable> getVariables() {
		return variables;
	}
	
	public List<Expression> getExpressions() {
		return expressions;
	}
}
