package sk.tuke.bkpi.model.substitution;

import java.util.List;

import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.expression.Expression;

public class CaseSubstitution extends Substitution {

	private Expression expression;
	private List<Branch> alternatives;
	private Substitution elseSubstitution;
	
	public CaseSubstitution(Expression expression, List<Branch> alternatives, Substitution elseSubstitution) {
		this.expression = expression;
		if (alternatives.size() < 2)
			throw new IllegalArgumentException();
		this.alternatives = alternatives;
		this.elseSubstitution = elseSubstitution;
	}
	
	public Expression expression() {
		return expression;
	}
	
	public List<Branch> branches() {
		return alternatives;
	}

	public Substitution elseSubstitution() {
		return elseSubstitution;
	}
	
	public static class Branch {
		private List<B0DataValue> literalConstants;
		private Substitution substitution;
	
		public List<B0DataValue> literalConstants() {
			return literalConstants;
		}
		
		public Substitution substitution() {
			return substitution;
		}
		
		public Branch(List<B0DataValue> literalConstants, Substitution substitution) {
			if (literalConstants.size() > 0) {
				this.literalConstants = literalConstants;
			} else {
				throw new IllegalArgumentException();
			}
			this.substitution = substitution;
		}
	}
}
