package sk.tuke.bkpi.model.substitution;

import java.util.Collections;
import java.util.List;

public class IfSubstitution extends Substitution {

	private Branch ifBranch;
	private List<Branch> elseifBranches = Collections.emptyList();
	private Substitution elseSubstitution;
	
	public IfSubstitution(Branch ifBranch) {
		this.ifBranch = ifBranch;
	}
	
	public IfSubstitution(Branch ifBranch, List<Branch> elseifBranches) {
		this(ifBranch);
		this.elseifBranches = elseifBranches != null? elseifBranches : Collections.<Branch>emptyList();
	}
	
	public IfSubstitution(Branch ifBranch, List<Branch> elseifBranches, Substitution elseSubstitution) {
		this(ifBranch, elseifBranches);
		this.elseSubstitution = elseSubstitution;
	}
	
	public Branch ifBranch() {
		return ifBranch;
	}
	
	public List<Branch> elseifBranches() {
		return elseifBranches;
	}
	
	public Substitution elseSubstitution() {
		return elseSubstitution;
	}
}
