package sk.tuke.bkpi.model.substitution;

import java.util.List;

public class SelectSubstitution extends Substitution {

	private List<Branch> choices;
	private Substitution elseSubstitution;
	
	public SelectSubstitution(List<Branch> choices, Substitution elseSubstitution) {
		if (choices.size() == 0)
			throw new IllegalArgumentException("Choices list must contains at least one element");
		this.choices = choices;
		this.elseSubstitution = elseSubstitution;
	}
	
	public List<Branch> choices() {
		return choices;
	}
	
	public Substitution elseSubstitution() {
		return elseSubstitution;
	}
}
