package sk.tuke.bkpi.model.substitution;

import java.util.List;

import sk.tuke.bkpi.model.clause.OperationDeclaration;
import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class SubstitutionCall extends Substitution {

	public SubstitutionCall(OperationDeclaration declaration, List<DataField> outputVariables, List<Expression> inputParameters) {
		if (outputVariables != null) {
			int index = 0;
			for (DataField outVariable : outputVariables) {
				Type outVarType = declaration.outputParameters().get(index).type();
				
				if (outVariable.type() != null) {
					if (!outVariable.type().isCompatibile(outVarType))
						//throw new TypeCheckException(variable.type(), value.getType());
						throw new TypeCheckException(outVariable.type()+" not compatibile with "+ outVarType);
				} else {
					outVariable.typeData(outVarType);
				}
				index++;
			}
		}
	}
}
