package sk.tuke.bkpi.model.term;

import java.util.ArrayList;
import java.util.List;

import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.Type;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class ArrayInitialization extends ArrayExpression {

	private List<B0DataValue> indexes;
	private B0DataValue value;
	
	public ArrayInitialization(List<B0DataValue> indexes, B0DataValue value) {
		List<Type> indexesTypes = new ArrayList<Type>();
		
		//if (indexes.get(0))
		//Type t = indexes.get(0) == null? null : indexes.get(0).type();
		Type t = indexes.get(0).type();
		for (int i = 1; i < indexes.size(); i++) {
			//indexesTypes.add(indexRange.type());
			t = CartesianProduct(t, indexes.get(i).type());
		}
		type = CartesianProduct(t, PowerSet(value.type()));
		this.indexes = indexes;
		this.value = value;
	}
	
	public List<B0DataValue> indexes() {
		return indexes;
	}
	
	public B0DataValue value() {
		return value;
	}
	
	@Override
	public String toString() {
		return "Array Initialization: "+indexes+ " value: "+value;
	}
}
