package sk.tuke.bkpi.model.term;

import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.BasicType;


public class BooleanTerm extends B0DataValue {

	
	public static final BooleanTerm TRUE = new BooleanTerm(true);
	public static final BooleanTerm FALSE = new BooleanTerm(false);
	
	private final boolean value;
	
	private BooleanTerm(boolean value) {
		this.value = value;
		type = BasicType.BOOL;
	}
	
	public boolean value() {
		return value;
	}
	
	@Override
	public String toString() {
		return (""+value).toUpperCase();
	}
}
