package sk.tuke.bkpi.model.term;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.TypeCheckException;

public class IntervalB0 extends B0DataValue {

	B0DataValue minimum;
	B0DataValue maximum;
	
	public IntervalB0(B0DataValue minimum, B0DataValue maximum) {		
		if (minimum.type() != Z || maximum.type() != Z)
			throw new TypeCheckException("");
		
		type = PowerSet(Z);
		this.minimum = minimum;
		this.maximum = maximum;
	}
	
	public B0DataValue minimum() {
		return minimum;
	}
	
	public B0DataValue maximum() {
		return maximum;
	}
	
	@Override
	public String toString() {
		return "interval: "+minimum+" .. "+maximum;
	}
}
