package sk.tuke.bkpi.model.term;

import java.util.ArrayList;
import java.util.List;

import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.Record;

public class RecordTerm extends B0DataValue {

	private List<RecordField> fields;
	
	public RecordTerm(List<RecordField> fields) {
		this.fields = fields;
		List<Record.Field> fieldsTypes = new ArrayList<Record.Field>(fields.size()); 
		for (RecordField field : fields) {
			fieldsTypes.add(new Record.Field(field.label, field.value.type()));
		}
		type = new Record(fieldsTypes);
	}
	
	public List<RecordField> fields() {
		return fields;
	}
	
	@Override
	public String toString() {
		return "Record Term "+fields;
	}
	
	public static class RecordField {
		String label;
		B0DataValue value;
		
		public RecordField(B0DataValue value) {
			//if (!(value.getType() instanceof BasicType) && !(value instanceof ArrayExpression))
			//	throw new TypeCheckException("Invalid record field value. Expected Term or ArrayExpression, but is: "+value +" of class: "+value.getClass()+" type: "+value.getType());
			this.value = value; 
		}
		
		public RecordField(String label, B0DataValue value) {
			this(value);
			this.label = label;
		}
		
		public B0DataValue value() {
			return value;
		}
		
		public String label() {
			return label;
		}
		
		@Override
		public String toString() {
			return label+":"+value;
		}
	}
}
