package sk.tuke.bkpi.model.types;

public class BasicType extends Type {
	
	public static final BasicType Z = new Z(null);//new BasicType("Z");
	public static final BasicType BOOL = new BasicType("BOOL");
	public static final BasicType STRING = new BasicType("STRING");
	
	private String name;
	
	BasicType(String name) {
		this.name = name;
	}
		
	@Override
	public boolean isCompatibile(Type t) {
		return this == t || t instanceof GenericType;
	}
	
	@Override
	public boolean isSubtype(Type t) {
		return t instanceof GenericType || this == t;
	}
	
	@Override
	public boolean isEqual(Type t) {
		return this == t;
	}
	
	@Override
	public final boolean containsGenricType() {
		return false;
	}
	
	public boolean contains(Type type) {
		return isEqual(type);
	}
	
	@Override
	public Type inference(Type t) {
		if (t instanceof GenericType)
			return this;
		if (this.isEqual(t))
			return this;
		
		throw new TypeCheckException("union failed: "+this+" and "+t);
	}
	
	@Override
	public String toString() {
		return name;
	}
	
}

