package sk.tuke.bkpi.model.types;

import sk.tuke.bkpi.model.data.DataValue;
import sk.tuke.bkpi.model.expression.Expression;

public class TypeCheckException extends RuntimeException {
	
	private static final long serialVersionUID = 6499213237954589590L;

	private int line = -1;
	private int column = -1;
	
	public TypeCheckException(Type expected, Type encountered) {
		this(expected, encountered, -1, -1);
	}
	
	public TypeCheckException(Type expected, Type encountered, int line, int column) {
		super("Incompatibile types. Expected "+expected+", encountered: "+encountered);
		this.line = line;
		this.column = column;
	}
	
	public TypeCheckException(Type expected, Type encountered, String msg) {
		super(msg+"\nEncountered type: "+encountered+", but was expecting: "+expected);
	}
	
	public boolean containsPositionInfo() {
		return line > -1;
		//return line != -1 && column != -1;
	}
	
	public TypeCheckException(String msg) {
		super(msg);
	}
	
	public TypeCheckException(String msg, Throwable cause) {
		super(msg, cause);
	}
}
