package sk.tuke.bkpi.model.types;

import sk.tuke.bkpi.model.expression.IntervalExpression;

public class Z extends BasicType {

	private IntervalExpression interval;
	
	public Z(IntervalExpression interval) {
		super("Z");
		this.interval = interval;
	}

	public IntervalExpression interval() {
		return interval;
	}
	
	@Override
	public boolean isCompatibile(Type t) {
		return t instanceof Z || t instanceof GenericType;
	}
	
	@Override
	public boolean isSubtype(Type t) {
		return t instanceof GenericType || t instanceof Z;
	}
	
	@Override
	public boolean isEqual(Type t) {
		return t instanceof Z;
	}
	
	public boolean contains(Type type) {
		return isEqual(type);
	}
	
	@Override
	public Type inference(Type t) {
		if (t instanceof GenericType)
			return this;
		if (this.isEqual(t))
			return this;
		
		throw new TypeCheckException("union failed: "+this+" and "+t);
	}
	
	@Override
	public String toString() {
		return interval != null ? "Z["+interval+"]" : super.toString();
	}
}
