package sk.tuke.bkpi.parser;

import sk.tuke.bkpi.model.component.Component;

/**
 * Provides abstraction for resolving B-Method components dependencies.
 *  
 * @author Marcel Dancak
 */
public interface DependencyResolver {

	/**
	 * Returns B-method component by its name.
	 * @param name The name of B-method component
	 * @return instance of required B-method component
	 */
	Component getComponent(String name);
}
