/* javacc postprocess: last modification: 1397741389 */
/* Generated By:JavaCC: Do not edit this line. Parser.java */
package sk.tuke.bkpi.parser.javacc;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Hashtable;
import java.util.Stack;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import sk.tuke.bkpi.model.*;
import sk.tuke.bkpi.model.component.*;
import sk.tuke.bkpi.model.clause.*;

import sk.tuke.bkpi.model.expression.*;
import sk.tuke.bkpi.model.expression.bool.*;
import sk.tuke.bkpi.model.expression.arithmetical.*;
import sk.tuke.bkpi.model.expression.set.*;
import sk.tuke.bkpi.model.expression.sequence.*;
import sk.tuke.bkpi.model.expression.relation.*;
import sk.tuke.bkpi.model.expression.function.*;

import sk.tuke.bkpi.model.term.*;
import sk.tuke.bkpi.model.predicate.*;
import sk.tuke.bkpi.model.substitution.*;
import sk.tuke.bkpi.model.instruction.*;
import sk.tuke.bkpi.model.condition.*;
import sk.tuke.bkpi.model.data.*;
import sk.tuke.bkpi.model.b0data.*;
import sk.tuke.bkpi.model.types.*;

import sk.tuke.bkpi.parser.DefinitionsContext.Definition;
import java.lang.reflect.Field;
import sk.tuke.bkpi.parser.*;

public final class Parser implements ParserConstants {

        // loggers will be created in constructor for parsing file
        Logger javaccLogger;
        private Logger logger;

        private boolean expressionList = true;
        private boolean inParenthesesExpression;
        private int whilesCount; // for preprocess
        private boolean inDefinitionsClause;
        private boolean parsingDefinitionFile = false;

        private DataContext dataContext;
        private DependencyResolver dependencyResolver;
        private java.io.File parsingFile;
        private Stack<java.io.File> parsingFilesStack = new Stack<java.io.File>();

        private Map<String, OperationDeclaration> declaredOperations = new Hashtable<String, OperationDeclaration>();
        private PreprocessData.ClausePosition[] order = new PreprocessData.ClausePosition[0];
        private List<PreprocessData.ClausePosition> unprocessedClauses;

        DefinitionsContext definitions;
        PreprocessData preprocessData;

        public void setDefinitionsContext(DefinitionsContext definitions) {
                this.definitions = definitions;
        }

        public void setPreprocessedData(PreprocessData data) {
                this.preprocessData = data;
                //this.definitions = data.getDefinitionContext();
                order = preprocessData.getClausePositions().toArray(new PreprocessData.ClausePosition[preprocessData.getClausePositions().size()]);
                unprocessedClauses = new ArrayList<PreprocessData.ClausePosition>(preprocessData.getClausePositions());
        }

        private void checkPreprocessedData() {
                if (preprocessData == null) {
                        logger.warn("Component wasn't preprocessed");
                } else {
                        List<PreprocessData.ClausePosition> positions = preprocessData.getClausePositions();
                        for (int i = 0; i < positions.size(); i++) {
                                // find clause with minimal higher
                                /*
				PreprocessData.ClausePosition x = null; 
				for (int j = 0; j < i; j++) {
					if (positions.get(j).clause.orderNumber > positions.get(i).clause.orderNumber) {
						if (x == null || positions.get(j).clause.orderNumber < x.clause.orderNumber ) {
							x = positions.get(j);
						}
					}
				}
				if (x != null) {
					logger.warn(String.format("Clause %s at %d:%d has not optimal location, should be before clause %s at %d:%d",
						positions.get(i).clause, positions.get(i).line, positions.get(i).column, x.clause, x.line, x.column));
				}
				*/

                                for (int j = 0; j < i; j++) {
                                        if (positions.get(j).clause.orderNumber > positions.get(i).clause.orderNumber) {
                                                logger.warn(String.format("Clause %s at %d:%d has not optimal location, should be before clause %s at %d:%d",
                                                        positions.get(i).clause, positions.get(i).line, positions.get(i).column,
                                                        positions.get(j).clause, positions.get(j).line, positions.get(j).column));
                                                logger.warn(parsingFile);
                                                break;
                                        }
                                }
                        }
                }
        }

        private boolean endOfClauses() throws ParseException {
                javaccLogger.debug("End Of Clauses Lookahead");
                if (unprocessedClauses != null) {
                        if (unprocessedClauses.size() > 0) {// wasn't parsed every clause
                                return false;
                        }
                        // every clause was parsed, but the position is wrong. must find last end
                        logger.info("skip to last END");

                        logger.info("tokens: "+getToken(0) +" "+ getToken(1));

                        processDefinitions = false;
                        while(getToken(1).kind != END || getToken(2).kind != EOF) {
                                //logger.info("skipping token: "+token);
                                jj_consume_token(getToken(1).kind);
                        }

                    //processDefinitions = true;
                        logger.info("token: "+token);
                        logger.info("tokens: "+getToken(1) +" "+ getToken(2));

                        return true;
                }
                return getToken(1).kind == END;
        }

        private void seekBackward(int line, int column) {
                logger.info("\u005ct seek backward");

        try {
                while(jj_input_stream.line < line) {
                        jj_input_stream.readChar();
                }
                        jj_input_stream.backup(1);
        } catch (java.io.IOException ioe) {
                        ioe.printStackTrace();
                }
        }

        private void ensureClauseOrder() throws ParseException {
                logger.debug("ensureClauseOrder: "+getToken(1));
                logger.debug("not parsed clauses: "+unprocessedClauses);
                if (unprocessedClauses.size() == 0)
                        return;

                boolean changePosition = false;
                PreprocessData.Clause followingClause;
                try {
                        followingClause = PreprocessData.Clause.valueOf(getToken(1).image);
                } catch (IllegalArgumentException iae) {
                        if (getToken(1).kind == END) {
                                // some clauses are not parsed, but END token come
                                followingClause = unprocessedClauses.get(0).clause;
                                changePosition = true;
                        } else {
                                throw new ParseException("Unexpected token: "+getToken(1));
                        }
                }

                logger.debug("follows clause: "+followingClause);

                // find following clause preprocessing info. if it's not in unprocessed clauses,
                // choose first unprocessed
                PreprocessData.ClausePosition nextClauseToParse = null;
                for (PreprocessData.ClausePosition clauseInfo : unprocessedClauses) {
                        if (followingClause == clauseInfo.clause) {
                                nextClauseToParse = clauseInfo;
                        }
                }
                if (nextClauseToParse == null) {
                        nextClauseToParse = unprocessedClauses.get(0);
                        changePosition = true;
                }
                // check, if other unprocessed clauses shouldn't be parsed first
                for (PreprocessData.ClausePosition clauseInfo : unprocessedClauses) {
                        if (clauseInfo.clause.orderNumber < nextClauseToParse.clause.orderNumber) {
                                nextClauseToParse = clauseInfo;
                                changePosition = true;
                        }
                }

                //if (nextClauseToParse.clause != followingClause) {
                if (changePosition) {

                        //if (nextClauseToParse.clause.orderNumber < followingClause.orderNumber) logger.warn("Clause "+nextClauseToParse.clause+" is in not in optimal position, should be before "+followingClause);
                        //if (nextClauseToParse.line > jj_input_stream.line) logger.warn("2Clause "+nextClauseToParse.clause+" is in not in optimal position, should be before "+followingClause);
                        logger.debug("must be parsed first: "+nextClauseToParse.clause);
                        logger.debug("position line: "+jj_input_stream.line);
                        //logger.debug("position line: "+jj_input_stream.getLine());
                        //jj_input_stream.line = jj_input_stream.getLine();
                        if (jj_input_stream.line != nextClauseToParse.line) {
                logger.info("\u005ctcurrent token: "+token);

                try {
                        ReInit(new java.io.FileReader(parsingFile));
                } catch (java.io.FileNotFoundException e) {}

                if (jj_input_stream.line < nextClauseToParse.line) {
                        logger.info("\u005ct seek forward");
                        try {

                                while(jj_input_stream.line < nextClauseToParse.line) {
                                        jj_input_stream.readChar();
                                        //logger.info("skipping: " + jj_input_stream.readChar() +"  line "+jj_input_stream.line +" line "+jj_input_stream.getLine());//jj_input_stream.readChar();
                                }
                                jj_input_stream.backup(1);
                                        } catch (Exception e) {
                                                e.printStackTrace();
                                        }
                                        logger.info("\u005ctcurrent token after seek: "+getToken(1));
                } else {
                        try {
                        for (int i = 0; i < 10; i++) {
                                //logger.info("before: " + jj_input_stream.readChar());
                        }
                        seekBackward(nextClauseToParse.line, nextClauseToParse.column);

                        //logger.info("token "+token);
                        //logger.info("get "+getToken(1));
                        //logger.info(nextClauseToParse.line+", "+nextClauseToParse.column);
                        //logger.info("line "+jj_input_stream.line);
                        //logger.info("column "+jj_input_stream.column);
                        //jj_input_stream.line =nextClauseToParse.line;
                        //jj_input_stream.column = nextClauseToParse.column;
                        for (int i = 0; i < 10; i++) {
                                //logger.info("after: " + jj_input_stream.readChar());
                        }
                        //logger.info("\tcurrent token after seek: "+getToken(1));
                        } catch (Exception e) {}
                        //if (true) throw new RuntimeException();
                }
            }
                }
                unprocessedClauses.remove(nextClauseToParse);
        }

        public void setDataContext(DataContext context) {
                this.dataContext = context;
        }

        private DataField processIdentifier(String id) {
                if (dataContext.hasData(id))
                        return dataContext.getData(id.toString());

                String positionInfo = String.format("%d: %d", token.beginLine, token.beginColumn);
                logger.error("Unknown data: "+id+" "+dataContext+" at: "+positionInfo +" definitions trace: "+definitionsTrace);
                logger.error("Data Context: "+dataContext.getAllData());
                throw new RuntimeException("Unknown Variable: "+id+" at line: "+token.beginLine+" definitions trace: "+definitionsTrace);
        }

        private DataField processIdentifier(Identifier id) {
                return processIdentifier(id.toString());
        }

        private List<LocalVariable> createLocalVariables(List<String> variablesNames) {
                List<LocalVariable> variables = new ArrayList<LocalVariable>();
                for(String name : variablesNames) {
                        LocalVariable variable = new LocalVariable(name);
                        variables.add(variable);
                        dataContext.addDataItem(variable);
                }
                return variables;
        }

        private void destroyLocalVariables(List<? extends DataField> variables) {
                for(DataField variable : variables) {
                        dataContext.removeData(variable.name());
                }
        }

        private void checkDataIfTyped(List<? extends DataField> variables, Predicate p) {
                List<String> untypedVariables = null;
                for(DataField variable : variables) {
                        if (variable.type() == null) {
                                if (untypedVariables == null) // rather lazy initialisation
                                        untypedVariables = new ArrayList<String>();
                                untypedVariables.add(variable.name());
                        }
                }
                // check predicate for location of typing predicates
                if (untypedVariables != null)
                        throw new TypeCheckException("following variables was not typed in predicate: "+untypedVariables);
        }

        public static Parser myParser(String text) {
                Parser parser = new Parser(new java.io.StringReader(text));
                parser.token_sources.push(parser.token_source);
                parser.javaccLogger = sk.tuke.bkpi.logging.Logger.getLogger(Parser.class);
                parser.logger = parser.javaccLogger;
                parser.dataContext = new DataContext();
                return parser;
        }

        private Component getComponent(String componentName) {
                if (dependencyResolver == null) {
                        throw new IllegalStateException("Dependency resolver not set");
                }
                return dependencyResolver.getComponent(componentName);
        }

        private static Map<String, Integer> filesMap = new Hashtable<String, Integer>();

        public static Parser myParser(java.io.File file) throws java.io.FileNotFoundException {
                Parser parser = new Parser(new java.io.FileReader(file));
                parser.parsingFile = file;
                parser.token_sources.push(parser.token_source);
                parser.javaccLogger = sk.tuke.bkpi.logging.Logger.getLogger("sk.tuke.bkpi.parser.javacc."+file.getName());
                parser.logger = sk.tuke.bkpi.logging.Logger.getLogger("sk.tuke.bkpi.parser."+file.getName());
                parser.dataContext = new DataContext(file.getName());
                return parser;
        }

        public static Parser myParser(java.io.File file, DependencyResolver dependencyResolver) throws java.io.FileNotFoundException {
                Parser parser = myParser(file);
                parser.dependencyResolver = dependencyResolver;
                return parser;
        }

        private void parseDefinitionsFile(File definitionsFile, DefinitionsContext context) throws ParseException {
                java.io.FileInputStream inStream = null;
                try {
                        inStream = new java.io.FileInputStream(definitionsFile);
                } catch (java.io.FileNotFoundException fnfe) {
                        throw new ParseException("Definition file not found: "+definitionsFile);
                }
                Parser parser = new Parser(inStream);
                parser.parsingFile = definitionsFile;
                parser.parsingDefinitionFile = true;
                parser.javaccLogger = javaccLogger;
                parser.logger = logger;
                DefinitionsContext c = parser.DefinitionsPreprocess();
                for (Definition d : c.listDefinitions()) {
                        context.addDefinition(d);
                }
                try {
                        inStream.close();
                } catch (java.io.IOException ioe) {}
        }
        /***************************************
	 *******   Semantic LOOKAHEADS   *******
	 ***************************************/

         private int parenthesesBalanceAfter(Token t) {
                int balance = 0;
                do {
                        switch(t.kind) {
                                case LPAREN: balance++;break;
                                case RPAREN: balance--;break;
                        }
                        t = t.next;
                } while(t != null);
                return balance;
         }

         private boolean inParentheses() {
                 return token_source.parentheses-parenthesesBalanceAfter(getToken(1)) > 0;
         }

        private boolean testLookahed() {
                logger.debug("token 1: "+getToken(1));
                logger.debug("token 2: "+getToken(2));
                logger.debug(getToken(1).kind == TIMES && !getToken(2).image.equals("("));
                return getToken(1).kind == TIMES && getToken(2).kind != LPAREN;
                //return true;	
        }

        private final boolean followOperationHeader() {
                // [ ListIdent() "<--" ] Ident [ "(" ListIdent() ")" ] =
                int i = 2;
                StringBuilder string = new StringBuilder();
                /*
		Token t = getToken(i);
		while(!isClause(t) && !getToken(i-1).image.equals("=") && t.kind != END && t.kind != SEMICOLON && t.kind != EOF) {
			string.append(t.image);
			t = getToken(++i);
		}
		*/

                javaccLogger.debug("Operation Header lookahead: "+string);
                if (getToken(1).kind != SEMICOLON) {
                        return false;
                }

                int index = 2;
                if (getToken(index++).kind != Ident) {
                        javaccLogger.debug("\u005ctFalse: not Identifier, but "+getToken(2));
                        return false;
                }

                while (getToken(index).kind == COMMA) { //will have output parameters
                        if (getToken(++index).kind != Ident) {
                                javaccLogger.debug("\u005ctFalse: not identifier");
                                return false;
                        }
                        index++;
                }

                if (getToken(index).kind == ARROW) {
                        if (getToken(++index).kind != Ident) {
                                javaccLogger.debug("\u005ctFalse: operation name identifier is missing");
                                return false;
                        }
                        index++;
                } else if (index > 3) {
                        javaccLogger.debug("\u005ctFalse: has multiple output parameters, but no '<--'");
                        return false;
                }
                // operation input parameters 
                if (getToken(index).kind == LPAREN) {
                        javaccLogger.debug("\u005ctwill have input parameters");
                        if (getToken(++index).kind != Ident) {
                                javaccLogger.debug("\u005ctnot identifier as input parameter");
                                return false;
                        }
                        javaccLogger.debug("\u005ctfirst input parameter: "+getToken(index));
                        index++;
                        while(getToken(index).kind == COMMA) {
                                if (getToken(++index).kind != Ident) {
                                        javaccLogger.debug("\u005ctnot identifier as input parameter");
                                        return false;
                                }
                                javaccLogger.debug("\u005ctanother input parameter: "+getToken(index));
                                index++;
                        }
                        if (getToken(index).kind != RPAREN) {
                                javaccLogger.debug("\u005ctinput parameter(s) not enclosed by ')', but by '"+getToken(index)+"'");
                                return false;
                        }
                        index++;
                }

                if (!getToken(index).image.equals("=")) {
                        javaccLogger.debug("\u005ct'=' should be at the end, but is '"+getToken(index)+"'");
                        javaccLogger.debug("token index: "+index);
                        return false;
                }

                javaccLogger.debug("\u005ctTrue, operation follows");
                return true;
        }

        private final boolean notSubstitutionLookahead() {
                switch(getToken(1).kind) {
                        case BEGIN:
                        case skip:
                        case CHOICE:
                        case PRE:
                        case ASSERT:
                        case IF:
                        case SELECT:
                        case CASE:
                        case ANY:
                        case LET:
                        case VAR:
                        case WHILE:
                                return false;
                }
                // SubstitutionCall
                return true;
        }

        private final boolean predicateInParenthesesLookahead() {
                javaccLogger.debug("Predicate In Parentheses Lookahead");
                if (getToken(1).kind != LPAREN) {
                        javaccLogger.debug("first token must be: '(', but is: '"+getToken(1).image+"'");
                        return false;
                }
                int parenthesesCount = 1;
                int i = 1;
                int kind;
                while (parenthesesCount > 0) {
                        kind = getToken(++i).kind;
                        switch(kind) {
                                case LPAREN:
                                        parenthesesCount++;
                                        break;
                                case RPAREN:
                                        parenthesesCount--;
                                        break;
                                case NEGATION:
                                case CONJUNCTION:
                                case DISJUNCTION:
                                case IMPLICATION:
                                case EQUIVALENCE:

                                case LESS:
                                case LESS_OR_EQUAL:
                                case GREATER:
                                case GREATER_OR_EQUAL:
                                case EQUAL:
                                case UNEQUAL:

                                case INCLUSION:
                                case STRICT_INCLUSION:
                                case NON_INCLUSION:
                                case STRICT_NON_INCLUSION:

                                case BELONGS:
                                case NON_BELONGS:
                                        //logger.debug("i think it will be predicate, cause: "+getToken(i).image);
                                        return true;
                                //default:
                                        //javaccLogger.debug(getToken(i).image);

                        }
                }
                //logger.debug("i think it will NOT be predicate");
                return false;
        }

        private final boolean isClause(Token token) {
                //javaccLogger.debug("is "+token+" Clause Keyword ?");
                switch(token.kind) {
                        case MACHINE:
                        case REFINEMENT:
                        case IMPLEMENTATION:
                        case REFINES:
                        case INCLUDES:
                        case USES:
                        case IMPORTS:
                        case EXTENDS:
                        case SETS:
                        case OPERATIONS:
                        case LOCAL_OPERATIONS:
                        case INITIALISATION:
                        case CONSTRAINTS:
                        case INVARIANT:
                        case CONCRETE_CONSTANTS:
                        case CONCRETE_VARIABLES:
                        case ABSTRACT_CONSTANTS:
                        case ABSTRACT_VARIABLES:
                        case CONSTANTS:
                        case VARIABLES:
                        case VALUES:
                        case PROPERTIES:
                        case ASSERTIONS:
                        case DEFINITIONS:
                                //javaccLogger.debug("\tTrue");
                                return true;
                }
                //javaccLogger.debug("\tFalse");
                return false;
        }


        private final boolean endOfDefinitionsClauseLookahead() {
                javaccLogger.debug("End Of Definitions Clause Lookahead:");
                Token nextToken = (getToken(1).kind == SEMICOLON)? getToken(2) : getToken(1);
                if (isClause(nextToken) || nextToken.kind == END || nextToken.kind == EOF) {
                  javaccLogger.debug("\u005ctEnd of definitions clause, B keyword");
              return true;
                }
                javaccLogger.debug("\u005ctFalse! next token: "+nextToken);
                return false;
        }

        private final boolean followsDefinitionLookahead() {
          javaccLogger.debug("Follows Definition Lookahead:");

          if (getToken(1).kind != SEMICOLON) {
                javaccLogger.debug("\u005ctNo, first token is not \u005c";\u005c"");
                return false;
          }

          // relative or absolute file with definitions
          if (getToken(2).image.equals("\u005c"") || getToken(2).image.equals("<")) {
              String enclosingSymbol = getToken(2).image.equals("\u005c"")? "\u005c"" : ">";
              //StringBuilder filenameBuffer = new StringBuilder();
              int tokenIndex = 3;
              Token t = getToken(tokenIndex);
              while(!t.image.equals(enclosingSymbol) && !isClause(t)) {
                         //filenameBuffer.append(t.image);
                         t = getToken(++tokenIndex);
              }
              if (!isClause(t)) {
                      return true;
              }
          }

          if (isClause(getToken(2)) || getToken(2).kind == EOF) {
                  javaccLogger.debug("\u005ctNo, encountered B clause keyword or end of file");
              return false;
          }

          if (getToken(2).kind != Ident) {
                  javaccLogger.debug("\u005ctFalse, second token is not Ident");
                  return false;
          }

          int i = 3;
          if (getToken(i).kind == LPAREN) {
                  javaccLogger.debug("\u005cthave some arguments");
                  if (getToken(++i).kind != Ident) {
                      javaccLogger.debug("\u005ctNot Definition, not Identifier in argument list: "+getToken(i).image);
                          return false;
                  }
                  while(getToken(++i).kind != RPAREN) {
                          if (getToken(i).kind != COMMA) {
                                javaccLogger.debug("\u005ctNot Definition, definitions arguments must be separated by \u005c",\u005c": "+getToken(i).image);
                                return false;
                          }
                          if(getToken(++i).kind != Ident) {
                                  javaccLogger.debug("\u005ctNot Definition, not Identifier in argument list: "+getToken(i).image);
                                  return false;
                          }
                  }
                  if (i == 4) { // must have at least 1 argument
                                javaccLogger.debug("\u005ctNot Definition, must have at least 1 parameter in parentheses");
                            return false;
                  }
                  i++;
          }
          if (getToken(i).kind != DEFINITION_START) {
                        javaccLogger.debug("\u005ctNo, missing \u005c"==\u005c"");
                        return false;
          }
          javaccLogger.debug("\u005ctDefinition follows!");
          return true;
  }

        /****************************************
	******   Preprocessing Capability  ******
	****************************************/
        // ISSUE: setting LexicalStates when change TokenManager ?

        private boolean processDefinitions = true;
    private Stack<ParserTokenManager> token_sources = new Stack<ParserTokenManager>();;
        private Stack<Integer> definitionsTrace = new Stack<Integer>();
        private Stack<Couple<Integer, Integer>> definitionsTrace2 = new Stack<Couple<Integer, Integer>>();

        private Token getFollowingToken() {

                Token t = token_source.getNextToken();
                //javaccLogger.info("getFollowingToken: "+t);	
                if (t.kind == EOF && token_sources.size() > 1) {
                        definitionsTrace.pop();
                        javaccLogger.info("definitions trace pop");
                        token_sources.pop();
                        token_source = token_sources.peek();
                        t = getFollowingToken();
                }
                if (processDefinitions && definitions != null && definitions.hasDefinition(t.image)) {
                        Definition definition = definitions.getDefinition(t.image);

                        definitionsTrace.push(t.beginLine);
                        definitionsTrace2.push(new Couple<Integer, Integer>(t.beginLine, t.beginColumn));
                        logger.info(String.format("Encountered definition at %d, %d: %s", t.beginLine, t.beginColumn, definition));
                        javaccLogger.info(String.format("Encountered definition at %d, %d: %s", t.beginLine, t.beginColumn, definition));
                        javaccLogger.info("def trace: "+definitionsTrace);
                        // read following tokens as definition parameters
                        List<String> definitionArguments = java.util.Collections.emptyList();
                        if (definition.parameters.size() > 0) {
                                logger.info("Parsing arguments for definition: "+definition.name);
                                javaccLogger.info("Parsing arguments for definition: "+definition.name);
                                try {
                                        definitionArguments = parseDefinitionArguments();
                                        javaccLogger.info("arguments: "+definitionArguments);
                                } catch (ParseException ex) {
                                        logger.log(Level.ERROR, "Error in parsing definition parameters: ", ex);
                                        throw new RuntimeException(
                                                String.format("Parsing arguments for definition: \u005c"%s\u005c" wasn't successfull: %d, %d",
                                                definition.name,
                                                token.beginLine,
                                                token.beginColumn));
                                }
                                if (definitionArguments.size() != definition.parameters.size()) {
                                        throw new RuntimeException(
                                                String.format("Wrong number of arguments for definition: \u005c"%s\u005c". Expected %d but encountered %d at: %d, %d",
                                                definition.name,
                                                definition.parameters.size(),
                                                definitionArguments.size(),
                                                token.beginLine,
                                                token.beginColumn));
                                        }
                        }

                        String definitionText = definition.getText(definitionArguments);
                        logger.info("definition after substitution: " + definitionText);
                        java.io.Reader definitionReader = new java.io.StringReader(definitionText);

                        // depends on some JavaCC options
                        SimpleCharStream definitionStream = new SimpleCharStream(definitionReader, definition.beginLine, definition.beginColumn);
                        //JavaCharStream definitionStream = new JavaCharStream(definitionReader, definition.beginLine, definition.beginColumn);

                        // depends on TOKEN_MANAGER_USES_PARSER
                        //ParserTokenManager tm = new ParserTokenManager(this, definitionStream);
                        ParserTokenManager tm = new ParserTokenManager(definitionStream);

                        assert !token_sources.empty() : "source file must always be in stack";
                        token_sources.push(tm);
                        token_source = tm;
                        t = getFollowingToken();
                        javaccLogger.info("following token: "+t);
                }
                return t;
        }

        private List<String> parseDefinitionArguments() throws ParseException {
                List<String> parameters = new ArrayList<String>();
                Token t = token_source.getNextToken();
                if (t.kind == LPAREN) {
                        StringBuilder parameter = new StringBuilder();
                        int parenthesesCount = 0;
                        logger.debug("will have some arguments...");
                        t = token_source.getNextToken();
                        while(t.kind != RPAREN || parenthesesCount != 0) {

                                if (t.kind == COMMA && parenthesesCount == 0) {
                                        parameters.add(parameter.toString());
                                        parameter = new StringBuilder();
                                } else {
                                        switch (t.kind) {
                                                case LPAREN:parenthesesCount++;
                                                                        break;
                                                case RPAREN:parenthesesCount--;
                                                                        break;
                                        }
                                        // whatever token it is, append it's image
                                        parameter.append(t.image);
                                }
                                t = token_source.getNextToken();
                        }
                        parameters.add(parameter.toString());
                }
                logger.debug("parameters count: "+parameters.size());
                logger.debug("parameters: "+parameters);
                return parameters;
        }

        private String specialTokensImage(Token token) {
                StringBuilder image = new StringBuilder();
                Token t = token;
                while(t.specialToken != null) {
                        image.append(t.specialToken.image);
                        t = t.specialToken;
                }
                //logger.info("special tokens: \""+image+"\"");
                return image.toString();
        }

  /*******************************
  ******   Debuging Parser  ******
  *******************************/
        private StringBuilder traceIndent = new StringBuilder();

        private void trace_call(String s) {
                if (trace_enabled) {
                        javaccLogger.info(traceIndent + "Call:   " + s);
                }
        traceIndent.append("  ");
        }

        private void trace_return(String s) {
                traceIndent.delete(traceIndent.length()-2, traceIndent.length());
                if (trace_enabled) {
                        javaccLogger.info(traceIndent + "Return: " + s);
                }
        }

  private void trace_token(Token t, String where) {
    if (trace_enabled) {

      String prefix = traceIndent + "Consumed token: <" + tokenImage[t.kind];
      if (t.kind != 0 && !tokenImage[t.kind].equals("\u005c"" + t.image + "\u005c""))
        prefix += ": \u005c"" + t.image + "\u005c"";
      javaccLogger.info(prefix+" at line " + t.beginLine + " column " + t.beginColumn + ">" + where);
    }
  }

  private void trace_scan(Token t1, int t2) {
    if (trace_enabled) {
      String prefix = traceIndent + "Visited token: <" + tokenImage[t1.kind];
      if (t1.kind != 0 && !tokenImage[t1.kind].equals("\u005c"" + t1.image + "\u005c""))
              prefix += ": \u005c"" + t1.image + "\u005c"";
      javaccLogger.info(prefix + " at line " + t1.beginLine + " column " + t1.beginColumn + ">; Expected token: <" + tokenImage[t2] + ">");
    }
  }


  /*******************************
  *******   Another stuff  *******
  *******************************/
        public void checkEndOfInput() throws ParseException {
                jj_consume_token(EOF);
        }

        /* debuging tokens */
    public void dumpToken() {
          StringBuilder sb = new StringBuilder();
          Token t = token;
          while(t != null) {
                  sb.append(t+" ");
                  t = t.next;
          }
          System.out.println("Token chain: "+sb);
        }

    public void skipTo(int... kinds) throws ParseException {
        logger.debug("starting skipping tokens with: "+getToken(1));

        //jj_consume_token(getToken(1).kind);

                int kind = getToken(1).kind;
                boolean tokenMatch;
                while (kind != EOF) {
                        tokenMatch = false;
                        for (int k : kinds) {
                                if (kind == k) {
                                        tokenMatch = true;
                                        break;
                                }
                        }
                        if (!tokenMatch) {
                                try {
                                        //logger.debug("trying consume token of kind: "+getToken(1));
                                        jj_consume_token(kind);
                                } catch (ParseException e) {
                                        logger.log(Level.ERROR, "error during skipping tokens", e);
                                        break;
                                }
                                kind = getToken(1).kind;
                        } else break;
                }
                logger.debug("ending skipping tokens with: "+getToken(1));
        }

        private static final boolean isUpperCase(String string) {
                for (char c : string.toCharArray()) {
                        if (Character.isLetter(c) &&!Character.isUpperCase(c))
                                return false;
                }
                return true;
        }
        /*
	*  Class to encapsulate result from Valuation clause
	*/
        public static final class Valuation {

                public final DataField data;
                public final B0DataValue value;

                public Valuation(DataField data, B0DataValue value) {
                        this.data = data;
                        this.value = value;
                }
        }
        /*
	*  Class to encapsulate ??
	*/
        public static final class DefinitionSource {

                public final ParserTokenManager tokenManager;
                public final Definition definition;

                public DefinitionSource(ParserTokenManager tokenManager, Definition definition) {
                        this.tokenManager = tokenManager;
                        this.definition = definition;
                }
        }

  final public PreprocessData Preprocess() throws ParseException {
    trace_call("Preprocess");
    try {
        PreprocessData preprocessData = new PreprocessData();
        DefinitionsContext definitionContext = null;
                Logger javacc = javaccLogger;
                logger = sk.tuke.bkpi.logging.Logger.getLogger("sk.tuke.bkpi.parser."+parsingFile.getName()+"_Preprocess");
                javaccLogger = sk.tuke.bkpi.logging.Logger.getLogger("sk.tuke.bkpi.parser.javacc."+parsingFile.getName()+"_Preprocess");//Logging.getJavaccLogger(parsingFile.getName()+"Preprocess");
                logger.info("\u005ctPreprocessing definitions:");
                token_source.SwitchTo(PREPROCESS);
      label_1:
      while (true) {
        if (jj_2_1(1)) {
          ;
        } else {
          break label_1;
        }
        if (jj_2_2(2147483647) && (whilesCount > 0)) {
          jj_consume_token(INVARIANT);
                             whilesCount--;
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IMPORTS:
            jj_consume_token(IMPORTS);
                        logger.info("imports...");
                        preprocessData.addClausePosition(PreprocessData.Clause.valueOf(token.image), token.beginLine, token.beginColumn);

                        token_source.SwitchTo(IMPORTS_PREPROCESS);
                        List<String> importedMachines = new ArrayList<String>();
                        Identifier i;
            // we CAN use RenIdent() cause "." token isn't defined, when it will need to be, add it to IMPORTS_PREPROCESS
                            i = RenIdent();
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LPAREN:
              jj_consume_token(LPAREN);
              skip_to_matching_brace();
              jj_consume_token(RPAREN);
              break;
            default:
              jj_la1[0] = jj_gen;
              ;
            }
                  importedMachines.add(i.componentName());
            label_2:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[1] = jj_gen;
                break label_2;
              }
              jj_consume_token(COMMA);
              i = RenIdent();
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case LPAREN:
                jj_consume_token(LPAREN);
                skip_to_matching_brace();
                jj_consume_token(RPAREN);
                break;
              default:
                jj_la1[2] = jj_gen;
                ;
              }
                          importedMachines.add(i.componentName());
            }
                        logger.info("end of imp");
                        preprocessData.setImportedMachines(importedMachines);
                        token_source.SwitchTo(PREPROCESS);
            break;
          case REFINES:
          case INCLUDES:
          case USES:
          case PROMOTES:
          case SEES:
          case EXTENDS:
          case SETS:
          case OPERATIONS:
          case LOCAL_OPERATIONS:
          case INITIALISATION:
          case CONSTRAINTS:
          case INVARIANT:
          case CONCRETE_CONSTANTS:
          case CONCRETE_VARIABLES:
          case ABSTRACT_CONSTANTS:
          case ABSTRACT_VARIABLES:
          case CONSTANTS:
          case VARIABLES:
          case VALUES:
          case PROPERTIES:
          case ASSERTIONS:
          case DEFINITIONS:
            ClauseKeyWord();
                        if (token.kind == DEFINITIONS) {
                                inDefinitionsClause = true;
                        } else {
                                inDefinitionsClause = false;
                        }
                        preprocessData.addClausePosition(PreprocessData.Clause.valueOf(token.image), token.beginLine, token.beginColumn);
            break;
          case ANY_CHAR:
            jj_consume_token(ANY_CHAR);
            break;
          case WHILE2:
            jj_consume_token(WHILE2);
                           whilesCount++;
            break;
          case Ident:
            jj_consume_token(Ident);
            break;
          default:
            jj_la1[3] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
      jj_consume_token(0);
                if (definitionContext != null) {
                        javaccLogger.info("Definitions:");
                        for (Definition def : definitionContext.listDefinitions()) {
                                javaccLogger.info("\u005ct"+def);
                        }
                        javaccLogger.info("********************");
                }

                logger.info("\u005ctPositions: "+preprocessData.getClausePositions());
                javaccLogger.info("\u005ctPositions: "+preprocessData.getClausePositions());
                for (PreprocessData.ClausePosition clause : preprocessData.getClausePositions()) {
                        //logger.error(clause + " "+clause.clause.orderNumber);
                }

                for (PreprocessData.Chain chain : preprocessData.getChains().keySet()) {
                        logger.info(chain+ ": "+preprocessData.getChains().get(chain));
                }
                logger.info("\u005ctOperations: "+preprocessData.getOperationsNames());
                javaccLogger.info("\u005ctOperations: "+preprocessData.getOperationsNames());
                logger.info("End of preprocessing.");
                javaccLogger = javacc;
                {if (true) return preprocessData;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Preprocess");
    }
  }

  final public void OperationsPreprocess(PreprocessData preprocessData) throws ParseException {
    trace_call("OperationsPreprocess");
    try {
        OperationHeader header; Identifier operation;
      jj_consume_token(OPERATIONS);
                token_source.SwitchTo(OPERATIONS_PREPROCESS);
                preprocessData.addClausePosition(PreprocessData.Clause.OPERATIONS, token.beginLine, token.beginColumn);
      label_3:
      while (true) {
        if (jj_2_3(1)) {
          ;
        } else {
          break label_3;
        }
        if (jj_2_6(2147483647)) {
          if (jj_2_4(2)) {
            ListIdent();
            jj_consume_token(ARROW);
          } else {
            ;
          }
          operation = RenIdent();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            jj_consume_token(LPAREN);
            ListIdent();
            jj_consume_token(RPAREN);
            break;
          default:
            jj_la1[4] = jj_gen;
            ;
          }
          jj_consume_token(ASIGN);
                                        preprocessData.addOperationName(operation);
                                        javaccLogger.info("Operation: "+operation);
        } else if (jj_2_7(1)) {
          label_4:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LPAREN:
              jj_consume_token(LPAREN);
              break;
            case RPAREN:
              jj_consume_token(RPAREN);
              break;
            case COMMA:
              jj_consume_token(COMMA);
              break;
            case ASIGN:
              jj_consume_token(ASIGN);
              break;
            case ARROW:
              jj_consume_token(ARROW);
              break;
            case Ident:
              jj_consume_token(Ident);
              break;
            default:
              jj_la1[5] = jj_gen;
              if (getToken(1).kind == END && getToken(2).kind != EOF) {
                jj_consume_token(END);
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case ANY_CHAR:
                  jj_consume_token(ANY_CHAR);
                  break;
                default:
                  jj_la1[6] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseException();
                }
              }
            }
            if (jj_2_5(1)) {
              ;
            } else {
              break label_4;
            }
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[7] = jj_gen;
            ;
          }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
                javaccLogger.info("End of preprocessing operations");
                javaccLogger.info("Next token: "+getToken(1));
                javaccLogger.info("Next token: "+getToken(2));
                token_source.SwitchTo(PREPROCESS);
    } finally {
      trace_return("OperationsPreprocess");
    }
  }

  final public void OperationsPreprocess2(PreprocessData preprocessData) throws ParseException {
    trace_call("OperationsPreprocess2");
    try {
        OperationHeader header;
        Identifier name;
      jj_consume_token(OPERATIONS);
                javaccLogger.info("Starting operations preprocessing");
                token_source.SwitchTo(OPERATIONS_PREPROCESS);
                preprocessData.addClausePosition(PreprocessData.Clause.OPERATIONS, token.beginLine, token.beginColumn);
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
        case Ident:
          ;
          break;
        default:
          jj_la1[8] = jj_gen;
          break label_5;
        }
        if (jj_2_8(2)) {
          ListIdent();
          jj_consume_token(ARROW);
        } else {
          ;
        }
        name = RenIdent();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          jj_consume_token(LPAREN);
          ListIdent();
          jj_consume_token(RPAREN);
          break;
        default:
          jj_la1[9] = jj_gen;
          ;
        }
        jj_consume_token(ASIGN);
                        javaccLogger.info("Operation: "+name);
                        preprocessData.addOperationName(name);
        label_6:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            jj_consume_token(LPAREN);
            break;
          case RPAREN:
            jj_consume_token(RPAREN);
            break;
          case COMMA:
            jj_consume_token(COMMA);
            break;
          case ASIGN:
            jj_consume_token(ASIGN);
            break;
          case Ident:
            jj_consume_token(Ident);
            break;
          case ARROW:
            jj_consume_token(ARROW);
            break;
          case END:
            jj_consume_token(END);
            break;
          case ANY_CHAR:
            jj_consume_token(ANY_CHAR);
            break;
          default:
            jj_la1[10] = jj_gen;
            if (!followOperationHeader()) {
              jj_consume_token(SEMICOLON);
            } else {
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          if (jj_2_9(1)) {
            ;
          } else {
            break label_6;
          }
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[11] = jj_gen;
          ;
        }
      }
                javaccLogger.info("End of preprocessing operations");
                token_source.SwitchTo(PREPROCESS);
    } finally {
      trace_return("OperationsPreprocess2");
    }
  }

  final public void ReferenceChainPreprocess(PreprocessData preprocessData) throws ParseException {
    trace_call("ReferenceChainPreprocess");
    try {
        PreprocessData.Chain chain;
        Identifier machineIdent;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEES:
        jj_consume_token(SEES);
                         chain = PreprocessData.Chain.SEES;
        break;
      case USES:
        jj_consume_token(USES);
                         chain = PreprocessData.Chain.USES;
        break;
      case REFINES:
        jj_consume_token(REFINES);
                            chain = PreprocessData.Chain.REFINES;
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                //logger.info("sees clause at:"+token.beginLine);
                preprocessData.addClausePosition(PreprocessData.Clause.SEES, token.beginLine, token.beginColumn);

                token_source.SwitchTo(DEFAULT);
      machineIdent = RenIdent();
          preprocessData.addChain(chain, machineIdent.toString());
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[13] = jj_gen;
          break label_7;
        }
        jj_consume_token(COMMA);
        machineIdent = RenIdent();
                  preprocessData.addChain(chain, machineIdent.toString());
      }
          token_source.SwitchTo(PREPROCESS);
    } finally {
      trace_return("ReferenceChainPreprocess");
    }
  }

  final public void ParametricChainPreprocess(PreprocessData preprocessData) throws ParseException {
    trace_call("ParametricChainPreprocess");
    try {
        PreprocessData.Chain chain;
        Identifier machineIdent;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPORTS:
        jj_consume_token(IMPORTS);
                             chain = PreprocessData.Chain.IMPORTS;
        break;
      case INCLUDES:
        jj_consume_token(INCLUDES);
                             chain = PreprocessData.Chain.INCLUDES;
        break;
      case EXTENDS:
        jj_consume_token(EXTENDS);
                             chain = PreprocessData.Chain.EXTENDS;
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                //logger.info("imports clause at:"+token.beginLine);
                //logger.info("next: "+token.next);
                preprocessData.addClausePosition(PreprocessData.Clause.IMPORTS, token.beginLine, token.beginColumn);

                token_source.SwitchTo(DEFAULT);
      machineIdent = RenIdent();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        InstanciationB0();
        label_8:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[15] = jj_gen;
            break label_8;
          }
          jj_consume_token(COMMA);
          InstanciationB0();
        }
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[16] = jj_gen;
        ;
      }
          preprocessData.addChain(chain, machineIdent.toString());
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[17] = jj_gen;
          break label_9;
        }
        jj_consume_token(COMMA);
        machineIdent = RenIdent();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          jj_consume_token(LPAREN);
          InstanciationB0();
          label_10:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[18] = jj_gen;
              break label_10;
            }
            jj_consume_token(COMMA);
            InstanciationB0();
          }
          jj_consume_token(RPAREN);
          break;
        default:
          jj_la1[19] = jj_gen;
          ;
        }
                  preprocessData.addChain(chain, machineIdent.toString());
      }
          token_source.SwitchTo(PREPROCESS);
    } finally {
      trace_return("ParametricChainPreprocess");
    }
  }

  final public void InvariantPreprocess() throws ParseException {
    trace_call("InvariantPreprocess");
    try {
      jj_consume_token(INVARIANT);
                logger.info("state: "+token_source.curLexState);
                logger.info("next: "+token.next);
                logger.info("invariant clause at:"+token.beginLine);
    } finally {
      trace_return("InvariantPreprocess");
    }
  }

  final public void ClauseKeyWord() throws ParseException {
    trace_call("ClauseKeyWord");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REFINES:
        jj_consume_token(REFINES);
        break;
      case DEFINITIONS:
        jj_consume_token(DEFINITIONS);
        break;
      case IMPORTS:
        jj_consume_token(IMPORTS);
        break;
      case SEES:
        jj_consume_token(SEES);
        break;
      case INCLUDES:
        jj_consume_token(INCLUDES);
        break;
      case USES:
        jj_consume_token(USES);
        break;
      case EXTENDS:
        jj_consume_token(EXTENDS);
        break;
      case PROMOTES:
        jj_consume_token(PROMOTES);
        break;
      case SETS:
        jj_consume_token(SETS);
        break;
      case ABSTRACT_CONSTANTS:
        jj_consume_token(ABSTRACT_CONSTANTS);
        break;
      case CONCRETE_CONSTANTS:
        jj_consume_token(CONCRETE_CONSTANTS);
        break;
      case CONSTANTS:
        jj_consume_token(CONSTANTS);
        break;
      case VALUES:
        jj_consume_token(VALUES);
        break;
      case ABSTRACT_VARIABLES:
        jj_consume_token(ABSTRACT_VARIABLES);
        break;
      case CONCRETE_VARIABLES:
        jj_consume_token(CONCRETE_VARIABLES);
        break;
      case CONSTRAINTS:
        jj_consume_token(CONSTRAINTS);
        break;
      case VARIABLES:
        jj_consume_token(VARIABLES);
        break;
      case PROPERTIES:
        jj_consume_token(PROPERTIES);
        break;
      case INVARIANT:
        jj_consume_token(INVARIANT);
        break;
      case ASSERTIONS:
        jj_consume_token(ASSERTIONS);
        break;
      case INITIALISATION:
        jj_consume_token(INITIALISATION);
        break;
      case OPERATIONS:
        jj_consume_token(OPERATIONS);
        break;
      case LOCAL_OPERATIONS:
        jj_consume_token(LOCAL_OPERATIONS);
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("ClauseKeyWord");
    }
  }

  final public DefinitionsContext DefinitionsPreprocess() throws ParseException {
    trace_call("DefinitionsPreprocess");
    try {
        int lexState = token_source.curLexState;
        DefinitionsContext context = new DefinitionsContext();
          logger.info("Preprocessing definitions:");
      jj_consume_token(DEFINITIONS);
                               token_source.SwitchTo(DEFINITIONS_STATE);
      Definition(context);
      label_11:
      while (true) {
        if (jj_2_10(2147483647) && (!endOfDefinitionsClauseLookahead())) {
          ;
        } else {
          break label_11;
        }
        jj_consume_token(SEMICOLON);
        Definition(context);
      }
                logger.info("\u005ct\u005ctEnd of preprocessing. state: "+token_source.curLexState);
                token_source.SwitchTo(PREPROCESS);
                logger.info("\u005ct\u005ctEnd of preprocessing definitions.");
                {if (true) return context;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("DefinitionsPreprocess");
    }
  }

  final public void Definition(DefinitionsContext context) throws ParseException {
    trace_call("Definition");
    try {
        Token first, t;
        StringBuilder filename;
        String definitionName;
        List<String> arguments = new ArrayList<String>();
        StringBuilder buffer;
        int startLine   = -1;
        int startColumn = -1;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case Ident:
        jj_consume_token(Ident);
                                  definitionName = token.image;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          jj_consume_token(LPAREN);
          arguments = ListIdent();
          jj_consume_token(RPAREN);
          break;
        default:
          jj_la1[21] = jj_gen;
          ;
        }
        jj_consume_token(DEFINITION_START);
                                logger.debug("\u005ct\u005ctDefinition: "+definitionName);
                                javaccLogger.info("Definition: "+definitionName);
                                buffer = new StringBuilder();
        label_12:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            jj_consume_token(LPAREN);
            break;
          case RPAREN:
            jj_consume_token(RPAREN);
            break;
          case COMMA:
            jj_consume_token(COMMA);
            break;
          case 13:
            jj_consume_token(13);
            break;
          case LESS:
            jj_consume_token(LESS);
            break;
          case GREATER:
            jj_consume_token(GREATER);
            break;
          case Ident:
            jj_consume_token(Ident);
            break;
          case ANY_CHAR:
            jj_consume_token(ANY_CHAR);
            break;
          case INVARIANT:
            jj_consume_token(INVARIANT);
            break;
          default:
            jj_la1[22] = jj_gen;
            if (jj_2_11(2147483647) && (!followsDefinitionLookahead())) {
              jj_consume_token(SEMICOLON);
            } else if (getToken(1).kind == END && (parsingDefinitionFile || getToken(2).kind != EOF)) {
              jj_consume_token(END);
            } else {
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
                                        // first symbol of definition lexem is important for position handling,
                                        // but we need first token including white symbols !!!
                                        if (startLine == -1) {
                                                Token firstToken = token;
                                                while(firstToken.specialToken != null) {
                                                        firstToken = firstToken.specialToken;
                                                }
                                                startLine   = firstToken.beginLine;
                                                startColumn = firstToken.beginColumn;
                                        }
                                        if (token.specialToken != null) {
                                                buffer.append(specialTokensImage(token));
                                        }
                                        buffer.append(token.image);
          if (jj_2_12(1)) {
            ;
          } else {
            break label_12;
          }
        }
                                Definition definition = new Definition(definitionName, arguments, buffer.toString(), parsingFile, startLine, startColumn);
                                logger.debug("\u005ct\u005ctProcesses Definition: "+definition);
                                javaccLogger.info("Processes Definition: "+definition);
                                context.addDefinition(definition);
        break;
      case LESS:
        first = jj_consume_token(LESS);
        label_13:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case Ident:
            jj_consume_token(Ident);
            break;
          case LPAREN:
            jj_consume_token(LPAREN);
            break;
          case RPAREN:
            jj_consume_token(RPAREN);
            break;
          case COMMA:
            jj_consume_token(COMMA);
            break;
          case ANY_CHAR:
            jj_consume_token(ANY_CHAR);
            break;
          default:
            jj_la1[23] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
          case RPAREN:
          case COMMA:
          case Ident:
          case ANY_CHAR:
            ;
            break;
          default:
            jj_la1[24] = jj_gen;
            break label_13;
          }
        }
        jj_consume_token(GREATER);
                                t = first.next;
                                filename = new StringBuilder();
                                while(t != token) {
                                        filename.append(t.image);
                                        t = t.next;
                                }
                                File absolutePathFile = new File(filename.toString());
                                javaccLogger.debug("Absolute file definition: "+absolutePathFile);
                                parseDefinitionsFile(absolutePathFile, context);
        break;
      case 13:
        first = jj_consume_token(13);
        label_14:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case Ident:
            jj_consume_token(Ident);
            break;
          case LPAREN:
            jj_consume_token(LPAREN);
            break;
          case RPAREN:
            jj_consume_token(RPAREN);
            break;
          case COMMA:
            jj_consume_token(COMMA);
            break;
          case ANY_CHAR:
            jj_consume_token(ANY_CHAR);
            break;
          default:
            jj_la1[25] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
          case RPAREN:
          case COMMA:
          case Ident:
          case ANY_CHAR:
            ;
            break;
          default:
            jj_la1[26] = jj_gen;
            break label_14;
          }
        }
        jj_consume_token(13);
                                t = first.next;
                                filename = new StringBuilder();
                                while(t != token) {
                                        filename.append(t.image);
                                        t = t.next;
                                }
                                File definitionsFile = new File(parsingFile.getParentFile().getAbsolutePath()+File.separator+filename.toString());
                                javaccLogger.debug("Relative file definition: "+definitionsFile);
                                parseDefinitionsFile(definitionsFile, context);
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("Definition");
    }
  }

  final public Component Component() throws ParseException {
    trace_call("Component");
    try {
        Component bComponent = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MACHINE:
        bComponent = Machine();
        break;
      case REFINEMENT:
        bComponent = Refinement();
        break;
      case IMPLEMENTATION:
        bComponent = Implementation();
        break;
      default:
        jj_la1[28] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
          {if (true) return bComponent;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Component");
    }
  }

/*************************************
 ******     MACHINE GRAMMAR     ******
 *************************************/
  final public Machine Machine() throws ParseException {
    trace_call("Machine");
    try {
        Header header;

        List<ConcreteConstant> concreteConstants = null;
        List<ConcreteVariable> concreteVariables = null;
        List<AbstractConstant> abstractConstants = null;
        List<AbstractVariable> abstractVariables = null;
        List<Set> sets = null;

        Predicate properties = null;
        Predicate constraints = null;
        Predicate invariant  = null;

        List<SeenMachine> seenMachines = null;
        List<IncludedMachine> includedMachines = null;
        List<IncludedMachine> extendedMachines = null;
        List<Operation> operations = null;
      jj_consume_token(MACHINE);
      header = Header();
                for (DataField formalParam : header.parameters()) {
                        dataContext.addDataItem(formalParam);
                }
                logger.info("************************\u005cnPARSING Machine: "+header.name());
                checkPreprocessedData();
      label_15:
      while (true) {
        if (!endOfClauses()) {
          ;
        } else {
          break label_15;
        }
                  ensureClauseOrder();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CONSTRAINTS:
          constraints = ClauseConstraints();
          break;
        case SEES:
          seenMachines = ClauseSees();
          break;
        case INCLUDES:
          includedMachines = ClauseIncludes();
          break;
        case PROMOTES:
          ClausePromotes();
          break;
        case EXTENDS:
          extendedMachines = ClauseExtends();
          break;
        case USES:
          ClauseUses();
          break;
        case SETS:
          sets = ClauseSets();
          break;
        case CONCRETE_CONSTANTS:
        case CONSTANTS:
          concreteConstants = ClauseConcreteConstants();
          break;
        case ABSTRACT_CONSTANTS:
          abstractConstants = ClauseAbctractConstants();
          break;
        case PROPERTIES:
          properties = ClauseProperties();
          break;
        case CONCRETE_VARIABLES:
          concreteVariables = ClauseConcreteVariables();
          break;
        case ABSTRACT_VARIABLES:
        case VARIABLES:
          abstractVariables = ClauseAbstractVariables();
          break;
        case INVARIANT:
          invariant = ClauseInvariant();
          break;
        case INITIALISATION:
          ClauseInitialization();
          break;
        case OPERATIONS:
          operations = ClauseOperations();
          break;
        case ASSERTIONS:
          ClauseAssertions();
          break;
        case DEFINITIONS:
          DefinitionsClause();
          break;
        default:
          jj_la1[29] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(END);
      jj_consume_token(0);
                logger.debug("Machine "+header.name()+" parsed:");
                logger.debug("Formal parameters:");
                for (DataField param : header.parameters()) {
                        logger.debug(param.name()+" type: "+param.type());
                }

                if (concreteVariables != null) {
                        logger.debug("Concrete variables:");
                        for (DataField var : concreteVariables) {
                                logger.debug(var.name()+ " type: "+var.type());
                        }
                }

                if (abstractVariables != null) {
                        logger.debug("Abstract variables:");
                        for (DataField var : abstractVariables) {
                                logger.debug(var.name()+ " type: "+var.type());
                        }
                }

                {if (true) return new Machine(header, constraints, seenMachines, includedMachines, extendedMachines, sets, concreteConstants, abstractConstants, concreteVariables, abstractVariables, properties, invariant, operations);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Machine");
    }
  }

  final public void DefinitionsClause() throws ParseException {
    trace_call("DefinitionsClause");
    try {
         processDefinitions = false;
      definitions = DefinitionsPreprocess();
                processDefinitions = true;
                token_source.SwitchTo(DEFAULT);

                javaccLogger.info("Definitions:");
                logger.info("Definitions:");
                for (Definition def : definitions.listDefinitions()) {
                        javaccLogger.info("\u005ct"+def);
                        logger.info("\u005ct"+def);
                }
                javaccLogger.info("********************");
    } finally {
      trace_return("DefinitionsClause");
    }
  }

  final public void SkipDefinitionsClause() throws ParseException {
    trace_call("SkipDefinitionsClause");
    try {
      jj_consume_token(DEFINITIONS);
                processDefinitions = false;
                // it is needed to skip to first clause keyword, but either for END keyword,
                // cause DEFINITIONS clause can be placed just before last END keyword.
                // But as END is valid string for definitions (can be used in substitutions),
                // so it is needed to check if it is last END. If it isn't, continue skipping
                // tokens as before.
                skipTo(END, MACHINE,REFINEMENT,IMPLEMENTATION,REFINES,DEFINITIONS,IMPORTS,SEES,INCLUDES,USES,EXTENDS,PROMOTES,SETS,ABSTRACT_CONSTANTS,CONCRETE_CONSTANTS,CONSTANTS,VALUES,ABSTRACT_VARIABLES,CONCRETE_VARIABLES,VARIABLES,PROPERTIES,INVARIANT,ASSERTIONS,INITIALISATION,OPERATIONS,LOCAL_OPERATIONS);
                while (getToken(1).kind == END && (!isClause(getToken(2)) && getToken(2).kind != EOF)) {
                        logger.debug("next token: "+getToken(2).image);
                        jj_consume_token(getToken(1).kind);
                        skipTo(END, MACHINE,REFINEMENT,IMPLEMENTATION,REFINES,DEFINITIONS,IMPORTS,SEES,INCLUDES,USES,EXTENDS,PROMOTES,SETS,ABSTRACT_CONSTANTS,CONCRETE_CONSTANTS,CONSTANTS,VALUES,ABSTRACT_VARIABLES,CONCRETE_VARIABLES,VARIABLES,PROPERTIES,INVARIANT,ASSERTIONS,INITIALISATION,OPERATIONS,LOCAL_OPERATIONS);
                }
                processDefinitions = true;
    } finally {
      trace_return("SkipDefinitionsClause");
    }
  }

  final public List<IncludedMachine> ClauseIncludes() throws ParseException {
    trace_call("ClauseIncludes");
    try {
        Identifier machine;
        IncludedMachine includedMachine;
        List<IncludedMachine> includedMachines = new ArrayList<IncludedMachine>();
      jj_consume_token(INCLUDES);
      includedMachine = Include();
                                     includedMachines.add(includedMachine);
      label_16:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[30] = jj_gen;
          break label_16;
        }
        jj_consume_token(COMMA);
        includedMachine = Include();
                                                 includedMachines.add(includedMachine);
      }
          {if (true) return includedMachines;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseIncludes");
    }
  }

  final public IncludedMachine Include() throws ParseException {
    trace_call("Include");
    try {
        Identifier ident;
        Machine machine;
        DataValue parameter;
        List<DataValue> parameters = new ArrayList<DataValue>();
      ident = RenIdent();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        parameter = Instanciation();
                                                              parameters.add(parameter);
        label_17:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[31] = jj_gen;
            break label_17;
          }
          jj_consume_token(COMMA);
          parameter = Instanciation();
        }
                                                                                                                              parameters.add(parameter);
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[32] = jj_gen;
        ;
      }
                machine = (Machine) getComponent(ident.componentName());
                IncludedMachine includedMachine;
                if (ident.prefixList().size() > 0)
                        includedMachine = new IncludedMachine(ident.prefixList().get(0), machine, parameters);
                else
                        includedMachine = new IncludedMachine(machine, parameters);

                dataContext.addDataItems(includedMachine.includedAbstractVariables());
                dataContext.addDataItems(includedMachine.includedConcreteVariables());

                dataContext.addDataItems(includedMachine.machine().sets());
                dataContext.addDataItems(includedMachine.machine().abstractConstants());
                dataContext.addDataItems(includedMachine.machine().concreteConstants());

                // TODO
                //for (Operation operation : machine.operations()) {
                for (Operation operation : includedMachine.includedOperations()) {
                        OperationDeclaration declaration = new OperationDeclaration(includedMachine, operation.name(), operation.inputParameters(), operation.outputParameters());
                        declaredOperations.put(declaration.operationCallName(), declaration);
                }
                {if (true) return includedMachine;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Include");
    }
  }

  final public List<OperationDeclaration> ClausePromotes() throws ParseException {
    trace_call("ClausePromotes");
    try {
  List<Identifier> operationsIdentifiers;
      jj_consume_token(PROMOTES);
      operationsIdentifiers = RenIdentList();
                List<OperationDeclaration> promotedOperations = new ArrayList<OperationDeclaration>();
                for (Identifier id : operationsIdentifiers) {
                        if (!declaredOperations.containsKey(id.toString())) {
                                {if (true) throw new RuntimeException("Unknown promoted operation: "+id +" at line: "+token.beginLine);}
                        }
                        OperationDeclaration declaration = declaredOperations.get(id.toString());
                        if (declaration.source() == null) {
                                {if (true) throw new RuntimeException("Unknown machine of promoted operation: "+id +" at line: "+token.beginLine);}
                        }
                        promotedOperations.add(declaration);
                }
                {if (true) return promotedOperations;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClausePromotes");
    }
  }

  final public List<Import> ClauseExtendsB0() throws ParseException {
    trace_call("ClauseExtendsB0");
    try {
        Import extendedMachine;
        List<Import> extendedMachines = new ArrayList<Import>();
      jj_consume_token(EXTENDS);
      extendedMachine = Import();
                                              extendedMachines.add(extendedMachine);
      label_18:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[33] = jj_gen;
          break label_18;
        }
        jj_consume_token(COMMA);
        extendedMachine = Import();
                                                extendedMachines.add(extendedMachine);
      }
          {if (true) return extendedMachines;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseExtendsB0");
    }
  }

  final public List<IncludedMachine> ClauseExtends() throws ParseException {
    trace_call("ClauseExtends");
    try {
        IncludedMachine extendedMachine;
        List<IncludedMachine> extendedMachines = new ArrayList<IncludedMachine>();
      jj_consume_token(EXTENDS);
      extendedMachine = Extend();
                                              extendedMachines.add(extendedMachine);
      label_19:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[34] = jj_gen;
          break label_19;
        }
        jj_consume_token(COMMA);
        extendedMachine = Extend();
                                                extendedMachines.add(extendedMachine);
      }
          {if (true) return extendedMachines;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseExtends");
    }
  }

  final public IncludedMachine Extend() throws ParseException {
    trace_call("Extend");
    try {
        Identifier ident;
        Machine machine;
        DataValue parameter;
        List<DataValue> parameters = new ArrayList<DataValue>();
      ident = RenIdent();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        parameter = Instanciation();
                                                              parameters.add(parameter);
        label_20:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[35] = jj_gen;
            break label_20;
          }
          jj_consume_token(COMMA);
          parameter = Instanciation();
                                                                                                                            parameters.add(parameter);
        }
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[36] = jj_gen;
        ;
      }
                machine = (Machine) getComponent(ident.componentName());
                IncludedMachine includedMachine = new IncludedMachine(machine, parameters);
                dataContext.addDataItems(includedMachine.includedAbstractVariables());
                dataContext.addDataItems(includedMachine.includedConcreteVariables());

                dataContext.addDataItems(includedMachine.machine().sets());
                dataContext.addDataItems(includedMachine.machine().abstractConstants());
                dataContext.addDataItems(includedMachine.machine().concreteConstants());
                {if (true) return includedMachine;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Extend");
    }
  }

  final public void ClauseUses() throws ParseException {
    trace_call("ClauseUses");
    try {
        List<Identifier> idents;
        Machine machine;
      jj_consume_token(USES);
      idents = RenIdentList();
                for (Identifier ident : idents) {
                        machine = (Machine) getComponent(ident.componentName());
                        dataContext.addMachineConstantsAndSets(machine, ForeignData.Chain.USES);
                        for (AbstractVariable var : machine.abstractVariables()) {
                                dataContext.addDataItem(new ForeignData(machine, var));
                        }

                        //TODO add variables
                }
    } finally {
      trace_return("ClauseUses");
    }
  }

/*
for (Identifier id : sees) {
			String seenMachineName = id.componentName();
			logger.info("\tSeen Machine: "+seenMachineName);
			Component machine = getComponent(seenMachineName);
			if (machine != null) {
				//seenMachines.add((Machine) machine); // TODO: check class
				SeenMachine seenMachine = new SeenMachine(id.prefixList(), (Machine) machine);
				seenMachines.add(seenMachine);
				
				String name = id.hasPrefix()? id.prefixString() : null;
				dataContext.addMachineConstantsAndSets((Machine) machine, ForeignData.Chain.SEES);
				dataContext.addMachineVariables(seenMachine);
				
				String operationPrefix = id.hasPrefix()? id.prefixString()+"." : "";
				//System.out.println("prefixString: "+id.prefixString());
				for (Operation operation : ((Machine) machine).operations()) {
					logger.info("\t\t"+operation.name());
					logger.info("\t\t\tInput Parameters : "+operation.inputParameters());
					logger.info("\t\t\tOutput Parameters: "+operation.outputParameters());
					declaredOperations.put(operationPrefix+operation.name(), new OperationDeclaration(seenMachine, operation.name(), operation.inputParameters(), operation.outputParameters()));
				}
			}  else {
				// trouble log
				logger.error("Missing machine module: "+seenMachineName);
				throw new RuntimeException("Sees problem");
			}
		}
		*/
  final public Predicate ClauseAssertions() throws ParseException {
    trace_call("ClauseAssertions");
    try {
                               Predicate assertions;
      jj_consume_token(ASSERTIONS);
      assertions = Predicate();
      label_21:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[37] = jj_gen;
          break label_21;
        }
        jj_consume_token(SEMICOLON);
        Predicate();
      }
          {if (true) return assertions;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseAssertions");
    }
  }

  final public Expression Instanciation() throws ParseException {
    trace_call("Instanciation");
    try {
                              Expression expr;
      expr = Expression();
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Instanciation");
    }
  }

  final public void IntegerSet() throws ParseException {
    trace_call("IntegerSet");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NAT:
      case NAT1:
      case INT:
        IntegerSetB0();
        break;
      case Z:
        jj_consume_token(Z);
        break;
      case N:
        jj_consume_token(N);
        break;
      case N1:
        jj_consume_token(N1);
        break;
      default:
        jj_la1[38] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("IntegerSet");
    }
  }

  final public void Interval() throws ParseException {
    trace_call("Interval");
    try {
      Expression();
    } finally {
      trace_return("Interval");
    }
  }

  final public Instruction ClauseInitializationB0() throws ParseException {
    trace_call("ClauseInitializationB0");
    try {
                                        Instruction initialization;
      jj_consume_token(INITIALISATION);
      initialization = Instruction();
          {if (true) return initialization;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseInitializationB0");
    }
  }

  final public List<ConcreteVariable> ClauseConcreteVariables() throws ParseException {
    trace_call("ClauseConcreteVariables");
    try {
        List<String> variablesNames;
        List<ConcreteVariable> variables = new ArrayList<ConcreteVariable>();
      jj_consume_token(CONCRETE_VARIABLES);
      variablesNames = ListIdent();
                for (String variableName : variablesNames) {
                        ConcreteVariable variable = new ConcreteVariable(variableName);
                        dataContext.addDataItem(variable);
                        variables.add(variable);
                }
                {if (true) return variables;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseConcreteVariables");
    }
  }

  final public List<AbstractVariable> ClauseAbstractVariables() throws ParseException {
    trace_call("ClauseAbstractVariables");
    try {
        List<String> variablesNames;
        List<AbstractVariable> variables = new ArrayList<AbstractVariable>();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT_VARIABLES:
        jj_consume_token(ABSTRACT_VARIABLES);
        break;
      case VARIABLES:
        jj_consume_token(VARIABLES);
        break;
      default:
        jj_la1[39] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      variablesNames = ListIdent();
                for (String variableName : variablesNames) {
                        AbstractVariable variable = new AbstractVariable(variableName);
                        dataContext.addDataItem(variable);
                        variables.add(variable);
                }
                {if (true) return variables;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseAbstractVariables");
    }
  }

  final public Predicate ClauseInvariant() throws ParseException {
    trace_call("ClauseInvariant");
    try {
                               Predicate p;
      jj_consume_token(INVARIANT);
      p = Predicate();
          {if (true) return p;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseInvariant");
    }
  }

  final public List<AbstractConstant> ClauseAbctractConstants() throws ParseException {
    trace_call("ClauseAbctractConstants");
    try {
        List<String> constantsNames;
        List<AbstractConstant> constants = new ArrayList<AbstractConstant>();
      jj_consume_token(ABSTRACT_CONSTANTS);
      constantsNames = ListIdent();
                for (String name : constantsNames) {
                        AbstractConstant constant = new AbstractConstant(name);
                        constants.add(constant);
                        dataContext.addDataItem(constant);
                }
                {if (true) return constants;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseAbctractConstants");
    }
  }

  final public List<ConcreteConstant> ClauseConcreteConstants() throws ParseException {
    trace_call("ClauseConcreteConstants");
    try {
        List<String> constantsNames;
        List<ConcreteConstant> constants = new ArrayList<ConcreteConstant>();;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONCRETE_CONSTANTS:
        jj_consume_token(CONCRETE_CONSTANTS);
        break;
      case CONSTANTS:
        jj_consume_token(CONSTANTS);
        break;
      default:
        jj_la1[40] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      constantsNames = ListIdent();
                for (String name : constantsNames) {
                        ConcreteConstant constant = new ConcreteConstant(name);
                        constants.add(constant);
                        dataContext.addDataItem(constant);
                }
                {if (true) return constants;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseConcreteConstants");
    }
  }

  final public Predicate ClauseProperties() throws ParseException {
    trace_call("ClauseProperties");
    try {
                                Predicate p;
      jj_consume_token(PROPERTIES);
      p = Predicate();
                List<DataField> constants = new ArrayList<DataField>();
                constants.addAll(dataContext.dataOf(ConcreteConstant.class));
                constants.addAll(dataContext.dataOf(AbstractConstant.class));
                logger.info("abstract constants after properties clause: "+constants);
                for (DataField constant : constants) {
                        if (!constant.isTyped())
                                {if (true) throw new TypeCheckException("Constant "+constant+" was not typed in Properties Clause");}
                }
                {if (true) return p;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseProperties");
    }
  }

/***************************************
***********   OPERATIONS   *************
****************************************/
  final public List<Operation> ClauseLocalOperations() throws ParseException {
    trace_call("ClauseLocalOperations");
    try {
        List<Operation> operations = new ArrayList<Operation>();
        Operation operation;
      jj_consume_token(LOCAL_OPERATIONS);
      operation = Operation();
                                                    operations.add(operation);
      label_22:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[41] = jj_gen;
          break label_22;
        }
        jj_consume_token(SEMICOLON);
        operation = Operation();
                                                                                                              operations.add(operation);
      }
          {if (true) return operations;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseLocalOperations");
    }
  }

  final public List<Operation> ClauseOperations() throws ParseException {
    trace_call("ClauseOperations");
    try {
        List<Operation> operations = new ArrayList<Operation>();
        Operation operation;
      jj_consume_token(OPERATIONS);
      operation = Operation();
                                              operations.add(operation);
      label_23:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[42] = jj_gen;
          break label_23;
        }
        jj_consume_token(SEMICOLON);
        operation = Operation();
                                                                                                        operations.add(operation);
      }
          {if (true) return operations;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseOperations");
    }
  }

  final public Operation Operation() throws ParseException {
    trace_call("Operation");
    try {
        OperationHeader h;
        Substitution body;
        List<OperationInputParameter>  inputParams  = new ArrayList<OperationInputParameter>();
        List<OperationOutputParameter> outputParams = new ArrayList<OperationOutputParameter>();
        Token t;
      h = HeaderOperation();
                t = token;
                for (String inputParamName : h.inputParametersNames()) {
                        OperationInputParameter param = new OperationInputParameter(inputParamName);
                        inputParams.add(param);
                        dataContext.addDataItem(param);
                }
                for (String outputParamName : h.outputParametersNames()) {
                        OperationOutputParameter param = new OperationOutputParameter(outputParamName);
                        outputParams.add(param);
                        dataContext.addDataItem(param);
                }
      jj_consume_token(EQUAL);
      body = Level1Substitution();
                dataContext.removeDataItems(inputParams );
                dataContext.removeDataItems(outputParams);

                // TODO: check that all input and output parameters was typed in body substitution
                logger.info("Operation processed: "+h +" in params: "+inputParams + " out params: "+outputParams);
                try {
                        {if (true) return new Operation(h.operationName().componentName(), inputParams, outputParams, body);}
                } catch (TypeCheckException tce) {
                        {if (true) throw new TypeCheckException(t+" "+tce.getMessage()+" at line: "+t.beginLine+" definitions trace: "+definitionsTrace, tce);}
                }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Operation");
    }
  }

  final public List<OperationB0> ClauseOperationsB0() throws ParseException {
    trace_call("ClauseOperationsB0");
    try {
        List<OperationB0> operations = new ArrayList<OperationB0>();
        OperationB0 operation;
      jj_consume_token(OPERATIONS);
      operation = OperationB0();
                                                 operations.add(operation);
      label_24:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[43] = jj_gen;
          break label_24;
        }
        jj_consume_token(SEMICOLON);
        operation = OperationB0();
                                                                                                               operations.add(operation);
      }
          {if (true) return operations;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseOperationsB0");
    }
  }

  final public OperationB0 OperationB0() throws ParseException {
    trace_call("OperationB0");
    try {
        OperationHeader header;
        Instruction instruction;
      header = HeaderOperation();
                if (!declaredOperations.containsKey(header.operationName().toString()))
                        {if (true) throw new RuntimeException("Unknown Operation: "+header.operationName().toString());}

                OperationDeclaration declaration = declaredOperations.get(header.operationName().toString());

                //if (header.inputParametersNames().size() != declaration.inputParameters().size()) // and more checks
                //	throw new Exception(); 

                dataContext.addDataItems(declaration.inputParameters());
                dataContext.addDataItems(declaration.outputParameters());
      jj_consume_token(EQUAL);
      instruction = Level1Instruction();
                dataContext.removeDataItems(declaration.inputParameters());
                dataContext.removeDataItems(declaration.outputParameters());
                {if (true) return new OperationB0(header.operationName().toString(), declaration.inputParameters(), declaration.outputParameters(), instruction);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("OperationB0");
    }
  }

  final public OperationHeader HeaderOperation() throws ParseException {
    trace_call("HeaderOperation");
    try {
        List<String> outputParams = null, inputParams = null;
        Identifier name;
      if (jj_2_13(2)) {
        // or LOOKAHEAD(ListIdent() "<--")
                        outputParams = ListIdent();
        jj_consume_token(170);
      } else {
        ;
      }
      name = RenIdent();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        inputParams = ListIdent();
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[44] = jj_gen;
        ;
      }
          {if (true) return new OperationHeader(name, inputParams, outputParams);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("HeaderOperation");
    }
  }

/*************************************
 ******** REFINEMENT GRAMMAR *********
 *************************************/
  final public Refinement Refinement() throws ParseException {
    trace_call("Refinement");
    try {
        Header header;
        List<SeenMachine> seenMachines = null;
        List<Operation> operations = null;
        List<Set> sets = null;
        List<ConcreteConstant> concreteConstants = null;
        List<ConcreteVariable> concreteVariables = null;
        List<AbstractConstant> abstractConstants = null;
        List<AbstractVariable> abstractVariables = null;
        AbstractComponent refinedComponent = null;
        Predicate properties = null;
        Predicate invariant  = null;
      jj_consume_token(REFINEMENT);
      header = Header();
                logger.info("************************\u005cnPARSING Refinement: "+header.name());
                checkPreprocessedData();
      label_25:
      while (true) {
        if (!endOfClauses()) {
          ;
        } else {
          break label_25;
        }
                  ensureClauseOrder();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case REFINES:
          refinedComponent = ClauseRefines();
          break;
        case SEES:
          seenMachines = ClauseSees();
          break;
        case INCLUDES:
          ClauseIncludes();
          break;
        case PROMOTES:
          ClausePromotes();
          break;
        case EXTENDS:
          ClauseExtends();
          break;
        case SETS:
          sets = ClauseSets();
          break;
        case CONCRETE_CONSTANTS:
        case CONSTANTS:
          concreteConstants = ClauseConcreteConstants();
          break;
        case ABSTRACT_CONSTANTS:
          abstractConstants = ClauseAbctractConstants();
          break;
        case PROPERTIES:
          properties = ClauseProperties();
          break;
        case CONCRETE_VARIABLES:
          concreteVariables = ClauseConcreteVariables();
          break;
        case ABSTRACT_VARIABLES:
        case VARIABLES:
          abstractVariables = ClauseAbstractVariables();
          break;
        case INVARIANT:
          invariant = ClauseInvariant();
          break;
        case ASSERTIONS:
          ClauseAssertions();
          break;
        case INITIALISATION:
          ClauseInitialization();
          break;
        case OPERATIONS:
          operations = ClauseOperations();
          break;
        case DEFINITIONS:
          DefinitionsClause();
          break;
        default:
          jj_la1[45] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(END);
                logger.info("************************\u005cnEnd of Parsing Refinement: "+header.name());
                {if (true) return new Refinement(header, refinedComponent, seenMachines, sets, abstractConstants, concreteConstants, abstractVariables, concreteVariables, properties, invariant);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Refinement");
    }
  }

/********************************************
 ******     IMPLEMENTATION GRAMMAR     ******
 ********************************************/
  final public Implementation Implementation() throws ParseException {
    trace_call("Implementation");
    try {
        Header header;
        AbstractComponent refinedComponent = null;
        List<Import> imports = null;
        List<Import> extendedMachines = null;
        List<SeenMachine> sees = null;
        List<Set> sets = null;
        List<ConcreteConstant> concreteConstants = null;
        List<ConcreteVariable> concreteVariables = null;
        List<OperationB0> operations = null;
        List<Operation> localOperations = null;
        Predicate properties = null;
        Predicate invariant  = null;
        Map<DataField, B0DataValue> valuations = null;
        Instruction initialization = null;
        List<OperationDeclaration> promotedOperations = null;
      jj_consume_token(IMPLEMENTATION);
      header = Header();
                logger.info("************************\u005cnPARSING Implementation: "+header.name());
                checkPreprocessedData();
                if (preprocessData != null) {
                        logger.info("Checking imports");
                        for (String machineName : preprocessData.importedMachines()) {
                                logger.info("\u005ct"+machineName);
                                Machine machine = (Machine) getComponent(machineName);
                                logger.info("\u005ct"+machine);
                                dataContext.addMachineConstantsAndSets(machine, ForeignData.Chain.IMPORT);
                        }
                }
      label_26:
      while (true) {
        if (!endOfClauses()) {
          ;
        } else {
          break label_26;
        }
                  ensureClauseOrder();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case REFINES:
          refinedComponent = ClauseRefines();
          break;
        case SEES:
          sees = ClauseSees();
          break;
        case IMPORTS:
          imports = ClauseImports();
          break;
        case PROMOTES:
          promotedOperations = ClausePromotes();
          break;
        case EXTENDS:
          extendedMachines = ClauseExtendsB0();
          break;
        case SETS:
          sets = ClauseSets();
          break;
        case OPERATIONS:
          operations = ClauseOperationsB0();
          break;
        case INITIALISATION:
          initialization = ClauseInitializationB0();
          break;
        case CONCRETE_CONSTANTS:
        case CONSTANTS:
          concreteConstants = ClauseConcreteConstants();
          break;
        case CONCRETE_VARIABLES:
          concreteVariables = ClauseConcreteVariables();
          break;
        case PROPERTIES:
          properties = ClauseProperties();
          break;
        case INVARIANT:
          invariant = ClauseInvariant();
          break;
        case VALUES:
          valuations = ClauseValues(refinedComponent);
          break;
        case ASSERTIONS:
          ClauseAssertions();
          break;
        case DEFINITIONS:
          DefinitionsClause();
          break;
        case LOCAL_OPERATIONS:
          localOperations = ClauseLocalOperations();
                                for (Operation operation : localOperations) {
                                        OperationDeclaration declaration = new OperationDeclaration(operation.name(), operation.inputParameters(), operation.outputParameters());
                                        declaredOperations.put(declaration.operationCallName(), declaration);
                                }
          break;
        default:
          jj_la1[46] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(END);
      jj_consume_token(0);
                {if (true) return new Implementation(header, refinedComponent, extendedMachines, imports, sees, sets, concreteConstants, concreteVariables, properties, invariant, valuations, initialization, operations, promotedOperations);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Implementation");
    }
  }

  final public Header Header() throws ParseException {
    trace_call("Header");
    try {
        Token name;
        List<String> params = null;
        List<DataField> parameters = new ArrayList<DataField>();
      name = jj_consume_token(Ident);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        params = ListIdent();
        jj_consume_token(RPAREN);
                        DataField param;
                        int index = 0;
                        for (String paramName : params) {
                                param = isUpperCase(paramName)? new SetParameter(paramName, index) : new ScalarParameter(paramName, index);
                                parameters.add(param);
                                index++;
                        }
        break;
      default:
        jj_la1[47] = jj_gen;
        ;
      }
          {if (true) return new Header(name.image, parameters);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Header");
    }
  }

  final public AbstractComponent ClauseRefines() throws ParseException {
    trace_call("ClauseRefines");
    try {
      jj_consume_token(REFINES);
      jj_consume_token(Ident);
                AbstractComponent refinedComponent = (AbstractComponent) getComponent(token.image); // TODO: check
                if (refinedComponent == null) {
                        logger.error("Missing refining component: "+token.image);
                }

                AbstractComponent refined = refinedComponent;
                dataContext.logger().info("Add data of Refinements");
                while (true) {
                        dataContext.logger().info("Add data of "+refined);
                        dataContext.addDataItems(refined.sets());
                        dataContext.addDataItems(refined.concreteConstants());
                        dataContext.addDataItems(refined.abstractConstants());
                        dataContext.addDataItems(refined.concreteVariables());
                        dataContext.addDataItems(refined.abstractVariables());
                        if (refined instanceof Machine)
                            break;
                        refined = ((Refinement) refined).refinedComponent();
                }
                {
                                refined = refinedComponent;
                                while(refined instanceof Refinement) {
                                        refined = ((Refinement) refined).refinedComponent();
                                }
                                // ISSUE: is check needed here ? or this will already be checked somewhere ?
                                Machine specification = (Machine) refined;
                                System.out.println("Formal parameters: "+specification.formalParameters());

                                for (DataField formalParam : specification.formalParameters()) {
                                        dataContext.addDataItem(formalParam);
                                }

                                // insert operations declarations of abstract machine for this implementation
                                //Map<String, Operation> operaionsData = new Hashtable<String, Operation>();
                                logger.info("Machine operations:");
                                for (Operation operation : specification.operations()) {
                                        //operaionsData.put(operation.name(), operation);
                                        logger.info("\u005ct"+operation.name());
                                        logger.info("\u005ct\u005ctinput parameters: "+operation.inputParameters());
                                        logger.info("\u005ct\u005ctoutput parameters: "+operation.outputParameters());
                                        declaredOperations.put(operation.name(), new OperationDeclaration(operation.name(), operation.inputParameters(), operation.outputParameters()));
                                }
                        }

                {if (true) return refinedComponent;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseRefines");
    }
  }

  final public List<Set> ClauseSets() throws ParseException {
    trace_call("ClauseSets");
    try {
        List<Set> sets = new ArrayList<Set>();
        Set set;
      jj_consume_token(SETS);
      set = Set();
                             sets.add(set);
      label_27:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[48] = jj_gen;
          break label_27;
        }
        jj_consume_token(SEMICOLON);
        set = Set();
                                                                 sets.add(set);
      }
                dataContext.addDataItems(sets);
                {if (true) return sets;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseSets");
    }
  }

  final public Set Set() throws ParseException {
    trace_call("Set");
    try {
        Token name;
        List<String> itemsNames;
        List<EnumeratedSet.Item> items = new ArrayList<EnumeratedSet.Item>();
      if (jj_2_14(2)) {
        name = jj_consume_token(Ident);
        jj_consume_token(EQUAL);
        jj_consume_token(LBRACE);
        itemsNames = ListIdent();
        jj_consume_token(RBRACE);
                for (String itemName : itemsNames) {
                        EnumeratedSet.Item item = new EnumeratedSet.Item(itemName);
                        items.add(item);
                        //dataContext.addDataItem(item);
                }
                {if (true) return new EnumeratedSet(name.image, items);}
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case Ident:
          name = jj_consume_token(Ident);
          {if (true) return new DeferredSet(name.image);}
          break;
        default:
          jj_la1[49] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Set");
    }
  }

  final public List<SeenMachine> ClauseSees() throws ParseException {
    trace_call("ClauseSees");
    try {
        List<Identifier> sees;
        //List<Machine> seenMachines = new ArrayList<Machine>();
        List<SeenMachine> seenMachines = new ArrayList<SeenMachine>();
      jj_consume_token(SEES);
      sees = RenIdentList();
                logger.info("Seen Machines Clause:");
                for (Identifier id : sees) {
                        String seenMachineName = id.componentName();
                        logger.info("\u005ctSeen Machine: "+seenMachineName);
                        Component machine = getComponent(seenMachineName);
                        if (machine != null) {
                                //seenMachines.add((Machine) machine); // TODO: check class
                                SeenMachine seenMachine = new SeenMachine(id.prefixList(), (Machine) machine);
                                seenMachines.add(seenMachine);

                                String name = id.hasPrefix()? id.prefixString() : null;
                                dataContext.addMachineConstantsAndSets((Machine) machine, ForeignData.Chain.SEES);
                                dataContext.addMachineVariables(seenMachine);

                                String operationPrefix = id.hasPrefix()? id.prefixString()+"." : "";
                                //System.out.println("prefixString: "+id.prefixString());
                                for (Operation operation : ((Machine) machine).operations()) {
                                        logger.info("\u005ct\u005ct"+operation.name());
                                        logger.info("\u005ct\u005ct\u005ctInput Parameters : "+operation.inputParameters());
                                        logger.info("\u005ct\u005ct\u005ctOutput Parameters: "+operation.outputParameters());
                                        declaredOperations.put(operationPrefix+operation.name(), new OperationDeclaration(seenMachine, operation.name(), operation.inputParameters(), operation.outputParameters()));
                                }
                        }  else {
                                // trouble log
                                logger.error("Missing machine module: "+seenMachineName);
                                {if (true) throw new RuntimeException("Sees problem");}
                        }
                }
                {if (true) return seenMachines;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseSees");
    }
  }

  final public Map<DataField, B0DataValue> ClauseValues(AbstractComponent refinedComponent) throws ParseException {
    trace_call("ClauseValues");
    try {
        Map<DataField, B0DataValue> valuations = new Hashtable<DataField, B0DataValue>();
        Valuation valuation;
      jj_consume_token(VALUES);
      valuation = Valuation();
                                  valuations.put(valuation.data, valuation.value);
      label_28:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[50] = jj_gen;
          break label_28;
        }
        jj_consume_token(SEMICOLON);
        valuation = Valuation();
                                              valuations.put(valuation.data, valuation.value);
      }
                for (DataField data: valuations.keySet()) {
                        //DataField data = dataContext.getData(dataName);
                        if (data instanceof DeferredSet) {
                                Type t1 = ((PowerSet) data.type()).baseType();
                                Type t2 = ((PowerSet) valuations.get(data).type()).baseType();
                                dataContext.addTypeSubstitution(t1, t2);
                                System.out.println("All machine data:");

                                //for (DataField machineData : dataContext.allMachineData()) {
                                List<DataField> allData = new ArrayList<DataField>(dataContext.allMachineData());
                                for (int i = 0; i < allData.size(); i++) {
                                        DataField machineData = allData.get(i);
                                        if (machineData instanceof DeferredSet) {
                                                continue;
                                        }
                                        System.out.println(machineData);
                                        if (machineData.isTyped() && machineData.type().contains(t1)) {
                                                dataContext.removeData(machineData.name());
                                                DataField var = machineData.newData();
                                                var.typeData(machineData.type().replace(t1, t2));
                                                dataContext.addDataItem(var);
                                        }
                                }

                                for (AbstractVariable var : refinedComponent.abstractVariables()) {
                                        //DataField data = dataContext.getData(var.name());
                                        if (dataContext.getData(var.name()) instanceof RefinedVariable) {
                                                RefinedVariable refinedVar = (RefinedVariable) dataContext.getData(var.name());
                                                refinedVar.refineType(refinedVar.type().replace(t1, t2));
                                                //throw new RuntimeException("check "+refinedVar.getClass());
                                        } else if (dataContext.getData(var.name()) instanceof ConcreteConstant) {
                                                dataContext.removeData(data.name());
                                        }
                                }

                                //throw new RuntimeException(dataName+" : "+t1 + " replace by "+t2);
                        }
                }
                {if (true) return valuations;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseValues");
    }
  }

  final public Valuation Valuation() throws ParseException {
    trace_call("Valuation");
    try {
        Token variable;
        //String variable;
        Condition predicate;
        B0DataValue value;
      variable = jj_consume_token(Ident);
      jj_consume_token(EQUAL);
      value = Value();
                DataField data = processIdentifier(variable.image);
                if (data instanceof DeferredSet) {
                        //throw new RuntimeException("ha");	
                }
                {if (true) return new Valuation(data, value);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Valuation");
    }
  }

  final public B0DataValue Value() throws ParseException {
    trace_call("Value");
    try {
        B0DataValue value;
      //LOOKAHEAD(RenIdent() "(")
              //RenIdent()  "(" Term() ("," Term())* ")" // var.Square(x) ???
      
              value = ArithmeticalTerm();
          {if (true) return value;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Value");
    }
  }

  final public B0DataValue ArithmeticalTerm() throws ParseException {
    trace_call("ArithmeticalTerm");
    try {
                                  B0DataValue expr, right;
      expr = AdditiveExpression();
      label_29:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 171:
          ;
          break;
        default:
          jj_la1[51] = jj_gen;
          break label_29;
        }
        jj_consume_token(171);
        right = AdditiveExpression();
                        javaccLogger.info("Interval");
                        expr = new IntervalB0(expr, right);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ArithmeticalTerm");
    }
  }

  final public B0DataValue AdditiveExpression() throws ParseException {
    trace_call("AdditiveExpression");
    try {
        ArithmeticalBinaryExpression.Operator op = null;
        B0DataValue right, expr;
      expr = MultiplicativeExpression();
      label_30:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
        case MINUS:
          ;
          break;
        default:
          jj_la1[52] = jj_gen;
          break label_30;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
          jj_consume_token(PLUS);
                              op = ArithmeticalBinaryExpression.Operator.PLUS;
          break;
        case MINUS:
          jj_consume_token(MINUS);
                              op = ArithmeticalBinaryExpression.Operator.MINUS;
          break;
        default:
          jj_la1[53] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = MultiplicativeExpression();
                        if (expr.type() == null)
                                {if (true) throw new TypeCheckException("Expression not typed: "+expr+" on line:" +token.beginLine);}
                        try {
                                expr = new ArithmeticalBinaryExpression(op, expr, right);
                        } catch (TypeCheckException e) {
                                {if (true) throw new TypeCheckException("Type problem: "+" on line:" +token.beginLine, e);}
                        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AdditiveExpression");
    }
  }

  final public B0DataValue MultiplicativeExpression() throws ParseException {
    trace_call("MultiplicativeExpression");
    try {
        ArithmeticalBinaryExpression.Operator op = null;
        B0DataValue right, expr;
        List<B0DataValue> ranges = new ArrayList<B0DataValue>();
      expr = PowerOfExpression();
                if (expr.type() instanceof PowerSet) {
                        ranges.add(expr);
                }
      label_31:
      while (true) {
        if (jj_2_15(1)) {
          ;
        } else {
          break label_31;
        }
        if (getToken(1).kind == TIMES && getToken(2).kind == LBRACE) {
          jj_consume_token(TIMES);
          jj_consume_token(LBRACE);
          right = PowerOfExpression();
          jj_consume_token(RBRACE);
                        javaccLogger.info("Ranges: " + ranges + " "+right);
                        expr = new ArrayInitialization(ranges, right);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case TIMES:
          case DIVIDE:
          case MODULO:
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case TIMES:
              jj_consume_token(TIMES);
                                op = ArithmeticalBinaryExpression.Operator.TIMES;
              break;
            case DIVIDE:
              jj_consume_token(DIVIDE);
                                op = ArithmeticalBinaryExpression.Operator.DIVIDE;
              break;
            case MODULO:
              jj_consume_token(MODULO);
                                op = ArithmeticalBinaryExpression.Operator.MODULO;
              break;
            default:
              jj_la1[54] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
            right = PowerOfExpression();
                        if (op == ArithmeticalBinaryExpression.Operator.TIMES && expr.type() instanceof PowerSet) {
                                ranges.add(right);
                        }
                        else {
                                expr = new ArithmeticalBinaryExpression(op, expr, right);
                        }
            break;
          default:
            jj_la1[55] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("MultiplicativeExpression");
    }
  }

  final public B0DataValue PowerOfExpression() throws ParseException {
    trace_call("PowerOfExpression");
    try {
        B0DataValue left, expr;
        Stack<B0DataValue> stack = new Stack<B0DataValue>();
      expr = UnaryExpression();
          stack.push(expr);
      label_32:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 172:
          ;
          break;
        default:
          jj_la1[56] = jj_gen;
          break label_32;
        }
        jj_consume_token(172);
        expr = UnaryExpression();
                  stack.push(expr);
      }
                expr = stack.pop();
                while(!stack.empty()) {
                        left = stack.pop();
                        expr = new ArithmeticalBinaryExpression(ArithmeticalBinaryExpression.Operator.POWER, left, expr);
                }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PowerOfExpression");
    }
  }

  final public B0DataValue UnaryExpression() throws ParseException {
    trace_call("UnaryExpression");
    try {
        B0DataValue expr;
        Condition predicate;
        Identifier id;
        boolean bool;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        expr = Value();
        jj_consume_token(RPAREN);
        break;
      case MINUS:
        jj_consume_token(MINUS);
        expr = UnaryExpression();
                  expr = new NegativeTerm(expr);
        break;
      case SUCCESSOR:
        jj_consume_token(SUCCESSOR);
        jj_consume_token(LPAREN);
        expr = ArithmeticalTerm();
        jj_consume_token(RPAREN);
                  expr = new FunctionEvaluationTerm(FunctionEvaluationTerm.Function.SUCCESSOR, expr);
        break;
      case PREDECESSOR:
        jj_consume_token(PREDECESSOR);
        jj_consume_token(LPAREN);
        expr = ArithmeticalTerm();
        jj_consume_token(RPAREN);
                  expr = new FunctionEvaluationTerm(FunctionEvaluationTerm.Function.PREDECESSOR, expr);
        break;
      case rec:
        expr = RecordTerm();
        break;
      case BOOL_CAST:
        jj_consume_token(BOOL_CAST);
        jj_consume_token(LPAREN);
        predicate = Condition();
        jj_consume_token(RPAREN);
                  expr = new BoolConversionValue(predicate);
        break;
      case TRUE:
      case FALSE:
        bool = BooleanLiteral();
                  expr = bool? BooleanTerm.TRUE : BooleanTerm.FALSE;
        break;
      case NAT:
      case NAT1:
      case INT:
        expr = IntegerSetB0();
        break;
      case BOOL:
        jj_consume_token(BOOL);
                  expr = BooleanSetB0.BOOLEAN_SET;
        break;
      case LBRACE:
        expr = CoupleSet();
        break;
      default:
        jj_la1[60] = jj_gen;
        if (jj_2_16(2147483647)) {
                        //List<B0DataValue> params = new ArrayList<B0DataValue>();
                        B0DataValue t;
          id = RenIdent();
                  B0Variable var = new B0VariableReference(processIdentifier(id));
          label_33:
          while (true) {
            jj_consume_token(LPAREN);
                      List<B0DataValue> params = new ArrayList<B0DataValue>();
            t = Value();
                                      params.add(t);
            label_34:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
              case 173:
                ;
                break;
              default:
                jj_la1[57] = jj_gen;
                break label_34;
              }
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                jj_consume_token(COMMA);
                break;
              case 173:
                jj_consume_token(173);
                break;
              default:
                jj_la1[58] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
              t = Value();
                                                                                   params.add(t);
            }
            jj_consume_token(RPAREN);
                        var = new ArrayFieldVariable(var, params);
                        expr = var;
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LPAREN:
              ;
              break;
            default:
              jj_la1[59] = jj_gen;
              break label_33;
            }
          }
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MAXINT:
          case MININT:
          case INTEGER_LITERAL:
          case Ident:
            expr = SimpleArithmeticalTerm();
            break;
          default:
            jj_la1[61] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("UnaryExpression");
    }
  }

  final public CoupleSet CoupleSet() throws ParseException {
    trace_call("CoupleSet");
    try {
        B0DataValue expr, right;
        List<CoupleSet.Couple> couples = new ArrayList<CoupleSet.Couple>();
      jj_consume_token(LBRACE);
      expr = Value();
      label_35:
      while (true) {
        jj_consume_token(173);
        right = Value();
                                                        expr = new CoupleSet.Couple(expr, right);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 173:
          ;
          break;
        default:
          jj_la1[62] = jj_gen;
          break label_35;
        }
      }
                  couples.add((CoupleSet.Couple) expr);
      label_36:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[63] = jj_gen;
          break label_36;
        }
        jj_consume_token(COMMA);
        expr = Value();
        label_37:
        while (true) {
          jj_consume_token(173);
          right = Value();
                                                                     expr = new CoupleSet.Couple(expr, right);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case 173:
            ;
            break;
          default:
            jj_la1[64] = jj_gen;
            break label_37;
          }
        }
                          couples.add((CoupleSet.Couple) expr);
      }
      jj_consume_token(RBRACE);
          {if (true) return new CoupleSet(couples);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("CoupleSet");
    }
  }

/***************************************
************** IMPORTS *****************
****************************************/
  final public List<Import> ClauseImports() throws ParseException {
    trace_call("ClauseImports");
    try {
        Import i;
        List<Import> imports = new ArrayList<Import>();
      jj_consume_token(IMPORTS);
      i = Import();
                                 imports.add(i);
      label_38:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[65] = jj_gen;
          break label_38;
        }
        jj_consume_token(COMMA);
        i = Import();
                                                                      imports.add(i);
      }
                {if (true) return imports;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseImports");
    }
  }

  final public Import Import() throws ParseException {
    trace_call("Import");
    try {
        Identifier machineIdent;
        B0DataValue param;
        List<B0DataValue> params = new ArrayList<B0DataValue>();
      machineIdent = RenIdent();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        param = InstanciationB0();
                                         params.add(param);
        label_39:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[66] = jj_gen;
            break label_39;
          }
          jj_consume_token(COMMA);
          param = InstanciationB0();
                                                                                               params.add(param);
        }
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[67] = jj_gen;
        ;
      }
                if (machineIdent.prefixList().size() > 1) {
                        {if (true) throw new IllegalStateException("invalid import name ...");}
                }
                Component component = getComponent(machineIdent.componentName());
                if (component == null) {
                        logger.warn("Imported machine not found: "+machineIdent.componentName());
                        {if (true) throw new RuntimeException("Imported machine not found: "+machineIdent.componentName());}
                }
                else if (component instanceof Machine ) {
                        Machine machine = (Machine) component;
                        logger.info("Import "+machine.name());
                        logger.info("\u005ctParameters: "+params);
                        if (machine.formalParameters().size() != params.size()) {
                                {if (true) throw new ParseException("Wrong numer of arguments in imported machine. Expected "+machine.formalParameters().size()+", got "+params.size());} //or extended
                        }
                        Import importedMachine = new Import(machineIdent.prefixString(), machine, params);

                        for (SetParameter setParam : machine.setParameters()) {
                                Type t1 = ((PowerSet)setParam.type()).baseType();
                                Type t2 = ((PowerSet)params.get(setParam.index()).type()).baseType();
                                logger.info("type substitution: "+t1 +" -> "+t2);
                                dataContext.addTypeSubstitution(t1, t2);
                        }

                        //dataContext.addMachineData((Machine) machine);
                        //String instanceName = machineIdent.hasPrefix()? machineIdent.prefixList().get(0) : null;
                        dataContext.addMachineVariables(importedMachine);
                        //if (importedMachine.machine().name().equals("VAETVIENT")) throw new RuntimeException(machineIdent.prefixString().toString());

                        //System.out.println("before import:");
                        //System.out.println(dataContext);

                        //dataContext.addMachineInstanceData(instanceName, machine, params);
                        //((Machine) machine).importInstance("inst", params);

                        for (OperationDeclaration operation : importedMachine.operationsDeclarations()) {
                                //logger.info("import: adding operation "+declaration.operationCallName());
                                OperationDeclaration declaration = new OperationDeclaration(importedMachine, operation.operationName(), operation.inputParameters(), operation.outputParameters());
                                declaredOperations.put(declaration.operationCallName(), declaration);
                        }
                        {if (true) return importedMachine;}
                        //return ((Machine) machine).instance(null, params);
                        //return null;
                } else {
                        logger.error("Imported component must be abstract machine: "+machineIdent.componentName());
                        {if (true) throw new RuntimeException("Imported component must be abstract machine: "+machineIdent.componentName());}
                }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Import");
    }
  }

  final public B0DataValue InstanciationB0() throws ParseException {
    trace_call("InstanciationB0");
    try {
        B0DataValue value;
      value = Value();
          {if (true) return value;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("InstanciationB0");
    }
  }

/******************************
************ Term *************
*******************************/
  final public B0DataValue SimpleArithmeticalTerm() throws ParseException {
    trace_call("SimpleArithmeticalTerm");
    try {
        Identifier id;
        Integer integer;

        Token field;

        DataField data;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case Ident:
        id = RenIdent();
                data = processIdentifier(id);
                B0Variable variable = new B0VariableReference(data);
        label_40:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case QUOTE:
            ;
            break;
          default:
            jj_la1[68] = jj_gen;
            break label_40;
          }
          jj_consume_token(QUOTE);
          field = jj_consume_token(Ident);
                  variable = new RecordFieldVariable(variable, field.image);
        }
          {if (true) return variable;}
        break;
      case MAXINT:
      case MININT:
      case INTEGER_LITERAL:
        integer = IntegerLiteral();
          {if (true) return new IntegerTerm(integer);}
        break;
      default:
        jj_la1[69] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SimpleArithmeticalTerm");
    }
  }

  final public B0DataValue SimpleTerm() throws ParseException {
    trace_call("SimpleTerm");
    try {
        B0DataValue value;
        boolean bool;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MAXINT:
      case MININT:
      case INTEGER_LITERAL:
      case Ident:
        value = SimpleArithmeticalTerm();
          {if (true) return value;}
        break;
      case TRUE:
      case FALSE:
        bool = BooleanLiteral();
          {if (true) return bool? BooleanTerm.TRUE : BooleanTerm.FALSE;}
        break;
      default:
        jj_la1[70] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SimpleTerm");
    }
  }

  final public RecordTerm RecordTerm() throws ParseException {
    trace_call("RecordTerm");
    try {
        List<RecordTerm.RecordField> recordFields = new ArrayList<RecordTerm.RecordField>();
        String label = null;
        B0DataValue value;
      jj_consume_token(rec);
      jj_consume_token(LPAREN);
      if (jj_2_17(2)) {
        label = jj_consume_token(Ident).image;
        jj_consume_token(BELONGS);
      } else {
        ;
      }
      value = Value();
                        System.out.println("adding record field: "+label+" value: "+value);
                        recordFields.add(new RecordTerm.RecordField(label, value));
      label_41:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[71] = jj_gen;
          break label_41;
        }
        jj_consume_token(COMMA);
                        label = null;
        if (jj_2_18(2)) {
          label = jj_consume_token(Ident).image;
          jj_consume_token(BELONGS);
        } else {
          ;
        }
        value = Value();
                                System.out.println("adding record field: "+label+" value: "+value);
                                recordFields.add(new RecordTerm.RecordField(label, value));
      }
      jj_consume_token(RPAREN);
          {if (true) return new RecordTerm(recordFields);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RecordTerm");
    }
  }

/*

RecordTerm RecordTerm2():
{
	List<RecordTerm.RecordField> recordItems = new ArrayList<RecordTerm.RecordField>();
	RecordTerm.RecordField recordItem;
}
{
	"rec"
	"("
		recordItem = RecordField() { recordItems.add(recordItem); }
		( "," recordItem = RecordField() { recordItems.add(recordItem); } )*
	")"
	{ return null; }
}
RecordTerm.RecordField RecordField():
{
	String label = null;
	B0DataValue value;
}
{
	[ LOOKAHEAD(2) label = <Ident>.image ":"] 
	(
		LOOKAHEAD("{" | ((Range() "*") + "{" ) )
		value = ExpressionArray()
	|	value = Term()
	)
	{ return new RecordTerm.RecordField(label, value); }
}

ArrayExpression ExpressionArray2():
{
	List<Range> ranges = new ArrayList<Range>();
	Range range;
	
	//List<Term> terms = new ArrayList<Term>();
	List<CoupleSet.Couple> coupleSet = new ArrayList<CoupleSet.Couple>();
	B0DataValue term, left, right;
}
{
		range = Range() { ranges.add(range); } (LOOKAHEAD("*" Range() "*") "*" range = Range() { ranges.add(range); } )* "*" "{" term = Term() "}"
		{ return new ArrayInitialization(ranges, term); }
		// bez lookahead
		//Range() ( "*" Range() | "{" Term()"}")* // plus kontrola, aby iba posledny bol Term
		
	|	"{"
			left = Couple() "|->" right = Term()
			{ coupleSet.add(new CoupleSet.Couple(left, right)); }
			(
				"," left = Couple() "|->" right = Term()
				{ coupleSet.add(new CoupleSet.Couple(left, right)); }
			)*
		"}"
		{ return new CoupleSet(coupleSet); }
		
	// ExpressionArray is always used as en alternative to Term, so just <Ident> doesn't need to be here  
	//|	<Ident>
}

ArrayExpression ExpressionArray():
{
	List<Range> ranges = new ArrayList<Range>();
	Range range;
	
	//List<Term> terms = new ArrayList<Term>();
	List<CoupleSet.Couple> coupleSet = new ArrayList<CoupleSet.Couple>();
	B0DataValue term, left, right;
}
{
		//LOOKAHEAD(("{" SimpleTerm() ",") | (["("] IntervalB0()) )
		LOOKAHEAD(Range() "*")
		{ System.out.println("1 choice at: "+token.beginLine+" in "+parsingFile); }
		range = Range() { ranges.add(range); } (LOOKAHEAD("*" Range() "*") "*" range = Range() { ranges.add(range); } )* "*" "{" term = Term() "}"
		//{ return new ExpressionArray(ranges, term); }
		{ return new ArrayInitialization(ranges, term); }
		// bez lookahead
		//Range() ( "*" Range() | "{" Term()"}")* // plus kontrola, aby iba posledny bol Term
		
	|	{ System.out.println("2 choice at: "+token.beginLine+" in "+parsingFile); }
		"{"
			left = Couple() "|->" right = Term()
			{ coupleSet.add(new CoupleSet.Couple(left, right)); }
			(
				"," left = Couple() "|->" right = Term()
				{ coupleSet.add(new CoupleSet.Couple(left, right)); }
			)*
		"}"
		{ return new CoupleSet(coupleSet); }
		
	// ExpressionArray is always used as en alternative to Term, so just <Ident> doesn't need to be here  
	//|	<Ident>
}

B0DataValue Couple(): {B0DataValue left, right;}
{
	left = CoupleItem()
	(
		LOOKAHEAD("|->" CoupleItem() (")")*"|->")
		"|->" right = CoupleItem()
		{ left = new CoupleSet.Couple(left, right); }
	)*
	{ return left; }
}

B0DataValue CoupleItem(): {B0DataValue t;}
{
		t = SimpleTerm()
		{return t;}
	|	"(" t = Couple() ")"
		{ return t; }
}

Range Range():
{
	Token t;
	Identifier id;
	IntervalB0 interval;
	Range range;
}
// both syntactic LOOKAHEADs can be ignored (Range is part of another syntactic LOOKAHEAD),
// so the order of the prodaction rules is important
{
		//"{" SimpleTerm() ( "," SimpleTerm() )* "}" // should or shouldn't be ???
		
		"BOOL"
		{ return BooleanSetB0.BOOLEAN_SET; }
		
	//|	LOOKAHEAD("(" Range() ")") "(" range = Range() ")"
	//	{ return range; }
		
	|	LOOKAHEAD("(" IntervalB0() ")")
		"(" interval = IntervalB0() ")"
		{ return interval; }
		
	|	LOOKAHEAD(IntervalB0())
		interval = IntervalB0()
		{ return interval; }
		//{ return new IntervalRange(interval); }
		
	|	//t = <Ident>
		id = RenIdent()
		{
			return new VariableRange(processIdentifier(id));
		}
		
}


B0DataValue ArithmeticalTerm(): { B0DataValue expr; }
{
	expr = AdditiveExpression()
	{ return expr; }
}

B0DataValue AdditiveExpression(): // priority: 180
{
	ArithmeticalBinaryExpression.Operator op = null;
	B0DataValue right, expr;
}
{
	expr = MultiplicativeExpression()
	(
		(	
			"+" { op = ArithmeticalBinaryExpression.Operator.PLUS;  }
		|	"-" { op = ArithmeticalBinaryExpression.Operator.MINUS; }
		)
		right = MultiplicativeExpression()
		{
			if (expr.type() == null)
				throw new TypeCheckException("Expression not typed: "+expr+" on line:" +token.beginLine);
			try {
				expr = new ArithmeticalBinaryExpression(op, expr, right);
			} catch (TypeCheckException e) {
				throw new TypeCheckException("Type problem: "+" on line:" +token.beginLine, e);
			}
		}
	)*
	{ return expr; }
}

B0DataValue MultiplicativeExpression():  // priority: 190
{
	ArithmeticalBinaryExpression.Operator op = null;
	B0DataValue right, expr;
}
{
	expr = PowerOfExpression()
	(
		(
			
			//LOOKAHEAD({testLookahed()})
			LOOKAHEAD({getToken(1).kind == TIMES && getToken(2).kind != LBRACE})
			"*"   { op = ArithmeticalBinaryExpression.Operator.TIMES;  }
		|	"/"   { op = ArithmeticalBinaryExpression.Operator.DIVIDE; }
		|	"mod" { op = ArithmeticalBinaryExpression.Operator.MODULO; }
		)
		right = PowerOfExpression()
		{ expr = new ArithmeticalBinaryExpression(op, expr, right); }
	)*
	{ return expr; }
}

B0DataValue PowerOfExpression():
{
	B0DataValue left, expr;
	Stack<B0DataValue> stack = new Stack<B0DataValue>();
}
{
	expr = UnaryExpression()
	{ stack.push(expr); }
	(
		"**" expr = UnaryExpression()
		{ stack.push(expr); }
	)*
	{
		expr = stack.pop();
		while(!stack.empty()) {
			left = stack.pop();
			expr = new ArithmeticalBinaryExpression(ArithmeticalBinaryExpression.Operator.POWER, left, expr);
		}
		return expr;
	}
}

B0DataValue UnaryExpression():
{
	B0DataValue expr;
	Identifier id;
}
{
	"(" expr = ArithmeticalTerm() ")"
	{ return expr; }
	
|	"succ" "(" expr = ArithmeticalTerm() ")"
	{ return new FunctionEvaluationTerm(FunctionEvaluationTerm.Function.SUCCESSOR, expr); }
	
|	"pred" "(" expr = ArithmeticalTerm() ")"
	{ return new FunctionEvaluationTerm(FunctionEvaluationTerm.Function.PREDECESSOR, expr); }

	
|	LOOKAHEAD( RenIdent() "(" ) // var.Square(x) ???
	{
		List<B0DataValue> params = new ArrayList<B0DataValue>();
		B0DataValue t;
	}
	id = RenIdent()
	"("
		t = Term() { params.add(t);} ("," t = Term() { params.add(t);} )*
	")"
	{
		B0VariableReference var = new B0VariableReference(processIdentifier(id)); // TODO: change to function evaluation instance
		//processIdentifier(id.getIdentifier(), "variable", var);
		return new ArrayFieldVariable(new B0VariableReference(processIdentifier(id)), params);
	}

|	expr = SimpleArithmeticalTerm()
	{ return expr; }
}
*/

//*/
  final public Condition Condition() throws ParseException {
    trace_call("Condition");
    try {
        BinaryCondition.Operator op;
        Condition left, right;
      left = Condition1();
      label_42:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CONJUNCTION:
        case DISJUNCTION:
          ;
          break;
        default:
          jj_la1[72] = jj_gen;
          break label_42;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CONJUNCTION:
          jj_consume_token(CONJUNCTION);
                               op = BinaryCondition.Operator.CONJUNCTION;
          break;
        case DISJUNCTION:
          jj_consume_token(DISJUNCTION);
                               op = BinaryCondition.Operator.DISJUNCTION;
          break;
        default:
          jj_la1[73] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = Condition1();
                  left = new BinaryCondition(op, left, right);
      }
          {if (true) return left;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Condition");
    }
  }

  final public Condition Condition1() throws ParseException {
    trace_call("Condition1");
    try {
        Condition condition;
        B0DataValue left, right;
        ComparisonCondition.Operator op;
      if (jj_2_19(2147483647)) {
        jj_consume_token(LPAREN);
        condition = Condition();
        jj_consume_token(RPAREN);
          {if (true) return condition;}
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case NEGATION:
          jj_consume_token(NEGATION);
          jj_consume_token(LPAREN);
          condition = Condition();
          jj_consume_token(RPAREN);
          {if (true) return new NegationCondition(condition);}
          break;
        case LBRACE:
        case LPAREN:
        case MINUS:
        case SUCCESSOR:
        case PREDECESSOR:
        case BOOL_CAST:
        case NAT:
        case NAT1:
        case INT:
        case MAXINT:
        case MININT:
        case BOOL:
        case TRUE:
        case FALSE:
        case rec:
        case INTEGER_LITERAL:
        case Ident:
          left = Value();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case EQUAL:
            jj_consume_token(EQUAL);
                        op = ComparisonCondition.Operator.EQUAL;
            break;
          case 174:
            jj_consume_token(174);
                        op = ComparisonCondition.Operator.NOT_EQUAL;
            break;
          case LESS:
            jj_consume_token(LESS);
                        op = ComparisonCondition.Operator.LESS;
            break;
          case GREATER:
            jj_consume_token(GREATER);
                        op = ComparisonCondition.Operator.GREATER;
            break;
          case LESS_OR_EQUAL:
            jj_consume_token(LESS_OR_EQUAL);
                        op = ComparisonCondition.Operator.LESS_OR_EQUAL;
            break;
          case GREATER_OR_EQUAL:
            jj_consume_token(GREATER_OR_EQUAL);
                        op = ComparisonCondition.Operator.GREATER_OR_EQUAL;
            break;
          default:
            jj_la1[74] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          right = Value();
          {if (true) return new ComparisonCondition(op, left, right);}
          break;
        default:
          jj_la1[75] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Condition1");
    }
  }

  final public boolean BooleanLiteral() throws ParseException {
    trace_call("BooleanLiteral");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
        jj_consume_token(TRUE);
                  {if (true) return true;}
        break;
      case FALSE:
        jj_consume_token(FALSE);
                  {if (true) return false;}
        break;
      default:
        jj_la1[76] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BooleanLiteral");
    }
  }

// IntegerLiteral as return ?
  final public Integer IntegerLiteral() throws ParseException {
    trace_call("IntegerLiteral");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
        jj_consume_token(INTEGER_LITERAL);
          {if (true) return Integer.parseInt(token.image);}
        break;
      case MININT:
        jj_consume_token(MININT);
          {if (true) return Integer.MIN_VALUE;}
        break;
      case MAXINT:
        jj_consume_token(MAXINT);
          {if (true) return Integer.MAX_VALUE;}
        break;
      default:
        jj_la1[77] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("IntegerLiteral");
    }
  }

  final public IntegerSetB0 IntegerSetB0() throws ParseException {
    trace_call("IntegerSetB0");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NAT:
        jj_consume_token(NAT);
                 {if (true) return IntegerSetB0.NAT;}
        break;
      case NAT1:
        jj_consume_token(NAT1);
                 {if (true) return IntegerSetB0.NAT1;}
        break;
      case INT:
        jj_consume_token(INT);
                 {if (true) return IntegerSetB0.INT;}
        break;
      default:
        jj_la1[78] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("IntegerSetB0");
    }
  }

/* #########################
   #     Expressions       #
   ######################### */
// for testing only
  final public Expression lookaheadExpression() throws ParseException {
    trace_call("lookaheadExpression");
    try {
  Expression expr = null;
      if (jj_2_20(2147483647)) {
        expr = Expression();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case Ident:
          jj_consume_token(Ident);
          break;
        default:
          jj_la1[79] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookaheadExpression");
    }
  }

  final public Expression Expression() throws ParseException {
    trace_call("Expression");
    try {
                           Expression expr = null;
      try {
        expr = Expression80();
      } catch (TypeCheckException tce) {
                {if (true) throw new TypeCheckException(tce.getMessage()+" at line: "+token.beginLine+" definitions trace: "+definitionsTrace, tce);}
                //throw tce;

      } catch (NullPointerException npe) {
                {if (true) throw new NullPointerException(npe.getMessage()+" at line: "+token.beginLine+" definitions trace: "+definitionsTrace);}
      }
                if (expr == null)
                        {if (true) throw new NullPointerException("Expression is null at line: "+token.beginLine+" definitions trace: "+definitionsTrace);}
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression");
    }
  }

  final public Expression Expression80() throws ParseException {
    trace_call("Expression80");
    try {
        Expression expr, right;
      expr = Expression90();
      label_43:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 175:
          ;
          break;
        default:
          jj_la1[80] = jj_gen;
          break label_43;
        }
        jj_consume_token(175);
        right = Expression90();
                  expr = new Overwrite(expr, right);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression80");
    }
  }

  final public Expression Expression90() throws ParseException {
    trace_call("Expression90");
    try {
        Expression expr, right;
      expr = Expression100();
      label_44:
      while (true) {
        if (jj_2_21(2147483647) && (inParentheses())) {
          ;
        } else {
          break label_44;
        }
        jj_consume_token(SEMICOLON);
        right = Expression100();
                  expr = new Composition(expr, right);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression90");
    }
  }

  final public Expression Expression100() throws ParseException {
    trace_call("Expression100");
    try {
        Expression expr, right;
        Token type;
      expr = Expression110();
      label_45:
      while (true) {
        if (jj_2_22(1)) {
          ;
        } else {
          break label_45;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DIRECT_PRODUCT:
          type = jj_consume_token(DIRECT_PRODUCT);
          break;
        default:
          jj_la1[81] = jj_gen;
          if (jj_2_23(2147483647) && (inParentheses())) {
            type = jj_consume_token(PARALLEL_PRODUCT);
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        right = Expression110();
                        switch(type.kind) {
                                case DIRECT_PRODUCT:   expr = new DirectProduct(expr, right); break;
                                case PARALLEL_PRODUCT: expr = new ParallelProduct(expr, right); break;
                        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression100");
    }
  }

  final public Expression Expression110() throws ParseException {
    trace_call("Expression110");
    try {
        Expression right, expr;
      expr = Expression125();
      label_46:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 176:
          ;
          break;
        default:
          jj_la1[82] = jj_gen;
          break label_46;
        }
        jj_consume_token(176);
        right = Expression125();
                  expr = new SequenceConcatenation(expr, right);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression110");
    }
  }

  final public Expression Expression125() throws ParseException {
    trace_call("Expression125");
    try {
        Expression right, expr;
        SetOfFunctions.Function function = null;
      expr = Expression130();
      label_47:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 177:
        case 178:
        case 179:
        case 180:
        case 181:
        case 182:
        case 183:
        case 184:
          ;
          break;
        default:
          jj_la1[83] = jj_gen;
          break label_47;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 177:
          jj_consume_token(177);
                                 function = null;
          break;
        case 178:
          jj_consume_token(178);
                                 function = SetOfFunctions.Function.PARTIAL_FUNCTIONS;
          break;
        case 179:
          jj_consume_token(179);
                                 function = SetOfFunctions.Function.TOTAL_FUNCTIONS;
          break;
        case 180:
          jj_consume_token(180);
                                 function = SetOfFunctions.Function.PARTIAL_INJECTIONS;
          break;
        case 181:
          jj_consume_token(181);
                                 function = SetOfFunctions.Function.TOTAL_INJECTIONS;
          break;
        case 182:
          jj_consume_token(182);
                                 function = SetOfFunctions.Function.PARTIAL_SURJECTIONS;
          break;
        case 183:
          jj_consume_token(183);
                                 function = SetOfFunctions.Function.TOTAL_SURJECTIONS;
          break;
        case 184:
          jj_consume_token(184);
                                 function = SetOfFunctions.Function.TOTAL_BIJECTIONS;
          break;
        default:
          jj_la1[84] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = Expression130();
                        expr = function != null? new SetOfFunctions(function, expr, right) : new SetsOfRelations(expr, right);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression125");
    }
  }

  final public Expression Expression130() throws ParseException {
    trace_call("Expression130");
    try {
        Expression expr, right;
        Token op;
      expr = BinarySetExpression();
      label_48:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOMAIN_RESTRICTION:
        case DOMAIN_SUBTRACTION:
        case RANGE_RESTRICTION:
        case RANGE_SUBTRACTION:
        case INSERT_IN_FRONT:
        case INSERT_AT_TAIL:
          ;
          break;
        default:
          jj_la1[85] = jj_gen;
          break label_48;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOMAIN_RESTRICTION:
          op = jj_consume_token(DOMAIN_RESTRICTION);
          break;
        case DOMAIN_SUBTRACTION:
          op = jj_consume_token(DOMAIN_SUBTRACTION);
          break;
        case RANGE_RESTRICTION:
          op = jj_consume_token(RANGE_RESTRICTION);
          break;
        case RANGE_SUBTRACTION:
          op = jj_consume_token(RANGE_SUBTRACTION);
          break;
        case INSERT_IN_FRONT:
          op = jj_consume_token(INSERT_IN_FRONT);
          break;
        case INSERT_AT_TAIL:
          op = jj_consume_token(INSERT_AT_TAIL);
          break;
        default:
          jj_la1[86] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = BinarySetExpression();
                        switch(op.kind) {
                                case DOMAIN_RESTRICTION: expr = new DomainRestriction(right, expr); break; // changed order
                                case DOMAIN_SUBTRACTION: expr = new DomainSubtraction(right, expr); break; // changed order
                                case RANGE_RESTRICTION:  expr = new RangeRestriction(expr, right); break;
                                case RANGE_SUBTRACTION:  expr = new RangeSubtraction(expr, right); break;

                                case INSERT_IN_FRONT:    expr = new InsertInFront(right, expr); break; // changed order
                                case INSERT_AT_TAIL:     expr = new InsertAtTail (expr, right); break;
                        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression130");
    }
  }

  final public Expression BinarySetExpression() throws ParseException {
    trace_call("BinarySetExpression");
    try {
        BinarySetExpression.Operator op;
        Expression right, expr;
      expr = Expression150();
      label_49:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 185:
        case 186:
          ;
          break;
        default:
          jj_la1[87] = jj_gen;
          break label_49;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 185:
          jj_consume_token(185);
                                op = BinarySetExpression.Operator.UNION;
          break;
        case 186:
          jj_consume_token(186);
                                op = BinarySetExpression.Operator.INTERSECTION;
          break;
        default:
          jj_la1[88] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = Expression150();
                  expr = new BinarySetExpression(op, expr, right);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BinarySetExpression");
    }
  }

  final public Expression Expression150() throws ParseException {
    trace_call("Expression150");
    try {
        Expression expr, right;
        Token op;
      expr = ExpressionCouple();
      label_50:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case RESTRICT_FRONT:
        case RESTRICT_TAIL:
          ;
          break;
        default:
          jj_la1[89] = jj_gen;
          break label_50;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case RESTRICT_FRONT:
          op = jj_consume_token(RESTRICT_FRONT);
          break;
        case RESTRICT_TAIL:
          op = jj_consume_token(RESTRICT_TAIL);
          break;
        default:
          jj_la1[90] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = ExpressionCouple();
                        switch(op.kind) {
                                case RESTRICT_FRONT: expr = new RestrictFront(expr, right); break;
                                case RESTRICT_TAIL : expr = new RestrictTail (expr, right); break;
                        }
                        /*
			if (op.kind == RESTRICT_FRONT)
				expr = new RestrictFront(expr, right);
			else //RESTRICT_TAIL
				expr = new RestrictTail(expr, right);
			*/

      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression150");
    }
  }

  final public Expression ExpressionCouple() throws ParseException {
    trace_call("ExpressionCouple");
    try {
        Expression expr, right;
        //CoupleExpression.Type type = null; // null docasne kvoli typu ","
        List<Expression> exprList = new ArrayList<Expression>();
      expr = ExpressionInterval();
      label_51:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 173:
          ;
          break;
        default:
          jj_la1[91] = jj_gen;
          break label_51;
        }
        jj_consume_token(173);
        right = ExpressionInterval();
                        //if (type == null)
                        //	exprList.add(right);
                        expr = new CoupleExpression(expr, right);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ExpressionCouple");
    }
  }

  final public Expression ExpressionInterval() throws ParseException {
    trace_call("ExpressionInterval");
    try {
        Expression expr, right;
      expr = Expression180();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 171:
        jj_consume_token(171);
        right = Expression180();
                        logger.debug("Interval Expression");
                        expr = new IntervalExpression(expr, right);
        break;
      default:
        jj_la1[92] = jj_gen;
        ;
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ExpressionInterval");
    }
  }

  final public Expression Expression180() throws ParseException {
    trace_call("Expression180");
    try {
        BinaryArithmeticalExpression.Operator op;
        Expression right, expr;
      expr = Expression190();
      label_52:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
        case MINUS:
          ;
          break;
        default:
          jj_la1[93] = jj_gen;
          break label_52;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
          jj_consume_token(PLUS);
                              op = BinaryArithmeticalExpression.Operator.PLUS;
          break;
        case MINUS:
          jj_consume_token(MINUS);
                              op = BinaryArithmeticalExpression.Operator.MINUS;
          break;
        default:
          jj_la1[94] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = Expression190();
                        if (op == BinaryArithmeticalExpression.Operator.MINUS && (!expr.type().isEqual(BasicType.Z) || !right.type().isEqual(BasicType.Z))) {
                                expr = new BinarySetExpression(BinarySetExpression.Operator.DIFFERENCE, expr, right);
                        } else {
                                expr = new BinaryArithmeticalExpression(op, expr, right);
                        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression180");
    }
  }

  final public Expression Expression190() throws ParseException {
    trace_call("Expression190");
    try {
        BinaryArithmeticalExpression.Operator op;
        Expression right, expr;
      expr = Expression200();
      label_53:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TIMES:
        case DIVIDE:
        case MODULO:
          ;
          break;
        default:
          jj_la1[95] = jj_gen;
          break label_53;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TIMES:
          jj_consume_token(TIMES);
                                op = BinaryArithmeticalExpression.Operator.TIMES;
          break;
        case DIVIDE:
          jj_consume_token(DIVIDE);
                                op = BinaryArithmeticalExpression.Operator.DIVIDE;
          break;
        case MODULO:
          jj_consume_token(MODULO);
                                op = BinaryArithmeticalExpression.Operator.MODULO;
          break;
        default:
          jj_la1[96] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = Expression200();
                        if (op == BinaryArithmeticalExpression.Operator.TIMES && (!expr.type().isEqual(BasicType.Z) || !right.type().isEqual(BasicType.Z))) {
                                expr = new CartesianProductExpression(expr, right);
                        } else {
                                expr = new BinaryArithmeticalExpression(op, expr, right);
                        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression190");
    }
  }

  final public Expression Expression200() throws ParseException {
    trace_call("Expression200");
    try {
        Expression left, expr;
        Stack<Expression> stack = new Stack<Expression>();
      expr = Expression230();
          stack.push(expr);
      label_54:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 172:
          ;
          break;
        default:
          jj_la1[97] = jj_gen;
          break label_54;
        }
        jj_consume_token(172);
        expr = Expression230();
                  stack.push(expr);
      }
                expr = stack.pop();
                while(!stack.empty()) {
                        left = stack.pop();
                        expr = new BinaryArithmeticalExpression(BinaryArithmeticalExpression.Operator.POWER, left, expr);
                }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression200");
    }
  }

  final public Expression Expression230() throws ParseException {
    trace_call("Expression230");
    try {
  Expression expr;
      expr = RecordFieldExpression();
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Expression230");
    }
  }

  final public Expression RecordFieldExpression() throws ParseException {
    trace_call("RecordFieldExpression");
    try {
                                      Expression expr;
      expr = EvaluationExpression();
      label_55:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case QUOTE:
          ;
          break;
        default:
          jj_la1[98] = jj_gen;
          break label_55;
        }
        jj_consume_token(QUOTE);
        jj_consume_token(Ident);
                                                      expr = new RecordFieldExpressionVariable(expr, token.image);
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RecordFieldExpression");
    }
  }

  final public Expression EvaluationExpression() throws ParseException {
    trace_call("EvaluationExpression");
    try {
                                     Expression expr, argument;
      expr = Unary();
      label_56:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
        case LPAREN:
        case 187:
          ;
          break;
        default:
          jj_la1[99] = jj_gen;
          break label_56;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          jj_consume_token(LPAREN);
          argument = Expression();
          jj_consume_token(RPAREN);
                  expr = new FunctionEvaluation(expr, argument);
          break;
        case LBRACKET:
          jj_consume_token(LBRACKET);
          argument = Expression();
          jj_consume_token(RBRACKET);
                  expr = new Image(expr, argument);
          break;
        case 187:
          jj_consume_token(187);
                  expr = new InverseRelation(expr);
          break;
        default:
          jj_la1[100] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("EvaluationExpression");
    }
  }

  final public Expression Unary() throws ParseException {
    trace_call("Unary");
    try {
        Expression expr = null;
        Expression arg = null;
        Expression arg1;
        Expression arg2;
        Integer int_literal;
        Predicate p;
        List<LocalVariable> variables;
        List<Expression> exprList;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
      case STRING_LITERAL:
      case Ident:
        expr = ExpressionsPrimary();
        break;
      case BOOL_CAST:
      case TRUE:
      case FALSE:
        expr = ExpressionsBoolean();
        break;
      case MAXINT:
      case MININT:
      case INTEGER_LITERAL:
        int_literal = IntegerLiteral();
                                                      expr = new IntegerLiteral(int_literal);
        break;
      case MINUS:
        jj_consume_token(MINUS);
        expr = Unary();
                                                      expr = new Negation(expr);
        break;
      case MAXIMUM:
        jj_consume_token(MAXIMUM);
        jj_consume_token(LPAREN);
        arg = Expression();
        jj_consume_token(RPAREN);
                                                      expr = new Maximum(arg);
        break;
      case MINIMUM:
        jj_consume_token(MINIMUM);
        jj_consume_token(LPAREN);
        arg = Expression();
        jj_consume_token(RPAREN);
                                                      expr = new Minimum(arg);
        break;
      case CARDINAL:
        jj_consume_token(CARDINAL);
        jj_consume_token(LPAREN);
        arg = Expression();
        jj_consume_token(RPAREN);
                                                      expr = new CardinalExpression(arg);
        break;
      case SUCCESSOR:
        jj_consume_token(SUCCESSOR);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          jj_consume_token(LPAREN);
          arg = Expression();
          jj_consume_token(RPAREN);
          break;
        default:
          jj_la1[101] = jj_gen;
          ;
        }
                                                                    expr = arg == null? new SuccessorFunction() : new Successor(arg);
        break;
      case PREDECESSOR:
        jj_consume_token(PREDECESSOR);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          jj_consume_token(LPAREN);
          arg = Expression();
          jj_consume_token(RPAREN);
          break;
        default:
          jj_la1[102] = jj_gen;
          ;
        }
                                                                    expr = arg == null? new PredecessorFunction() : new Predecessor(arg);
        break;
      case PI:
        jj_consume_token(PI);
        variables = LocalVariablesList();
        jj_consume_token(DOT);
        jj_consume_token(LPAREN);
        p = Predicate();
        jj_consume_token(188);
        expr = Expression();
        jj_consume_token(RPAREN);
                        expr = new GeneralizedExpression(variables, p, expr);
                        destroyLocalVariables(variables);
        break;
      case SIGMA:
        jj_consume_token(SIGMA);
        variables = LocalVariablesList();
        jj_consume_token(DOT);
        jj_consume_token(LPAREN);
        p = Predicate();
        jj_consume_token(188);
        expr = Expression();
        jj_consume_token(RPAREN);
                        expr = new GeneralizedExpression(variables, p, expr);
                        destroyLocalVariables(variables);
        break;
      case 189:
        jj_consume_token(189);
        variables = LocalVariablesList();
        jj_consume_token(DOT);
        jj_consume_token(LPAREN);
        p = Predicate();
        jj_consume_token(188);
        arg = Expression();
        jj_consume_token(RPAREN);
                        expr = new LambdaExpression(variables, p, arg);
                        destroyLocalVariables(variables);
        break;
      case FUNCTION_CAST:
        jj_consume_token(FUNCTION_CAST);
        jj_consume_token(LPAREN);
        arg = Expression();
        jj_consume_token(RPAREN);
                                                   expr = new TransformedFunction(arg);
        break;
      case RELATION_CAST:
        jj_consume_token(RELATION_CAST);
        jj_consume_token(LPAREN);
        arg = Expression();
        jj_consume_token(RPAREN);
                                                   expr = new TransformedRelation(arg);
        break;
      default:
        jj_la1[103] = jj_gen;
        if (jj_2_24(2)) {
          expr = BuildingSetExpression();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
          case P:
          case P1:
          case F:
          case F1:
            expr = SetExpression();
            break;
          case union:
            jj_consume_token(union);
            jj_consume_token(LPAREN);
            arg = Expression();
            jj_consume_token(RPAREN);
                                                     expr = new GeneralizedUnion(arg);
            break;
          case intersection:
            jj_consume_token(intersection);
            jj_consume_token(LPAREN);
            arg = Expression();
            jj_consume_token(RPAREN);
                                                     expr = new GeneralisedIntersection(arg);
            break;
          case UNION:
            jj_consume_token(UNION);
            variables = LocalVariablesList();
            jj_consume_token(DOT);
            jj_consume_token(LPAREN);
            p = Predicate();
            jj_consume_token(188);
            expr = Expression();
            jj_consume_token(RPAREN);
                        expr = new QuantifiedUnion(variables, p, expr);
                        destroyLocalVariables(variables);
            break;
          case INTERSECTION:
            jj_consume_token(INTERSECTION);
            variables = LocalVariablesList();
            jj_consume_token(DOT);
            jj_consume_token(LPAREN);
            p = Predicate();
            jj_consume_token(188);
            expr = Expression();
            jj_consume_token(RPAREN);
                        expr = new QuantifiedIntersection(variables, p, expr);
                        destroyLocalVariables(variables);
            break;
          case struct:
          case rec:
            expr = RecordExpression();
            break;
          case identity:
            jj_consume_token(identity);
            jj_consume_token(LPAREN);
            expr = Expression();
            jj_consume_token(RPAREN);
                                                   expr = new IdentityRelation(expr);
            break;
          case first_projection:
            jj_consume_token(first_projection);
                           expressionList=false;
            jj_consume_token(LPAREN);
            arg1 = Expression();
            jj_consume_token(COMMA);
            arg2 = Expression();
            jj_consume_token(RPAREN);
                  expressionList=true; expr = new FirstProjection(arg1, arg2);
            break;
          case second_projection:
            jj_consume_token(second_projection);
                           expressionList=false;
            jj_consume_token(LPAREN);
            arg1 = Expression();
            jj_consume_token(COMMA);
            arg2 = Expression();
            jj_consume_token(RPAREN);
                  expressionList=true; expr = new SecondProjection(arg1, arg2);
            break;
          case ITERATE:
            jj_consume_token(ITERATE);
                           expressionList=false;
            jj_consume_token(LPAREN);
            arg1 = Expression();
            jj_consume_token(COMMA);
            arg2 = Expression();
            jj_consume_token(RPAREN);
                 expressionList=true; expr = new Iteration(arg1, arg2);
            break;
          case CLOSURE:
            jj_consume_token(CLOSURE);
            jj_consume_token(LPAREN);
            arg = Expression();
            jj_consume_token(RPAREN);
                                                        expr = new ReflexiveClosure(arg);
            break;
          case CLOSURE1:
            jj_consume_token(CLOSURE1);
            jj_consume_token(LPAREN);
            arg = Expression();
            jj_consume_token(RPAREN);
                                                        expr = new Closure(arg);
            break;
          case DOMAIN:
            jj_consume_token(DOMAIN);
            jj_consume_token(LPAREN);
            expr = Expression();
            jj_consume_token(RPAREN);
                                                     expr = new DomainExpression(expr);
            break;
          case RANGE:
            jj_consume_token(RANGE);
            jj_consume_token(LPAREN);
            expr = Expression();
            jj_consume_token(RPAREN);
                                                     expr = new RangeExpression(expr);
            break;
          default:
            jj_la1[104] = jj_gen;
            if (jj_2_25(2)) {
              jj_consume_token(LBRACKET);
              jj_consume_token(RBRACKET);
                                                      expr = EmptySequence.EMPTY_SEQUENCE;
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case LBRACKET:
                jj_consume_token(LBRACKET);
                exprList = ExpressionList();
                jj_consume_token(RBRACKET);
                                                      expr = new SequenceExtension(exprList);
                break;
              case SEQUENCE:
                jj_consume_token(SEQUENCE);
                jj_consume_token(LPAREN);
                expr = Expression();
                jj_consume_token(RPAREN);
                                                      expr = new SetOfSequences(SetOfSequences.Type.SEQUENCE, expr);
                break;
              case NON_EMPTY_SEQUENCE:
                jj_consume_token(NON_EMPTY_SEQUENCE);
                jj_consume_token(LPAREN);
                expr = Expression();
                jj_consume_token(RPAREN);
                                                      expr = new SetOfSequences(SetOfSequences.Type.NON_EMPTY_SEQUENCE, expr);
                break;
              case INJECTIVE_SEQUENCE:
                jj_consume_token(INJECTIVE_SEQUENCE);
                jj_consume_token(LPAREN);
                expr = Expression();
                jj_consume_token(RPAREN);
                                                      expr = new SetOfSequences(SetOfSequences.Type.INJECTIVE_SEQUENCE, expr);
                break;
              case INJECTIVE_NON_EMPTY_SEQUENCE:
                jj_consume_token(INJECTIVE_NON_EMPTY_SEQUENCE);
                jj_consume_token(LPAREN);
                expr = Expression();
                jj_consume_token(RPAREN);
                                                      expr = new SetOfSequences(SetOfSequences.Type.INJECTIVE_NON_EMPTY_SEQUENCE, expr);
                break;
              case PERMUTATIONS:
                jj_consume_token(PERMUTATIONS);
                jj_consume_token(LPAREN);
                expr = Expression();
                jj_consume_token(RPAREN);
                                                      expr = new SetOfSequences(SetOfSequences.Type.PERMUTATION, expr);
                break;
              case SIZE:
                jj_consume_token(SIZE);
                jj_consume_token(LPAREN);
                arg = Expression();
                jj_consume_token(RPAREN);
                                                     expr = new SequenceSize(arg);
                break;
              case FIRST:
                jj_consume_token(FIRST);
                jj_consume_token(LPAREN);
                arg = Expression();
                jj_consume_token(RPAREN);
                                                     expr = new SequenceFirstElement(arg);
                break;
              case LAST:
                jj_consume_token(LAST);
                jj_consume_token(LPAREN);
                arg = Expression();
                jj_consume_token(RPAREN);
                                                     expr = new SequenceLastElement(arg);
                break;
              case FRONT:
                jj_consume_token(FRONT);
                jj_consume_token(LPAREN);
                arg = Expression();
                jj_consume_token(RPAREN);
                                                     expr = new SequenceFront(arg);
                break;
              case TAIL:
                jj_consume_token(TAIL);
                jj_consume_token(LPAREN);
                arg = Expression();
                jj_consume_token(RPAREN);
                                                     expr = new SequenceTail(arg);
                break;
              case REVERSE:
                jj_consume_token(REVERSE);
                jj_consume_token(LPAREN);
                arg = Expression();
                jj_consume_token(RPAREN);
                                                     expr = new ReverseSequence(arg);
                break;
              case CONCATENATION:
                jj_consume_token(CONCATENATION);
                jj_consume_token(LPAREN);
                arg = Expression();
                jj_consume_token(RPAREN);
                                                     expr = new GeneralConcatenation(arg);
                break;
              case LESS:
                jj_consume_token(LESS);
                jj_consume_token(GREATER);
                  expr = EmptySequence.EMPTY_SEQUENCE;
                break;
              default:
                jj_la1[105] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
        }
      }
           {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Unary");
    }
  }

  final public Expression RecordExpression() throws ParseException {
    trace_call("RecordExpression");
    try {
        String label = null;
        Expression expr;
        //RecordField field;
        List<RecordField> fields = new ArrayList<RecordField>();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case struct:
        jj_consume_token(struct);
        jj_consume_token(LPAREN);
                              expressionList=false;
        label = jj_consume_token(Ident).image;
        jj_consume_token(BELONGS);
        expr = Expression();
                  fields.add(new RecordField(label, expr));
        label_57:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[106] = jj_gen;
            break label_57;
          }
          jj_consume_token(COMMA);
          label = jj_consume_token(Ident).image;
          jj_consume_token(BELONGS);
          expr = Expression();
                          fields.add(new RecordField(label, expr));
        }
        jj_consume_token(RPAREN);
                     expressionList=true;
                  {if (true) return new SetOfRecordsExpression(fields);}
        break;
      case rec:
        jj_consume_token(rec);
        jj_consume_token(LPAREN);
                            expressionList=false;
        if (jj_2_26(2)) {
          label = jj_consume_token(Ident).image;
          jj_consume_token(BELONGS);
        } else {
          ;
        }
        expr = Expression();
                  fields.add(new RecordField(label, expr));
        label_58:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[107] = jj_gen;
            break label_58;
          }
          jj_consume_token(COMMA);
                             label = null;
          if (jj_2_27(2)) {
            label = jj_consume_token(Ident).image;
            jj_consume_token(BELONGS);
          } else {
            ;
          }
          expr = Expression();
                          fields.add(new RecordField(label, expr));
        }
        jj_consume_token(RPAREN);
                     expressionList=true;
                  {if (true) return new RecordExpression(fields);}
        break;
      default:
        jj_la1[108] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RecordExpression");
    }
  }

  final public Expression BuildingSetExpression() throws ParseException {
    trace_call("BuildingSetExpression");
    try {
                                      Expression set;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        jj_consume_token(LBRACE);
        jj_consume_token(RBRACE);
                             set = EmptySet.EMPTY_SET;
        break;
      case Z:
        jj_consume_token(Z);
                             set = IntegerSet.INTEGER;
        break;
      case N:
        jj_consume_token(N);
                             set = IntegerSet.NATURAL;
        break;
      case N1:
        jj_consume_token(N1);
                             set = IntegerSet.NATURAL1;
        break;
      case INT:
        jj_consume_token(INT);
                             set = IntegerSet.INT;
        break;
      case NAT:
        jj_consume_token(NAT);
                             set = IntegerSet.NAT;
        break;
      case NAT1:
        jj_consume_token(NAT1);
                             set = IntegerSet.NAT1;
        break;
      case BOOL:
        jj_consume_token(BOOL);
                             set = BooleanSet.BOOLEAN_SET;
        break;
      case STRING:
        jj_consume_token(STRING);
                             set = StringSet.STRING_SET;
        break;
      default:
        jj_la1[109] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
          {if (true) return set;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BuildingSetExpression");
    }
  }

  final public Expression SetExpression() throws ParseException {
    trace_call("SetExpression");
    try {
        Expression expr;
        List<Expression> list;
        Predicate predicate;
        List<LocalVariable> variables;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case P:
        jj_consume_token(P);
        jj_consume_token(LPAREN);
        expr = Expression();
        jj_consume_token(RPAREN);
                  expr = new SetOfSubsets(SetOfSubsets.Kind.POWERSET, expr);
        break;
      case P1:
        jj_consume_token(P1);
        jj_consume_token(LPAREN);
        expr = Expression();
        jj_consume_token(RPAREN);
                  expr = new SetOfSubsets(SetOfSubsets.Kind.SET_OF_NON_EMPTY_SUBSETS, expr);
        break;
      case F:
        jj_consume_token(F);
        jj_consume_token(LPAREN);
        expr = Expression();
        jj_consume_token(RPAREN);
                  expr = new SetOfSubsets(SetOfSubsets.Kind.SET_OF_FINITE_SUBSETS, expr);
        break;
      case F1:
        jj_consume_token(F1);
        jj_consume_token(LPAREN);
        expr = Expression();
        jj_consume_token(RPAREN);
                  expr = new SetOfSubsets(SetOfSubsets.Kind.SET_OF_NON_EMPTY_FINITE_SUBSETS, expr);
        break;
      default:
        jj_la1[110] = jj_gen;
        if (jj_2_28(2147483647)) {
          jj_consume_token(LBRACE);
          variables = LocalVariablesList();
          jj_consume_token(188);
          predicate = Predicate();
          jj_consume_token(RBRACE);
                        checkDataIfTyped(variables, predicate);
                        expr = new ComprehensionSet(variables, predicate);
                        destroyLocalVariables(variables);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            list = ExpressionList();
            jj_consume_token(RBRACE);
                  expr = new SetExtensionExpression(list);
            break;
          default:
            jj_la1[111] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
          {if (true) return expr;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SetExpression");
    }
  }

  final public Expression ExpressionsPrimary() throws ParseException {
    trace_call("ExpressionsPrimary");
    try {
        Identifier id;
        boolean dontknownameyet;
        Expression expr;
        String stringLiteral;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case Ident:
        id = RenIdent();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOT:
          jj_consume_token(DOT);
          jj_consume_token(190);
                                           dontknownameyet = true;
          break;
        default:
          jj_la1[112] = jj_gen;
          ;
        }
                        //ExpressionReference ref = new ExpressionReference(processIdentifier(id));
                        {if (true) return ExpressionReference.newReference(processIdentifier(id));}
        break;
      case LPAREN:
        jj_consume_token(LPAREN);
                     inParenthesesExpression = true;
        expr = Expression();
                                                                           inParenthesesExpression = false;
        jj_consume_token(RPAREN);
                  {if (true) return expr;}
        break;
      case STRING_LITERAL:
        stringLiteral = StringLiteral();
                  {if (true) return new StringLiteralExpression(stringLiteral);}
        break;
      default:
        jj_la1[113] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ExpressionsPrimary");
    }
  }

  final public Expression ExpressionsBoolean() throws ParseException {
    trace_call("ExpressionsBoolean");
    try {
        boolean literal;
        Predicate predicate;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
      case FALSE:
        literal = BooleanLiteral();
                  {if (true) return literal? BooleanLiteral.TRUE : BooleanLiteral.FALSE;}
        break;
      case BOOL_CAST:
        jj_consume_token(BOOL_CAST);
        jj_consume_token(LPAREN);
        predicate = Predicate();
        jj_consume_token(RPAREN);
                  {if (true) return new BooleanConversionExpression(predicate);}
        break;
      default:
        jj_la1[114] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ExpressionsBoolean");
    }
  }

/* ######################################## 
   ##              Predicates            ##
   ######################################## */
  final public Predicate Predicate() throws ParseException {
    trace_call("Predicate");
    try {
                         Predicate p;
      try {
        p = Predicate30();
      } catch (TypeCheckException tce) {
                {if (true) throw new TypeCheckException(tce.getMessage()+" at line: "+token.beginLine+" definitions trace: "+definitionsTrace, tce);}
                //throw tce;

      }
          {if (true) return p;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Predicate");
    }
  }

  final public Predicate Predicate30() throws ParseException {
    trace_call("Predicate30");
    try {
        Predicate right, predicate;
        BinaryPredicate.Operator op;
      predicate = Predicate40();
                                    System.out.println(predicate+" => ?");
      label_59:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IMPLICATION:
        case EQUIVALENCE:
          ;
          break;
        default:
          jj_la1[115] = jj_gen;
          break label_59;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IMPLICATION:
          jj_consume_token(IMPLICATION);
                                op = BinaryPredicate.Operator.IMPLICATION;
          break;
        case EQUIVALENCE:
          jj_consume_token(EQUIVALENCE);
                                op = BinaryPredicate.Operator.EQUIVALENCE;
          break;
        default:
          jj_la1[116] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = Predicate40();
                  predicate = new BinaryPredicate(op, predicate, right);
      }
          {if (true) return predicate;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Predicate30");
    }
  }

  final public Predicate Predicate40() throws ParseException {
    trace_call("Predicate40");
    try {
        Predicate right, ret;
        BinaryPredicate.Operator op;
      ret = PrimaryPredicate();
      label_60:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CONJUNCTION:
        case DISJUNCTION:
          ;
          break;
        default:
          jj_la1[117] = jj_gen;
          break label_60;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DISJUNCTION:
          jj_consume_token(DISJUNCTION);
                               op = BinaryPredicate.Operator.DISJUNCTION;
          break;
        case CONJUNCTION:
          jj_consume_token(CONJUNCTION);
                               op = BinaryPredicate.Operator.CONJUNCTION;
          break;
        default:
          jj_la1[118] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        right = PrimaryPredicate();
                  ret = new BinaryPredicate(op, ret, right);
      }
          {if (true) return ret;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Predicate40");
    }
  }

  final public Predicate PrimaryPredicate() throws ParseException {
    trace_call("PrimaryPredicate");
    try {
                                Predicate p;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEGATION:
        p = NegationPredicate();
        break;
      case 191:
        p = UniversalPredicate();
        break;
      case 192:
        p = ExistentialPredicate();
        break;
      default:
        jj_la1[119] = jj_gen;
        if (jj_2_29(2147483647)) {
          jj_consume_token(LPAREN);
          p = Predicate();
          jj_consume_token(RPAREN);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LESS:
          case LBRACE:
          case LBRACKET:
          case LPAREN:
          case MINUS:
          case SUCCESSOR:
          case PREDECESSOR:
          case MAXIMUM:
          case MINIMUM:
          case CARDINAL:
          case PI:
          case SIGMA:
          case BOOL_CAST:
          case FUNCTION_CAST:
          case RELATION_CAST:
          case NAT:
          case NAT1:
          case INT:
          case Z:
          case N:
          case N1:
          case P:
          case P1:
          case F:
          case F1:
          case MAXINT:
          case MININT:
          case STRING:
          case BOOL:
          case TRUE:
          case FALSE:
          case union:
          case UNION:
          case intersection:
          case INTERSECTION:
          case struct:
          case rec:
          case identity:
          case first_projection:
          case second_projection:
          case ITERATE:
          case CLOSURE:
          case CLOSURE1:
          case DOMAIN:
          case RANGE:
          case SEQUENCE:
          case NON_EMPTY_SEQUENCE:
          case INJECTIVE_SEQUENCE:
          case INJECTIVE_NON_EMPTY_SEQUENCE:
          case PERMUTATIONS:
          case SIZE:
          case FIRST:
          case LAST:
          case FRONT:
          case TAIL:
          case REVERSE:
          case CONCATENATION:
          case INTEGER_LITERAL:
          case STRING_LITERAL:
          case Ident:
          case 189:
            p = ExpressionsPredicate();
            break;
          default:
            jj_la1[120] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
          {if (true) return p;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PrimaryPredicate");
    }
  }

  final public Predicate ExpressionsPredicate() throws ParseException {
    trace_call("ExpressionsPredicate");
    try {
        Expression left, right;
        Predicate predicate;
        Object op = null;
      left = Expression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BELONGS:
        jj_consume_token(BELONGS);
                                     op = BelongingPredicate.Operator.BELONGING;
        break;
      case NON_BELONGS:
        jj_consume_token(NON_BELONGS);
                                 op = BelongingPredicate.Operator.NON_BELONGING;
        break;
      case INCLUSION:
        jj_consume_token(INCLUSION);
                                 op = InclusionPredicate.Operator.INCLUSION;
        break;
      case STRICT_INCLUSION:
        jj_consume_token(STRICT_INCLUSION);
                                 op = InclusionPredicate.Operator.STRICT_INCLUSION;
        break;
      case NON_INCLUSION:
        jj_consume_token(NON_INCLUSION);
                                 op = InclusionPredicate.Operator.NON_INCLUSION;
        break;
      case STRICT_NON_INCLUSION:
        jj_consume_token(STRICT_NON_INCLUSION);
                                 op = InclusionPredicate.Operator.STRICT_NON_INCLUSION;
        break;
      case EQUAL:
        jj_consume_token(EQUAL);
                                op = EqualityPredicate.Operator.EQUAL;
        break;
      case 174:
        jj_consume_token(174);
                                op = EqualityPredicate.Operator.NOT_EQUAL;
        break;
      case LESS:
        jj_consume_token(LESS);
                                op = ComparisonPredicate.Operator.LESS;
        break;
      case LESS_OR_EQUAL:
        jj_consume_token(LESS_OR_EQUAL);
                                op = ComparisonPredicate.Operator.LESS_OR_EQUAL;
        break;
      case GREATER_OR_EQUAL:
        jj_consume_token(GREATER_OR_EQUAL);
                                op = ComparisonPredicate.Operator.GREATER_OR_EQUAL;
        break;
      case GREATER:
        jj_consume_token(GREATER);
                                op = ComparisonPredicate.Operator.GREATER;
        break;
      default:
        jj_la1[121] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      right = Expression();
                /*
		switch(op.kind) {
			case BELONGS:
			case NON_BELONGS:
				return new BelongingPredicate(left, (BelongingPredicate.Operator)op, right);
		} */
                if (op instanceof BelongingPredicate.Operator) {
                        {if (true) return new BelongingPredicate(left, (BelongingPredicate.Operator)op, right);}
                } else if (op instanceof InclusionPredicate.Operator) {
                        {if (true) return new InclusionPredicate(left, (InclusionPredicate.Operator)op, right);}
                } else if (op instanceof ComparisonPredicate.Operator) {
                        {if (true) return new ComparisonPredicate(left, (ComparisonPredicate.Operator)op, right);}
                } else if (op instanceof EqualityPredicate.Operator) {
                        {if (true) return new EqualityPredicate(left, (EqualityPredicate.Operator)op, right);}
                } else
                        {if (true) throw new IllegalStateException();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ExpressionsPredicate");
    }
  }

  final public Predicate NegationPredicate() throws ParseException {
    trace_call("NegationPredicate");
    try {
                                 Predicate p;
      jj_consume_token(NEGATION);
      p = PrimaryPredicate();
          {if (true) return new NegationPredicate(p);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("NegationPredicate");
    }
  }

  final public UniversalPredicate UniversalPredicate() throws ParseException {
    trace_call("UniversalPredicate");
    try {
        List<LocalVariable> variables;
        Predicate predicate;
      jj_consume_token(191);
      variables = LocalVariablesList();
      jj_consume_token(DOT);
      jj_consume_token(LPAREN);
      predicate = Predicate30();
      jj_consume_token(RPAREN);
                destroyLocalVariables(variables);
                if (!(predicate instanceof BinaryPredicate && ((BinaryPredicate)predicate).operator() == BinaryPredicate.Operator.IMPLICATION)) {
                        {if (true) throw new ParseException("Implication predicate expected");}//TODO: Semantic exception ?
                }
                {if (true) return new UniversalPredicate(variables, (BinaryPredicate) predicate);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("UniversalPredicate");
    }
  }

  final public ExistentialPredicate ExistentialPredicate() throws ParseException {
    trace_call("ExistentialPredicate");
    try {
        List<LocalVariable> variables;
        Predicate predicate;
      jj_consume_token(192);
      variables = LocalVariablesList();
      jj_consume_token(DOT);
      jj_consume_token(LPAREN);
      predicate = Predicate();
      jj_consume_token(RPAREN);
                destroyLocalVariables(variables);
                {if (true) return new ExistentialPredicate(variables, predicate);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ExistentialPredicate");
    }
  }

  final public Predicate InclusionPredicate() throws ParseException {
    trace_call("InclusionPredicate");
    try {
        Expression l,r;
        InclusionPredicate.Operator op;
      l = Expression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCLUSION:
        jj_consume_token(INCLUSION);
                                 op = InclusionPredicate.Operator.INCLUSION;
        break;
      case STRICT_INCLUSION:
        jj_consume_token(STRICT_INCLUSION);
                                 op = InclusionPredicate.Operator.STRICT_INCLUSION;
        break;
      case NON_INCLUSION:
        jj_consume_token(NON_INCLUSION);
                                 op = InclusionPredicate.Operator.NON_INCLUSION;
        break;
      case STRICT_NON_INCLUSION:
        jj_consume_token(STRICT_NON_INCLUSION);
                                 op = InclusionPredicate.Operator.STRICT_NON_INCLUSION;
        break;
      default:
        jj_la1[122] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      r = Expression();
          {if (true) return new InclusionPredicate(l, op, r);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("InclusionPredicate");
    }
  }

  final public ComparisonPredicate ComparisonPredicate() throws ParseException {
    trace_call("ComparisonPredicate");
    try {
        Expression l, r;
        ComparisonPredicate.Operator op;
      l = Expression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LESS:
        jj_consume_token(LESS);
                                op = ComparisonPredicate.Operator.LESS;
        break;
      case LESS_OR_EQUAL:
        jj_consume_token(LESS_OR_EQUAL);
                                op = ComparisonPredicate.Operator.LESS_OR_EQUAL;
        break;
      case GREATER_OR_EQUAL:
        jj_consume_token(GREATER_OR_EQUAL);
                                op = ComparisonPredicate.Operator.GREATER_OR_EQUAL;
        break;
      case GREATER:
        jj_consume_token(GREATER);
                                op = ComparisonPredicate.Operator.GREATER;
        break;
      default:
        jj_la1[123] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      r = Expression();
          {if (true) return new ComparisonPredicate(l, op, r);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ComparisonPredicate");
    }
  }

/* ################################
   ##       Substitutions        ##
   ################################ */
  final public Substitution Substitution() throws ParseException {
    trace_call("Substitution");
    try {
                               Substitution s;
      try {
        s = SequenceSubstitution();
      } catch (TypeCheckException tce) {
                // not very accurate position information, but can help
                {if (true) throw new TypeCheckException(tce.getMessage()+" at line: "+token.beginLine, tce);}
      }
          {if (true) return s;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Substitution");
    }
  }

  final public Substitution SequenceSubstitution() throws ParseException {
    trace_call("SequenceSubstitution");
    try {
        List<Substitution> sequence = new ArrayList<Substitution>();
        Substitution s;
      s = SimultaneousSubstitution();
                                         sequence.add(s);
      label_61:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[124] = jj_gen;
          break label_61;
        }
        jj_consume_token(SEMICOLON);
        s = SimultaneousSubstitution();
                                               sequence.add(s);
      }
                // return sequence substitution only if it is "real" sequence
                {if (true) return (sequence.size() == 1)? sequence.get(0) : new SequenceSubstitution(sequence);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SequenceSubstitution");
    }
  }

  final public Substitution SimultaneousSubstitution() throws ParseException {
    trace_call("SimultaneousSubstitution");
    try {
        List<Substitution> simultaneous = new ArrayList<Substitution>();
        Substitution s;
      s = Level1Substitution();
                                   simultaneous.add(s);
      label_62:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PARALLEL_PRODUCT:
          ;
          break;
        default:
          jj_la1[125] = jj_gen;
          break label_62;
        }
        jj_consume_token(PARALLEL_PRODUCT);
        s = Level1Substitution();
                                          simultaneous.add(s);
      }
          {if (true) return (simultaneous.size() == 1)? simultaneous.get(0) : new SimultaneousSubstitution(simultaneous);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SimultaneousSubstitution");
    }
  }

  final public Substitution Level1Substitution() throws ParseException {
    trace_call("Level1Substitution");
    try {
  Substitution s;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BEGIN:
        s = BlockSubstitution();
        break;
      case skip:
        s = IdentitySubstitution();
        break;
      case CHOICE:
        s = BoundedChoiceSubstitution();
        break;
      case PRE:
        s = PreconditionSubstitution();
        break;
      case ASSERT:
        s = AssertionSubstitution();
        break;
      case IF:
        s = IfSubstitution();
        break;
      case SELECT:
        s = SelectSubstitution();
        break;
      case CASE:
        s = CaseSubstitution();
        break;
      case ANY:
        s = AnySubstitution();
        break;
      case VAR:
        s = VarSubstitution();
        break;
      case LET:
        s = LetSubstitution();
        break;
      default:
        jj_la1[126] = jj_gen;
        if (jj_2_30(2147483647)) {
          //LOOKAHEAD( RenIdentList() [("'" <Ident>)+ | ("(" ExpressionList() ")")+ ] ":=" )
                          s = BecomesEqualSubstitution();
        } else if (jj_2_31(2147483647)) {
          s = BecomesSuchThatSubstitution();
        } else if (jj_2_32(2147483647)) {
          s = BecomesEltSubstitution();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case Ident:
            s = SubstitutionCall();
            break;
          default:
            jj_la1[127] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
          {if (true) return s;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Level1Substitution");
    }
  }

  final public BlockSubstitution BlockSubstitution() throws ParseException {
    trace_call("BlockSubstitution");
    try {
                                         Substitution s;
      jj_consume_token(BEGIN);
      s = Substitution();
      jj_consume_token(END);
          {if (true) return new BlockSubstitution(s);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BlockSubstitution");
    }
  }

  final public IdentitySubstitution IdentitySubstitution() throws ParseException {
    trace_call("IdentitySubstitution");
    try {
      jj_consume_token(skip);
          {if (true) return new IdentitySubstitution();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("IdentitySubstitution");
    }
  }

  final public Substitution BoundedChoiceSubstitution() throws ParseException {
    trace_call("BoundedChoiceSubstitution");
    try {
        Substitution s;
        List<Substitution> choices = new ArrayList<Substitution>();
      jj_consume_token(CHOICE);
      s = Substitution();
                                      choices.add(s);
      label_63:
      while (true) {
        jj_consume_token(OR);
        s = Substitution();
                                          choices.add(s);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OR:
          ;
          break;
        default:
          jj_la1[128] = jj_gen;
          break label_63;
        }
      }
      jj_consume_token(END);
          {if (true) return new ChoiceSubstitution(choices);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BoundedChoiceSubstitution");
    }
  }

  final public PreconditionSubstitution PreconditionSubstitution() throws ParseException {
    trace_call("PreconditionSubstitution");
    try {
        Predicate precondition;
        Substitution substitution;
      jj_consume_token(PRE);
      precondition = Predicate();
      jj_consume_token(THEN);
      substitution = Substitution();
      jj_consume_token(END);
          {if (true) return new PreconditionSubstitution(precondition, substitution);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PreconditionSubstitution");
    }
  }

  final public AssertionSubstitution AssertionSubstitution() throws ParseException {
    trace_call("AssertionSubstitution");
    try {
        Predicate assertion;
        Substitution substitution;
      jj_consume_token(ASSERT);
      assertion = Predicate();
      jj_consume_token(THEN);
      substitution = Substitution();
      jj_consume_token(END);
          {if (true) return new AssertionSubstitution(assertion, substitution);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AssertionSubstitution");
    }
  }

  final public IfSubstitution IfSubstitution() throws ParseException {
    trace_call("IfSubstitution");
    try {
        Predicate p;
        Substitution s;
        Branch ifBranch;
        List<Branch> elseifBranches = new ArrayList<Branch>();
        Substitution elseSubstitution = null;
      jj_consume_token(IF);
      p = Predicate();
      jj_consume_token(THEN);
      s = Substitution();
          ifBranch = new Branch(p, s);
      label_64:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ELSIF:
          ;
          break;
        default:
          jj_la1[129] = jj_gen;
          break label_64;
        }
        jj_consume_token(ELSIF);
        p = Predicate();
        jj_consume_token(THEN);
        s = Substitution();
                  elseifBranches.add(new Branch(p, s));
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELSE:
        jj_consume_token(ELSE);
        elseSubstitution = Substitution();
        break;
      default:
        jj_la1[130] = jj_gen;
        ;
      }
      jj_consume_token(END);
          {if (true) return new IfSubstitution(ifBranch, elseifBranches, elseSubstitution);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("IfSubstitution");
    }
  }

  final public SelectSubstitution SelectSubstitution() throws ParseException {
    trace_call("SelectSubstitution");
    try {
        Predicate p;
        Substitution s;
        List<Branch> choices = new ArrayList<Branch>();
        Substitution elseSubstitution = null;
      jj_consume_token(SELECT);
      p = Predicate();
      jj_consume_token(THEN);
      s = Substitution();
          choices.add(new Branch(p, s));
      label_65:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case WHEN:
          ;
          break;
        default:
          jj_la1[131] = jj_gen;
          break label_65;
        }
        jj_consume_token(WHEN);
        p = Predicate();
        jj_consume_token(THEN);
        s = Substitution();
                  choices.add(new Branch(p, s));
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELSE:
        jj_consume_token(ELSE);
        elseSubstitution = Substitution();
        break;
      default:
        jj_la1[132] = jj_gen;
        ;
      }
      jj_consume_token(END);
          {if (true) return new SelectSubstitution(choices, elseSubstitution);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SelectSubstitution");
    }
  }

  final public CaseSubstitution CaseSubstitution() throws ParseException {
    trace_call("CaseSubstitution");
    try {
        B0DataValue literal;
        Substitution s;

        Expression expression;
        List<B0DataValue> literalConstants = new ArrayList<B0DataValue>();
        List<CaseSubstitution.Branch> choices = new ArrayList<CaseSubstitution.Branch>();
        Substitution elseSubstitution = null;
      jj_consume_token(CASE);
      expression = Expression();
      jj_consume_token(OF);
      jj_consume_token(EITHER);
      literal = SimpleTerm();
                                         literalConstants.add(literal);
      label_66:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[133] = jj_gen;
          break label_66;
        }
        jj_consume_token(COMMA);
        literal = SimpleTerm();
                                                                                                       literalConstants.add(literal);
      }
      jj_consume_token(THEN);
      s = Substitution();
          choices.add(new CaseSubstitution.Branch(literalConstants, s));
      label_67:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OR:
          ;
          break;
        default:
          jj_la1[134] = jj_gen;
          break label_67;
        }
                  literalConstants = new ArrayList<B0DataValue>();
        jj_consume_token(OR);
        literal = SimpleTerm();
                                             literalConstants.add(literal);
        label_68:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[135] = jj_gen;
            break label_68;
          }
          jj_consume_token(COMMA);
          literal = SimpleTerm();
                                                                                                           literalConstants.add(literal);
        }
        jj_consume_token(THEN);
        s = Substitution();
                  choices.add(new CaseSubstitution.Branch(literalConstants, s));
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELSE:
        jj_consume_token(ELSE);
        elseSubstitution = Substitution();
        break;
      default:
        jj_la1[136] = jj_gen;
        ;
      }
      jj_consume_token(END);
      jj_consume_token(END);
          {if (true) return new CaseSubstitution(expression, choices, elseSubstitution);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("CaseSubstitution");
    }
  }

  final public AnySubstitution AnySubstitution() throws ParseException {
    trace_call("AnySubstitution");
    try {
        List<String> variablesNames;
        List<LocalVariable> variables;
      jj_consume_token(ANY);
      variablesNames = ListIdent();
                                             variables = createLocalVariables(variablesNames);
      jj_consume_token(WHERE);
      Predicate();
      jj_consume_token(THEN);
      Substitution();
      jj_consume_token(END);
                destroyLocalVariables(variables);
                {if (true) return new AnySubstitution();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AnySubstitution");
    }
  }

  final public LetSubstitution LetSubstitution() throws ParseException {
    trace_call("LetSubstitution");
    try {
        Token variableToken;
        Expression expr;
        List<LocalVariable> variables;
      jj_consume_token(LET);
      variables = LocalVariablesList();
      jj_consume_token(BE);
      variableToken = jj_consume_token(Ident);
      jj_consume_token(EQUAL);
      expr = Expression();
                processIdentifier(variableToken.image).typeData(expr.type());
      label_69:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CONJUNCTION:
          ;
          break;
        default:
          jj_la1[137] = jj_gen;
          break label_69;
        }
        jj_consume_token(CONJUNCTION);
        jj_consume_token(Ident);
        jj_consume_token(EQUAL);
        Expression();
      }
      jj_consume_token(IN);
      Substitution();
      jj_consume_token(END);
                destroyLocalVariables(variables);
                {if (true) return new LetSubstitution();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("LetSubstitution");
    }
  }

  final public VarSubstitution VarSubstitution() throws ParseException {
    trace_call("VarSubstitution");
    try {
      jj_consume_token(VAR);
      ListIdent();
      jj_consume_token(IN);
      Substitution();
      jj_consume_token(END);
          {if (true) return new VarSubstitution();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("VarSubstitution");
    }
  }

  final public WhileInstruction WhileInstruction() throws ParseException {
    trace_call("WhileInstruction");
    try {
        Condition condition;
        Instruction body;
        Predicate invariant;
        Expression variant;
      jj_consume_token(WHILE);
      condition = Condition();
      jj_consume_token(DO);
      body = Instruction();
      jj_consume_token(INVARIANT);
      invariant = Predicate();
      jj_consume_token(VARIANT);
      variant = Expression();
      jj_consume_token(END);
          {if (true) return new WhileInstruction(condition, body, invariant, variant);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("WhileInstruction");
    }
  }

  final public SubstitutionCall SubstitutionCall() throws ParseException {
    trace_call("SubstitutionCall");
    try {
        Identifier operationName;
        Identifier impRenMach = null; //by SKor[oprava prekladu operacie]: premenna na odpamatanie mena premenovaneho stroja z ktoreho je tato operacia volana.
        List<Identifier> outputVariablesNames;
        List<DataField> outputVariables = null;
        List<Expression> inputParameters = null;
      if (jj_2_33(2147483647)) {
        outputVariablesNames = RenIdentList();
        jj_consume_token(170);
                        outputVariables = new ArrayList<DataField>();
                        for (Identifier outVarName : outputVariablesNames) {
                                outputVariables.add(processIdentifier(outVarName));
                        }
      } else {
        ;
      }
      operationName = RenIdent();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        inputParameters = ExpressionList();
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[138] = jj_gen;
        ;
      }
            //System.out.println("operation call: "+operationName.componentName()+" <> "+ operationName.prefixString()); //by SKor[oprava prekladu operacie]: pomocny vypis

                if (!declaredOperations.containsKey(operationName.componentName()))  //by SKor[oprava prekladu operacie]: nahrada operationName.toString() za operationName.componentName()
                        {if (true) throw new RuntimeException("Unknown operation: "+operationName);}

                OperationDeclaration declaration = declaredOperations.get(operationName.componentName());  //by SKor[oprava prekladu operacie]: nahrada operationName.toString() za operationName.componentName()
                logger.info("operation call: "+declaration);
                //System.out.println("operation call: "+declaration); //by SKor[oprava prekladu operacie]: pomocny vypis
                {if (true) return new SubstitutionCall(declaration, outputVariables, inputParameters);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SubstitutionCall");
    }
  }

  final public BecomesEqualSubstitution BecomesEqualSubstitution() throws ParseException {
    trace_call("BecomesEqualSubstitution");
    try {
        BecomesEqualSubstitution substitution = null;
        Identifier id;
        List<Identifier> idList = new ArrayList<Identifier>();
        List<Expression> params = new ArrayList<Expression>();
        List<Expression> exprList = new ArrayList<Expression>();
        List<ExpressionVariable> variables = new ArrayList<ExpressionVariable>();
        Expression e;
      if (jj_2_34(2147483647)) {
        id = RenIdent();
                                  idList.add(id);
        label_70:
        while (true) {
          jj_consume_token(LPAREN);
          params = ExpressionList();
          jj_consume_token(RPAREN);

          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            ;
            break;
          default:
            jj_la1[139] = jj_gen;
            break label_70;
          }
        }
        jj_consume_token(194);
        e = Expression();
                                           exprList.add(e);
      } else if (jj_2_35(2147483647)) {
        RenIdent();
        label_71:
        while (true) {
          jj_consume_token(QUOTE);
          jj_consume_token(Ident);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case QUOTE:
            ;
            break;
          default:
            jj_la1[140] = jj_gen;
            break label_71;
          }
        }
        jj_consume_token(194);
        Expression();
      } else if (jj_2_36(2147483647)) {
        idList = RenIdentList();
        jj_consume_token(194);
        exprList = ExpressionList();
                        //List<DataField> variables = new ArrayList<DataField>();
                        for (Identifier ident : idList) {
                                DataField dataVariable = processIdentifier(ident);
                                variables.add(ExpressionReference.newReference(dataVariable));
                        }
                        substitution = new BecomesEqualSubstitution(variables, exprList);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
          {if (true) return substitution;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BecomesEqualSubstitution");
    }
  }

  final public BecomesEltSubstitution BecomesEltSubstitution() throws ParseException {
    trace_call("BecomesEltSubstitution");
    try {
        List<ExpressionVariable> variables = new ArrayList<ExpressionVariable>();
        List<Identifier> idList;
        Expression set;
      idList = RenIdentList();
      jj_consume_token(193);
      set = Expression();
                for (Identifier ident : idList) {
                        DataField dataVariable = processIdentifier(ident);
                        variables.add(ExpressionReference.newReference(dataVariable));
                }
                {if (true) return new BecomesEltSubstitution(variables, set);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BecomesEltSubstitution");
    }
  }

  final public Substitution BecomesSuchThatSubstitution() throws ParseException {
    trace_call("BecomesSuchThatSubstitution");
    try {
      RenIdentList();
      jj_consume_token(BELONGS);
      Predicate();
          {if (true) return null;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BecomesSuchThatSubstitution");
    }
  }

/* ######################################### 
   ##             Instructions            ##
   ######################################### */
  final public Instruction Instruction() throws ParseException {
    trace_call("Instruction");
    try {
                            Instruction i;
      try {
        i = SequenceInstruction();
      } catch (TypeCheckException tce) {
                {if (true) throw new TypeCheckException(tce.getMessage()+" at line: "+token.beginLine+" definitions trace: "+definitionsTrace, tce);}
      } catch (Exception tce) {
                {if (true) throw new ParseException(tce.getMessage()+" at line: "+token.beginLine+" definitions trace: "+definitionsTrace);} // TODO: some new exception class 

      }
          {if (true) return i;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Instruction");
    }
  }

  final public SequenceInstruction SequenceInstruction() throws ParseException {
    trace_call("SequenceInstruction");
    try {
        Instruction i;
        List<Instruction> iList = new ArrayList<Instruction>();
      i = Level1Instruction();
                                 iList.add(i);
      label_72:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[141] = jj_gen;
          break label_72;
        }
        jj_consume_token(SEMICOLON);
        i = Level1Instruction();
                                                                              iList.add(i);
      }
          {if (true) return new SequenceInstruction(iList);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SequenceInstruction");
    }
  }

  final public Instruction Level1Instruction() throws ParseException {
    trace_call("Level1Instruction");
    try {
                                   Instruction i = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BEGIN:
        i = BlockInstruction();
        break;
      case VAR:
        i = VarInstruction();
        break;
      case skip:
        i = IdentityInstruction();
        break;
      case IF:
        i = IfInstruction();
        break;
      case CASE:
        i = CaseInstruction();
        break;
      case ASSERT:
        i = AssertionInstruction();
        break;
      case WHILE:
        i = WhileInstruction();
        break;
      default:
        jj_la1[142] = jj_gen;
        if (jj_2_37(2147483647)) {
          i = BecomesEqualInstruction();
        } else if (jj_2_38(2147483647)) {
          i = CallupInstruction();
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
                if (i == null)
                        {if (true) throw new NullPointerException();}
                {if (true) return i;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Level1Instruction");
    }
  }

  final public BlockInstruction BlockInstruction() throws ParseException {
    trace_call("BlockInstruction");
    try {
                                      Instruction instruction;
      jj_consume_token(BEGIN);
      instruction = Instruction();
      jj_consume_token(END);
          {if (true) return new BlockInstruction(instruction);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BlockInstruction");
    }
  }

  final public IdentityInstruction IdentityInstruction() throws ParseException {
    trace_call("IdentityInstruction");
    try {
      jj_consume_token(skip);
          {if (true) return IdentityInstruction.IDENTITY_INSTRUCTION;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("IdentityInstruction");
    }
  }

  final public LocalVariableInstruction VarInstruction() throws ParseException {
    trace_call("VarInstruction");
    try {
        List<String> variablesNames;
        List<LocalVariable> variables;
        Instruction  instruction;
      jj_consume_token(VAR);
      variablesNames = ListIdent();
                variables = createLocalVariables(variablesNames);
      jj_consume_token(IN);
      instruction = Instruction();
      jj_consume_token(END);
          {if (true) return new LocalVariableInstruction(variables, instruction);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("VarInstruction");
    }
  }

  final public AssertionInstruction AssertionInstruction() throws ParseException {
    trace_call("AssertionInstruction");
    try {
        Predicate predicate;
        Instruction substitution;
      jj_consume_token(ASSERT);
      predicate = Predicate();
      jj_consume_token(THEN);
      substitution = Instruction();
      jj_consume_token(END);
          {if (true) return new AssertionInstruction(predicate, substitution);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AssertionInstruction");
    }
  }

  final public IfConditionalInstruction IfInstruction() throws ParseException {
    trace_call("IfInstruction");
    try {
        Condition condition;
        Instruction instruction, elseInstruction = null;
        IfConditionalInstruction.Branch ifBranch;
        List<IfConditionalInstruction.Branch> elseBranches = new ArrayList<IfConditionalInstruction.Branch>();
      jj_consume_token(IF);
      condition = Condition();
      jj_consume_token(THEN);
      instruction = Instruction();
          ifBranch = new IfConditionalInstruction.Branch(condition, instruction);
      label_73:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ELSIF:
          ;
          break;
        default:
          jj_la1[143] = jj_gen;
          break label_73;
        }
        jj_consume_token(ELSIF);
        condition = Condition();
        jj_consume_token(THEN);
        instruction = Instruction();
                  elseBranches.add(new IfConditionalInstruction.Branch(condition, instruction));
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELSE:
        jj_consume_token(ELSE);
        elseInstruction = Instruction();

        break;
      default:
        jj_la1[144] = jj_gen;
        ;
      }
      jj_consume_token(END);
          {if (true) return new IfConditionalInstruction(ifBranch, elseBranches, elseInstruction);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("IfInstruction");
    }
  }

  final public CaseConditionalInstruction CaseInstruction() throws ParseException {
    trace_call("CaseInstruction");
    try {
        B0DataValue expression, literal;
        //java.util.Set<Term> literalConstants = new java.util.TreeSet<Term>();
        List<B0DataValue> literalConstants = new ArrayList<B0DataValue>();
        List<CaseConditionalInstruction.Branch> caseBranches = new ArrayList<CaseConditionalInstruction.Branch>();

        Instruction instruction, elseInstruction = null;
      jj_consume_token(CASE);
      expression = SimpleTerm();
      jj_consume_token(OF);
      jj_consume_token(EITHER);
      literal = SimpleTerm();
                                         literalConstants.add(literal);
      label_74:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[145] = jj_gen;
          break label_74;
        }
        jj_consume_token(COMMA);
        literal = SimpleTerm();
                                                                                                       literalConstants.add(literal);
      }
      jj_consume_token(THEN);
      instruction = Instruction();
          caseBranches.add(new CaseConditionalInstruction.Branch(literalConstants, instruction));
      label_75:
      while (true) {
                  literalConstants = new ArrayList<B0DataValue>();
        jj_consume_token(OR);
        literal = SimpleTerm();
                                             literalConstants.add(literal);
        label_76:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[146] = jj_gen;
            break label_76;
          }
          jj_consume_token(COMMA);
          literal = SimpleTerm();
                                                                                                           literalConstants.add(literal);
        }
        jj_consume_token(THEN);
        instruction = Instruction();
                  caseBranches.add(new CaseConditionalInstruction.Branch(literalConstants, instruction));
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OR:
          ;
          break;
        default:
          jj_la1[147] = jj_gen;
          break label_75;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELSE:
        jj_consume_token(ELSE);
        elseInstruction = Instruction();
        break;
      default:
        jj_la1[148] = jj_gen;
        ;
      }
      jj_consume_token(END);
      jj_consume_token(END);
          {if (true) return new CaseConditionalInstruction(expression, caseBranches, elseInstruction);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("CaseInstruction");
    }
  }

  final public Instruction BecomesEqualInstruction() throws ParseException {
    trace_call("BecomesEqualInstruction");
    try {
        Identifier id;

        Condition predicate;
        B0Variable variable = null;
        B0DataValue value = null;
      id = RenIdent();
          variable = new B0VariableReference(processIdentifier(id));
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case QUOTE:
        label_77:
        while (true) {
          jj_consume_token(QUOTE);
          jj_consume_token(Ident);
                          variable = new RecordFieldVariable(variable, token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case QUOTE:
            ;
            break;
          default:
            jj_la1[149] = jj_gen;
            break label_77;
          }
        }
        break;
      default:
        jj_la1[150] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
                        List<B0DataValue> indexes = new ArrayList<B0DataValue>();
                        B0DataValue index;
        jj_consume_token(LPAREN);
        index = Value();
                                      indexes.add(index);
        label_78:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[151] = jj_gen;
            break label_78;
          }
          jj_consume_token(COMMA);
          index = Value();
                                                                                   indexes.add(index);
        }
        jj_consume_token(RPAREN);
                  variable = new ArrayFieldVariable(variable, indexes);
        break;
      default:
        jj_la1[152] = jj_gen;
        ;
      }
      jj_consume_token(194);
      value = Value();
                if (value instanceof IntervalB0) {
                        {if (true) throw new TypeCheckException("value cannot be interval");}
                }
          {if (true) return new BecomesEqualInstruction(variable, value);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BecomesEqualInstruction");
    }
  }

  final public B0DataValue B0ScalarValue() throws ParseException {
    trace_call("B0ScalarValue");
    try {
        Condition predicate;
        B0DataValue value;
      value = Value();
          {if (true) return value;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("B0ScalarValue");
    }
  }

  final public CallupInstruction CallupInstruction() throws ParseException {
    trace_call("CallupInstruction");
    try {
        List<Identifier> outputVariablesNames;
        List<DataField> outputVariables = new ArrayList<DataField>();
        Identifier operationName;
        B0DataValue parameter;
        List<B0DataValue> inputParameters = new ArrayList<B0DataValue>();
        String stringParameter;
      if (jj_2_39(2147483647)) {
        outputVariablesNames = RenIdentList();
        jj_consume_token(170);
                        for (Identifier id : outputVariablesNames) {
                                outputVariables.add(processIdentifier(id));
                        }
      } else {
        ;
      }
      operationName = RenIdent();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
        case LPAREN:
        case MINUS:
        case SUCCESSOR:
        case PREDECESSOR:
        case BOOL_CAST:
        case NAT:
        case NAT1:
        case INT:
        case MAXINT:
        case MININT:
        case BOOL:
        case TRUE:
        case FALSE:
        case rec:
        case INTEGER_LITERAL:
        case Ident:
          parameter = B0ScalarValue();
          break;
        case STRING_LITERAL:
          stringParameter = StringLiteral();
                                                                                    parameter = new StringValue(stringParameter);
          break;
        default:
          jj_la1[153] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                  inputParameters.add(parameter);
        label_79:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[154] = jj_gen;
            break label_79;
          }
          jj_consume_token(COMMA);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
          case LPAREN:
          case MINUS:
          case SUCCESSOR:
          case PREDECESSOR:
          case BOOL_CAST:
          case NAT:
          case NAT1:
          case INT:
          case MAXINT:
          case MININT:
          case BOOL:
          case TRUE:
          case FALSE:
          case rec:
          case INTEGER_LITERAL:
          case Ident:
            parameter = Value();
            break;
          case STRING_LITERAL:
            stringParameter = StringLiteral();
                                                                                        parameter = new StringValue(stringParameter);
            break;
          default:
            jj_la1[155] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                          inputParameters.add(parameter);
        }
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[156] = jj_gen;
        ;
      }
                if (!declaredOperations.containsKey(operationName.toString()))
                        {if (true) throw new RuntimeException("Unknown Operation: "+operationName.toString());}

                OperationDeclaration declaration = declaredOperations.get(operationName.toString());
                logger.info(""+declaration);

                // TODO: complete check
                // check input/output parameters
                if (inputParameters.size() != declaration.inputParameters().size())
                        {if (true) throw new RuntimeException("wrong arguments count: "+operationName.toString());}


                {if (true) return new CallupInstruction(declaration, outputVariables, inputParameters);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("CallupInstruction");
    }
  }

  final public void ClauseInitialization() throws ParseException {
    trace_call("ClauseInitialization");
    try {
      jj_consume_token(INITIALISATION);
      Substitution();
    } finally {
      trace_return("ClauseInitialization");
    }
  }

  final public Predicate ClauseConstraints() throws ParseException {
    trace_call("ClauseConstraints");
    try {
                                 Predicate p;
      jj_consume_token(CONSTRAINTS);
      p = Predicate();
          {if (true) return p;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ClauseConstraints");
    }
  }

/****************************************
 ******* Often used constructions *******
 ****************************************/
  final public List<String> ListIdent() throws ParseException {
    trace_call("ListIdent");
    try {
        List<String> list = new ArrayList<String>();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case Ident:
        jj_consume_token(Ident);
                  list.add(token.image);
        label_80:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[157] = jj_gen;
            break label_80;
          }
          jj_consume_token(COMMA);
          jj_consume_token(Ident);
                          list.add(token.image);
        }
        break;
      case LPAREN:
        jj_consume_token(LPAREN);
        list = ListIdent();
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[158] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
          {if (true) return list;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ListIdent");
    }
  }

  final public List<LocalVariable> LocalVariablesList() throws ParseException {
    trace_call("LocalVariablesList");
    try {
                                            List<String> variablesNames;
      variablesNames = ListIdent();
          {if (true) return createLocalVariables(variablesNames);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("LocalVariablesList");
    }
  }

  final public Identifier RenIdent() throws ParseException {
    trace_call("RenIdent");
    try {
        List<String> renIdent = new ArrayList<String>();
      jj_consume_token(Ident);
          renIdent.add(token.image);
      label_81:
      while (true) {
        if (jj_2_40(2)) {
          ;
        } else {
          break label_81;
        }
        jj_consume_token(DOT);
        jj_consume_token(Ident);
                  renIdent.add(token.image);
      }
          {if (true) return new Identifier(renIdent);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RenIdent");
    }
  }

  final public List<Identifier> RenIdentList() throws ParseException {
    trace_call("RenIdentList");
    try {
        List<Identifier> list = new ArrayList<Identifier>();
        Identifier elem;
      elem = RenIdent();
          list.add(elem);
      label_82:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[159] = jj_gen;
          break label_82;
        }
        jj_consume_token(COMMA);
        elem = RenIdent();
                  list.add(elem);
      }
          {if (true) return list;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RenIdentList");
    }
  }

  final public String StringLiteral() throws ParseException {
    trace_call("StringLiteral");
    try {
      jj_consume_token(STRING_LITERAL);
          {if (true) return token.image.substring(1, token.image.length()-1);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("StringLiteral");
    }
  }

  final public List<Expression> ExpressionList() throws ParseException {
    trace_call("ExpressionList");
    try {
        Expression e;
        List<Expression> list = new ArrayList<Expression>();
          expressionList = false;
      e = Expression();
                           list.add(e);
      label_83:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[160] = jj_gen;
          break label_83;
        }
        jj_consume_token(COMMA);
        e = Expression();
                                                                   list.add(e);
      }
                expressionList = true;
                {if (true) return list;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ExpressionList");
    }
  }

  void skip_to_matching_brace() throws ParseException {
    trace_call("skip_to_matching_brace");
    try {
      Token tok;
      int nesting = 1;
      while (true) {
        tok = getToken(1);
        if (tok.kind == LPAREN) nesting++;
        if (tok.kind == RPAREN) {
          nesting--;
          if (nesting == 0) break;
        }
        tok = getNextToken();
        logger.info(tok);
      }
    } finally {
      trace_return("skip_to_matching_brace");
    }
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_35(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(34, xla); }
  }

  private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_36(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(35, xla); }
  }

  private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_37(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(36, xla); }
  }

  private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_38(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(37, xla); }
  }

  private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_39(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(38, xla); }
  }

  private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_40(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(39, xla); }
  }

  private boolean jj_3R_189() {
    if (jj_scan_token(NON_BELONGS)) return true;
    return false;
  }

  private boolean jj_3R_188() {
    if (jj_scan_token(BELONGS)) return true;
    return false;
  }

  private boolean jj_3R_143() {
    if (jj_3R_96()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_161()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_182() {
    if (jj_3R_96()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_188()) {
    jj_scanpos = xsp;
    if (jj_3R_189()) {
    jj_scanpos = xsp;
    if (jj_3R_190()) {
    jj_scanpos = xsp;
    if (jj_3R_191()) {
    jj_scanpos = xsp;
    if (jj_3R_192()) {
    jj_scanpos = xsp;
    if (jj_3R_193()) {
    jj_scanpos = xsp;
    if (jj_3R_194()) {
    jj_scanpos = xsp;
    if (jj_3R_195()) {
    jj_scanpos = xsp;
    if (jj_3R_196()) {
    jj_scanpos = xsp;
    if (jj_3R_197()) {
    jj_scanpos = xsp;
    if (jj_3R_198()) {
    jj_scanpos = xsp;
    if (jj_3R_199()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(14)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(166)) {
    jj_scanpos = xsp;
    if (jj_scan_token(169)) {
    jj_scanpos = xsp;
    if (jj_scan_token(152)) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = !followsDefinitionLookahead();
    jj_lookingAhead = false;
    if (!jj_semLA || jj_scan_token(26)) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = getToken(1).kind == END && (parsingDefinitionFile || getToken(2).kind != EOF);
    jj_lookingAhead = false;
    if (!jj_semLA || jj_scan_token(139)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_164() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_126() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_91()) return true;
    return false;
  }

  private boolean jj_3_29() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_10() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  private boolean jj_3R_172() {
    if (jj_3R_182()) return true;
    return false;
  }

  private boolean jj_3R_100() {
    if (jj_3R_91()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_126()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_171() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_170() {
    if (jj_3R_181()) return true;
    return false;
  }

  private boolean jj_3_40() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(Ident)) return true;
    return false;
  }

  private boolean jj_3R_169() {
    if (jj_3R_180()) return true;
    return false;
  }

  private boolean jj_3R_168() {
    if (jj_3R_179()) return true;
    return false;
  }

  private boolean jj_3R_174() {
    if (jj_scan_token(CONJUNCTION)) return true;
    return false;
  }

  private boolean jj_3R_173() {
    if (jj_scan_token(DISJUNCTION)) return true;
    return false;
  }

  private boolean jj_3R_157() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_168()) {
    jj_scanpos = xsp;
    if (jj_3R_169()) {
    jj_scanpos = xsp;
    if (jj_3R_170()) {
    jj_scanpos = xsp;
    if (jj_3R_171()) {
    jj_scanpos = xsp;
    if (jj_3R_172()) return true;
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_91() {
    if (jj_scan_token(Ident)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_40()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_158() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_173()) {
    jj_scanpos = xsp;
    if (jj_3R_174()) return true;
    }
    if (jj_3R_157()) return true;
    return false;
  }

  private boolean jj_3R_131() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(Ident)) return true;
    return false;
  }

  private boolean jj_3R_106() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_89()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_187() {
    if (jj_3R_89()) return true;
    return false;
  }

  private boolean jj_3R_160() {
    if (jj_scan_token(EQUIVALENCE)) return true;
    return false;
  }

  private boolean jj_3R_159() {
    if (jj_scan_token(IMPLICATION)) return true;
    return false;
  }

  private boolean jj_3R_139() {
    if (jj_3R_157()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_158()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_105() {
    if (jj_scan_token(Ident)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_131()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_140() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) return true;
    }
    if (jj_3R_139()) return true;
    return false;
  }

  private boolean jj_3R_166() {
    if (jj_3R_164()) return true;
    return false;
  }

  private boolean jj_3R_89() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_105()) {
    jj_scanpos = xsp;
    if (jj_3R_106()) return true;
    }
    return false;
  }

  private boolean jj_3R_147() {
    if (jj_3R_164()) return true;
    return false;
  }

  private boolean jj_3R_122() {
    if (jj_3R_139()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_140()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_165() {
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_98() {
    if (jj_3R_122()) return true;
    return false;
  }

  private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(140)) {
    jj_scanpos = xsp;
    if (jj_scan_token(162)) {
    jj_scanpos = xsp;
    if (jj_scan_token(145)) {
    jj_scanpos = xsp;
    if (jj_scan_token(144)) {
    jj_scanpos = xsp;
    if (jj_scan_token(141)) {
    jj_scanpos = xsp;
    if (jj_scan_token(142)) {
    jj_scanpos = xsp;
    if (jj_scan_token(146)) {
    jj_scanpos = xsp;
    if (jj_scan_token(143)) {
    jj_scanpos = xsp;
    if (jj_scan_token(147)) {
    jj_scanpos = xsp;
    if (jj_scan_token(155)) {
    jj_scanpos = xsp;
    if (jj_scan_token(153)) {
    jj_scanpos = xsp;
    if (jj_scan_token(157)) {
    jj_scanpos = xsp;
    if (jj_scan_token(159)) {
    jj_scanpos = xsp;
    if (jj_scan_token(156)) {
    jj_scanpos = xsp;
    if (jj_scan_token(154)) {
    jj_scanpos = xsp;
    if (jj_scan_token(151)) {
    jj_scanpos = xsp;
    if (jj_scan_token(158)) {
    jj_scanpos = xsp;
    if (jj_scan_token(160)) {
    jj_scanpos = xsp;
    if (jj_scan_token(152)) {
    jj_scanpos = xsp;
    if (jj_scan_token(161)) {
    jj_scanpos = xsp;
    if (jj_scan_token(150)) {
    jj_scanpos = xsp;
    if (jj_scan_token(148)) {
    jj_scanpos = xsp;
    if (jj_scan_token(149)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_331() {
    if (jj_scan_token(BOOL_CAST)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_330() {
    if (jj_3R_234()) return true;
    return false;
  }

  private boolean jj_3R_322() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_330()) {
    jj_scanpos = xsp;
    if (jj_3R_331()) return true;
    }
    return false;
  }

  private boolean jj_3R_148() {
    if (jj_scan_token(COMMA)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_165()) {
    jj_scanpos = xsp;
    if (jj_3R_166()) return true;
    }
    return false;
  }

  private boolean jj_3R_340() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(190)) return true;
    return false;
  }

  private boolean jj_3R_146() {
    if (jj_3R_163()) return true;
    return false;
  }

  private boolean jj_3R_329() {
    if (jj_3R_164()) return true;
    return false;
  }

  private boolean jj_3R_130() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_146()) {
    jj_scanpos = xsp;
    if (jj_3R_147()) return true;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_148()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_39() {
    if (jj_3R_100()) return true;
    if (jj_scan_token(170)) return true;
    return false;
  }

  private boolean jj_3R_328() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_327() {
    if (jj_3R_91()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_340()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_321() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_327()) {
    jj_scanpos = xsp;
    if (jj_3R_328()) {
    jj_scanpos = xsp;
    if (jj_3R_329()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_129() {
    if (jj_3R_100()) return true;
    if (jj_scan_token(170)) return true;
    return false;
  }

  private boolean jj_3_28() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_89()) return true;
    if (jj_scan_token(188)) return true;
    return false;
  }

  private boolean jj_3R_103() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_129()) jj_scanpos = xsp;
    if (jj_3R_91()) return true;
    xsp = jj_scanpos;
    if (jj_3R_130()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_337() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_143()) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3R_336() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(188)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3R_335() {
    if (jj_scan_token(F1)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_334() {
    if (jj_scan_token(F)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_163() {
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_333() {
    if (jj_scan_token(P1)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_332() {
    if (jj_scan_token(P)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_325() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_332()) {
    jj_scanpos = xsp;
    if (jj_3R_333()) {
    jj_scanpos = xsp;
    if (jj_3R_334()) {
    jj_scanpos = xsp;
    if (jj_3R_335()) {
    jj_scanpos = xsp;
    if (jj_3R_336()) {
    jj_scanpos = xsp;
    if (jj_3R_337()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_121() {
    if (jj_scan_token(STRING)) return true;
    return false;
  }

  private boolean jj_3R_120() {
    if (jj_scan_token(BOOL)) return true;
    return false;
  }

  private boolean jj_3R_119() {
    if (jj_scan_token(NAT1)) return true;
    return false;
  }

  private boolean jj_3R_118() {
    if (jj_scan_token(NAT)) return true;
    return false;
  }

  private boolean jj_3R_117() {
    if (jj_scan_token(INT)) return true;
    return false;
  }

  private boolean jj_3R_116() {
    if (jj_scan_token(N1)) return true;
    return false;
  }

  private boolean jj_3R_115() {
    if (jj_scan_token(N)) return true;
    return false;
  }

  private boolean jj_3R_114() {
    if (jj_scan_token(Z)) return true;
    return false;
  }

  private boolean jj_3R_113() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3_9() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(164)) {
    jj_scanpos = xsp;
    if (jj_scan_token(166)) {
    jj_scanpos = xsp;
    if (jj_scan_token(165)) {
    jj_scanpos = xsp;
    if (jj_scan_token(139)) {
    jj_scanpos = xsp;
    if (jj_scan_token(169)) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = !followOperationHeader();
    jj_lookingAhead = false;
    if (!jj_semLA || jj_scan_token(26)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_27() {
    if (jj_scan_token(Ident)) return true;
    if (jj_scan_token(BELONGS)) return true;
    return false;
  }

  private boolean jj_3R_342() {
    if (jj_scan_token(COMMA)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_27()) jj_scanpos = xsp;
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_97() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) {
    jj_scanpos = xsp;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) {
    jj_scanpos = xsp;
    if (jj_3R_119()) {
    jj_scanpos = xsp;
    if (jj_3R_120()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_13() {
    if (jj_3R_89()) return true;
    if (jj_scan_token(170)) return true;
    return false;
  }

  private boolean jj_3R_341() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(Ident)) return true;
    if (jj_scan_token(BELONGS)) return true;
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3_26() {
    if (jj_scan_token(Ident)) return true;
    if (jj_scan_token(BELONGS)) return true;
    return false;
  }

  private boolean jj_3R_339() {
    if (jj_scan_token(rec)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_26()) jj_scanpos = xsp;
    if (jj_3R_96()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_342()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_8() {
    if (jj_3R_89()) return true;
    if (jj_scan_token(ARROW)) return true;
    return false;
  }

  private boolean jj_3R_338() {
    if (jj_scan_token(struct)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(Ident)) return true;
    if (jj_scan_token(BELONGS)) return true;
    if (jj_3R_96()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_341()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_326() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_338()) {
    jj_scanpos = xsp;
    if (jj_3R_339()) return true;
    }
    return false;
  }

  private boolean jj_3R_92() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_89()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_5() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(164)) {
    jj_scanpos = xsp;
    if (jj_scan_token(165)) {
    jj_scanpos = xsp;
    if (jj_scan_token(166)) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = getToken(1).kind == END && getToken(2).kind != EOF;
    jj_lookingAhead = false;
    if (!jj_semLA || jj_scan_token(139)) {
    jj_scanpos = xsp;
    if (jj_scan_token(169)) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_317() {
    if (jj_scan_token(LESS)) return true;
    if (jj_scan_token(GREATER)) return true;
    return false;
  }

  private boolean jj_3R_316() {
    if (jj_scan_token(CONCATENATION)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_315() {
    if (jj_scan_token(REVERSE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_314() {
    if (jj_scan_token(TAIL)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_313() {
    if (jj_scan_token(FRONT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_312() {
    if (jj_scan_token(LAST)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_145() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_311() {
    if (jj_scan_token(FIRST)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_310() {
    if (jj_scan_token(SIZE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_309() {
    if (jj_scan_token(PERMUTATIONS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_308() {
    if (jj_scan_token(INJECTIVE_NON_EMPTY_SEQUENCE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_307() {
    if (jj_scan_token(INJECTIVE_SEQUENCE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_306() {
    if (jj_scan_token(NON_EMPTY_SEQUENCE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_305() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_304() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_143()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3_25() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_128() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_144()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_145()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_3R_89()) return true;
    if (jj_scan_token(ARROW)) return true;
    return false;
  }

  private boolean jj_3R_90() {
    if (jj_3R_89()) return true;
    if (jj_scan_token(ARROW)) return true;
    return false;
  }

  private boolean jj_3_18() {
    if (jj_scan_token(Ident)) return true;
    if (jj_scan_token(BELONGS)) return true;
    return false;
  }

  private boolean jj_3_7() {
    Token xsp;
    if (jj_3_5()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_5()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_6() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_90()) jj_scanpos = xsp;
    if (jj_3R_91()) return true;
    xsp = jj_scanpos;
    if (jj_3R_92()) jj_scanpos = xsp;
    if (jj_scan_token(ASIGN)) return true;
    return false;
  }

  private boolean jj_3R_303() {
    if (jj_scan_token(RANGE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_302() {
    if (jj_scan_token(DOMAIN)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_102() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_128()) jj_scanpos = xsp;
    if (jj_scan_token(194)) return true;
    return false;
  }

  private boolean jj_3R_301() {
    if (jj_scan_token(CLOSURE1)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_300() {
    if (jj_scan_token(CLOSURE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_299() {
    if (jj_scan_token(ITERATE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_298() {
    if (jj_scan_token(second_projection)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_241() {
    if (jj_scan_token(COMMA)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_18()) jj_scanpos = xsp;
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_297() {
    if (jj_scan_token(first_projection)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_88() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) jj_scanpos = xsp;
    if (jj_3R_91()) return true;
    return false;
  }

  private boolean jj_3R_296() {
    if (jj_scan_token(identity)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_17() {
    if (jj_scan_token(Ident)) return true;
    if (jj_scan_token(BELONGS)) return true;
    return false;
  }

  private boolean jj_3R_295() {
    if (jj_3R_326()) return true;
    return false;
  }

  private boolean jj_3R_127() {
    if (jj_scan_token(QUOTE)) return true;
    if (jj_scan_token(Ident)) return true;
    return false;
  }

  private boolean jj_3R_101() {
    Token xsp;
    if (jj_3R_127()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_127()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_294() {
    if (jj_scan_token(INTERSECTION)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(188)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_233() {
    if (jj_scan_token(rec)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_17()) jj_scanpos = xsp;
    if (jj_3R_144()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_241()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_3() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_88()) {
    jj_scanpos = xsp;
    if (jj_3_7()) return true;
    }
    return false;
  }

  private boolean jj_3R_293() {
    if (jj_scan_token(UNION)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(188)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_38() {
    if (jj_3R_103()) return true;
    return false;
  }

  private boolean jj_3R_292() {
    if (jj_scan_token(intersection)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_291() {
    if (jj_scan_token(union)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_37() {
    if (jj_3R_91()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_101()) {
    jj_scanpos = xsp;
    if (jj_3R_102()) return true;
    }
    return false;
  }

  private boolean jj_3R_290() {
    if (jj_3R_325()) return true;
    return false;
  }

  private boolean jj_3_24() {
    if (jj_3R_97()) return true;
    return false;
  }

  private boolean jj_3R_289() {
    if (jj_scan_token(RELATION_CAST)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_288() {
    if (jj_scan_token(FUNCTION_CAST)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_287() {
    if (jj_scan_token(189)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(188)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_324() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_251() {
    if (jj_3R_256()) return true;
    return false;
  }

  private boolean jj_3R_255() {
    if (jj_scan_token(QUOTE)) return true;
    if (jj_scan_token(Ident)) return true;
    return false;
  }

  private boolean jj_3R_286() {
    if (jj_scan_token(SIGMA)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(188)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_323() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_285() {
    if (jj_scan_token(PI)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(188)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_284() {
    if (jj_scan_token(PREDECESSOR)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_324()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_283() {
    if (jj_scan_token(SUCCESSOR)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_323()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_282() {
    if (jj_scan_token(CARDINAL)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_281() {
    if (jj_scan_token(MINIMUM)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_280() {
    if (jj_scan_token(MAXIMUM)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_279() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_3R_274()) return true;
    return false;
  }

  private boolean jj_3R_278() {
    if (jj_3R_256()) return true;
    return false;
  }

  private boolean jj_3R_238() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_250()) {
    jj_scanpos = xsp;
    if (jj_3R_251()) return true;
    }
    return false;
  }

  private boolean jj_3R_250() {
    if (jj_3R_91()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_255()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_87() {
    if (jj_scan_token(WHILE2)) return true;
    return false;
  }

  private boolean jj_3R_277() {
    if (jj_3R_322()) return true;
    return false;
  }

  private boolean jj_3R_276() {
    if (jj_3R_321()) return true;
    return false;
  }

  private boolean jj_3R_273() {
    if (jj_scan_token(QUOTE)) return true;
    if (jj_scan_token(Ident)) return true;
    return false;
  }

  private boolean jj_3R_86() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3R_274() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_276()) {
    jj_scanpos = xsp;
    if (jj_3R_277()) {
    jj_scanpos = xsp;
    if (jj_3R_278()) {
    jj_scanpos = xsp;
    if (jj_3R_279()) {
    jj_scanpos = xsp;
    if (jj_3R_280()) {
    jj_scanpos = xsp;
    if (jj_3R_281()) {
    jj_scanpos = xsp;
    if (jj_3R_282()) {
    jj_scanpos = xsp;
    if (jj_3R_283()) {
    jj_scanpos = xsp;
    if (jj_3R_284()) {
    jj_scanpos = xsp;
    if (jj_3R_285()) {
    jj_scanpos = xsp;
    if (jj_3R_286()) {
    jj_scanpos = xsp;
    if (jj_3R_287()) {
    jj_scanpos = xsp;
    if (jj_3R_288()) {
    jj_scanpos = xsp;
    if (jj_3R_289()) {
    jj_scanpos = xsp;
    if (jj_3_24()) {
    jj_scanpos = xsp;
    if (jj_3R_290()) {
    jj_scanpos = xsp;
    if (jj_3R_291()) {
    jj_scanpos = xsp;
    if (jj_3R_292()) {
    jj_scanpos = xsp;
    if (jj_3R_293()) {
    jj_scanpos = xsp;
    if (jj_3R_294()) {
    jj_scanpos = xsp;
    if (jj_3R_295()) {
    jj_scanpos = xsp;
    if (jj_3R_296()) {
    jj_scanpos = xsp;
    if (jj_3R_297()) {
    jj_scanpos = xsp;
    if (jj_3R_298()) {
    jj_scanpos = xsp;
    if (jj_3R_299()) {
    jj_scanpos = xsp;
    if (jj_3R_300()) {
    jj_scanpos = xsp;
    if (jj_3R_301()) {
    jj_scanpos = xsp;
    if (jj_3R_302()) {
    jj_scanpos = xsp;
    if (jj_3R_303()) {
    jj_scanpos = xsp;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3R_304()) {
    jj_scanpos = xsp;
    if (jj_3R_305()) {
    jj_scanpos = xsp;
    if (jj_3R_306()) {
    jj_scanpos = xsp;
    if (jj_3R_307()) {
    jj_scanpos = xsp;
    if (jj_3R_308()) {
    jj_scanpos = xsp;
    if (jj_3R_309()) {
    jj_scanpos = xsp;
    if (jj_3R_310()) {
    jj_scanpos = xsp;
    if (jj_3R_311()) {
    jj_scanpos = xsp;
    if (jj_3R_312()) {
    jj_scanpos = xsp;
    if (jj_3R_313()) {
    jj_scanpos = xsp;
    if (jj_3R_314()) {
    jj_scanpos = xsp;
    if (jj_3R_315()) {
    jj_scanpos = xsp;
    if (jj_3R_316()) {
    jj_scanpos = xsp;
    if (jj_3R_317()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_320() {
    if (jj_scan_token(187)) return true;
    return false;
  }

  private boolean jj_3R_319() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_275() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_318()) {
    jj_scanpos = xsp;
    if (jj_3R_319()) {
    jj_scanpos = xsp;
    if (jj_3R_320()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_318() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_96()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_scan_token(INVARIANT)) return true;
    return false;
  }

  private boolean jj_3R_85() {
    if (jj_scan_token(IMPORTS)) return true;
    return false;
  }

  private boolean jj_3_1() {
    Token xsp;
    xsp = jj_scanpos;
    jj_lookingAhead = true;
    jj_semLA = whilesCount > 0;
    jj_lookingAhead = false;
    if (!jj_semLA || jj_3R_84()) {
    jj_scanpos = xsp;
    if (jj_3R_85()) {
    jj_scanpos = xsp;
    if (jj_3R_86()) {
    jj_scanpos = xsp;
    if (jj_scan_token(169)) {
    jj_scanpos = xsp;
    if (jj_3R_87()) {
    jj_scanpos = xsp;
    if (jj_scan_token(166)) return true;
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_84() {
    if (jj_scan_token(INVARIANT)) return true;
    return false;
  }

  private boolean jj_3R_272() {
    if (jj_3R_274()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_275()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_271() {
    if (jj_3R_272()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_273()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_36() {
    if (jj_3R_100()) return true;
    if (jj_scan_token(194)) return true;
    return false;
  }

  private boolean jj_3R_142() {
    if (jj_scan_token(QUOTE)) return true;
    if (jj_scan_token(Ident)) return true;
    return false;
  }

  private boolean jj_3R_266() {
    if (jj_3R_271()) return true;
    return false;
  }

  private boolean jj_3_35() {
    if (jj_3R_91()) return true;
    if (jj_scan_token(QUOTE)) return true;
    return false;
  }

  private boolean jj_3R_141() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_143()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_267() {
    if (jj_scan_token(172)) return true;
    if (jj_3R_266()) return true;
    return false;
  }

  private boolean jj_3R_125() {
    if (jj_3R_100()) return true;
    if (jj_scan_token(194)) return true;
    if (jj_3R_143()) return true;
    return false;
  }

  private boolean jj_3_34() {
    if (jj_3R_91()) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  private boolean jj_3R_124() {
    if (jj_3R_91()) return true;
    Token xsp;
    if (jj_3R_142()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_142()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(194)) return true;
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_123() {
    if (jj_3R_91()) return true;
    Token xsp;
    if (jj_3R_141()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_141()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(194)) return true;
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_262() {
    if (jj_3R_266()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_267()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_254() {
    if (jj_scan_token(173)) return true;
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_270() {
    if (jj_scan_token(MODULO)) return true;
    return false;
  }

  private boolean jj_3R_269() {
    if (jj_scan_token(DIVIDE)) return true;
    return false;
  }

  private boolean jj_3R_268() {
    if (jj_scan_token(TIMES)) return true;
    return false;
  }

  private boolean jj_3R_99() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_123()) {
    jj_scanpos = xsp;
    if (jj_3R_124()) {
    jj_scanpos = xsp;
    if (jj_3R_125()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_263() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_268()) {
    jj_scanpos = xsp;
    if (jj_3R_269()) {
    jj_scanpos = xsp;
    if (jj_3R_270()) return true;
    }
    }
    if (jj_3R_262()) return true;
    return false;
  }

  private boolean jj_3R_249() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(173)) return true;
    }
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_247() {
    if (jj_scan_token(173)) return true;
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_248() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_144()) return true;
    Token xsp;
    if (jj_3R_254()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_254()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_257() {
    if (jj_3R_262()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_263()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_33() {
    if (jj_3R_100()) return true;
    if (jj_scan_token(170)) return true;
    return false;
  }

  private boolean jj_3R_265() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  private boolean jj_3R_264() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  private boolean jj_3R_258() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_264()) {
    jj_scanpos = xsp;
    if (jj_3R_265()) return true;
    }
    if (jj_3R_257()) return true;
    return false;
  }

  private boolean jj_3R_236() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_144()) return true;
    Token xsp;
    if (jj_3R_247()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_247()) { jj_scanpos = xsp; break; }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_248()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3R_228() {
    if (jj_3R_238()) return true;
    return false;
  }

  private boolean jj_3R_252() {
    if (jj_3R_257()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_258()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_16() {
    if (jj_3R_91()) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  private boolean jj_3R_237() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_144()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_249()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_253() {
    if (jj_scan_token(171)) return true;
    if (jj_3R_252()) return true;
    return false;
  }

  private boolean jj_3R_227() {
    if (jj_3R_91()) return true;
    Token xsp;
    if (jj_3R_237()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_237()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_226() {
    if (jj_3R_236()) return true;
    return false;
  }

  private boolean jj_3R_239() {
    if (jj_3R_252()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_253()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_225() {
    if (jj_scan_token(BOOL)) return true;
    return false;
  }

  private boolean jj_3R_224() {
    if (jj_3R_235()) return true;
    return false;
  }

  private boolean jj_3R_223() {
    if (jj_3R_234()) return true;
    return false;
  }

  private boolean jj_3R_222() {
    if (jj_scan_token(BOOL_CAST)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_95()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_240() {
    if (jj_scan_token(173)) return true;
    if (jj_3R_239()) return true;
    return false;
  }

  private boolean jj_3R_221() {
    if (jj_3R_233()) return true;
    return false;
  }

  private boolean jj_3R_220() {
    if (jj_scan_token(PREDECESSOR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_162()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_219() {
    if (jj_scan_token(SUCCESSOR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_162()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_218() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_3R_213()) return true;
    return false;
  }

  private boolean jj_3R_229() {
    if (jj_3R_239()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_240()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_217() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_144()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_213() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_217()) {
    jj_scanpos = xsp;
    if (jj_3R_218()) {
    jj_scanpos = xsp;
    if (jj_3R_219()) {
    jj_scanpos = xsp;
    if (jj_3R_220()) {
    jj_scanpos = xsp;
    if (jj_3R_221()) {
    jj_scanpos = xsp;
    if (jj_3R_222()) {
    jj_scanpos = xsp;
    if (jj_3R_223()) {
    jj_scanpos = xsp;
    if (jj_3R_224()) {
    jj_scanpos = xsp;
    if (jj_3R_225()) {
    jj_scanpos = xsp;
    if (jj_3R_226()) {
    jj_scanpos = xsp;
    if (jj_3R_227()) {
    jj_scanpos = xsp;
    if (jj_3R_228()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_230() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(90)) {
    jj_scanpos = xsp;
    if (jj_scan_token(91)) return true;
    }
    if (jj_3R_229()) return true;
    return false;
  }

  private boolean jj_3R_214() {
    if (jj_scan_token(172)) return true;
    if (jj_3R_213()) return true;
    return false;
  }

  private boolean jj_3R_232() {
    if (jj_scan_token(186)) return true;
    return false;
  }

  private boolean jj_3R_231() {
    if (jj_scan_token(185)) return true;
    return false;
  }

  private boolean jj_3R_215() {
    if (jj_3R_229()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_230()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_200() {
    if (jj_3R_213()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_214()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_216() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_231()) {
    jj_scanpos = xsp;
    if (jj_3R_232()) return true;
    }
    if (jj_3R_215()) return true;
    return false;
  }

  private boolean jj_3R_109() {
    if (jj_scan_token(MODULO)) return true;
    return false;
  }

  private boolean jj_3R_108() {
    if (jj_scan_token(DIVIDE)) return true;
    return false;
  }

  private boolean jj_3R_107() {
    if (jj_scan_token(TIMES)) return true;
    return false;
  }

  private boolean jj_3R_203() {
    if (jj_3R_215()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_216()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_94() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_107()) {
    jj_scanpos = xsp;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) return true;
    }
    }
    if (jj_3R_200()) return true;
    return false;
  }

  private boolean jj_3_15() {
    Token xsp;
    xsp = jj_scanpos;
    jj_lookingAhead = true;
    jj_semLA = getToken(1).kind == TIMES && getToken(2).kind == LBRACE;
    jj_lookingAhead = false;
    if (!jj_semLA || jj_3R_93()) {
    jj_scanpos = xsp;
    if (jj_3R_94()) return true;
    }
    return false;
  }

  private boolean jj_3R_93() {
    if (jj_scan_token(TIMES)) return true;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_200()) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3R_204() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(82)) {
    jj_scanpos = xsp;
    if (jj_scan_token(83)) {
    jj_scanpos = xsp;
    if (jj_scan_token(84)) {
    jj_scanpos = xsp;
    if (jj_scan_token(85)) {
    jj_scanpos = xsp;
    if (jj_scan_token(88)) {
    jj_scanpos = xsp;
    if (jj_scan_token(89)) return true;
    }
    }
    }
    }
    }
    if (jj_3R_203()) return true;
    return false;
  }

  private boolean jj_3R_183() {
    if (jj_3R_200()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_15()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_202() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  private boolean jj_3R_201() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  private boolean jj_3R_185() {
    if (jj_3R_203()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_204()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_212() {
    if (jj_scan_token(184)) return true;
    return false;
  }

  private boolean jj_3R_211() {
    if (jj_scan_token(183)) return true;
    return false;
  }

  private boolean jj_3R_210() {
    if (jj_scan_token(182)) return true;
    return false;
  }

  private boolean jj_3R_209() {
    if (jj_scan_token(181)) return true;
    return false;
  }

  private boolean jj_3R_208() {
    if (jj_scan_token(180)) return true;
    return false;
  }

  private boolean jj_3R_207() {
    if (jj_scan_token(179)) return true;
    return false;
  }

  private boolean jj_3R_206() {
    if (jj_scan_token(178)) return true;
    return false;
  }

  private boolean jj_3R_184() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_201()) {
    jj_scanpos = xsp;
    if (jj_3R_202()) return true;
    }
    if (jj_3R_183()) return true;
    return false;
  }

  private boolean jj_3R_205() {
    if (jj_scan_token(177)) return true;
    return false;
  }

  private boolean jj_3R_175() {
    if (jj_3R_183()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_184()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_186() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_205()) {
    jj_scanpos = xsp;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) {
    jj_scanpos = xsp;
    if (jj_3R_208()) {
    jj_scanpos = xsp;
    if (jj_3R_209()) {
    jj_scanpos = xsp;
    if (jj_3R_210()) {
    jj_scanpos = xsp;
    if (jj_3R_211()) {
    jj_scanpos = xsp;
    if (jj_3R_212()) return true;
    }
    }
    }
    }
    }
    }
    }
    if (jj_3R_185()) return true;
    return false;
  }

  private boolean jj_3R_176() {
    if (jj_scan_token(171)) return true;
    if (jj_3R_175()) return true;
    return false;
  }

  private boolean jj_3R_177() {
    if (jj_3R_185()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_186()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_178() {
    if (jj_scan_token(176)) return true;
    if (jj_3R_177()) return true;
    return false;
  }

  private boolean jj_3R_162() {
    if (jj_3R_175()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_176()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_23() {
    if (jj_scan_token(PARALLEL_PRODUCT)) return true;
    return false;
  }

  private boolean jj_3R_144() {
    if (jj_3R_162()) return true;
    return false;
  }

  private boolean jj_3R_167() {
    if (jj_3R_177()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_178()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_32() {
    if (jj_3R_100()) return true;
    if (jj_scan_token(193)) return true;
    return false;
  }

  private boolean jj_3_31() {
    if (jj_3R_100()) return true;
    if (jj_scan_token(BELONGS)) return true;
    return false;
  }

  private boolean jj_3_30() {
    if (jj_3R_99()) return true;
    return false;
  }

  private boolean jj_3_22() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(86)) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = inParentheses();
    jj_lookingAhead = false;
    if (!jj_semLA || jj_scan_token(87)) return true;
    }
    if (jj_3R_167()) return true;
    return false;
  }

  private boolean jj_3_21() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  private boolean jj_3R_155() {
    if (jj_3R_167()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_22()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_156() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_3R_155()) return true;
    return false;
  }

  private boolean jj_3R_137() {
    if (jj_3R_155()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_156()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_138() {
    if (jj_scan_token(175)) return true;
    if (jj_3R_137()) return true;
    return false;
  }

  private boolean jj_3R_112() {
    if (jj_3R_137()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_138()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_20() {
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_96() {
    if (jj_3R_112()) return true;
    return false;
  }

  private boolean jj_3R_246() {
    if (jj_scan_token(INT)) return true;
    return false;
  }

  private boolean jj_3R_245() {
    if (jj_scan_token(NAT1)) return true;
    return false;
  }

  private boolean jj_3R_235() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_244()) {
    jj_scanpos = xsp;
    if (jj_3R_245()) {
    jj_scanpos = xsp;
    if (jj_3R_246()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_244() {
    if (jj_scan_token(NAT)) return true;
    return false;
  }

  private boolean jj_3R_261() {
    if (jj_scan_token(MAXINT)) return true;
    return false;
  }

  private boolean jj_3R_260() {
    if (jj_scan_token(MININT)) return true;
    return false;
  }

  private boolean jj_3R_256() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_259()) {
    jj_scanpos = xsp;
    if (jj_3R_260()) {
    jj_scanpos = xsp;
    if (jj_3R_261()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_259() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_243() {
    if (jj_scan_token(FALSE)) return true;
    return false;
  }

  private boolean jj_3R_154() {
    if (jj_scan_token(GREATER_OR_EQUAL)) return true;
    return false;
  }

  private boolean jj_3R_234() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_242()) {
    jj_scanpos = xsp;
    if (jj_3R_243()) return true;
    }
    return false;
  }

  private boolean jj_3R_242() {
    if (jj_scan_token(TRUE)) return true;
    return false;
  }

  private boolean jj_3R_153() {
    if (jj_scan_token(LESS_OR_EQUAL)) return true;
    return false;
  }

  private boolean jj_3R_152() {
    if (jj_scan_token(GREATER)) return true;
    return false;
  }

  private boolean jj_3R_151() {
    if (jj_scan_token(LESS)) return true;
    return false;
  }

  private boolean jj_3R_150() {
    if (jj_scan_token(174)) return true;
    return false;
  }

  private boolean jj_3R_149() {
    if (jj_scan_token(EQUAL)) return true;
    return false;
  }

  private boolean jj_3R_181() {
    if (jj_scan_token(192)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_19() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_95()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3_14() {
    if (jj_scan_token(Ident)) return true;
    if (jj_scan_token(EQUAL)) return true;
    return false;
  }

  private boolean jj_3R_134() {
    if (jj_3R_144()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_149()) {
    jj_scanpos = xsp;
    if (jj_3R_150()) {
    jj_scanpos = xsp;
    if (jj_3R_151()) {
    jj_scanpos = xsp;
    if (jj_3R_152()) {
    jj_scanpos = xsp;
    if (jj_3R_153()) {
    jj_scanpos = xsp;
    if (jj_3R_154()) return true;
    }
    }
    }
    }
    }
    if (jj_3R_144()) return true;
    return false;
  }

  private boolean jj_3R_133() {
    if (jj_scan_token(NEGATION)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_95()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_136() {
    if (jj_scan_token(DISJUNCTION)) return true;
    return false;
  }

  private boolean jj_3R_135() {
    if (jj_scan_token(CONJUNCTION)) return true;
    return false;
  }

  private boolean jj_3R_132() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_95()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_110() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_132()) {
    jj_scanpos = xsp;
    if (jj_3R_133()) {
    jj_scanpos = xsp;
    if (jj_3R_134()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_180() {
    if (jj_scan_token(191)) return true;
    if (jj_3R_187()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_122()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_111() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_135()) {
    jj_scanpos = xsp;
    if (jj_3R_136()) return true;
    }
    if (jj_3R_110()) return true;
    return false;
  }

  private boolean jj_3R_179() {
    if (jj_scan_token(NEGATION)) return true;
    if (jj_3R_157()) return true;
    return false;
  }

  private boolean jj_3R_161() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_95() {
    if (jj_3R_110()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_111()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_199() {
    if (jj_scan_token(GREATER)) return true;
    return false;
  }

  private boolean jj_3R_198() {
    if (jj_scan_token(GREATER_OR_EQUAL)) return true;
    return false;
  }

  private boolean jj_3R_197() {
    if (jj_scan_token(LESS_OR_EQUAL)) return true;
    return false;
  }

  private boolean jj_3R_196() {
    if (jj_scan_token(LESS)) return true;
    return false;
  }

  private boolean jj_3R_195() {
    if (jj_scan_token(174)) return true;
    return false;
  }

  private boolean jj_3R_194() {
    if (jj_scan_token(EQUAL)) return true;
    return false;
  }

  private boolean jj_3_11() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  private boolean jj_3R_193() {
    if (jj_scan_token(STRICT_NON_INCLUSION)) return true;
    return false;
  }

  private boolean jj_3R_192() {
    if (jj_scan_token(NON_INCLUSION)) return true;
    return false;
  }

  private boolean jj_3R_191() {
    if (jj_scan_token(STRICT_INCLUSION)) return true;
    return false;
  }

  private boolean jj_3R_190() {
    if (jj_scan_token(INCLUSION)) return true;
    return false;
  }

  /** Generated Token Manager. */
  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  /** Whether we are looking ahead. */
  private boolean jj_lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[161];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static private int[] jj_la1_4;
  static private int[] jj_la1_5;
  static private int[] jj_la1_6;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
      jj_la1_init_2();
      jj_la1_init_3();
      jj_la1_init_4();
      jj_la1_init_5();
      jj_la1_init_6();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x800000,0x2000000,0x800000,0x0,0x800000,0x3800000,0x0,0x4000000,0x800000,0x800000,0x3800000,0x4000000,0x0,0x2000000,0x0,0x2000000,0x800000,0x2000000,0x2000000,0x800000,0x0,0x800000,0x380e000,0x3800000,0x3800000,0x3800000,0x3800000,0x6000,0x0,0x0,0x2000000,0x2000000,0x800000,0x2000000,0x2000000,0x2000000,0x800000,0x4000000,0x0,0x0,0x0,0x4000000,0x4000000,0x4000000,0x800000,0x0,0x0,0x800000,0x4000000,0x0,0x4000000,0x0,0x18000000,0x18000000,0xe0000000,0xe0000000,0x0,0x2000000,0x2000000,0x800000,0x10810000,0x0,0x0,0x2000000,0x0,0x2000000,0x2000000,0x800000,0x100000,0x0,0x0,0x2000000,0x0,0x0,0xc000,0x10810000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x18000000,0x18000000,0xe0000000,0xe0000000,0x0,0x100000,0x840000,0x840000,0x800000,0x800000,0x10800000,0x10000,0x44000,0x2000000,0x2000000,0x0,0x10000,0x0,0x10000,0x400000,0x800000,0x0,0x0,0x0,0x0,0x0,0x0,0x10854000,0xc000,0x0,0xc000,0x4000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000000,0x0,0x2000000,0x0,0x0,0x800000,0x800000,0x100000,0x4000000,0x0,0x0,0x0,0x2000000,0x2000000,0x0,0x0,0x100000,0x100000,0x2000000,0x800000,0x10810000,0x2000000,0x10810000,0x800000,0x2000000,0x800000,0x2000000,0x2000000,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x83,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x83,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3ff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x3ff,0x0,0x0,0x0,0x0,0x0,0x1a535800,0x0,0x200000,0x40000,0x80000,0x1000000,0x80000,0x0,0x200000,0x0,0x80000,0x0,0x0,0x0,0x0,0x0,0x82034800,0x40000,0x80000,0x0,0x0,0x200000,0x80000,0x0,0x0,0x0,0x0,0x83,0x0,0x83,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf0000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x70000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30,0x30,0x700,0x70000008,0x0,0x0,0x70000000,0x0,0x0,0x400000,0x0,0x0,0x0,0x33c0000,0x33c0000,0x0,0x0,0xc000000,0xc000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf0000000,0x0,0x0,0x0,0x0,0x0,0xc0,0xc0,0x30,0x30,0x8,0xf0000000,0x3f700,0xf000,0x300,0x0,0x800000,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x70000000,0x0,0x70000000,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_3() {
      jj_la1_3 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20e00,0xc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0,0xcc0,0x0,0x0,0x0,0x0,0x20ec0,0xc00,0xc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xcc0,0x3fff03c,0xfc000000,0x0,0x0,0x30000,0x303,0x3c,0x0,0x0,0x0,0xc00,0x0,0x0,0x0,0x0,0x0,0xffffffff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20ec0,0x0,0x20ec0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_4() {
      jj_la1_4 = new int[] {0x0,0x0,0x0,0xfffff000,0x0,0x0,0x0,0x0,0x0,0x0,0x800,0x0,0x15000,0x0,0x62000,0x0,0x0,0x0,0x0,0x0,0xfffff000,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x700,0x7fdde000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x50000000,0x22000000,0x0,0x0,0x0,0x0,0x7f5db000,0xa77f9000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x40,0x0,0x0,0x0,0x0,0x40,0x0,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0,0x0,0x3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0,0x0,0xc0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_5() {
      jj_la1_5 = new int[] {0x0,0x0,0x0,0x247,0x0,0x70,0x200,0x0,0x40,0x0,0x270,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7,0x0,0x240,0x240,0x240,0x240,0x240,0x40,0x0,0x7,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7,0x7,0x0,0x0,0x40,0x0,0x800,0x0,0x0,0x0,0x0,0x1000,0x2000,0x2000,0x0,0x0,0x40,0x2000,0x0,0x2000,0x0,0x0,0x0,0x0,0x40,0x40,0x0,0x0,0x0,0x4000,0x40,0x0,0x0,0x0,0x40,0x8000,0x0,0x10000,0x1fe0000,0x1fe0000,0x0,0x0,0x6000000,0x6000000,0x0,0x0,0x2000,0x800,0x0,0x0,0x0,0x0,0x1000,0x0,0x8000000,0x8000000,0x0,0x0,0x20000040,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x0,0x0,0x0,0x80000000,0x20000040,0x4000,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x40,0x0,0x0,0x40,0x0,0x0,};
   }
   private static void jj_la1_init_6() {
      jj_la1_6 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[40];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public Parser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public Parser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 161; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 161; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 161; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 161; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 161; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 161; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = getFollowingToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      trace_token(token, "");
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = getFollowingToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = getFollowingToken();
    jj_ntk = -1;
    jj_gen++;
      trace_token(token, " (in getNextToken)");
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = jj_lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = getFollowingToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=getFollowingToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[195];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 161; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
          if ((jj_la1_5[i] & (1<<j)) != 0) {
            la1tokens[160+j] = true;
          }
          if ((jj_la1_6[i] & (1<<j)) != 0) {
            la1tokens[192+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 195; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  private int trace_indent = 0;
  private boolean trace_enabled = true;

/** Enable tracing. */
  final public void enable_tracing() {
    trace_enabled = true;
  }

/** Disable tracing. */
  final public void disable_tracing() {
    trace_enabled = false;
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 40; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
